#include "common.h"
enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)),
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)),
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)),
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)),
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)),
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)),
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)),
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)),
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)),
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)),
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)),
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8))
};
extern __const unsigned short int *__ctype_b;


void save_file_ff (buf_T *buf);
void scroll_cursor_halfway (int atend);
void set_curbuf (buf_T *buf, int action);


void set_last_cursor (win_T *win);


char_u *shorten_fname (char_u *full_path, char_u *dir_name);
void shorten_fnames (int force);
int shortmess (int x);
char_u *alloc_clear (unsigned size);
char_u *skipdigits (char_u *p);
char_u *skiptowhite_esc (char_u *p);
char_u *skipwhite (char_u *p);
int smsg (char_u *, ...);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern int toupper (int __c) ;
char_u *transstr (char_u *s);
void trunc_string (char_u *s, char_u *buf, int room);
void u_sync (void);
void ui_breakcheck (void);
void ui_delay (long msec, int ignoreinput);


void buf_clear_file (buf_T *buf);
void buf_freeall (buf_T *buf, int del_buf, int wipe_buf);
void get_winopts (buf_T *buf);
pos_T *buflist_findfpos (buf_T *buf);
void buf_name_changed (void);
void buflist_altfpos (void);
void fname_expand (char_u **ffname, char_u **sfname);
void diff_new_buffer (void);
int apply_autocmds_retval (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf, int *retval);
void fmarks_check_names (buf_T *buf);
win_T *buf_jump_open_win (buf_T *buf);
extern buf_T *au_new_curbuf ;
void unchanged (buf_T *buf, int ff);
void validate_virtcol (void);


void var_init (garray_T *gap);
void var_clear (garray_T *gap);
int vgetc (void);
int vim_chdirfile (char_u *fname);
int vim_isspace (int x);
regprog_T *vim_regcomp (char_u *expr, int re_flags);


typedef struct
{
    regprog_T *regprog;
    char_u *startp[10];
    char_u *endp[10];
    int rm_ic;
} regmatch_T;
int vim_regexec (regmatch_T *rmp, char_u *line, colnr_T col);
extern int atoi (__const char *__nptr) __attribute__ ((__pure__));
char_u *vim_strrchr (char_u *string, int c);
int vim_strsize (char_u *s);




__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;



  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;




  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;

  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;

  struct _IO_marker *_markers;

  struct _IO_FILE *_chain;

  int _fileno;
  int _blksize;
  __off_t _old_offset;



  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];



  _IO_lock_t *_lock;
  __off64_t _offset;





  void *__pad1;
  void *__pad2;

  int _mode;

  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];

};


typedef struct _IO_FILE _IO_FILE;
typedef struct
{
    char_u *vir_line;
    FILE *vir_fd;



} vir_T;
void viminfo_writestring (FILE *fd, char_u *p);
int viminfo_readline (vir_T *virp);
char_u *viminfo_readstring (vir_T *virp, int off, int convert);
void win_close (win_T *win, int free_buf);
void win_enter (win_T *wp, int undo_sync);
int win_split (int size, int flags);
int win_valid (win_T *win);
void wipe_buffer (buf_T *buf, int aucmd);
extern long int atol (__const char *__nptr) __attribute__ ((__pure__));
typedef struct
{
    buf_T *save_buf;
    buf_T *new_curbuf;
    win_T *save_curwin;
    win_T *new_curwin;
    pos_T save_cursor;
    linenr_T save_topline;

    int save_topfill;

} aco_save_T;
void aucmd_prepbuf (aco_save_T *aco, buf_T *buf);
void aucmd_restbuf (aco_save_T *aco);
typedef struct
{
    int hide;

    int browse;


    int split;


    int confirm;

} cmdmod_T;
typedef unsigned int int_u;
typedef int scid_T;
int autowrite (buf_T *buf, int forceit);
extern long Columns ;
extern int RedrawingDisabled ;
extern long Rows







                            ;
extern int State ;
extern int VIsual_reselect;
extern int arg_had_last ;
int bt_dontwrite (buf_T *buf);
extern int autocmd_block ;


extern cmdmod_T cmdmod;
extern int cmdwin_type ;


extern scid_T current_SID ;
extern char_u e_trailing[] ;
extern int emsg_silent ;
int bt_nofile (buf_T *buf);
extern int readonlymode ;
extern win_T *firstwin;
extern buf_T *lastbuf ;
extern win_T *lastwin;
extern int lcs_tab1 ;
extern int msg_scroll ;
int bt_quickfix (buf_T *buf);
extern int need_maketitle ;
extern int need_mouse_correct ;
extern char_u *p_cpo;
extern int p_magic;
extern long p_report;
extern int p_sol;
extern char_u *p_swb;
extern int restart_edit ;
extern char_u *serverName ;


extern linenr_T sourcing_lnum ;
extern char_u *sourcing_name ;
void backslash_halve (char_u *p);
int ga_grow (garray_T *gap, int n);
void ga_init2 (garray_T *gap, int itemsize, int growsize);
void getvvcol (win_T *wp, pos_T *pos, colnr_T *start, colnr_T *cursor, colnr_T *end);
int hex2nr (int c);
int buf_check_timestamp (buf_T *buf, int focus);


int lbr_chartabsize (unsigned char *s, colnr_T col);


extern void *memset (void *__s, int __c, size_t __n) ;
int ptr2cells (char_u *p);
int rem_backslash (char_u *str);
char_u *skip_to_option_part (char_u *p);
extern int tolower (int __c) ;
char_u *transchar (int c);
void transchar_nonprint (char_u *buf, int c);
int vim_isprintc_strict (int c);
extern int p_acd;
void buf_copy_options (buf_T *buf, int flags);
int virtual_active (void);
int win_col_off (win_T *wp);
int win_col_off2 (win_T *wp);
extern int VIsual_active ;
extern char_u *p_sbr;
extern char_u *p_sel;
int buf_hide (buf_T *buf);
int call_shell (char_u *cmd, int opt);
void changed_line_abv_curs_win (win_T *wp);
void changed_lines (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
void changed_window_setting (void);
extern int chdir (__const char *__path) ;
void check_topfill (win_T *wp, int down);
int buf_init_chartab (buf_T *buf, int global);
int diff_check (win_T *wp, linenr_T lnum);
char_u *do_browse (int saving, char_u *title, char_u *dflt, char_u *ext, char_u *initdir, char_u *filter, buf_T *buf);
int do_cmdline_cmd (char_u *cmd);



void ex_diffupdate (exarg_T *eap);
void ex_diffgetput (exarg_T *eap);
void ex_file (exarg_T *eap);
void do_exedit (exarg_T *eap, win_T *old_curwin);
extern int fclose (FILE *__stream) ;
void foldUpdate (win_T *wp, linenr_T top, linenr_T bot);
int foldmethodIsDiff (win_T *wp);
extern int diff_context ;
extern FILE *fopen (__const char *__restrict __filename,
                    __const char *__restrict __modes) ;
void buf_setino (buf_T *buf);
int prep_exarg (exarg_T *eap, buf_T *buf);
void ml_timestamp (buf_T *buf);
void status_redraw_all (void);
void u_clearall (buf_T *buf);
void u_blockfree (buf_T *buf);
extern int autocmd_no_enter ;
extern int autocmd_no_leave ;
extern int netbeansFireChanges ;
typedef struct foldinfo
{
    int fi_level;

    int fi_lnum;
    int fi_low_level;

} foldinfo_T;
int hasFoldingWin (win_T *win, linenr_T lnum, linenr_T *firstp, linenr_T *lastp, int cache, foldinfo_T *infop);
void invalidate_botline_win (win_T *wp);
void mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
void redraw_win_later (win_T *wp, int type);
void set_string_option_direct (char_u *name, int opt_idx, char_u *val, int opt_flags);
extern int strcasecmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
int u_save (linenr_T top, linenr_T bot);
int vim_fgets (char_u *buf, int size, FILE *fp);
char_u *vim_strnsave (char_u *string, int len);
char_u *vim_tempname (int extra_char);
extern int KeyTyped;
extern char_u e_prev_dir[] ;
int add_to_showcmd (int c);
int char2cells (int c);
int buf_valid (buf_T *buf);
void putcmdline (int c, int shift);
int safe_vgetc (void);
extern int no_mapping ;
extern int allow_keys ;
extern int cmdline_star ;
extern char_u e_invarg[] ;
extern int msg_col;
extern int must_redraw ;
enum key_extra
{
    KE_NAME = 3

    , KE_S_UP
    , KE_S_DOWN

    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10

    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20

    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30

    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37

    , KE_MOUSE





    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE

    , KE_IGNORE

    , KE_TAB
    , KE_S_TAB_OLD

    , KE_SNIFF

    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME

    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM

    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4

    , KE_MOUSEDOWN
    , KE_MOUSEUP

    , KE_KINS
    , KE_KDEL

    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN

    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END

    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE

    , KE_DROP
};
buf_T *buflist_findnr (int nr);


typedef struct oparg
{
    int op_type;
    int regname;
    int motion_type;
    int motion_force;
    int use_reg_one;

    int inclusive;

    int end_adjusted;

    pos_T start;
    pos_T end;

    long line_count;

    int empty;


    int is_VIsual;
    int block_mode;

    colnr_T start_vcol;
    colnr_T end_vcol;
} oparg_T;
extern int p_sta;
extern char_u *p_ww;
void auto_format (void);
int oneright (void);
int cursor_up (long n, int upd_topline);
int cursor_down (long n, int upd_topline);
void ResetRedobuff (void);
void AppendCharToRedobuff (int c);
void AppendNumberToRedobuff (long n);
int open_line (int dir, int flags, int old_indent);
int onepage (int dir, long count);
int do_mouse (oparg_T *oap, int c, int dir, long count, int fixindent);
void scroll_redraw (int up, long count);
void start_selection (void);
int insert_reg (int regname, int literally);
void netbeans_keycommand (int key);
extern pos_T where_paste_started;
extern int km_startsel ;
void AppendToRedobuff (char_u *s);
void AppendToRedobuffLit (char_u *s);
int oneleft (void);
int fwd_word (long count, int bigword, int eol);
int bck_word (long count, int bigword, int stop);
void beginline (int flags);
void change_warning (int col);
int buflist_findpat (char_u *pattern, char_u *pattern_end, int unlisted, int diffmode);
void changed_bytes (linenr_T lnum, colnr_T col);
int char_avail (void);
int chartabsize (char_u *p, colnr_T col);
void check_for_delay (int check_msg_scroll);
int check_timestamps (int focus);
void clear_showcmd (void);
extern int clear_cmdline ;
void curs_columns (int scroll);
void cursor_off (void);
int inindent (int extra);
int inc_cursor (void);
int dec_cursor (void);
void do_check_scrollbind (int check);
void do_put (int regname, int dir, long count, int flags);
void edit_putchar (int c, int highlight);
void edit_unputchar (void);
int vim_is_ctrl_x_key (int c);
void find_pattern_in_path (char_u *ptr, int dir, int len, int whole, int skip_comments, int type, long count, int action, linenr_T start_lnum, linenr_T end_lnum);
int find_tags (char_u *pat, int *num_matches, char_u ***matchesp, int flags, int mincount);
int ins_compl_add_infercase (char_u *str, int len, char_u *fname, int dir, int reuse);
char_u *find_word_start (char_u *ptr);
char_u *find_word_end (char_u *ptr);
extern int completion_length ;
buf_T *buflist_new (char_u *ffname, char_u *sfname, linenr_T lnum, int flags);
pos_T *findmatch (oparg_T *oap, int initc);
void foldCheckClose (void);
void foldOpenCursor (void);
int gchar_cursor (void);
int get_literal (void);
void im_set_active (int active);
int get_expr_register (void);
void im_save_status (long *psave);
int gui_do_scroll (void);
int gui_do_horiz_scroll (void);
int get_indent (void);
int set_indent (int size, int flags);
int get_leader_len (char_u *line, char_u **flags, int backward);
int get_lisp_indent (void);
char_u *get_special_key_name (int c, int modifiers);
int getviscol (void);
struct stl_hlrec
{
    char_u *start;
    int userhl;
};
int build_stl_str_hl (win_T *wp, char_u *out, size_t outlen, char_u *fmt, int fillchar, int maxwidth, struct stl_hlrec *hl);
int goto_im (void);
void gui_update_cursor (int force, int clear_selection);
int hasAnyFolding (win_T *win);
int hasFolding (linenr_T lnum, linenr_T *firstp, linenr_T *lastp);
int has_format_option (int x);
int ignorecase (char_u *pat);
int im_get_status (void);
void ins_compl_check_keys (void);
extern int completion_interrupted ;
int byte2cells (int b);
int linetabsize (char_u *s);
int linewhite (linenr_T lnum);
int map_to_exists_mode (char_u *rhs, int mode);
extern int no_abbr ;
char_u *ml_get_curline (void);
char_u *ml_get_cursor (void);
win_T *mouse_find_win (int *rowp, int *colp);
int mouse_has (int c);
int msg_attr (char_u *s, int attr);
void redraw_statuslines (void);
int redrawing (void);
void screen_putchar (int c, int row, int col, int attr);
void screen_puts (char_u *text, int row, int col, int attr);
void scrolldown_clamp (void);
void scrollup_clamp (void);
int searchit (win_T *win, buf_T *buf, pos_T *pos, int dir, char_u *pat, long count, int options, int pat_use);
void setcursor (void);
void changed (void);
void setmouse (void);
int showmode (void);
void showruler (int always);
void stuffReadbuff (char_u *s);
int stuff_empty (void);
void stuffcharReadbuff (int c);
int u_save_cursor (void);
void ui_cursor_shape (void);
void update_curswant (void);
void update_screen (int type);
void update_topline (void);
void validate_cursor (void);
void vim_beep (void);
int vim_isIDc (int c);
int vim_isdigit (int c);
int vim_isfilec (int c);
int vim_isprintc (int c);
int vim_iswordc (int c);
void changed_line_abv_curs (void);
int vim_iswordp (char_u *p);
int vpeekc (void);
typedef struct expand
{
    int xp_context;
    char_u *xp_pattern;
    char_u *xp_arg;
    int xp_backslash;
} expand_T;


typedef void (*GtkItemFactoryCallback) ();
extern int Recording ;
void check_arg_idx (win_T *win);
extern char_u e_nowrtmsg[] ;
extern pos_T VIsual;
extern int arrow_used;
extern int cmdwin_result ;
extern int continue_status ;
extern int ctrl_x_mode ;
extern int did_ai ;
extern colnr_T dollar_vcol ;
extern char_u e_internal[] ;
extern char_u e_sandbox[] ;
char_u *FullName_save (char_u *fname, int force);
void check_cursor_col (void);
extern int emsg_on_display ;
extern unsigned fdo_flags;
extern int global_busy ;
extern int intr_char ;
extern int mod_mask ;
extern int mouse_col;
extern int mouse_row;
extern int need_start_insertmode ;
extern int no_u_sync ;
extern int p_ic;
void check_cursor_lnum (void);
extern int p_im;
extern int p_js;
extern int p_paste;
extern int p_scs;
extern int p_sm;
extern int p_smd;
extern long p_so;
extern int p_ws;
extern int redraw_cmdline ;
extern int sandbox ;
void clearFolding (win_T *win);
extern int sc_col;
extern unsigned ve_flags;


char_u *ExpandOne (expand_T *xp, char_u *str, char_u *orig, int options, int mode);
void add_pathsep (char_u *p);
void add_to_history (int histype, char_u *new_entry, int in_map);
char_u *check_nextcmd (char_u *p);
int check_restricted (void);
int check_secure (void);





struct buffblock
{
    struct buffblock *b_next;
    char_u b_str[1];
};
struct buffheader
{
    struct buffblock bh_first;
    struct buffblock *bh_curr;
    int bh_index;
    int bh_space;
};
typedef struct
{
    char_u *tb_buf;
    char_u *tb_noremap;
    int tb_buflen;
    int tb_off;
    int tb_len;
    int tb_maplen;
    int tb_silent;
    int tb_no_abbr_cnt;
} typebuf_T;
typedef struct
{
    typebuf_T save_typebuf;
    int typebuf_valid;
    struct buffheader save_stuffbuff;

    char_u *save_inputbuf;

} tasave_T;
void report_make_pending (int pending, void *value);
int cleanup_conditionals (struct condstack *cstack, int searched_cond, int inclusive);
void save_typeahead (tasave_T *tp);
void restore_typeahead (tasave_T *tp);
extern int ex_nesting_level ;
int do_cmdline (char_u *cmdline, char_u *(*getline)(int, void *, int), void *cookie, int flags);
int do_return (exarg_T *eap, int reanimate, int is_cmd, void *value);
char_u *get_func_line (int c, void *cookie, int indent);
int modify_fname (char_u *src, int *usedlen, char_u **fnamep, char_u **bufp, int *fnamelen);
char_u *skip_range (char_u *cmd, int *ctx);
char_u *eval_vars (char_u *src, int *usedlen, linenr_T *lnump, char_u **errormsg, char_u *srcstart);
int gui_mch_get_winpos (int *x, int *y);
extern int force_abort ;
extern char_u e_outofmem[] ;
int ends_excmd (int c);
char_u *eval_to_string (char_u *arg, char_u **nextcmd);
void close_buffer (win_T *win, buf_T *buf, int action);
char_u *expand_env_save (char_u *src);
void ga_append (garray_T *gap, int c);
void ga_clear (garray_T *gap);
void ga_concat (garray_T *gap, char_u *s);
void ga_init (garray_T *gap);
int get_c_indent (void);
void vim_setenv (char_u *name, char_u *val);
char_u *get_cmd_output (char_u *cmd, int flags);
extern int didset_vim ;
extern int didset_vimruntime ;
char_u *get_user_var_name (expand_T *xp, int idx);
char_u *get_function_name (expand_T *xp, int idx);
char_u *get_user_func_name (expand_T *xp, int idx);
char_u *globpath (char_u *path, char_u *file);
int get_histtype (char_u *name);
char_u *get_highlight_name (expand_T *xp, int idx);
int get_indent_lnum (linenr_T lnum);
int get_map_mode (char_u **cmdp, int forceit);
char_u *get_past_head (char_u *path);
char_u *getcmdline (int firstc, long count, int indent);
char_u *getcmdline_prompt (int firstc, char_u *prompt, int attr);
extern char *getenv (__const char *__name) ;
pos_T *getmark (int c, int changefile);


typedef struct _XDisplay Display;
Display *gui_mch_get_display (void);
int curbufIsChanged (void);
int mch_isFullName (char_u *fname);
int mch_isdir (char_u *name);
void msg_advance (int col);
void msg_clr_eos (void);
int msg_outtrans_len_attr (char_u *msgstr, int len, int attr);
void msg_starthere (void);
int diff_check_fill (win_T *wp, linenr_T lnum);
int no_console_input (void);
int put_eol (FILE *fd);
char_u *replace_termcodes (char_u *from, char_u **bufp, int from_part, int do_lt);
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
void set_vim_var_string (int idx, char_u *val, int len);
char_u *skiptowhite (char_u *p);
int do_ecmd (int fnum, char_u *ffname, char_u *sfname, exarg_T *eap, linenr_T newlnum, int flags);
extern char *strpbrk (__const char *__s, __const char *__accept)
             __attribute__ ((__pure__));
extern char *strstr (__const char *__haystack, __const char *__needle)
             __attribute__ ((__pure__));
int syn_get_final_id (int hl_id);
int syn_id2attr (int hl_id);
int syn_name2id (char_u *name);
int syntax_present (buf_T *buf);


extern time_t time (time_t *__timer) ;
int trans_special (char_u **srcp, char_u *dst, int keycode);
int u_savesub (linenr_T lnum);
int vim_isAbsName (char_u *name);
void do_modelines (void);
void vim_str2nr (char_u *start, int *hexp, int *len, int dooct, int dohex, long *nptr, unsigned long *unptr);
char_u *vim_strsave_escaped (char_u *string, char_u *esc_chars);
void write_reg_contents (int name, char_u *str, int maxlen, int must_append);
void write_reg_contents_ex (int name, char_u *str, int maxlen, int must_append, int yank_type, long block_len);
typedef unsigned long XID;
typedef XID Window;
extern int _IO_putc (int __c, _IO_FILE *__fp) ;
extern int VIsual_mode ;
extern int VIsual_select ;
extern int cmd_silent ;
extern int did_emsg;
extern int did_filetype ;
extern char_u e_invarg2[] ;
extern char_u e_usingsid[] ;
extern int emsg_off ;
extern int emsg_skip ;
int do_unlet (char_u *name);
extern int lines_left ;
extern int msg_didout ;
extern char_u *p_go;
extern long p_verbose;
extern int t_colors ;
extern Display *xterm_dpy ;
void add_termcode (char_u *name, char_u *string, int use_8bit);
char_u *find_termcode (char_u *name);
char_u *alloc_check (unsigned size);
void do_shell (char_u *cmd, int flags);
void autowrite_all (void);
extern int p_awa;
extern int p_write;
int check_changed (buf_T *buf, int checkaw, int mult_win, int forceit, int allbuf);
void do_argfile (exarg_T *eap, int argn);
int check_fname (void);
void cursor_on (void);
void del_lines (long nlines, int undo);
char_u *make_filter_cmd (char_u *cmd, char_u *itmp, char_u *otmp);
int smsg_attr (int, char_u *, ...);
void deleted_lines_mark (linenr_T lnum, long count);
char_u *vim_getenv (char_u *name, int *mustfree);
int u_savedel (linenr_T lnum, long nlines);
void display_errors (void);
buf_T *setaltfname (char_u *ffname, char_u *sfname, linenr_T lnum);
void do_bang (int addr_count, exarg_T *eap, int forceit, int do_in, int do_out);
void print_line_no_prefix (linenr_T lnum, int use_number);
void print_line (linenr_T lnum, int use_number);
int do_write (exarg_T *eap);
void ex_append (exarg_T *eap);
void global_exe (char_u *cmd);
void not_exiting (void);
void ml_setmarked (linenr_T lnum);
void ml_clearmarked (void);
int vim_dialog_yesno (int type, char_u *title, char_u *message, int dflt);
extern int ex_no_reprint ;
extern char_u e_backslash[] ;
extern char_u e_curdir[] ;
extern char_u e_invcmd[] ;
extern char_u e_isadir2[] ;
extern char_u e_zerocount[] ;
int do_tag (char_u *tag, int type, int count, int forceit, int verbose);
void ex_next (exarg_T *eap);
int find_help_tags (char_u *arg, int *num_matches, char_u ***matches);
int gen_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
int get_viminfo_parameter (int type);
extern __uid_t getuid (void) ;
void gotocmdline (int clr);
void invalidate_botline (void);
int messaging (void);
void msgmore (long n);
int otherfile (char_u *ffname);



typedef int (*__compar_fn_t) (__const void *, __const void *);
extern void qsort (void *__base, size_t __nmemb, size_t __size,
                   __compar_fn_t __compar);
void redraw_later_clear (void);
char_u *skip_regexp (char_u *startp, int dirc, int magic, char_u **newp);
void starttermcap (void);
void stoptermcap (void);
extern char *strncat (char *__restrict __dest, __const char *__restrict __src,
                      size_t __n) ;
int syn_check_group (char_u *pp, int len);
void u_clearline (void);
int vim_fexists (char_u *fname);
extern char_u e_argreq[] ;
long vim_regexec_multi (regmmatch_T *rmp, win_T *win, buf_T *buf, linenr_T lnum, colnr_T col);
int viminfo_error (char *errnum, char *message, char_u *line);
void wait_return (int redraw);
void win_init (win_T *wp);
void win_setheight (int height);
void windgoto (int row, int col);
extern int autocmd_busy ;
char_u *file_pat_to_reg_pat (char_u *pat, char_u *pat_end, char *allow_dirs, int no_bslash);
extern char_u e_notmp[] ;
extern char_u e_notread[] ;
extern int exiting ;
extern int exmode_active ;
extern int g_do_tagpreview ;
extern int highlight_match ;
extern int keep_help_flag ;
extern char_u *p_hf;
extern char_u msg_buf[80];
extern int msg_didany ;
char_u *find_viminfo_parameter (int type);
extern int msg_no_more ;
extern int msg_silent ;
extern int p_confirm;
extern char_u *p_ffs;
extern char_u *p_rtp;
extern linenr_T search_match_lines;
extern colnr_T search_match_endcol;
extern int secure ;
extern int silent_mode ;
extern int skip_redraw ;
enum
{
  __LC_CTYPE = 0,
  __LC_NUMERIC = 1,
  __LC_TIME = 2,
  __LC_COLLATE = 3,
  __LC_MONETARY = 4,
  __LC_MESSAGES = 5,
  __LC_ALL = 6,
  __LC_PAPER = 7,
  __LC_NAME = 8,
  __LC_ADDRESS = 9,
  __LC_TELEPHONE = 10,
  __LC_MEASUREMENT = 11,
  __LC_IDENTIFICATION = 12
};
extern char *setlocale (int __category, __const char *__locale) ;
void goto_buffer (exarg_T *eap, int start, int dir, int count);
void do_debug (char_u *cmd);
void dbg_check_breakpoint (exarg_T *eap);
char_u *getsourceline (int c, void *cookie, int indent);
void do_finish (exarg_T *eap, int reanimate);
void alist_new (void);
void alist_set (alist_T *al, int count, char_u **files, int use_curbuf);
extern int debug_break_level ;
extern char_u e_noname[] ;
int buflist_add (char_u *fname, int flags);
int cmd_runtime (char_u *name, int all);
void dialog_changed (buf_T *buf, int checkall);





typedef char Boolean;
typedef void (*GPrintFunc) (const gchar *string);
typedef char *String;
typedef void (*GErrorFunc) (const gchar *str);
typedef void (*GWarningFunc) (const gchar *str);
typedef void (*XtErrorHandler)(

  String

);
typedef Boolean (*XtFilePredicate)(

   String

);
int do_in_runtimepath (char_u *name, int all, void (*callback)(char_u *fname));
int aborting (void);
void foldUpdateAll (win_T *win);
int do_source (char_u *fname, int check_other, int is_vimrc);
int expand_filename (exarg_T *eap, char_u **cmdlinep, char_u **errormsgp);
extern size_t fread (void *__restrict __ptr, size_t __size,
                     size_t __n, FILE *__restrict __stream) ;
char_u *getexline (int c, void *dummy, int indent);
int setmark (int c);
void screen_fill (int start_row, int end_row, int start_col, int end_col, int c1, int c2, int attr);
void settmode (int tmode);
extern int fprintf (FILE *__restrict __stream,
                    __const char *__restrict __format, ...) ;
void win_goto (win_T *wp);
typedef struct
{
    const char *name;
    int hasnum;
    long number;
    char_u *string;
    int strlen;
    int present;
} option_table_T;
extern char_u e_nomatch2[] ;
extern char_u e_notopen[] ;
extern int ex_normal_busy ;
extern int listcmd_busy ;
extern int no_check_timestamps ;
extern char_u *p_bg;
extern int redir_off ;
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,

    KS_CSV,

    KS_OP
};
extern char_u *(term_strings[]);
struct msglist
{
    char_u *msg;
    char_u *throw_msg;
    struct msglist *next;
};
typedef struct vim_exception except_T;
void write_viminfo (char_u *file, int forceit);
void alist_init (alist_T *al);
void alist_add (alist_T *al, char_u *fname, int set_fnum);
void scroll_start (void);
struct vim_exception
{
    int type;
    char_u *value;
    struct msglist *messages;
    char_u *throw_name;
    linenr_T throw_lnum;
    except_T *caught;
};
int ask_yesno (char_u *str, int direct);
void beep_flush (void);
void do_ascii (exarg_T *eap);
void ex_help (exarg_T *eap);
void do_sleep (long msec);
void opFoldRange (linenr_T first, linenr_T last, int opening, int recurse, int had_visual);
int foldManualAllowed (int create);
void foldCreate (linenr_T start, linenr_T end);
void checkpcmark (void);
int check_mark (pos_T *pos);
void goto_byte (long cnt);
void op_shift (oparg_T *oap, int curs_top, int amount);
int do_execreg (int regname, int colon, int addcr);
void do_do_join (long count, int insert_space);
void u_undo (int count);
void u_redo (int count);
void do_window (int nchar, long Prenum, int xchar);
extern int did_syncbind ;
void clear_oparg (oparg_T *oap);
void scrollup (long line_count, int byfold);
void cursor_correct (void);


extern int mkdir (__const char *__path, __mode_t __mode) ;
int do_doautocmd (char_u *arg, int do_msg);
extern char_u *autocmd_fname ;
extern int autocmd_bufnr ;
extern char_u *autocmd_match ;
void mch_restore_title (int which);
void do_fixdel (exarg_T *eap);
extern long p_mmd;
void update_topline_cursor (void);
int do_map (int maptype, char_u *arg, int mode, int abbrev);
int do_search (oparg_T *oap, int dirc, char_u *pat, long count, int options);
void ex_cclose (exarg_T *eap);
void ex_copen (exarg_T *eap);
int find_ident_under_cursor (char_u **string, int find_type);
char_u *file_name_at_cursor (int options, long count);
extern int fputs (__const char *__restrict __s, FILE *__restrict __stream)
            ;
int read_viminfo (char_u *file, int want_info, int want_marks, int forceit);
char_u *get_crypt_key (int store, int twice);
int ins_typebuf (char_u *str, int noremap, int offset, int nottyped, int silent);
int mch_has_wildcard (char_u *p);
int msg_outtrans_special (char_u *strstart, int from);
long getdigits (char_u **pp);
void normal_cmd (oparg_T *oap, int toplevel);
int valid_yank_reg (int regname, int writing);
int op_delete (oparg_T *oap);
int op_yank (oparg_T *oap, int deleting, int mess);
void out_char (unsigned c);
void prepare_tagpreview (void);
void scrolldown (long line_count, int byfold);
void shell_resized (void);
int typebuf_typed (void);
int getfile (int fnum, char_u *ffname, char_u *sfname, int setpm, linenr_T lnum, int forceit);


extern Window clientWindow ;
extern char_u e_cmdwin[] ;
extern char_u e_invrange[] ;
extern char_u e_modifiable[] ;
extern int finish_op ;
extern int no_hlsearch ;
extern char_u *p_sh;
extern FILE *redir_fd ;
extern int redir_reg ;
extern int searchcmdlen;
extern typebuf_T typebuf



                    ;
extern int virtual_op ;
int inchar (char_u *buf, int maxlen, long wait_time);
void add_map (char_u *map, int mode);
extern int maptick ;
void clip_copy_modeless_selection (int both);
int get_digraph (int cmdline);
int get_mouse_button (int code, int *is_click, int *is_drag);
void clip_modeless (int button, int is_click, int is_drag);
void compute_cmdrow (void);
int get_list_range (char_u **str, int *num1, int *num2);
void main_loop (int cmdwin);
void getvcol (win_T *wp, pos_T *pos, colnr_T *start, colnr_T *cursor, colnr_T *end);
int mouse_model_popup (void);
void msg_check (void);
int msg_outtrans_len (char_u *str, int len);
void redrawcmdline (void);



typedef unsigned long Atom;
typedef gulong GdkAtom;
typedef struct VimClipboard
{
    int available;
    int owned;
    pos_T start;
    pos_T end;
    int vmode;


    short_u origin_row;
    short_u origin_start_col;
    short_u origin_end_col;
    short_u word_start_col;
    short_u word_end_col;

    pos_T prev;
    short_u state;
    short_u mode;


    Atom sel_atom;



    GdkAtom gtk_sel_atom;
} VimClipboard;
void handle_swap_exists (buf_T *old_curbuf);
typedef struct _GdkIC GdkIC;


extern VimClipboard clip_star;
extern int quit_more ;
void do_outofmem_msg (long_u size);
extern int dup (int __fd) ;
int foldmethodIsManual (win_T *wp);
void gui_write (char_u *s, int len);
int match_file_list (char_u *list, char_u *sfname, char_u *ffname);
char_u *home_replace_save (buf_T *buf, char_u *src);
int path_with_url (char_u *fname);
void screenclear (void);
int update_keys (int c);


extern ssize_t write (int __fd, __const void *__buf, size_t __n) ;
extern char_u *keep_msg ;
int foldmethodIsMarker (win_T *wp);
void closeFold (linenr_T lnum, long count);
char_u *lalloc (long_u size, int message);


long foldedCount (win_T *win, linenr_T lnum, foldinfo_T *infop);
void set_vim_var_nr (int idx, long val);
int add_termcap_entry (char_u *name, int force);
extern int postponed_mouseshape ;
extern int did_outofmem_msg ;
int fix_input_buffer (char_u *buf, int len, int script);
int check_termcode (int max_offset, char_u *buf, int buflen);
int curwin_col_off (void);
void maketitle (void);
void del_typebuf (int len, int offset);
void flush_buffers (int typeahead);
int get_keystroke (void);
int get_real_state (void);
void ml_sync_all (int check_file, int check_char);
void stuffReadbuffLen (char_u *s, long len);
int ui_inchar (char_u *buf, int maxlen, long wtime);
void update_mouseshape (int shape_idx);
void updatescript (int c);
void map_clear_int (buf_T *buf, int mode, int local, int abbr);
typedef struct VimMenu vimmenu_T;
struct VimMenu
{
    int modes;
    int enabled;
    char_u *name;
    char_u *dname;
    int mnemonic;
    char_u *actext;
    int priority;

    void (*cb)();


    char_u *iconfile;
    int iconidx;
    int icon_builtin;

    char_u *strings[6];
    int noremap[6];
    char silent[6];
    vimmenu_T *children;
    vimmenu_T *parent;
    vimmenu_T *next;





    GtkWidget *id;
    GtkWidget *submenu_id;
    GtkWidget *tearoff_handle;
    GtkWidget *label;
};
extern int Exec_reg ;
extern int KeyStuffed;


extern vimmenu_T *current_menu;
extern int did_swapwrite_msg ;
extern int mapped_ctrl_c ;
extern int vgetc_im_active;
extern int redo_VIsual_busy ;
extern int pipe (int __pipedes[2]) ;
extern void _exit (int __status) __attribute__ ((__noreturn__));
extern __pid_t setsid (void) ;
extern __pid_t fork (void) ;
extern long p_ut;
int has_cursorhold (void);
int mch_dirname (char_u *buf, int len);
void add_to_input_buf (char_u *s, int len);
int check_col (int col);
int check_row (int row);
void clip_init (int can_use);
int del_bytes (long count, int fixpos);
void mch_settitle (char_u *title, char_u *icon);
int process_env (char_u *env, int is_viminit);
void termcapinit (char_u *name);
int gui_init_check (void);
void netbeans_startup_done (void);
void gui_mch_flush (void);
void gui_undraw_cursor (void);
int input_available (void);
extern int isatty (int __fd) ;
int leftcol_changed (void);
void mch_errmsg (char *str);
void out_str (char_u *s);
extern unsigned *LineOffset ;
extern char_u *ScreenAttrs ;
extern int drag_status_line ;
extern int drag_sep_line ;
extern garray_T error_ga



        ;
extern int full_screen ;
extern FILE *stderr;
extern int newline_on_exit ;
extern vimmenu_T *root_menu ;
extern int sys_menu ;
typedef struct argentry
{
    char_u *ae_fname;
    int ae_fnum;
} aentry_T;
char_u *alist_name (aentry_T *aep);
int menu_is_menubar (char_u *name);
int menu_is_popup (char_u *name);
int menu_is_toolbar (char_u *name);
void gui_menu_cb (vimmenu_T *menu);
int menu_is_separator (char_u *name);


typedef struct _GdkRectangle GdkRectangle;
typedef enum
{
  GDK_EXPOSURE_MASK = 1 << 1,
  GDK_POINTER_MOTION_MASK = 1 << 2,
  GDK_POINTER_MOTION_HINT_MASK = 1 << 3,
  GDK_BUTTON_MOTION_MASK = 1 << 4,
  GDK_BUTTON1_MOTION_MASK = 1 << 5,
  GDK_BUTTON2_MOTION_MASK = 1 << 6,
  GDK_BUTTON3_MOTION_MASK = 1 << 7,
  GDK_BUTTON_PRESS_MASK = 1 << 8,
  GDK_BUTTON_RELEASE_MASK = 1 << 9,
  GDK_KEY_PRESS_MASK = 1 << 10,
  GDK_KEY_RELEASE_MASK = 1 << 11,
  GDK_ENTER_NOTIFY_MASK = 1 << 12,
  GDK_LEAVE_NOTIFY_MASK = 1 << 13,
  GDK_FOCUS_CHANGE_MASK = 1 << 14,
  GDK_STRUCTURE_MASK = 1 << 15,
  GDK_PROPERTY_CHANGE_MASK = 1 << 16,
  GDK_VISIBILITY_NOTIFY_MASK = 1 << 17,
  GDK_PROXIMITY_IN_MASK = 1 << 18,
  GDK_PROXIMITY_OUT_MASK = 1 << 19,
  GDK_SUBSTRUCTURE_MASK = 1 << 20,
  GDK_ALL_EVENTS_MASK = 0x0FFFFF
} GdkEventMask;
struct _GdkRectangle
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
typedef struct _GdkPoint GdkPoint;
typedef struct _GdkICAttr GdkICAttr;
typedef enum
{
  GDK_IM_PREEDIT_AREA = 0x0001,
  GDK_IM_PREEDIT_CALLBACKS = 0x0002,
  GDK_IM_PREEDIT_POSITION = 0x0004,
  GDK_IM_PREEDIT_NOTHING = 0x0008,
  GDK_IM_PREEDIT_NONE = 0x0010,
  GDK_IM_PREEDIT_MASK = 0x001f,

  GDK_IM_STATUS_AREA = 0x0100,
  GDK_IM_STATUS_CALLBACKS = 0x0200,
  GDK_IM_STATUS_NOTHING = 0x0400,
  GDK_IM_STATUS_NONE = 0x0800,
  GDK_IM_STATUS_MASK = 0x0f00
} GdkIMStyle;
struct _GdkPoint
{
  gint16 x;
  gint16 y;
};
struct _GdkICAttr
{
  GdkIMStyle style;
  GdkWindow *client_window;
  GdkWindow *focus_window;
  GdkEventMask filter_events;
  GdkPoint spot_location;
  gint line_spacing;
  GdkCursor *cursor;

  GdkFont *preedit_fontset;
  GdkRectangle preedit_area;
  GdkRectangle preedit_area_needed;
  GdkColor preedit_foreground;
  GdkColor preedit_background;
  GdkPixmap *preedit_pixmap;
  GdkColormap *preedit_colormap;

  GdkFont *status_fontset;
  GdkRectangle status_area;
  GdkRectangle status_area_needed;
  GdkColor status_foreground;
  GdkColor status_background;
  GdkPixmap *status_pixmap;
  GdkColormap *status_colormap;
};


typedef gint gboolean;
typedef const void *gconstpointer;
typedef void (*__gconv_trans_end_fct) (void *);
typedef int __io_close_fn (void *__cookie);
typedef gpointer (*GCacheNewFunc) (gpointer key);
typedef gpointer (*GCacheDupFunc) (gpointer value);
typedef void (*GCacheDestroyFunc) (gpointer value);
typedef gchar* (*GCompletionFunc) (gpointer);
typedef void (*GDestroyNotify) (gpointer data);
typedef guint (*GHashFunc) (gconstpointer key);
typedef void (*GFreeFunc) (gpointer data);
typedef void (*GHookFunc) (gpointer data);
typedef gboolean (*GHookCheckFunc) (gpointer data);
typedef gboolean (*GSourceFunc) (gpointer data);
typedef void (*GdkDestroyNotify) (gpointer data);
typedef void (*GtkClassInitFunc) (gpointer klass);
typedef gint (*GtkFunction) (gpointer data);


typedef void (*GtkDestroyNotify) (gpointer data);
typedef unsigned long Time;
typedef XID Drawable;
typedef XID Colormap;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;





} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;

        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;




        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;



        int new;

        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
extern int XFree(

    void*

);
typedef unsigned int Cardinal;
void preserve_exit (void);
void clip_lose_selection (VimClipboard *cbd);
int vim_is_input_buf_full (void);
void gui_mch_menu_hidden (vimmenu_T *menu, int hidden);
extern void *memcpy (void *__restrict __dest,
                     __const void *__restrict __src, size_t __n) ;
extern int printf (__const char *__restrict __format, ...) ;


void serverEventProc (Display *dpy, XEvent *eventPtr);
extern Window commWindow ;
extern Atom commProperty ;
int serverRegisterName (Display *dpy, char_u *name);
int simplify_key (int key, int *modifiers);
typedef unsigned long VisualID;
typedef char *XPointer;
typedef struct _XGC *GC;
typedef struct _XExtData {
        int number;
        struct _XExtData *next;
        int (*free_private)(

        struct _XExtData *extension

        );
        XPointer private_data;
} XExtData;
typedef struct {
        XExtData *ext_data;
        VisualID visualid;



        int class;

        unsigned long red_mask, green_mask, blue_mask;
        int bits_per_rgb;
        int map_entries;
} Visual;
typedef struct {
        XExtData *ext_data;
        int depth;
        int bits_per_pixel;
        int scanline_pad;
} ScreenFormat;
typedef struct {
        int depth;
        int nvisuals;
        Visual *visuals;
} Depth;
typedef struct {
        XExtData *ext_data;
        struct _XDisplay *display;
        Window root;
        int width, height;
        int mwidth, mheight;
        int ndepths;
        Depth *depths;
        int root_depth;
        Visual *root_visual;
        GC default_gc;
        Colormap cmap;
        unsigned long white_pixel;
        unsigned long black_pixel;
        int max_maps, min_maps;
        int backing_store;
        int save_unders;
        long root_input_mask;
} Screen;
typedef struct



{
        XExtData *ext_data;
        struct _XPrivate *private1;
        int fd;
        int private2;
        int proto_major_version;
        int proto_minor_version;
        char *vendor;
        XID private3;
        XID private4;
        XID private5;
        int private6;
        XID (*resource_alloc)(

                struct _XDisplay*

        );
        int byte_order;
        int bitmap_unit;
        int bitmap_pad;
        int bitmap_bit_order;
        int nformats;
        ScreenFormat *pixmap_format;
        int private8;
        int release;
        struct _XPrivate *private9, *private10;
        int qlen;
        unsigned long last_request_read;
        unsigned long request;
        XPointer private11;
        XPointer private12;
        XPointer private13;
        XPointer private14;
        unsigned max_request_size;
        struct _XrmHashBucketRec *db;
        int (*private15)(

                struct _XDisplay*

                );
        char *display_name;
        int default_screen;
        int nscreens;
        Screen *screens;
        unsigned long motion_buffer;
        unsigned long private16;
        int min_keycode;
        int max_keycode;
        XPointer private17;
        XPointer private18;
        int private19;
        char *xdefaults;

}



*_XPrivDisplay;
extern VimClipboard clip_plus;
extern FILE *stdout;


extern int XFlush(

    Display*

);
extern Atom XInternAtom(

    Display* ,
    const char* ,
    int

);
typedef void* XtPointer;
extern int XSync(

    Display* ,
    int

);
extern int sscanf (__const char *__restrict __s,
                   __const char *__restrict __format, ...) ;


typedef long int __suseconds_t;
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
void ml_recover (void);
int gui_wait_for_chars (long wtime);
void init_highlight (int both, int reset);
void list_version (void);
extern char *longVersion;
void mch_exit (int r);
int win_count (void);
void win_equal (win_T *next_curwin, int current, int dir);
void screen_start (void);
void screenalloc (int clear);
void scroll_region_reset (void);
int term_is_gui (char_u *name);
int ui_get_shellsize (void);
void update_curbuf (int type);
char_u *vim_strsave_up (char_u *string);
typedef struct _XtAppStruct *XtAppContext;
int buflist_getfile (int n, linenr_T lnum, int options, int forceit);
int findpar (oparg_T *oap, int dir, long count, int what, int both);
int findsent (int dir, long count);
int can_clear (char_u *p);
int screen_del_lines (int off, int row, int line_count, int end, int force, win_T *wp);
extern int lcs_tab2 ;
extern int lcs_trail ;
char_u *get_var_value (char_u *name);
extern int termcap_active ;
void screen_puts_len (char_u *text, int len, int row, int col, int attr);
int screen_valid (int clear);
extern int called_emsg;
extern int did_wait_return ;
extern int do_redraw ;
extern int lcs_eol ;



extern int fseek (FILE *__stream, long int __off, int __whence) ;
extern long int ftell (FILE *__stream) ;
extern int setenv (__const char *__name, __const char *__value, int __replace)
            ;
struct passwd
{
  char *pw_name;
  char *pw_passwd;
  __uid_t pw_uid;
  __gid_t pw_gid;
  char *pw_gecos;
  char *pw_dir;
  char *pw_shell;
};
int mch_has_exp_wildcard (char_u *p);
void ml_close_all (int del_file);
void addfile (garray_T *gap, char_u *f, int flags);
int coladvance_force (colnr_T wcol);
int file_ff_differs (buf_T *buf);
pos_T *findmatchlimit (oparg_T *oap, int initc, int flags, int maxtravel);
void alist_unlink (alist_T *al);
extern alist_T global_alist;
int get_expr_indent (void);
void showmatch (void);
char_u *ml_get_pos (pos_T *pos);
int plines_win (win_T *wp, linenr_T lnum, int winheight);
int plines_win_nofill (win_T *wp, linenr_T lnum, int winheight);
int win_linetabsize (win_T *wp, char_u *p, colnr_T len);
int inc (pos_T *lp);
extern void *malloc (size_t __size) __attribute__ ((__malloc__));
void msg_puts_title (char_u *s);
extern long p_siso;
int plines (linenr_T lnum);
extern int mouse_dragging ;
void validate_virtcol_win (win_T *wp);
void set_empty_rows (win_T *wp, int used);
int win_ins_lines (win_T *wp, int row, int line_count, int invalid, int mayclear);
int win_del_lines (win_T *wp, int row, int line_count, int invalid, int mayclear);


typedef struct cmdarg
{
    oparg_T *oap;
    int prechar;
    int cmdchar;
    int nchar;




    int extra_char;
    long opcount;
    long count0;
    long count1;
    int arg;
    int retval;
    char_u *searchbuf;
} cmdarg_T;
extern int clip_unnamed ;
int edit (int cmdchar, int startln, long count);
void do_pending_operator (cmdarg_T *cap, int old_col, int gui_yank);
void adjust_clip_reg (int *rp);
int swapchar (int op_type, pos_T *pos);
void check_visual_highlight (void);
void end_visual_mode (void);
void may_start_select (int c);
extern int mouse_past_bottom ;
extern int mouse_past_eol ;
char_u *find_file_name_in_path (char_u *ptr, int len, int options, long count, char_u *rel_fname);
int gchar_pos (pos_T *pos);
void getvcols (win_T *wp, pos_T *pos1, pos_T *pos2, colnr_T *left, colnr_T *right);
void reset_VIsual_and_resel (void);
void syn_stack_free_all (buf_T *buf);
extern char_u *p_mousem;
char_u *msg_trunc_attr (char_u *s, int force, int attr);
void set_last_search_pat (char_u *s, int idx, int magic, int setlast);
int startPS (linenr_T lnum, int para, int both);
extern char_u e_noprevre[] ;
void update_topline_redraw (void);




typedef struct {
    unsigned char *value;
    Atom encoding;
    int format;
    unsigned long nitems;
} XTextProperty;
typedef struct _WidgetRec *Widget;
extern Boolean XtDispatchEvent(

    XEvent*

);
void mch_delay (long msec, int ignoreinput);
int read_from_input_buf (char_u *buf, long maxlen);
void fill_input_buf (int exit_on_error);
extern int read_cmd_fd ;
extern XtAppContext app_context ;



struct timezone
  {
    int tz_minuteswest;
    int tz_dsttime;
  };
typedef struct timezone *__restrict __timezone_ptr_t;
extern char_u *p_mouse;
int vim_is_xterm (char_u *name);
int use_xterm_mouse (void);
int vim_is_iris (char_u *name);
void mch_setmouse (int on);
int term_is_8bit (char_u *name);
void out_str_nf (char_u *s);
typedef unsigned int speed_t;
extern int gettimeofday (struct timeval *__restrict __tv,
                         __timezone_ptr_t __tz) ;
void restore_cterm_colors (void);
extern long p_wd;
extern int cur_tmode ;
void free_string_option (char_u *p);
extern char_u *empty_option ;
extern win_T *prevwin ;
void unref_extmatch (reg_extmatch_T *em);
extern int reg_syn ;
extern int reg_do_extmatch ;
extern reg_extmatch_T *re_extmatch_in ;
extern reg_extmatch_T *re_extmatch_out ;
extern int p_hls;
char_u *file_name_in_line (char_u *line, int col, int options, long count, char_u *rel_fname);
void give_warning (char_u *message, int hl);
void redraw_later (int type);
void resettitle (void);
