typedef unsigned char char_u;
char_u *FullName_save (char_u *fname, int force);
int aborting (void);
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
typedef struct
{
    buf_T *save_buf;
    buf_T *new_curbuf;
    win_T *save_curwin;
    win_T *new_curwin;
    pos_T save_cursor;
    linenr_T save_topline;
    int save_topfill;
} aco_save_T;
void aucmd_prepbuf (aco_save_T *aco, buf_T *buf);
void aucmd_restbuf (aco_save_T *aco);
int bt_dontwrite (buf_T *buf);
int bt_nofile (buf_T *buf);
extern int readonlymode ;
int bufIsChanged (buf_T *buf);
int buf_check_timestamp (buf_T *buf, int focus);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
void buf_setino (buf_T *buf);
int prep_exarg (exarg_T *eap, buf_T *buf);
void ml_timestamp (buf_T *buf);
void status_redraw_all (void);
void u_clearall (buf_T *buf);
void u_blockfree (buf_T *buf);
extern int autocmd_no_enter ;
extern int autocmd_no_leave ;
extern int netbeansFireChanges ;
int buf_valid (buf_T *buf);
buf_T *buflist_new (char_u *ffname, char_u *sfname, linenr_T lnum, int flags);
void check_cursor_lnum (void);
void do_modelines (void);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
void expand_env (char_u *src, char_u *dst, int dstlen);
char_u *file_pat_to_reg_pat (char_u *pat, char_u *pat_end, char *allow_dirs, int no_bslash);
void foldUpdateAll (win_T *win);
int get_fileformat (buf_T *buf);
char_u *gettail (char_u *fname);
void home_replace (buf_T *buf, char_u *src, char_u *dst, int dstlen, int one);
char_u *home_replace_save (buf_T *buf, char_u *src);
char_u *lalloc (long_u size, int message);
int mch_dirname (char_u *buf, int len);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int ml_delete (linenr_T lnum, int message);
char_u *ml_get (linenr_T lnum);
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
int ml_open (void);int msg (char_u *s);
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_puts_title (char_u *s);
void msg_start (void);
char_u *msg_trunc_attr (char_u *s, int force, int attr);
void out_flush (void);
int readfile (char_u *fname, char_u *sfname, linenr_T from, linenr_T lines_to_skip, linenr_T lines_to_read, exarg_T *eap, int flags);
void save_file_ff (buf_T *buf);
void set_keep_msg (char_u *s);
char_u *shorten_fname (char_u *full_path, char_u *dir_name);
int shortmess (int x);
char_u *skipwhite (char_u *p);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
typedef __u_int __mode_t;
typedef long int __off_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void ui_breakcheck (void);
void ui_delay (long msec, int ignoreinput);
void unchanged (buf_T *buf, int ff);void vim_free (void *x);
int vim_ispathsep (int c);
regprog_T *vim_regcomp (char_u *expr, int re_flags);
typedef struct
{
    regprog_T *regprog;
    char_u *startp[10];
    char_u *endp[10];
    int rm_ic;
} regmatch_T;
int vim_regexec (regmatch_T *rmp, char_u *line, colnr_T col);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
int win_valid (win_T *win);
void wipe_buffer (buf_T *buf, int aucmd);
extern char_u *IObuff;
extern char_u *NameBuff;
extern int RedrawingDisabled ;
extern int State ;
extern int autocmd_block ;
extern int cmdline_row;
extern buf_T *curbuf ;
typedef int scid_T;
extern scid_T current_SID ;
extern win_T *curwin;
extern int emsg_silent ;
extern buf_T *firstbuf ;
extern win_T *firstwin;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int keep_msg_attr ;
extern int msg_row;
extern int msg_scroll ;
extern int msg_scrolled;
extern int need_maketitle ;
extern int need_mouse_correct ;
extern int need_wait_return ;
extern char_u *p_cpo;
extern int restart_edit ;
extern linenr_T sourcing_lnum ;
extern char_u *sourcing_name ;
extern int swap_exists_action ;
int ga_grow (garray_T *gap, int n);
void check_cursor (void);
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
extern int strcasecmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern int unlink (__const char *__name) ;
char_u *vim_strnsave (char_u *string, int len);
extern char_u *vim_tempdir ;
extern int msg_col;
void FreeWild (int count, char_u **files);
void beginline (int flags);
void check_for_delay (int check_msg_scroll);
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
void line_breakcheck (void);
int msg_attr (char_u *s, int attr);
void redraw_curbuf_later (int type);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
int stuff_empty (void);
void update_topline (void);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
typedef struct expand
{
    int xp_context;
    char_u *xp_pattern;
    char_u *xp_arg;
    int xp_backslash;
} expand_T;
extern int need_check_timestamps ;
extern int did_check_timestamps ;
extern int global_busy ;
extern int redraw_cmdline ;
extern int access (__const char *__name, int __type) ;
void add_pathsep (char_u *p);
void appended_lines_mark (linenr_T lnum, long count);
int check_secure (void);
int do_cmdline (char_u *cmdline, char_u *(*getline)(int, void *, int), void *cookie, int flags);
int do_dialog (int type, char_u *title, char_u *message, char_u *buttons, int dfltbutton, char_u *textfield);
char_u *expand_env_save (char_u *src);
long mch_getperm (char_u *name);
int mch_isFullName (char_u *fname);
int mch_isdir (char_u *name);
void msg_clr_eos (void);
int msg_end (void);
void msg_str (char_u *s, char_u *arg);
void saveRedobuff (void);
void restoreRedobuff (void);
void save_search_patterns (void);
void restore_search_patterns (void);
void *save_funccal (void);
void restore_funccal (void *fc);
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
char_u *skiptowhite (char_u *p);
typedef __time_t time_t;
extern time_t time (time_t *__timer) ;
int vim_rename (char_u *from, char_u *to);
extern int did_filetype ;
extern int no_wait_return ;
extern long p_verbose;
extern int starting ;
char_u *buf_modname (int shortname, char_u *fname, char_u *ext, int prepend_dot);
void check_lnums (int do_curwin);
extern __mode_t umask (__mode_t __mask) ;
extern int chown (__const char *__file, __uid_t __owner, __gid_t __group)
            ;
extern __gid_t getgid (void) ;
int mch_setperm (char_u *name, long perm);
void diff_invalidate (void);
int should_abort (int retcode);
void set_fileformat (int t, int opt_flags);
int default_fileformat (void);
int gen_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
int get_viminfo_parameter (int type);
extern __uid_t getuid (void) ;
int otherfile (char_u *ffname);
int setfname (char_u *ffname, char_u *sfname, int message);
void starttermcap (void);
void u_clearline (void);
int vim_fexists (char_u *fname);
extern char_u e_argreq[] ;
typedef __mode_t mode_t;
extern int autocmd_busy ;
extern char_u e_interr[] ;
extern int exiting ;
extern int exmode_active ;
extern int msg_scrolled_ign ;
extern int msg_silent ;
extern char_u *p_ffs;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern char *fgets (char *__restrict __s, int __n, FILE *__restrict __stream)
            ;
void settmode (int tmode);
extern int no_check_timestamps ;
extern char_u *p_ei;
int ask_yesno (char_u *str, int direct);
extern int mkdir (__const char *__path, __mode_t __mode) ;
int do_doautocmd (char_u *arg, int do_msg);
extern char_u *autocmd_fname ;
extern int autocmd_bufnr ;
extern char_u *autocmd_match ;
int read_viminfo (char_u *file, int want_info, int want_marks, int forceit);
char_u *get_crypt_key (int store, int twice);
void ml_preserve (buf_T *buf, int message);
extern int recoverymode ;
int msg_outtrans_attr (char_u *str, int attr);
int typebuf_typed (void);
int vim_FullName (char_u *fname, char_u *buf, int len, int force);
extern int *__errno_location (void) __attribute__ ((__const__));
typedef void *vim_acl_T;
extern int rename (__const char *__old, __const char *__new) ;
extern int fchown (int __fd, __uid_t __owner, __gid_t __group) ;
extern int rmdir (__const char *__path) ;
extern int p_ar;
extern int p_bk;
extern char_u *p_bkc;
extern char_u *p_bdir;
extern char_u *p_bex;
extern char_u *p_bsk;
extern char_u *p_pm;
extern int p_wb;
vim_acl_T mch_get_acl (char_u *fname);
void mch_set_acl (char_u *fname, vim_acl_T aclent);
void mch_free_acl (vim_acl_T aclent);
int mch_nodetype (char_u *name);
int buf_contents_changed (buf_T *buf);
char_u *set_cmdarg (exarg_T *eap, char_u *oldarg);
char_u *expand_sfile (char_u *arg);
void filemess (buf_T *buf, char_u *name, char_u *s, int attr);
int match_file_pat (char_u *pattern, char_u *fname, char_u *sfname, char_u *tail, int allow_dirs);
void mf_fullname (memfile_T *mfp);
void check_need_swap (int newfile);
int get_fileformat_force (buf_T *buf, exarg_T *eap);
int decrypt_byte (void);
void crypt_init_keys (char_u *passwd);
void u_unchanged (buf_T *buf);
void netbeans_saved (buf_T *bufp);
extern int keep_filetype ;
extern char_u e_longname[] ;
struct utimbuf
  {
    __time_t actime;
    __time_t modtime;
  };
struct bw_info
{
    int bw_fd;
    char_u *bw_buf;
    int bw_len;
    int bw_flags;
};
typedef struct AutoCmd
{
    char_u *cmd;
    char nested;
    char last;
    scid_T scriptID;
    struct AutoCmd *next;
} AutoCmd;
extern int utime (__const char *__file,
                  __const struct utimbuf *__file_times) ;
typedef struct AutoPat
{
    int group;
    char_u *pat;
    int patlen;
    char_u *reg_pat;
    char allow_dirs;
    char last;
    AutoCmd *cmds;
    struct AutoPat *next;
} AutoPat;
typedef struct AutoPatCmd
{
    AutoPat *curpat;
    AutoCmd *nextcmd;
    int group;
    char_u *fname;
    char_u *sfname;
    char_u *tail;
    EVENT_T event;
} AutoPatCmd;
void buf_store_time (buf_T *buf, struct stat *st, char_u *fname);
char_u *get_file_in_dir (char_u *fname, char_u *dname);
extern int close (int __fd) ;
void do_outofmem_msg (long_u size);
extern int dup (int __fd) ;
int foldmethodIsManual (win_T *wp);
void gui_write (char_u *s, int len);
typedef __off_t off_t;
extern __off_t lseek (int __fd, __off_t __offset, int __whence) ;
extern int lstat (__const char *__restrict __file,
                  struct stat *__restrict __buf) ;
int match_file_list (char_u *list, char_u *sfname, char_u *ffname);
long mch_get_pid (void);
void mch_msg (char *str);
char_u *msg_may_trunc (int force, char_u *s);
extern int open (__const char *__file, int __oflag, ...) ;
int path_with_url (char_u *fname);
void screenclear (void);
int update_keys (int c);
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
extern ssize_t write (int __fd, __const void *__buf, size_t __n) ;
typedef __uid_t uid_t;
extern char_u *keep_msg ;
static void check_marks_read (void);
static char_u *check_for_cryptkey (char_u *cryptkey, char_u *ptr, long *sizep, long *filesizep, int newfile);
static void set_file_time (char_u *fname, time_t atime, time_t mtime);
static void msg_add_fname (buf_T *, char_u *);
static int msg_add_fileformat (int eol_type);
static void msg_add_lines (int, long, long);
static void msg_add_eol (void);
static int check_mtime (buf_T *buf, struct stat *s);
static int time_differs (long t1, long t2);
static int apply_autocmds_exarg (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf, exarg_T *eap);
static int buf_write_bytes (struct bw_info *ip);
static int move_lines (buf_T *frombuf, buf_T *tobuf);
static linenr_T write_no_eol_lnum = 0;
    void filemess(buf, name, s, attr)
    buf_T *buf;
    char_u *name;
    char_u *s;
    int attr;
{
    int msg_scroll_save;
    if (msg_silent != 0)
        return;
    msg_add_fname(buf, name);
    if (strlen((char *)(IObuff)) > (1024+1) - 80)
        IObuff[(1024+1) - 80] = '\000';
    strcat((char *)(IObuff), (char *)(s));
    msg_scroll_save = msg_scroll;
    if (shortmess('O') && !exiting && p_verbose == 0)
        msg_scroll = 0;
    if (!msg_scroll)
        check_for_delay(0);
    msg_start();
    msg_scroll = msg_scroll_save;
    msg_scrolled_ign = 1;
    msg_outtrans_attr(msg_may_trunc(0, IObuff), attr);
    msg_clr_eos();
    out_flush();
    msg_scrolled_ign = 0;
}
    int readfile(fname, sfname, from, lines_to_skip, lines_to_read, eap, flags)
    char_u *fname;
    char_u *sfname;
    linenr_T from;
    linenr_T lines_to_skip;
    linenr_T lines_to_read;
    exarg_T *eap;
    int flags;
{
    int fd = 0;
    int newfile = (flags & 0x01);
    int check_readonly;
    int filtering = (flags & 0x02);
    int read_stdin = (flags & 0x04);
    int read_buffer = (flags & 0x08);
    linenr_T read_buf_lnum = 1;
    colnr_T read_buf_col = 0;
    char_u c;
    linenr_T lnum = from;
    char_u *ptr = ((void *)0);
    char_u *buffer = ((void *)0);
    char_u *new_buffer = ((void *)0);
    char_u *line_start = ((void *)0);
    int wasempty;
    colnr_T len;
    long size = 0;
    char_u *p;
    long filesize = 0;
    int skip_read = 0;
    char_u *cryptkey = ((void *)0);
    int split = 0;
    linenr_T linecnt;
    int error = 0;
    int ff_error = -1;
    long linerest = 0;
    int perm = 0;
    int fileformat = 0;
    int keep_fileformat = 0;
    struct stat st;
    int file_readonly;
    linenr_T skip_count = 0;
    linenr_T read_count = 0;
    int msg_save = msg_scroll;
    linenr_T read_no_eol_lnum = 0;
    int try_mac = (vim_strchr(p_ffs, 'm') != ((void *)0));
    int try_dos = (vim_strchr(p_ffs, 'd') != ((void *)0));
    int try_unix = (vim_strchr(p_ffs, 'x') != ((void *)0));
    int file_rewind = 0;
    write_no_eol_lnum = 0;
    if (curbuf->b_ffname == ((void *)0)
            && !filtering
            && fname != ((void *)0)
            && vim_strchr(p_cpo, 'f') != ((void *)0)
            && !(flags & 0x10))
    {
        if (setfname(fname, sfname, 0) == 1)
            curbuf->b_flags |= 0x08;
    }
    if (sfname == ((void *)0))
        sfname = fname;
    fname = sfname;
    if (!filtering && !read_stdin && !read_buffer)
    {
        pos_T pos;
        pos = curbuf->b_op_start;
        curbuf->b_op_start.lnum = ((from == 0) ? 1 : from);
        curbuf->b_op_start.col = 0;
        if (newfile)
        {
            if (apply_autocmds_exarg(EVENT_BUFREADCMD, ((void *)0), sfname,
                                                          0, curbuf, eap))
                return aborting() ? 0 : 1;
        }
        else if (apply_autocmds_exarg(EVENT_FILEREADCMD, sfname, sfname,
                                                            0, ((void *)0), eap))
            return aborting() ? 0 : 1;
        curbuf->b_op_start = pos;
    }
    if ((shortmess('o') || curbuf->b_help) && p_verbose == 0)
        msg_scroll = 0;
    else
        msg_scroll = 1;
    if (fname != ((void *)0)
            && *fname != '\000'
            && (vim_ispathsep(*(fname + strlen((char *)(fname)) - 1))
                || strlen((char *)(fname)) >= 1024))
    {
        filemess(curbuf, fname, (char_u *)((char *)("Illegal file name")), 0);
        msg_end();
        msg_scroll = msg_save;
        return 0;
    }
    if (!read_stdin && !read_buffer)
    {
        perm = mch_getperm(fname);
        if (perm >= 0 && !((((perm)) & 0170000) == (0100000))
                      && !((((perm)) & 0170000) == (0010000))
                      && !((((perm)) & 0170000) == (0140000))
                                                )
        {
            if (((((perm)) & 0170000) == (0040000)))
                filemess(curbuf, fname, (char_u *)((char *)("is a directory")), 0);
            else
                filemess(curbuf, fname, (char_u *)((char *)("is not a file")), 0);
            msg_end();
            msg_scroll = msg_save;
            return 0;
        }
    }
    if (newfile)
    {
        if (eap != ((void *)0) && eap->force_ff != 0)
            set_fileformat(get_fileformat_force(curbuf, eap), 4);
        else if (*p_ffs != '\000')
            set_fileformat(default_fileformat(), 4);
    }
    check_readonly = (newfile && (curbuf->b_flags & 0x02));
    if (check_readonly && !readonlymode)
        curbuf->b_p_ro = 0;
    if (newfile && !read_stdin && !read_buffer)
    {
        if (stat(((char *)fname), (&st)) >= 0)
        {
            buf_store_time(curbuf, &st, fname);
            curbuf->b_mtime_read = curbuf->b_mtime;
            if (curbuf->b_ml.ml_mfp->mf_fname != ((void *)0))
                (void)mch_setperm(curbuf->b_ml.ml_mfp->mf_fname,
                                          (long)((st.st_mode & 0777) | 0600));
        }
        else
        {
            curbuf->b_mtime = 0;
            curbuf->b_mtime_read = 0;
            curbuf->b_orig_size = 0;
            curbuf->b_orig_mode = 0;
        }
        curbuf->b_flags &= ~(0x10 | 0x20);
    }
    file_readonly = 0;
    if (read_stdin)
    {
    }
    else if (!read_buffer)
    {
        if (
            !(perm & 0222) ||
                                access(((char *)fname), (2)))
            file_readonly = 1;
        fd = open(((char *)fname), (00 | 0), (0));
    }
    if (fd < 0)
    {
        msg_scroll = msg_save;
            if (newfile)
            {
                if (perm < 0)
                {
                    curbuf->b_flags |= 0x10;
                    if (!bt_dontwrite(curbuf))
                        check_need_swap(newfile);
                    filemess(curbuf, sfname, (char_u *)((char *)("[New File]")), 0);
                    check_marks_read();
                    apply_autocmds_exarg(EVENT_BUFNEWFILE, sfname, sfname,
                                                          0, curbuf, eap);
                    save_file_ff(curbuf);
                    if (aborting())
                        return 0;
                    return 1;
                }
                else
                {
                    filemess(curbuf, sfname,
                                       (char_u *)((char *)("[Permission Denied]")), 0);
                    curbuf->b_p_ro = 1;
                }
            }
        return 0;
    }
    if ((check_readonly && file_readonly) || curbuf->b_help)
        curbuf->b_p_ro = 1;
    if (newfile)
    {
        curbuf->b_p_eol = 1;
        curbuf->b_start_eol = 1;
    }
    if (!bt_dontwrite(curbuf))
        check_need_swap(newfile);
    if (swap_exists_action == 2)
    {
        if (!read_buffer && !read_stdin)
            close(fd);
        return 0;
    }
    ++no_wait_return;
    curbuf->b_op_start.lnum = ((from == 0) ? 1 : from);
    curbuf->b_op_start.col = 0;
    if (!read_buffer)
    {
        int m = msg_scroll;
        int n = msg_scrolled;
        buf_T *old_curbuf = curbuf;
        if (!read_stdin)
            close(fd);
        msg_scroll = 1;
        if (filtering)
            apply_autocmds_exarg(EVENT_FILTERREADPRE, ((void *)0), sfname,
                                                          0, curbuf, eap);
        else if (read_stdin)
            apply_autocmds_exarg(EVENT_STDINREADPRE, ((void *)0), sfname,
                                                          0, curbuf, eap);
        else if (newfile)
            apply_autocmds_exarg(EVENT_BUFREADPRE, ((void *)0), sfname,
                                                          0, curbuf, eap);
        else
            apply_autocmds_exarg(EVENT_FILEREADPRE, sfname, sfname,
                                                            0, ((void *)0), eap);
        if (msg_scrolled == n)
            msg_scroll = m;
        if (aborting())
        {
            --no_wait_return;
            msg_scroll = msg_save;
            curbuf->b_p_ro = 1;
            return 0;
        }
        if (!read_stdin && (curbuf != old_curbuf
                || (fd = open(((char *)fname), (00 | 0), (0))) < 0))
        {
            --no_wait_return;
            msg_scroll = msg_save;
            if (fd < 0)
                emsg((char_u *)(((char *)("E200: *ReadPre autocommands made the file unreadable"))));
            else
                emsg((char_u *)(((char *)("E201: *ReadPre autocommands must not change current buffer"))));
            curbuf->b_p_ro = 1;
            return 0;
        }
    }
    wasempty = (curbuf->b_ml.ml_flags & 1);
    if (!recoverymode && !filtering && !(flags & 0x10))
    {
        if (read_stdin)
        {
            mch_msg(((char *)("Vim: Reading from stdin...\n")));
            if (gui.in_use && !gui.dying && !gui.starting)
            {
                p = (char_u *)((char *)("Reading from stdin..."));
                gui_write(p, (int)strlen((char *)(p)));
            }
        }
        else if (!read_buffer)
            filemess(curbuf, sfname, (char_u *)"", 0);
    }
    msg_scroll = 0;
    linecnt = curbuf->b_ml.ml_line_count;
retry:
    if (file_rewind)
    {
        if (read_buffer)
        {
            read_buf_lnum = 1;
            read_buf_col = 0;
        }
        else if (read_stdin || lseek(fd, (off_t)0L, 0) != 0)
        {
            error = 1;
            goto failed;
        }
        while (lnum > from)
            ml_delete(lnum--, 0);
        file_rewind = 0;
    }
    if (keep_fileformat)
        keep_fileformat = 0;
    else
    {
        if (eap != ((void *)0) && eap->force_ff != 0)
            fileformat = get_fileformat_force(curbuf, eap);
        else if (curbuf->b_p_bin)
            fileformat = 0;
        else if (*p_ffs == '\000')
            fileformat = get_fileformat(curbuf);
        else
            fileformat = -1;
    }
    if (!skip_read)
    {
        linerest = 0;
        filesize = 0;
        skip_count = lines_to_skip;
        read_count = lines_to_read;
    }
    while (!error && !got_int)
    {
        {
            if (!skip_read)
            {
                size = 0x10000L;
                for ( ; size >= 10; size = (long_u)size >> 1)
                {
                    if ((new_buffer = lalloc((long_u)(size + linerest + 1),
                                                              0)) != ((void *)0))
                        break;
                }
                if (new_buffer == ((void *)0))
                {
                    do_outofmem_msg((long_u)(size * 2 + linerest + 1));
                    error = 1;
                    break;
                }
                if (linerest)
                    memmove((char *)(new_buffer), (char *)(ptr - linerest), (size_t)linerest);
                vim_free(buffer);
                buffer = new_buffer;
                ptr = buffer + linerest;
                line_start = buffer;
                if (read_buffer)
                {
                    if (read_buf_lnum > from)
                        size = 0;
                    else
                    {
                        int n;
                        long tlen;
                        tlen = 0;
                        for (;;)
                        {
                            p = ml_get(read_buf_lnum) + read_buf_col;
                            n = (int)strlen((char *)(p));
                            if ((int)tlen + n + 1 > size)
                            {
                                n = size - tlen;
                                memmove((char *)(ptr + tlen), (char *)(p), (size_t)n);
                                read_buf_col += n;
                                break;
                            }
                            else
                            {
                                memmove((char *)(ptr + tlen), (char *)(p), (size_t)n);
                                tlen += n;
                                ptr[tlen++] = '\012';
                                read_buf_col = 0;
                                if (++read_buf_lnum > from)
                                {
                                    if (!curbuf->b_p_eol)
                                        --tlen;
                                    size = tlen;
                                    break;
                                }
                            }
                        }
                    }
                }
                else
                {
                    size = read((fd), (char *)(ptr), (size_t) (size));
                }
                if (size <= 0)
                {
                    if (size < 0)
                        error = 1;
                }
                if (filesize == 0)
                    cryptkey = check_for_cryptkey(cryptkey, ptr, &size,
                                                          &filesize, newfile);
                if (cryptkey != ((void *)0) && size > 0)
                    for (p = ptr; p < ptr + size; ++p)
                        update_keys(*p ^= decrypt_byte());
            }
            skip_read = 0;
            if (size <= 0)
                break;
            filesize += size;
            if (fileformat == -1)
            {
                if (try_dos || try_unix)
                {
                    for (p = ptr; p < ptr + size; ++p)
                    {
                        if (*p == '\012')
                        {
                            if (!try_unix
                                    || (try_dos && p > ptr && p[-1] == '\015'))
                                fileformat = 1;
                            else
                                fileformat = 0;
                            break;
                        }
                    }
                    if (fileformat == 0 && try_mac)
                    {
                        try_mac = 1;
                        try_unix = 1;
                        for (; p >= ptr && *p != '\015'; p--)
                            ;
                        if (p >= ptr)
                        {
                            for (p = ptr; p < ptr + size; ++p)
                            {
                                if (*p == '\012')
                                    try_unix++;
                                else if (*p == '\015')
                                    try_mac++;
                            }
                            if (try_mac > try_unix)
                                fileformat = 2;
                        }
                    }
                }
                if (fileformat == -1 && try_mac)
                    fileformat = 2;
                if (fileformat == -1)
                    fileformat = default_fileformat();
                if (newfile)
                    set_fileformat(fileformat, 4);
            }
        }
        if (fileformat == 2)
        {
            --ptr;
            while (++ptr, --size >= 0)
            {
                if ((c = *ptr) != '\000' && c != '\015' && c != '\012')
                    continue;
                if (c == '\000')
                    *ptr = '\012';
                else if (c == '\012')
                    *ptr = '\015';
                else
                {
                    if (skip_count == 0)
                    {
                        *ptr = '\000';
                        len = (colnr_T) (ptr - line_start + 1);
                        if (ml_append(lnum, line_start, len, newfile) == 0)
                        {
                            error = 1;
                            break;
                        }
                        ++lnum;
                        if (--read_count == 0)
                        {
                            error = 1;
                            line_start = ptr;
                            break;
                        }
                    }
                    else
                        --skip_count;
                    line_start = ptr + 1;
                }
            }
        }
        else
        {
            --ptr;
            while (++ptr, --size >= 0)
            {
                if ((c = *ptr) != '\000' && c != '\012')
                    continue;
                if (c == '\000')
                    *ptr = '\012';
                else
                {
                    if (skip_count == 0)
                    {
                        *ptr = '\000';
                        len = (colnr_T)(ptr - line_start + 1);
                        if (fileformat == 1)
                        {
                            if (ptr[-1] == '\015')
                            {
                                ptr[-1] = '\000';
                                --len;
                            }
                            else if (ff_error != 1)
                            {
                                if ( try_unix
                                    && !read_stdin
                                    && (read_buffer
                                        || lseek(fd, (off_t)0L, 0) == 0))
                                {
                                    fileformat = 0;
                                    if (newfile)
                                        set_fileformat(0, 4);
                                    file_rewind = 1;
                                    keep_fileformat = 1;
                                    goto retry;
                                }
                                ff_error = 1;
                            }
                        }
                        if (ml_append(lnum, line_start, len, newfile) == 0)
                        {
                            error = 1;
                            break;
                        }
                        ++lnum;
                        if (--read_count == 0)
                        {
                            error = 1;
                            line_start = ptr;
                            break;
                        }
                    }
                    else
                        --skip_count;
                    line_start = ptr + 1;
                }
            }
        }
        linerest = (long)(ptr - line_start);
        ui_breakcheck();
    }
failed:
    if (error && read_count == 0)
        error = 0;
    if (!error
            && !got_int
            && linerest != 0
            && !(!curbuf->b_p_bin
                && fileformat == 1
                && *line_start == 26
                && ptr == line_start + 1))
    {
        if (newfile)
            curbuf->b_p_eol = 0;
        *ptr = '\000';
        if (ml_append(lnum, line_start,
                        (colnr_T)(ptr - line_start + 1), newfile) == 0)
            error = 1;
        else
            read_no_eol_lnum = ++lnum;
    }
    if (newfile)
        save_file_ff(curbuf);
    if (cryptkey != curbuf->b_p_key)
        vim_free(cryptkey);
    if (!read_buffer && !read_stdin)
        close(fd);
    vim_free(buffer);
    if (read_stdin)
    {
        close(0);
        dup(2);
    }
    --no_wait_return;
    if (!recoverymode)
    {
        if (newfile && wasempty && !(curbuf->b_ml.ml_flags & 1))
        {
            netbeansFireChanges = 0;
            ml_delete(curbuf->b_ml.ml_line_count, 0);
            netbeansFireChanges = 1;
            --linecnt;
        }
        linecnt = curbuf->b_ml.ml_line_count - linecnt;
        if (filesize == 0)
            linecnt = 0;
        if (newfile || read_buffer)
            redraw_curbuf_later(40);
        else if (linecnt)
            appended_lines_mark(from, linecnt);
        if ((newfile || read_buffer))
            diff_invalidate();
        if (read_stdin)
        {
            settmode(2);
            starttermcap();
            screenclear();
        }
        if (got_int)
        {
            if (!(flags & 0x10))
            {
                filemess(curbuf, sfname, (char_u *)((char *)(e_interr)), 0);
                if (newfile)
                    curbuf->b_p_ro = 1;
            }
            msg_scroll = msg_save;
            check_marks_read();
            return 1;
        }
        if (!filtering && !(flags & 0x10))
        {
            msg_add_fname(curbuf, sfname);
            c = 0;
            if (((((perm)) & 0170000) == (0010000)))
            {
                strcat((char *)(IObuff), (char *)(((char *)("[fifo/socket]"))));
                c = 1;
            }
            if (curbuf->b_p_ro)
            {
                strcat((char *)(IObuff), (char *)(shortmess('r') ? ((char *)("[RO]")) : ((char *)("[readonly]"))));
                c = 1;
            }
            if (read_no_eol_lnum)
            {
                msg_add_eol();
                c = 1;
            }
            if (ff_error == 1)
            {
                strcat((char *)(IObuff), (char *)(((char *)("[CR missing]"))));
                c = 1;
            }
            if (ff_error == 2)
            {
                strcat((char *)(IObuff), (char *)(((char *)("[NL found]"))));
                c = 1;
            }
            if (split)
            {
                strcat((char *)(IObuff), (char *)(((char *)("[long lines split]"))));
                c = 1;
            }
            if (cryptkey != ((void *)0))
            {
                strcat((char *)(IObuff), (char *)(((char *)("[crypted]"))));
                c = 1;
            }
                if (error)
            {
                strcat((char *)(IObuff), (char *)(((char *)("[READ ERRORS]"))));
                c = 1;
            }
            if (msg_add_fileformat(fileformat))
                c = 1;
            if (cryptkey != ((void *)0))
                msg_add_lines(c, (long)linecnt, filesize - 12);
            else
                msg_add_lines(c, (long)linecnt, filesize);
            vim_free(keep_msg);
            keep_msg = ((void *)0);
            msg_scrolled_ign = 1;
                p = msg_trunc_attr(IObuff, 0, 0);
            if (read_stdin || read_buffer || restart_edit != 0
                    || (msg_scrolled && !need_wait_return))
            {
                set_keep_msg(p);
                keep_msg_attr = 0;
            }
            msg_scrolled_ign = 0;
        }
        if (newfile && (error
                    ))
            curbuf->b_p_ro = 1;
        u_clearline();
        if (exmode_active)
            curwin->w_cursor.lnum = from + linecnt;
        else
            curwin->w_cursor.lnum = from + 1;
        check_cursor_lnum();
        beginline(1 | 4);
        curbuf->b_op_start.lnum = from + 1;
        curbuf->b_op_start.col = 0;
        curbuf->b_op_end.lnum = from + linecnt;
        curbuf->b_op_end.col = 0;
    }
    msg_scroll = msg_save;
    check_marks_read();
    write_no_eol_lnum = read_no_eol_lnum;
    if (!read_stdin && !read_buffer)
    {
        int m = msg_scroll;
        int n = msg_scrolled;
        if (newfile)
            save_file_ff(curbuf);
        msg_scroll = 1;
        if (filtering)
            apply_autocmds_exarg(EVENT_FILTERREADPOST, ((void *)0), sfname,
                                                          0, curbuf, eap);
        else if (newfile)
            apply_autocmds_exarg(EVENT_BUFREADPOST, ((void *)0), sfname,
                                                          0, curbuf, eap);
        else
            apply_autocmds_exarg(EVENT_FILEREADPOST, sfname, sfname,
                                                            0, ((void *)0), eap);
        if (msg_scrolled == n)
            msg_scroll = m;
        if (aborting())
            return 0;
    }
    if (recoverymode && error)
        return 0;
    return 1;
}
    int prep_exarg(eap, buf)
    exarg_T *eap;
    buf_T *buf;
{
    eap->cmd = alloc((unsigned)(strlen((char *)(buf->b_p_ff))
                                                 + 15));
    if (eap->cmd == ((void *)0))
        return 0;
    sprintf((char *)eap->cmd, "e ++ff=%s", buf->b_p_ff);
    eap->force_ff = 7;
    return 1;
}
    static void check_marks_read()
{
    if (!curbuf->b_marks_read && get_viminfo_parameter('\'') > 0)
    {
        read_viminfo(((void *)0), 0, 1, 0);
        curbuf->b_marks_read = 1;
    }
}
    static char_u * check_for_cryptkey(cryptkey, ptr, sizep, filesizep, newfile)
    char_u *cryptkey;
    char_u *ptr;
    long *sizep;
    long *filesizep;
    int newfile;
{
    if (*sizep >= 12
            && strncmp((char *)(ptr), (char *)("VimCrypt~01!"), (size_t)(12)) == 0)
    {
        if (cryptkey == ((void *)0))
        {
            if (*curbuf->b_p_key)
                cryptkey = curbuf->b_p_key;
            else
            {
                cryptkey = get_crypt_key(newfile, 0);
                if (cryptkey != ((void *)0) && *cryptkey == '\000')
                {
                    if (cryptkey != curbuf->b_p_key)
                        vim_free(cryptkey);
                    cryptkey = ((void *)0);
                }
            }
        }
        if (cryptkey != ((void *)0))
        {
            crypt_init_keys(cryptkey);
            *filesizep += 12;
            *sizep -= 12;
            memmove((char *)(ptr), (char *)(ptr + 12), (size_t)*sizep);
        }
    }
    else if (newfile && *curbuf->b_p_key && !starting)
        set_option_value((char_u *)"key", 0L, (char_u *)"", 4);
    return cryptkey;
}
    static void set_file_time(fname, atime, mtime)
    char_u *fname;
    time_t atime;
    time_t mtime;
{
    struct utimbuf buf;
    buf.actime = atime;
    buf.modtime = mtime;
    (void)utime((char *)fname, &buf);
}
    int buf_write(buf, fname, sfname, start, end, eap, append, forceit,
                                                      reset_changed, filtering)
    buf_T *buf;
    char_u *fname;
    char_u *sfname;
    linenr_T start, end;
    exarg_T *eap;
    int append;
    int forceit;
    int reset_changed;
    int filtering;
{
    int fd;
    char_u *backup = ((void *)0);
    int backup_copy = 0;
    int dobackup;
    char_u *ffname;
    char_u *wfname = ((void *)0);
    char_u *s;
    char_u *ptr;
    char_u c;
    int len;
    linenr_T lnum;
    long nchars;
    char_u *errmsg = ((void *)0);
    char_u *errnum = ((void *)0);
    char_u *buffer;
    char_u smallbuf[256];
    char_u *backup_ext;
    int bufsize;
    long perm;
    int retval = 1;
    int newfile = 0;
    int msg_save = msg_scroll;
    int overwriting;
    int no_eol = 0;
    int device = 0;
    struct stat st_old;
    int prev_got_int = got_int;
    int file_readonly = 0;
    static char *err_readonly = "is read-only (cannot override: \"W\" in 'cpoptions')";
    int made_writable = 0;
    int whole = (start == 1 && end == buf->b_ml.ml_line_count);
    linenr_T old_line_count = buf->b_ml.ml_line_count;
    int attr;
    int fileformat;
    struct bw_info write_info;
    int wb_flags = 0;
    vim_acl_T acl = ((void *)0);
    if (fname == ((void *)0) || *fname == '\000')
        return 0;
    if (check_secure())
        return 0;
    if (strlen((char *)(fname)) >= 1024)
    {
        emsg((char_u *)(((char *)(e_longname))));
        return 0;
    }
    if (reset_changed
            && whole
            && buf == curbuf
            && curbuf->b_ffname == ((void *)0)
            && !filtering
            && vim_strchr(p_cpo, 'F') != ((void *)0))
    {
        if (curbuf->b_p_bl)
            apply_autocmds(EVENT_BUFDELETE, ((void *)0), ((void *)0), 0, curbuf);
        apply_autocmds(EVENT_BUFWIPEOUT, ((void *)0), ((void *)0), 0, curbuf);
        if (aborting())
            return 0;
        if (setfname(fname, sfname, 0) == 1)
            curbuf->b_flags |= 0x08;
        apply_autocmds(EVENT_BUFNEW, ((void *)0), ((void *)0), 0, curbuf);
        if (curbuf->b_p_bl)
            apply_autocmds(EVENT_BUFADD, ((void *)0), ((void *)0), 0, curbuf);
    }
    if (sfname == ((void *)0))
        sfname = fname;
    ffname = fname;
    fname = sfname;
    if (*p_bex == '\000')
        backup_ext = (char_u *)".bak";
    else
        backup_ext = p_bex;
    if (buf->b_ffname != ((void *)0) && strcmp((char *)(ffname), (char *)(buf->b_ffname)) == 0)
        overwriting = 1;
    else
        overwriting = 0;
    if (exiting)
        settmode(0);
    ++no_wait_return;
    buf->b_op_start.lnum = start;
    buf->b_op_start.col = 0;
    buf->b_op_end.lnum = end;
    buf->b_op_end.col = 0;
    {
        aco_save_T aco;
        int buf_ffname = 0;
        int buf_sfname = 0;
        int buf_fname_f = 0;
        int buf_fname_s = 0;
        int did_cmd = 0;
        if (ffname == buf->b_ffname)
            buf_ffname = 1;
        if (sfname == buf->b_sfname)
            buf_sfname = 1;
        if (fname == buf->b_ffname)
            buf_fname_f = 1;
        if (fname == buf->b_sfname)
            buf_fname_s = 1;
        aucmd_prepbuf(&aco, buf);
        if (append)
        {
            if (!(did_cmd = apply_autocmds_exarg(EVENT_FILEAPPENDCMD,
                                         sfname, sfname, 0, curbuf, eap)))
                apply_autocmds_exarg(EVENT_FILEAPPENDPRE,
                                          sfname, sfname, 0, curbuf, eap);
        }
        else if (filtering)
        {
            apply_autocmds_exarg(EVENT_FILTERWRITEPRE,
                                            ((void *)0), sfname, 0, curbuf, eap);
        }
        else if (reset_changed && whole)
        {
            if (!(did_cmd = apply_autocmds_exarg(EVENT_BUFWRITECMD,
                                         sfname, sfname, 0, curbuf, eap)))
                apply_autocmds_exarg(EVENT_BUFWRITEPRE,
                                          sfname, sfname, 0, curbuf, eap);
        }
        else
        {
            if (!(did_cmd = apply_autocmds_exarg(EVENT_FILEWRITECMD,
                                         sfname, sfname, 0, curbuf, eap)))
                apply_autocmds_exarg(EVENT_FILEWRITEPRE,
                                          sfname, sfname, 0, curbuf, eap);
        }
        aucmd_restbuf(&aco);
        if (!buf_valid(buf))
            buf = ((void *)0);
        if (buf == ((void *)0) || buf->b_ml.ml_mfp == ((void *)0) || did_cmd || aborting())
        {
            --no_wait_return;
            msg_scroll = msg_save;
            if (aborting())
                return 0;
            if (did_cmd)
            {
                if (buf == ((void *)0))
                    return 1;
                if (overwriting)
                {
                    ml_timestamp(buf);
                    buf->b_flags &= ~(0x08 + 0x10 + 0x40);
                }
                if (reset_changed && buf->b_changed)
                    return 0;
                return 1;
            }
            if (!aborting())
                emsg((char_u *)(((char *)("E203: Autocommands deleted or unloaded buffer to be written"))));
            return 0;
        }
        if (buf->b_ml.ml_line_count != old_line_count)
        {
            if (whole)
                end = buf->b_ml.ml_line_count;
            else if (buf->b_ml.ml_line_count > old_line_count)
                end += buf->b_ml.ml_line_count - old_line_count;
            else
            {
                end -= old_line_count - buf->b_ml.ml_line_count;
                if (end < start)
                {
                    --no_wait_return;
                    msg_scroll = msg_save;
                    emsg((char_u *)(((char *)("E204: Autocommand changed number of lines in unexpected way"))));
                    return 0;
                }
            }
        }
        if (buf_ffname)
            ffname = buf->b_ffname;
        if (buf_sfname)
            sfname = buf->b_sfname;
        if (buf_fname_f)
            fname = buf->b_ffname;
        if (buf_fname_s)
            fname = buf->b_sfname;
    }
    if (shortmess('o') && !exiting)
        msg_scroll = 0;
    else
        msg_scroll = 1;
    if (!filtering)
        filemess(buf,
                fname,
                    (char_u *)"", 0);
    msg_scroll = 0;
    buffer = alloc(8192);
    if (buffer == ((void *)0))
    {
        buffer = smallbuf;
        bufsize = 256;
    }
    else
        bufsize = 8192;
    st_old.st_dev = st_old.st_ino = 0;
    perm = -1;
    if (stat(((char *)fname), (&st_old)) < 0)
        newfile = 1;
    else
    {
        perm = st_old.st_mode;
        if (!((((st_old.st_mode)) & 0170000) == (0100000)))
        {
            if (((((st_old.st_mode)) & 0170000) == (0040000)))
            {
                errnum = (char_u *)"E502: ";
                errmsg = (char_u *)((char *)("is a directory"));
                goto fail;
            }
            if (mch_nodetype(fname) != 1)
            {
                errnum = (char_u *)"E503: ";
                errmsg = (char_u *)((char *)("is not a file or writable device"));
                goto fail;
            }
            device = 1;
            newfile = 1;
            perm = -1;
        }
    }
    if (!device && !newfile)
    {
        file_readonly = (
                    (perm & 0222) == 0 ||
                    access(((char *)fname), (2))
                    );
        if (!forceit && file_readonly)
        {
            if (vim_strchr(p_cpo, 'W') != ((void *)0))
            {
                errnum = (char_u *)"E504: ";
                errmsg = (char_u *)((char *)(err_readonly));
            }
            else
            {
                errnum = (char_u *)"E505: ";
                errmsg = (char_u *)((char *)("is read-only (add ! to override)"));
            }
            goto fail;
        }
        if (overwriting)
        {
            retval = check_mtime(buf, &st_old);
            if (retval == 0)
                goto fail;
        }
    }
    if (!newfile)
        acl = mch_get_acl(fname);
    dobackup = (p_wb || p_bk || *p_pm != '\000');
    if (dobackup && *p_bsk != '\000' && match_file_list(p_bsk, sfname, ffname))
        dobackup = 0;
    prev_got_int = got_int;
    got_int = 0;
    buf->b_saving = 1;
    if (!(append && *p_pm == '\000') && !filtering && perm >= 0 && dobackup)
    {
        if (*p_bkc == 'y' || append)
            backup_copy = 1;
        else if (*p_bkc == 'a')
        {
            struct stat st;
            int i;
            if (st_old.st_nlink > 1
                    || lstat(((char *)fname), (&st)) < 0
                    || st.st_dev != st_old.st_dev
                    || st.st_ino != st_old.st_ino)
                backup_copy = 1;
            else
            {
                strcpy((char *)(IObuff), (char *)(fname));
                for (i = 4913; ; i += 123)
                {
                    sprintf((char *)gettail(IObuff), "%d", i);
                    if (stat(((char *)IObuff), (&st)) < 0)
                        break;
                }
                fd = open(((char *)IObuff), (0100|01|0200), (perm));
                close(fd);
                if (fd < 0)
                    backup_copy = 1;
                else
                {
                    chown((char *)IObuff, st_old.st_uid, st_old.st_gid);
                    (void)mch_setperm(IObuff, perm);
                    if (stat(((char *)IObuff), (&st)) < 0
                            || st.st_uid != st_old.st_uid
                            || st.st_gid != st_old.st_gid
                            || st.st_mode != perm)
                        backup_copy = 1;
                    unlink((char *)(IObuff));
                }
            }
        }
        if (backup_copy
                && (fd = open(((char *)fname), (00 | 0), (0))) >= 0)
        {
            int bfd;
            char_u *copybuf, *wp;
            int some_error = 0;
            struct stat st_new;
            char_u *dirp;
            char_u *rootname;
            int did_set_shortname;
            copybuf = alloc(8192 + 1);
            if (copybuf == ((void *)0))
            {
                some_error = 1;
                goto nobackup;
            }
            dirp = p_bdir;
            while (*dirp)
            {
                st_new.st_ino = 0;
                st_new.st_dev = 0;
                st_new.st_gid = 0;
                (void)copy_option_part(&dirp, copybuf, 8192, ",");
                rootname = get_file_in_dir(fname, copybuf);
                if (rootname == ((void *)0))
                {
                    some_error = 1;
                    goto nobackup;
                }
                did_set_shortname = 0;
                for (;;)
                {
                    backup = buf_modname(
                            (buf->b_p_sn || buf->b_shortname),
                                                 rootname, backup_ext, 0);
                    if (backup == ((void *)0))
                    {
                        vim_free(rootname);
                        some_error = 1;
                        goto nobackup;
                    }
                    if (stat(((char *)backup), (&st_new)) >= 0)
                    {
                        if (st_new.st_dev == st_old.st_dev
                                            && st_new.st_ino == st_old.st_ino)
                        {
                            vim_free(backup);
                            backup = ((void *)0);
                            if (!(buf->b_shortname || buf->b_p_sn))
                            {
                                buf->b_shortname = 1;
                                did_set_shortname = 1;
                                continue;
                            }
                            if (did_set_shortname)
                                buf->b_shortname = 0;
                            break;
                        }
                        if (!p_bk)
                        {
                            wp = backup + strlen((char *)(backup)) - 1
                                                         - strlen((char *)(backup_ext));
                            if (wp < backup)
                                wp = backup;
                            *wp = 'z';
                            while (*wp > 'a'
                                    && stat(((char *)backup), (&st_new)) >= 0)
                                --*wp;
                            if (*wp == 'a')
                            {
                                vim_free(backup);
                                backup = ((void *)0);
                            }
                        }
                    }
                    break;
                }
                vim_free(rootname);
                if (backup != ((void *)0))
                {
                    unlink((char *)(backup));
                    bfd = open(((char *)backup), (01|0100|0|0200), (0666));
                    if (bfd < 0)
                    {
                        vim_free(backup);
                        backup = ((void *)0);
                    }
                    else
                    {
                        (void)mch_setperm(backup, perm & 0777);
                        if (st_new.st_gid != st_old.st_gid &&
                                    fchown(bfd, (uid_t)-1, st_old.st_gid) != 0
                                                )
                            mch_setperm(backup,
                                          (perm & 0707) | ((perm & 07) << 3));
                        write_info.bw_fd = bfd;
                        write_info.bw_buf = copybuf;
                        write_info.bw_flags = 0x2000;
                        while ((write_info.bw_len = read((fd), (char *)(copybuf), (size_t) (8192))) > 0)
                        {
                            if (buf_write_bytes(&write_info) == 0)
                            {
                                errmsg = (char_u *)((char *)("E506: Can't write to backup file (add ! to override)"));
                                break;
                            }
                            ui_breakcheck();
                            if (got_int)
                            {
                                errmsg = (char_u *)((char *)(e_interr));
                                break;
                            }
                        }
                        if (close(bfd) < 0 && errmsg == ((void *)0))
                            errmsg = (char_u *)((char *)("E507: Close error for backup file (add ! to override)"));
                        if (write_info.bw_len < 0)
                            errmsg = (char_u *)((char *)("E508: Can't read file for backup (add ! to override)"));
                        set_file_time(backup, st_old.st_atime, st_old.st_mtime);
                        mch_set_acl(backup, acl);
                        break;
                    }
                }
            }
    nobackup:
            close(fd);
            vim_free(copybuf);
            if (backup == ((void *)0) && errmsg == ((void *)0))
                errmsg = (char_u *)((char *)("E509: Cannot create backup file (add ! to override)"));
            if ((some_error || errmsg != ((void *)0)) && !forceit)
            {
                retval = 0;
                goto fail;
            }
            errmsg = ((void *)0);
        }
        else
        {
            char_u *dirp;
            char_u *p;
            char_u *rootname;
            if (file_readonly && vim_strchr(p_cpo, 'W') != ((void *)0))
            {
                errnum = (char_u *)"E504: ";
                errmsg = (char_u *)((char *)(err_readonly));
                goto fail;
            }
            dirp = p_bdir;
            while (*dirp)
            {
                (void)copy_option_part(&dirp, IObuff, (1024+1), ",");
                rootname = get_file_in_dir(fname, IObuff);
                if (rootname == ((void *)0))
                    backup = ((void *)0);
                else
                {
                    backup = buf_modname(
                            (buf->b_p_sn || buf->b_shortname),
                                                 rootname, backup_ext, 0);
                    vim_free(rootname);
                }
                if (backup != ((void *)0))
                {
                    if (!p_bk && mch_getperm(backup) >= 0)
                    {
                        p = backup + strlen((char *)(backup)) - 1 - strlen((char *)(backup_ext));
                        if (p < backup)
                            p = backup;
                        *p = 'z';
                        while (*p > 'a' && mch_getperm(backup) >= 0)
                            --*p;
                        if (*p == 'a')
                        {
                            vim_free(backup);
                            backup = ((void *)0);
                        }
                    }
                }
                if (backup != ((void *)0))
                {
                    if (vim_rename(fname, backup) == 0)
                        break;
                    vim_free(backup);
                    backup = ((void *)0);
                }
            }
            if (backup == ((void *)0) && !forceit)
            {
                errmsg = (char_u *)((char *)("E510: Can't make backup file (add ! to override)"));
                goto fail;
            }
        }
    }
    if (forceit && st_old.st_uid == getuid() && perm >= 0 && !(perm & 0200)
                                     && vim_strchr(p_cpo, 'W') == ((void *)0))
    {
        perm |= 0200;
        (void)mch_setperm(fname, perm);
        made_writable = 1;
    }
    if (forceit && overwriting)
    {
        buf->b_p_ro = 0;
        need_maketitle = 1;
        status_redraw_all();
    }
    if (end > buf->b_ml.ml_line_count)
        end = buf->b_ml.ml_line_count;
    if (buf->b_ml.ml_flags & 1)
        start = end + 1;
    if (reset_changed && !newfile && !otherfile(ffname)
                                              && !(exiting && backup != ((void *)0)))
    {
        ml_preserve(buf, 0);
        if (got_int)
        {
            errmsg = (char_u *)((char *)(e_interr));
            goto restore_backup;
        }
    }
    wfname = fname;
    while ((fd = open(((char *)wfname), (01 | 0 | (append ? (forceit ? (02000 | 0100) : 02000) : (0100 | 01000))), (0666))) < 0)
    {
        if (errmsg == ((void *)0))
        {
            struct stat st;
            if ((!newfile && st_old.st_nlink > 1)
                    || (lstat(((char *)fname), (&st)) == 0
                        && (st.st_dev != st_old.st_dev
                            || st.st_ino != st_old.st_ino)))
                errmsg = (char_u *)((char *)("E166: Can't open linked file for writing"));
            else
            {
                errmsg = (char_u *)((char *)("E212: Can't open file for writing"));
                if (forceit && vim_strchr(p_cpo, 'W') == ((void *)0)
                                                                 && perm >= 0)
                {
                    if (!(perm & 0200))
                        made_writable = 1;
                    perm |= 0200;
                    if (st_old.st_uid != getuid() || st_old.st_gid != getgid())
                        perm &= 0777;
                    if (!append)
                        unlink((char *)(wfname));
                    continue;
                }
            }
        }
restore_backup:
        {
            struct stat st;
            if (backup != ((void *)0) && wfname == fname)
            {
                if (backup_copy)
                {
                    if (stat(((char *)fname), (&st)) < 0)
                        vim_rename(backup, fname);
                    if (stat(((char *)fname), (&st)) >= 0)
                        unlink((char *)(backup));
                }
                else
                {
                    vim_rename(backup, fname);
                }
            }
            if (!newfile && stat(((char *)fname), (&st)) < 0)
                end = 0;
        }
        goto fail;
    }
    errmsg = ((void *)0);
    write_info.bw_fd = fd;
    if (*buf->b_p_key && !filtering)
    {
        crypt_init_keys(buf->b_p_key);
        write_info.bw_buf = (char_u *)"VimCrypt~01!";
        write_info.bw_len = 12;
        write_info.bw_flags = 0x2000;
        if (buf_write_bytes(&write_info) == 0)
            end = 0;
        wb_flags |= 0x1000;
    }
    write_info.bw_buf = buffer;
    nchars = 0;
    write_info.bw_len = bufsize;
    write_info.bw_flags = wb_flags;
    fileformat = get_fileformat_force(buf, eap);
    s = buffer;
    len = 0;
    for (lnum = start; lnum <= end; ++lnum)
    {
        ptr = ml_get_buf(buf, lnum, 0) - 1;
        while ((c = *++ptr) != '\000')
        {
            if (c == '\012')
                *s = '\000';
            else if (c == '\015' && fileformat == 2)
                *s = '\012';
            else
                *s = c;
            ++s;
            if (++len != bufsize)
                continue;
            if (buf_write_bytes(&write_info) == 0)
            {
                end = 0;
                break;
            }
            nchars += bufsize;
            s = buffer;
            len = 0;
        }
        if (end == 0
                || (lnum == end
                    && buf->b_p_bin
                    && (lnum == write_no_eol_lnum
                        || (lnum == buf->b_ml.ml_line_count && !buf->b_p_eol))))
        {
            ++lnum;
            no_eol = 1;
            break;
        }
        if (fileformat == 0)
            *s++ = '\012';
        else
        {
            *s++ = '\015';
            if (fileformat == 1)
            {
                if (++len == bufsize)
                {
                    if (buf_write_bytes(&write_info) == 0)
                    {
                        end = 0;
                        break;
                    }
                    nchars += bufsize;
                    s = buffer;
                    len = 0;
                }
                *s++ = '\012';
            }
        }
        if (++len == bufsize && end)
        {
            if (buf_write_bytes(&write_info) == 0)
            {
                end = 0;
                break;
            }
            nchars += bufsize;
            s = buffer;
            len = 0;
            ui_breakcheck();
            if (got_int)
            {
                end = 0;
                break;
            }
        }
    }
    if (len > 0 && end > 0)
    {
        write_info.bw_len = len;
        if (buf_write_bytes(&write_info) == 0)
            end = 0;
        nchars += len;
    }
    if (close(fd) != 0)
    {
        errmsg = (char_u *)((char *)("E512: Close failed"));
        end = 0;
    }
    if (made_writable)
        perm &= ~0200;
    if (perm >= 0)
        (void)mch_setperm(wfname, perm);
    if (!backup_copy)
        mch_set_acl(wfname, acl);
    if (backup != ((void *)0) && !backup_copy)
    {
        struct stat st;
        if (stat(((char *)wfname), (&st)) < 0
                || st.st_uid != st_old.st_uid
                || st.st_gid != st_old.st_gid)
        {
            chown((char *)wfname, st_old.st_uid, st_old.st_gid);
            if (perm >= 0)
                (void)mch_setperm(wfname, perm);
        }
        buf_setino(buf);
    }
    if (end == 0)
    {
        if (errmsg == ((void *)0))
        {
                if (got_int)
                    errmsg = (char_u *)((char *)(e_interr));
                else
                    errmsg = (char_u *)((char *)("E514: write error (file system full?)"));
        }
        if (backup != ((void *)0))
        {
            if (backup_copy)
            {
                if (got_int)
                {
                    msg((char_u *)(((char *)(e_interr))));
                    out_flush();
                }
                if ((fd = open(((char *)backup), (00 | 0), (0))) >= 0)
                {
                    if ((write_info.bw_fd = open(((char *)fname), (01 | 0100 | 01000 | 0), (0666))) >= 0)
                    {
                        write_info.bw_buf = smallbuf;
                        write_info.bw_flags = 0x2000;
                        while ((write_info.bw_len = read((fd), (char *)(smallbuf), (size_t) (256))) > 0)
                            if (buf_write_bytes(&write_info) == 0)
                                break;
                        if (close(write_info.bw_fd) >= 0
                                                   && write_info.bw_len == 0)
                            end = 1;
                    }
                    close(fd);
                }
            }
            else
            {
                if (vim_rename(backup, fname) == 0)
                    end = 1;
            }
        }
        goto fail;
    }
    lnum -= start;
    --no_wait_return;
    if (!filtering)
    {
        msg_add_fname(buf, fname);
        c = 0;
        if (device)
        {
            strcat((char *)(IObuff), (char *)(((char *)("[Device]"))));
            c = 1;
        }
        else if (newfile)
        {
            strcat((char *)(IObuff), (char *)(shortmess('n') ? ((char *)("[New]")) : ((char *)("[New File]"))));
            c = 1;
        }
        if (no_eol)
        {
            msg_add_eol();
            c = 1;
        }
        if (msg_add_fileformat(fileformat))
            c = 1;
        if (wb_flags & 0x1000)
        {
            strcat((char *)(IObuff), (char *)(((char *)("[crypted]"))));
            c = 1;
        }
        msg_add_lines(c, (long)lnum, nchars);
        if (!shortmess('W'))
        {
            if (append)
                strcat((char *)(IObuff), (char *)(shortmess('w') ? ((char *)(" [a]")) : ((char *)(" appended"))));
            else
                strcat((char *)(IObuff), (char *)(shortmess('w') ? ((char *)(" [w]")) : ((char *)(" written"))));
        }
        set_keep_msg(msg_trunc_attr(IObuff, 0, 0));
        keep_msg_attr = 0;
    }
    if (reset_changed && whole
            )
    {
        unchanged(buf, 1);
        u_unchanged(buf);
        netbeans_saved(buf);
    }
    if (overwriting)
    {
        ml_timestamp(buf);
        buf->b_flags &= ~(0x08 + 0x10 + 0x40);
    }
    if (*p_pm && dobackup)
    {
        char *org = (char *)buf_modname(
                                        (buf->b_p_sn || buf->b_shortname),
                                                          fname, p_pm, 0);
        if (backup != ((void *)0))
        {
            struct stat st;
            if (org == ((void *)0))
                emsg((char_u *)(((char *)("E205: Patchmode: can't save original file"))));
            else if (stat((org), (&st)) < 0)
            {
                vim_rename(backup, (char_u *)org);
                vim_free(backup);
                backup = ((void *)0);
                set_file_time((char_u *)org, st_old.st_atime, st_old.st_mtime);
            }
        }
        else
        {
            int empty_fd;
            if (org == ((void *)0)
                    || (empty_fd = open((org), (0100 | 0 | 0200), (0666))) < 0)
              emsg((char_u *)(((char *)("E206: patchmode: can't touch empty original file"))));
            else
              close(empty_fd);
        }
        if (org != ((void *)0))
        {
            mch_setperm((char_u *)org, mch_getperm(fname) & 0777);
            vim_free(org);
        }
    }
    if (!p_bk && backup != ((void *)0) && unlink((char *)(backup)) != 0)
        emsg((char_u *)(((char *)("E207: Can't delete backup file"))));
    goto nofail;
fail:
    --no_wait_return;
nofail:
    buf->b_saving = 0;
    vim_free(backup);
    if (buffer != smallbuf)
        vim_free(buffer);
    mch_free_acl(acl);
    if (errmsg != ((void *)0))
    {
        int numlen = errnum != ((void *)0) ? strlen((char *)(errnum)) : 0;
        attr = highlight_attr[(int)(HLF_E)];
        msg_add_fname(buf,
                fname
                     );
        if (strlen((char *)(IObuff)) + strlen((char *)(errmsg)) + numlen >= (1024+1))
            IObuff[(1024+1) - strlen((char *)(errmsg)) - numlen - 1] = '\000';
        if (errnum != ((void *)0))
        {
            memmove((char *)(IObuff + numlen), (char *)(IObuff), strlen((char *)(IObuff)) + 1);
            memmove((char *)(IObuff), (char *)(errnum), (size_t)numlen);
        }
        strcat((char *)(IObuff), (char *)(errmsg));
        emsg(IObuff);
        retval = 0;
        if (end == 0)
        {
            msg_puts_attr((char_u *)(((char *)("\nWARNING: Original file may be lost or damaged\n"))), (attr | 0x1000));
            msg_puts_attr((char_u *)(((char *)("don't quit the editor until the file is successfully written!"))), (attr | 0x1000));
            if (stat(((char *)fname), (&st_old)) >= 0)
            {
                buf_store_time(buf, &st_old, fname);
                buf->b_mtime_read = buf->b_mtime;
            }
        }
    }
    msg_scroll = msg_save;
    if (!should_abort(retval))
    {
        aco_save_T aco;
        write_no_eol_lnum = 0;
        aucmd_prepbuf(&aco, buf);
        if (append)
            apply_autocmds_exarg(EVENT_FILEAPPENDPOST, fname, fname,
                                                          0, curbuf, eap);
        else if (filtering)
            apply_autocmds_exarg(EVENT_FILTERWRITEPOST, ((void *)0), fname,
                                                          0, curbuf, eap);
        else if (reset_changed && whole)
            apply_autocmds_exarg(EVENT_BUFWRITEPOST, fname, fname,
                                                          0, curbuf, eap);
        else
            apply_autocmds_exarg(EVENT_FILEWRITEPOST, fname, fname,
                                                          0, curbuf, eap);
        aucmd_restbuf(&aco);
        if (aborting())
            retval = 0;
    }
    got_int |= prev_got_int;
    return retval;
}
    static void msg_add_fname(buf, fname)
    buf_T *buf;
    char_u *fname;
{
    if (fname == ((void *)0))
        fname = (char_u *)"-stdin-";
    home_replace(buf, fname, IObuff + 1, (1024+1) - 4, 1);
    IObuff[0] = '"';
    strcat((char *)(IObuff), (char *)("\" "));
}
    static int msg_add_fileformat(eol_type)
    int eol_type;
{
    if (eol_type == 1)
    {
        strcat((char *)(IObuff), (char *)(shortmess('x') ? ((char *)("[dos]")) : ((char *)("[dos format]"))));
        return 1;
    }
    if (eol_type == 2)
    {
        strcat((char *)(IObuff), (char *)(shortmess('x') ? ((char *)("[mac]")) : ((char *)("[mac format]"))));
        return 1;
    }
    return 0;
}
    static void msg_add_lines(insert_space, lnum, nchars)
    int insert_space;
    long lnum;
    long nchars;
{
    char_u *p;
    p = IObuff + strlen((char *)(IObuff));
    if (insert_space)
        *p++ = ' ';
    if (shortmess('l'))
        sprintf((char *)p, "%ldL, %ldC", lnum, nchars);
    else
    {
        if (lnum == 1)
            strcpy((char *)(p), (char *)(((char *)("1 line, "))));
        else
            sprintf((char *)p, ((char *)("%ld lines, ")), lnum);
        p += strlen((char *)(p));
        if (nchars == 1)
            strcpy((char *)(p), (char *)(((char *)("1 character"))));
        else
            sprintf((char *)p, ((char *)("%ld characters")), nchars);
    }
}
    static void msg_add_eol()
{
    strcat((char *)(IObuff), (char *)(shortmess('i') ? ((char *)("[noeol]")) : ((char *)("[Incomplete last line]"))));
}
    static int check_mtime(buf, st)
    buf_T *buf;
    struct stat *st;
{
    if (buf->b_mtime_read != 0
            && time_differs((long)st->st_mtime, buf->b_mtime_read))
    {
        msg_scroll = 1;
        msg_silent = 0;
        msg_attr((char_u *)(((char *)("WARNING: The file has been changed since reading it!!!"))), (highlight_attr[(int)(HLF_E)]));
        if (ask_yesno((char_u *)((char *)("Do you really want to write to it")),
                                                                 1) == 'n')
            return 0;
        msg_scroll = 0;
    }
    return 1;
}
    static int time_differs(t1, t2)
    long t1, t2;
{
    return (t1 - t2 > 1 || t2 - t1 > 1);
}
    static int buf_write_bytes(ip)
    struct bw_info *ip;
{
    int wlen;
    char_u *buf = ip->bw_buf;
    int len = ip->bw_len;
    int flags = ip->bw_flags;
    if (flags & 0x1000)
    {
        int ztemp, t, i;
        for (i = 0; i < len; i++)
        {
            ztemp = buf[i];
            buf[i] = (t = decrypt_byte(), update_keys(ztemp), t^(ztemp));
        }
    }
    while (len)
    {
        wlen = write((ip->bw_fd), (char *)(buf), (size_t) (len));
        if (wlen <= 0)
            return 0;
        len -= wlen;
        buf += wlen;
    }
    return 1;
}
    char_u * shorten_fname(full_path, dir_name)
    char_u *full_path;
    char_u *dir_name;
{
    int len;
    char_u *p;
    if (full_path == ((void *)0))
        return ((void *)0);
    len = (int)strlen((char *)(dir_name));
    if (strncmp((char *)(dir_name), (char *)(full_path), (size_t)(len)) == 0)
    {
        p = full_path + len;
        {
            if (vim_ispathsep(*p))
                ++p;
            else
                p = ((void *)0);
        }
    }
    else
        p = ((void *)0);
    return p;
}
    void shorten_fnames(force)
    int force;
{
    char_u dirname[1024];
    buf_T *buf;
    char_u *p;
    mch_dirname(dirname, 1024);
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (buf->b_fname != ((void *)0)
                && !bt_nofile(buf)
                && !path_with_url(buf->b_fname)
                && (force
                    || buf->b_sfname == ((void *)0)
                    || mch_isFullName(buf->b_sfname)))
        {
            vim_free(buf->b_sfname);
            buf->b_sfname = ((void *)0);
            p = shorten_fname(buf->b_ffname, dirname);
            if (p != ((void *)0))
            {
                buf->b_sfname = vim_strsave(p);
                buf->b_fname = buf->b_sfname;
            }
            if (p == ((void *)0) || buf->b_fname == ((void *)0))
                buf->b_fname = buf->b_ffname;
            mf_fullname(buf->b_ml.ml_mfp);
        }
    }
    status_redraw_all();
}
    char_u * modname(fname, ext, prepend_dot)
    char_u *fname, *ext;
    int prepend_dot;
{
    return buf_modname(
                        (curbuf->b_p_sn || curbuf->b_shortname),
                                                     fname, ext, prepend_dot);
}
    char_u * buf_modname(shortname, fname, ext, prepend_dot)
    int shortname;
    char_u *fname, *ext;
    int prepend_dot;
{
    char_u *retval;
    char_u *s;
    char_u *e;
    char_u *ptr;
    int fnamelen, extlen;
    extlen = (int)strlen((char *)(ext));
    if (fname == ((void *)0) || *fname == '\000')
    {
        retval = alloc((unsigned)(1024 + extlen + 3));
        if (retval == ((void *)0))
            return ((void *)0);
        if (mch_dirname(retval, 1024) == 0 ||
                                     (fnamelen = (int)strlen((char *)(retval))) == 0)
        {
            vim_free(retval);
            return ((void *)0);
        }
        if (!vim_ispathsep(retval[fnamelen - 1]))
        {
            retval[fnamelen++] = '/';
            retval[fnamelen] = '\000';
        }
        prepend_dot = 0;
    }
    else
    {
        fnamelen = (int)strlen((char *)(fname));
        retval = alloc((unsigned)(fnamelen + extlen + 3));
        if (retval == ((void *)0))
            return ((void *)0);
        strcpy((char *)(retval), (char *)(fname));
    }
    for (ptr = retval + fnamelen; ptr >= retval; ptr--)
    {
        if (*ext == '.'
                    && shortname
                                                                )
            if (*ptr == '.')
                *ptr = '_';
        if (vim_ispathsep(*ptr))
            break;
    }
    ptr++;
    if (strlen((char *)(ptr)) > (unsigned)(255 - 5))
        ptr[(255 - 5)] = '\0';
    s = ptr + strlen((char *)(ptr));
    if (shortname)
    {
        if (fname == ((void *)0) || *fname == '\000'
                                   || vim_ispathsep(fname[strlen((char *)(fname)) - 1]))
        {
            if (*ext == '.')
                *s++ = '_';
        }
        else if (*ext == '.')
        {
            if (s - ptr > (size_t)8)
            {
                s = ptr + 8;
                *s = '\0';
            }
        }
        else if ((e = vim_strchr(ptr, '.')) == ((void *)0))
            *s++ = '.';
        else if ((int)strlen((char *)(e)) + extlen > 4)
            s = e + 4 - extlen;
    }
    strcpy((char *)(s), (char *)(ext));
    if (prepend_dot && !shortname && *(e = gettail(retval)) !=
            '.'
                                )
    {
        memmove((char *)(e + 1), (char *)(e), strlen((char *)(e)) + 1);
        *e = '.';
    }
    if (fname != ((void *)0) && strcmp((char *)(fname), (char *)(retval)) == 0)
    {
        while (--s >= ptr)
        {
            if (*s != '_')
            {
                *s = '_';
                break;
            }
        }
        if (s < ptr)
            *ptr = 'v';
    }
    return retval;
}
    int vim_fgets(buf, size, fp)
    char_u *buf;
    int size;
    FILE *fp;
{
    char *eof;
    char tbuf[200];
    buf[size - 2] = '\000';
    eof = fgets((char *)buf, size, fp);
    if (buf[size - 2] != '\000' && buf[size - 2] != '\n')
    {
        buf[size - 1] = '\000';
        do
        {
            tbuf[200 - 2] = '\000';
            fgets((char *)tbuf, 200, fp);
        } while (tbuf[200 - 2] != '\000' && tbuf[200 - 2] != '\n');
    }
    return (eof == ((void *)0));
}
    int vim_rename(from, to)
    char_u *from;
    char_u *to;
{
    int fd_in;
    int fd_out;
    int n;
    char *errmsg = ((void *)0);
    char *buffer;
    if (strcmp((char *)(from), (char *)(to)) == 0)
        return 0;
    unlink((char *)(to));
    if (rename((char *)from, (char *)to) == 0)
        return 0;
    fd_in = open(((char *)from), (00|0), (0));
    if (fd_in == -1)
        return -1;
    fd_out = open(((char *)to), (0100|0200|01|0), (0666));
    if (fd_out == -1)
    {
        close(fd_in);
        return -1;
    }
    buffer = (char *)alloc(8192);
    if (buffer == ((void *)0))
    {
        close(fd_in);
        close(fd_out);
        return -1;
    }
    while ((n = read((fd_in), (char *)(buffer), (size_t) (8192))) > 0)
        if (write((fd_out), (char *)(buffer), (size_t) (n)) != n)
        {
            errmsg = ((char *)("E208: Error writing to \"%s\""));
            break;
        }
    vim_free(buffer);
    close(fd_in);
    if (close(fd_out) < 0)
        errmsg = ((char *)("E209: Error closing \"%s\""));
    if (n < 0)
    {
        errmsg = ((char *)("E210: Error reading \"%s\""));
        to = from;
    }
    if (errmsg != ((void *)0))
    {
        emsg2((char_u *)(errmsg), (char_u *)(to));
        return -1;
    }
    unlink((char *)(from));
    return 0;
}
static int already_warned = 0;
    int check_timestamps(focus)
    int focus;
{
    buf_T *buf;
    int didit = 0;
    int n;
    if (no_check_timestamps > 0)
        return 0;
    if (focus && did_check_timestamps)
    {
        need_check_timestamps = 1;
        return 0;
    }
    if (!stuff_empty() || global_busy || !typebuf_typed()
                        || autocmd_busy
                                        )
        need_check_timestamps = 1;
    else
    {
        ++no_wait_return;
        did_check_timestamps = 1;
        already_warned = 0;
        for (buf = firstbuf; buf != ((void *)0); )
        {
            if (buf->b_nwindows > 0)
            {
                n = buf_check_timestamp(buf, focus);
                if (didit < n)
                    didit = n;
                if (n > 0 && !buf_valid(buf))
                {
                    buf = firstbuf;
                    continue;
                }
            }
            buf = buf->b_next;
        }
        --no_wait_return;
        need_check_timestamps = 0;
        if (need_wait_return && didit == 2)
        {
            msg_puts((char_u *)"\n");
            out_flush();
        }
    }
    return didit;
}
    static int move_lines(frombuf, tobuf)
    buf_T *frombuf;
    buf_T *tobuf;
{
    buf_T *tbuf = curbuf;
    int retval = 1;
    linenr_T lnum;
    char_u *p;
    curbuf = tobuf;
    for (lnum = 1; lnum <= frombuf->b_ml.ml_line_count; ++lnum)
    {
        p = vim_strsave(ml_get_buf(frombuf, lnum, 0));
        if (p == ((void *)0) || ml_append(lnum - 1, p, 0, 0) == 0)
        {
            vim_free(p);
            retval = 0;
            break;
        }
        vim_free(p);
    }
    if (retval != 0)
    {
        curbuf = frombuf;
        while (!(curbuf->b_ml.ml_line_count == 1 && *ml_get((linenr_T)1) == '\000'))
            if (ml_delete(curbuf->b_ml.ml_line_count, 0) == 0)
            {
                retval = 0;
                break;
            }
    }
    curbuf = tbuf;
    return retval;
}
    int buf_check_timestamp(buf, focus)
    buf_T *buf;
    int focus;
{
    struct stat st;
    int stat_res;
    int retval = 0;
    char_u *path;
    char_u *tbuf;
    char *mesg = ((void *)0);
    int reload = 0;
    int can_reload = 0;
    size_t orig_size = buf->b_orig_size;
    int orig_mode = buf->b_orig_mode;
    int save_mouse_correct = need_mouse_correct;
    if (buf->b_ffname == ((void *)0)
            || buf->b_ml.ml_mfp == ((void *)0)
            || *buf->b_p_bt != '\000'
            || buf->b_saving
            )
        return 0;
    if ( !(buf->b_flags & 0x08)
            && buf->b_mtime != 0
            && ((stat_res = stat(((char *)buf->b_ffname), (&st))) < 0
                || time_differs((long)st.st_mtime, buf->b_mtime)
                || (int)st.st_mode != buf->b_orig_mode
                ))
    {
        retval = 1;
        if (stat_res < 0)
        {
            buf->b_mtime = 0;
            buf->b_orig_size = 0;
            buf->b_orig_mode = 0;
        }
        else
            buf_store_time(buf, &st, buf->b_ffname);
        if (mch_isdir(buf->b_fname))
            ;
        else if ((buf->b_p_ar >= 0 ? buf->b_p_ar : p_ar)
                                       && !bufIsChanged(buf) && stat_res >= 0)
            reload = 1;
        else
        {
            if (apply_autocmds(EVENT_FILECHANGEDSHELL,
                                      buf->b_fname, buf->b_fname, 0, buf))
            {
                if (!buf_valid(buf))
                {
                    emsg((char_u *)(((char *)("E246: FileChangedShell autocommand deleted buffer"))));
                }
                return 2;
            }
            else
            {
                if (stat_res < 0)
                    mesg = ((char *)("E211: Warning: File \"%s\" no longer available"));
                else
                {
                    can_reload = 1;
                    if (bufIsChanged(buf))
                        mesg = ((char *)("W12: Warning: File \"%s\" has changed and the buffer was changed in Vim as well"));
                    else if (orig_size != buf->b_orig_size
                            || buf_contents_changed(buf))
                        mesg = ((char *)("W11: Warning: File \"%s\" has changed since editing started"));
                    else if (orig_mode != buf->b_orig_mode)
                        mesg = ((char *)("W16: Warning: Mode of file \"%s\" has changed since editing started"));
                }
            }
        }
    }
    else if ((buf->b_flags & 0x10) && !(buf->b_flags & 0x20)
                                                && vim_fexists(buf->b_ffname))
    {
        retval = 1;
        mesg = ((char *)("W13: Warning: File \"%s\" has been created after editing started"));
        buf->b_flags |= 0x20;
        can_reload = 1;
    }
    if (mesg != ((void *)0))
    {
        path = home_replace_save(buf, buf->b_fname);
        if (path != ((void *)0))
        {
            tbuf = alloc((unsigned)(strlen((char *)(path)) + strlen((char *)(mesg))));
            sprintf((char *)tbuf, mesg, path);
            if (can_reload)
            {
                if (do_dialog(2, (char_u *)((char *)("Warning")), tbuf,
                                (char_u *)((char *)("&OK\n&Load File")), 1, ((void *)0)) == 2)
                    reload = 1;
            }
            else
            if (State > (0x100 + 0x01) || (State & 0x08) || already_warned)
            {
                emsg((char_u *)(tbuf));
                retval = 2;
            }
            else
            {
                if (!autocmd_busy)
                {
                    msg_start();
                    msg_puts_attr(tbuf, highlight_attr[(int)(HLF_E)] + 0x1000);
                    msg_clr_eos();
                    (void)msg_end();
                    if (emsg_silent == 0)
                    {
                        out_flush();
                        if (!focus)
                            ui_delay(1000L, 1);
                        redraw_cmdline = 0;
                    }
                }
                already_warned = 1;
            }
            vim_free(path);
            vim_free(tbuf);
        }
    }
    if (reload)
    {
        exarg_T ea;
        pos_T old_cursor;
        linenr_T old_topline;
        int old_ro = curbuf->b_p_ro;
        buf_T *savebuf;
        int saved = 1;
        aco_save_T aco;
        aucmd_prepbuf(&aco, buf);
        if (prep_exarg(&ea, buf) == 1)
        {
            old_cursor = curwin->w_cursor;
            old_topline = curwin->w_topline;
            if ((curbuf->b_ml.ml_line_count == 1 && *ml_get((linenr_T)1) == '\000'))
                savebuf = ((void *)0);
            else
            {
                savebuf = buflist_new(((void *)0), ((void *)0), (linenr_T)1, 4);
                if (savebuf != ((void *)0))
                {
                    curbuf = savebuf;
                    curwin->w_buffer = savebuf;
                    saved = ml_open();
                    curbuf = buf;
                    curwin->w_buffer = buf;
                }
                if (savebuf == ((void *)0) || saved == 0
                                          || move_lines(buf, savebuf) == 0)
                {
                    emsg2((char_u *)(((char *)("E462: Could not prepare for reloading \"%s\""))), (char_u *)(buf->b_fname));
                    saved = 0;
                }
            }
            if (saved == 1)
            {
                curbuf->b_flags |= 0x02;
                keep_filetype = 1;
                if (readfile(buf->b_ffname, buf->b_fname, (linenr_T)0,
                            (linenr_T)0,
                            (linenr_T)(0x7fffffffL), &ea, 0x01) == 0)
                {
                    if (!aborting())
                        emsg2((char_u *)(((char *)("E321: Could not reload \"%s\""))), (char_u *)(buf->b_fname));
                    if (savebuf != ((void *)0))
                    {
                        while (!(curbuf->b_ml.ml_line_count == 1 && *ml_get((linenr_T)1) == '\000'))
                            if (ml_delete(curbuf->b_ml.ml_line_count, 0)
                                                                      == 0)
                                break;
                        (void)move_lines(savebuf, buf);
                    }
                }
                else
                {
                    unchanged(buf, 1);
                    u_blockfree(buf);
                    u_clearall(buf);
                }
            }
            vim_free(ea.cmd);
            if (savebuf != ((void *)0))
                wipe_buffer(savebuf, 0);
            diff_invalidate();
            if (old_topline > curbuf->b_ml.ml_line_count)
                curwin->w_topline = curbuf->b_ml.ml_line_count;
            else
                curwin->w_topline = old_topline;
            curwin->w_cursor = old_cursor;
            check_cursor();
            update_topline();
            keep_filetype = 0;
            {
                win_T *wp;
                for (wp = firstwin; wp != ((void *)0); wp = wp->w_next)
                    if (wp->w_buffer == curwin->w_buffer
                            && !foldmethodIsManual(wp))
                        foldUpdateAll(wp);
            }
            if (orig_mode == curbuf->b_orig_mode)
                curbuf->b_p_ro |= old_ro;
        }
        aucmd_restbuf(&aco);
    }
    need_mouse_correct = save_mouse_correct;
    return retval;
}
    void buf_store_time(buf, st, fname)
    buf_T *buf;
    struct stat *st;
    char_u *fname;
{
    buf->b_mtime = (long)st->st_mtime;
    buf->b_orig_size = (size_t)st->st_size;
    buf->b_orig_mode = (int)st->st_mode;
}
    void write_lnum_adjust(offset)
    linenr_T offset;
{
    if (write_no_eol_lnum)
        write_no_eol_lnum += offset;
}
static long temp_count = 0;
    void vim_deltempdir()
{
    char_u **files;
    int file_count;
    int i;
    if (vim_tempdir != ((void *)0))
    {
        sprintf((char *)NameBuff, "%s*", vim_tempdir);
        if (gen_expand_wildcards(1, &NameBuff, &file_count, &files,
                                              1|2|32) == 1)
        {
            for (i = 0; i < file_count; ++i)
                unlink((char *)(files[i]));
            FreeWild(file_count, files);
        }
        gettail(NameBuff)[-1] = '\000';
        (void)rmdir((char *)(NameBuff));
        vim_free(vim_tempdir);
        vim_tempdir = ((void *)0);
    }
}
    char_u * vim_tempname(extra_char)
    int extra_char;
{
    char_u itmp[256];
    static char *(tempdirs[]) = {"$TMPDIR", "/tmp", ".", "$HOME"};
    int i;
    long nr;
    long off;
    if (vim_tempdir == ((void *)0))
    {
        for (i = 0; i < sizeof(tempdirs) / sizeof(char *); ++i)
        {
            expand_env((char_u *)tempdirs[i], itmp, 256 - 20);
            if (mch_isdir(itmp))
            {
                    add_pathsep(itmp);
                nr = (mch_get_pid() + (long)time(((void *)0))) % 1000000L;
                for (off = 0; off < 10000L; ++off)
                {
                    int r;
                    mode_t umask_save;
                    sprintf((char *)itmp + strlen((char *)(itmp)), "v%ld", nr + off);
                    umask_save = umask(077);
                    r = mkdir((char *)(itmp), 0700);
                    (void)umask(umask_save);
                    if (r == 0)
                    {
                        char_u *buf;
                        buf = alloc((unsigned)1024 + 1);
                        if (buf != ((void *)0))
                        {
                            if (vim_FullName(itmp, buf, 1024, 0)
                                                                      == 0)
                                strcpy((char *)(buf), (char *)(itmp));
                                add_pathsep(buf);
                            vim_tempdir = vim_strsave(buf);
                            vim_free(buf);
                        }
                        break;
                    }
                    if ((*__errno_location ()) != 17)
                        break;
                }
                if (vim_tempdir != ((void *)0))
                    break;
            }
        }
    }
    if (vim_tempdir != ((void *)0))
    {
        sprintf((char *)itmp, "%s%ld", vim_tempdir, temp_count++);
        return vim_strsave(itmp);
    }
    return ((void *)0);
}
static struct event_name
{
    char *name;
    EVENT_T event;
} event_names[] =
{
    {"BufAdd", EVENT_BUFADD},
    {"BufCreate", EVENT_BUFADD},
    {"BufDelete", EVENT_BUFDELETE},
    {"BufEnter", EVENT_BUFENTER},
    {"BufFilePost", EVENT_BUFFILEPOST},
    {"BufFilePre", EVENT_BUFFILEPRE},
    {"BufHidden", EVENT_BUFHIDDEN},
    {"BufLeave", EVENT_BUFLEAVE},
    {"BufNew", EVENT_BUFNEW},
    {"BufNewFile", EVENT_BUFNEWFILE},
    {"BufRead", EVENT_BUFREADPOST},
    {"BufReadCmd", EVENT_BUFREADCMD},
    {"BufReadPost", EVENT_BUFREADPOST},
    {"BufReadPre", EVENT_BUFREADPRE},
    {"BufUnload", EVENT_BUFUNLOAD},
    {"BufWinEnter", EVENT_BUFWINENTER},
    {"BufWinLeave", EVENT_BUFWINLEAVE},
    {"BufWipeout", EVENT_BUFWIPEOUT},
    {"BufWrite", EVENT_BUFWRITEPRE},
    {"BufWritePost", EVENT_BUFWRITEPOST},
    {"BufWritePre", EVENT_BUFWRITEPRE},
    {"BufWriteCmd", EVENT_BUFWRITECMD},
    {"CmdwinEnter", EVENT_CMDWINENTER},
    {"CmdwinLeave", EVENT_CMDWINLEAVE},
    {"EncodingChanged", EVENT_ENCODINGCHANGED},
    {"FileEncoding", EVENT_ENCODINGCHANGED},
    {"CursorHold", EVENT_CURSORHOLD},
    {"FileAppendPost", EVENT_FILEAPPENDPOST},
    {"FileAppendPre", EVENT_FILEAPPENDPRE},
    {"FileAppendCmd", EVENT_FILEAPPENDCMD},
    {"FileChangedShell",EVENT_FILECHANGEDSHELL},
    {"FileChangedRO", EVENT_FILECHANGEDRO},
    {"FileReadPost", EVENT_FILEREADPOST},
    {"FileReadPre", EVENT_FILEREADPRE},
    {"FileReadCmd", EVENT_FILEREADCMD},
    {"FileType", EVENT_FILETYPE},
    {"FileWritePost", EVENT_FILEWRITEPOST},
    {"FileWritePre", EVENT_FILEWRITEPRE},
    {"FileWriteCmd", EVENT_FILEWRITECMD},
    {"FilterReadPost", EVENT_FILTERREADPOST},
    {"FilterReadPre", EVENT_FILTERREADPRE},
    {"FilterWritePost", EVENT_FILTERWRITEPOST},
    {"FilterWritePre", EVENT_FILTERWRITEPRE},
    {"FocusGained", EVENT_FOCUSGAINED},
    {"FocusLost", EVENT_FOCUSLOST},
    {"FuncUndefined", EVENT_FUNCUNDEFINED},
    {"GUIEnter", EVENT_GUIENTER},
    {"RemoteReply", EVENT_REMOTEREPLY},
    {"StdinReadPost", EVENT_STDINREADPOST},
    {"StdinReadPre", EVENT_STDINREADPRE},
    {"Syntax", EVENT_SYNTAX},
    {"TermChanged", EVENT_TERMCHANGED},
    {"TermResponse", EVENT_TERMRESPONSE},
    {"User", EVENT_USER},
    {"VimEnter", EVENT_VIMENTER},
    {"VimLeave", EVENT_VIMLEAVE},
    {"VimLeavePre", EVENT_VIMLEAVEPRE},
    {"WinEnter", EVENT_WINENTER},
    {"WinLeave", EVENT_WINLEAVE},
    {((void *)0), (EVENT_T)0}
};
static AutoPat *first_autopat[NUM_EVENTS] =
{
    ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0),
    ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0),
    ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0),
    ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0),
    ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0), ((void *)0)
};
garray_T augroups = {0, 0, sizeof(char_u *), 10, ((void *)0)};
static int current_augroup = -1;
static int au_need_clean = 0;
static void show_autocmd (AutoPat *ap, EVENT_T event);
static void au_remove_pat (AutoPat *ap);
static void au_remove_cmds (AutoPat *ap);
static void au_cleanup (void);
static int au_new_group (char_u *name);
static void au_del_group (char_u *name);
static int au_find_group (char_u *name);
static EVENT_T event_name2nr (char_u *start, char_u **end);
static char_u *event_nr2name (EVENT_T event);
static char_u *find_end_event (char_u *arg);
static int event_ignored (EVENT_T event);
static int au_get_grouparg (char_u **argp);
static int do_autocmd_event (EVENT_T event, char_u *pat, int nested, char_u *cmd, int forceit, int group);
static char_u *getnextac (int c, void *cookie, int indent);
static int apply_autocmds_group (EVENT_T event, char_u *fname, char_u *fname_io, int force, int group, buf_T *buf, exarg_T *eap);
static void auto_next_pat (AutoPatCmd *apc, int stop_at_last);
static EVENT_T last_event;
static int last_group;
    static void show_autocmd(ap, event)
    AutoPat *ap;
    EVENT_T event;
{
    AutoCmd *ac;
    if (got_int)
        return;
    if (ap->pat == ((void *)0))
        return;
    msg_putchar('\n');
    if (got_int)
        return;
    if (event != last_event || ap->group != last_group)
    {
        if (ap->group != -1)
        {
            if ((((char_u **)augroups.ga_data)[ap->group]) == ((void *)0))
                msg_puts_attr((char_u *)((char *)("--Deleted--")), highlight_attr[(int)(HLF_E)]);
            else
                msg_puts_attr((((char_u **)augroups.ga_data)[ap->group]), highlight_attr[(int)(HLF_T)]);
            msg_puts((char_u *)"  ");
        }
        msg_puts_attr(event_nr2name(event), highlight_attr[(int)(HLF_T)]);
        last_event = event;
        last_group = ap->group;
        msg_putchar('\n');
        if (got_int)
            return;
    }
    msg_col = 4;
    msg_outtrans(ap->pat);
    for (ac = ap->cmds; ac != ((void *)0); ac = ac->next)
    {
        if (ac->cmd != ((void *)0))
        {
            if (msg_col >= 14)
                msg_putchar('\n');
            msg_col = 14;
            if (got_int)
                return;
            msg_outtrans(ac->cmd);
            if (got_int)
                return;
            if (ac->next != ((void *)0))
            {
                msg_putchar('\n');
                if (got_int)
                    return;
            }
        }
    }
}
    static void au_remove_pat(ap)
    AutoPat *ap;
{
    vim_free(ap->pat);
    ap->pat = ((void *)0);
    au_need_clean = 1;
}
    static void au_remove_cmds(ap)
    AutoPat *ap;
{
    AutoCmd *ac;
    for (ac = ap->cmds; ac != ((void *)0); ac = ac->next)
    {
        vim_free(ac->cmd);
        ac->cmd = ((void *)0);
    }
    au_need_clean = 1;
}
    static void au_cleanup()
{
    AutoPat *ap, **prev_ap;
    AutoCmd *ac, **prev_ac;
    EVENT_T event;
    if (autocmd_busy || !au_need_clean)
        return;
    for (event = (EVENT_T)0; (int)event < (int)NUM_EVENTS;
                                            event = (EVENT_T)((int)event + 1))
    {
        prev_ap = &(first_autopat[(int)event]);
        for (ap = *prev_ap; ap != ((void *)0); ap = *prev_ap)
        {
            prev_ac = &(ap->cmds);
            for (ac = *prev_ac; ac != ((void *)0); ac = *prev_ac)
            {
                if (ap->pat == ((void *)0) || ac->cmd == ((void *)0))
                {
                    *prev_ac = ac->next;
                    vim_free(ac->cmd);
                    vim_free(ac);
                }
                else
                    prev_ac = &(ac->next);
            }
            if (ap->pat == ((void *)0))
            {
                *prev_ap = ap->next;
                vim_free(ap->reg_pat);
                vim_free(ap);
            }
            else
                prev_ap = &(ap->next);
        }
    }
    au_need_clean = 0;
}
    static int au_new_group(name)
    char_u *name;
{
    int i;
    i = au_find_group(name);
    if (i == -2)
    {
        for (i = 0; i < augroups.ga_len; ++i)
            if ((((char_u **)augroups.ga_data)[i]) == ((void *)0))
                break;
        if (i == augroups.ga_len && ga_grow(&augroups, 1) == 0)
            return -2;
        (((char_u **)augroups.ga_data)[i]) = vim_strsave(name);
        if ((((char_u **)augroups.ga_data)[i]) == ((void *)0))
            return -2;
        if (i == augroups.ga_len)
        {
            ++augroups.ga_len;
            --augroups.ga_room;
        }
    }
    return i;
}
    static void au_del_group(name)
    char_u *name;
{
    int i;
    i = au_find_group(name);
    if (i == -2)
        emsg2((char_u *)(((char *)("E367: No such group: \"%s\""))), (char_u *)(name));
    else
    {
        vim_free((((char_u **)augroups.ga_data)[i]));
        (((char_u **)augroups.ga_data)[i]) = ((void *)0);
    }
}
    static int au_find_group(name)
    char_u *name;
{
    int i;
    for (i = 0; i < augroups.ga_len; ++i)
        if ((((char_u **)augroups.ga_data)[i]) != ((void *)0) && strcmp((char *)((((char_u **)augroups.ga_data)[i])), (char *)(name)) == 0)
            return i;
    return -2;
}
    void do_augroup(arg, del_group)
    char_u *arg;
    int del_group;
{
    int i;
    if (del_group)
    {
        if (*arg == '\000')
            emsg((char_u *)(((char *)(e_argreq))));
        else
            au_del_group(arg);
    }
    else if (strcasecmp((char *)(arg), (char *)("end")) == 0)
        current_augroup = -1;
    else if (*arg)
    {
        i = au_new_group(arg);
        if (i != -2)
            current_augroup = i;
    }
    else
    {
        msg_start();
        for (i = 0; i < augroups.ga_len; ++i)
        {
            if ((((char_u **)augroups.ga_data)[i]) != ((void *)0))
            {
                msg_puts((((char_u **)augroups.ga_data)[i]));
                msg_puts((char_u *)"  ");
            }
        }
        msg_clr_eos();
        msg_end();
    }
}
    static EVENT_T event_name2nr(start, end)
    char_u *start;
    char_u **end;
{
    char_u *p;
    int i;
    int len;
    for (p = start; *p && !((*p) == ' ' || (*p) == '\t') && *p != ','; ++p)
        ;
    for (i = 0; event_names[i].name != ((void *)0); ++i)
    {
        len = (int)strlen((char *)(event_names[i].name));
        if (len == p - start && strncasecmp((char *)(event_names[i].name), (char *)(start), (size_t)(len)) == 0)
            break;
    }
    if (*p == ',')
        ++p;
    *end = p;
    if (event_names[i].name == ((void *)0))
        return NUM_EVENTS;
    return event_names[i].event;
}
    static char_u * event_nr2name(event)
    EVENT_T event;
{
    int i;
    for (i = 0; event_names[i].name != ((void *)0); ++i)
        if (event_names[i].event == event)
            return (char_u *)event_names[i].name;
    return (char_u *)"Unknown";
}
    static char_u * find_end_event(arg)
    char_u *arg;
{
    char_u *pat;
    char_u *p;
    if (*arg == '*')
    {
        if (arg[1] && !((arg[1]) == ' ' || (arg[1]) == '\t'))
        {
            emsg2((char_u *)(((char *)("E215: Illegal character after *: %s"))), (char_u *)(arg));
            return ((void *)0);
        }
        pat = arg + 1;
    }
    else
    {
        for (pat = arg; *pat && !((*pat) == ' ' || (*pat) == '\t'); pat = p)
        {
            if ((int)event_name2nr(pat, &p) >= (int)NUM_EVENTS)
            {
                emsg2((char_u *)(((char *)("E216: No such event: %s"))), (char_u *)(pat));
                return ((void *)0);
            }
        }
    }
    return pat;
}
    static int event_ignored(event)
    EVENT_T event;
{
    char_u *p = p_ei;
    if (strcasecmp((char *)(p_ei), (char *)("all")) == 0)
        return 1;
    while (*p)
        if (event_name2nr(p, &p) == event)
            return 1;
    return 0;
}
    int check_ei()
{
    char_u *p = p_ei;
    if (strcasecmp((char *)(p_ei), (char *)("all")) == 0)
        return 1;
    while (*p)
        if (event_name2nr(p, &p) == NUM_EVENTS)
            return 0;
    return 1;
}
    void do_autocmd(arg, forceit)
    char_u *arg;
    int forceit;
{
    char_u *pat;
    char_u *envpat = ((void *)0);
    char_u *cmd;
    EVENT_T event;
    int need_free = 0;
    int nested = 0;
    int group;
    group = au_get_grouparg(&arg);
    if (arg == ((void *)0))
        return;
    pat = find_end_event(arg);
    if (pat == ((void *)0))
        return;
    pat = skipwhite(pat);
    cmd = pat;
    while (*cmd && (!((*cmd) == ' ' || (*cmd) == '\t') || cmd[-1] == '\\'))
        cmd++;
    if (*cmd)
        *cmd++ = '\000';
    if (vim_strchr(pat, '$') != ((void *)0) || vim_strchr(pat, '~') != ((void *)0))
    {
        envpat = expand_env_save(pat);
        if (envpat != ((void *)0))
            pat = envpat;
    }
    cmd = skipwhite(cmd);
    if (*cmd != '\000' && strncmp((char *)(cmd), (char *)("nested"), (size_t)(6)) == 0 && ((cmd[6]) == ' ' || (cmd[6]) == '\t'))
    {
        nested = 1;
        cmd = skipwhite(cmd + 6);
    }
    if (*cmd != '\000')
    {
        cmd = expand_sfile(cmd);
        if (cmd == ((void *)0))
            return;
        need_free = 1;
    }
    if (!forceit && *cmd == '\000')
    {
        msg_puts_title((char_u *)(((char *)("\n--- Auto-Commands ---"))));
    }
    last_event = (EVENT_T)-1;
    last_group = -2;
    if (*arg == '*' || *arg == '\000')
    {
        for (event = (EVENT_T)0; (int)event < (int)NUM_EVENTS;
                                            event = (EVENT_T)((int)event + 1))
            if (do_autocmd_event(event, pat,
                                         nested, cmd, forceit, group) == 0)
                break;
    }
    else
    {
        while (*arg && !((*arg) == ' ' || (*arg) == '\t'))
            if (do_autocmd_event(event_name2nr(arg, &arg), pat,
                                        nested, cmd, forceit, group) == 0)
                break;
    }
    if (need_free)
        vim_free(cmd);
    vim_free(envpat);
}
    static int au_get_grouparg(argp)
    char_u **argp;
{
    char_u *group_name;
    char_u *p;
    char_u *arg = *argp;
    int group = -3;
    p = skiptowhite(arg);
    if (p > arg)
    {
        group_name = vim_strnsave(arg, (int)(p - arg));
        if (group_name == ((void *)0))
            return -2;
        group = au_find_group(group_name);
        if (group == -2)
            group = -3;
        else
            *argp = skipwhite(p);
        vim_free(group_name);
    }
    return group;
}
    static int do_autocmd_event(event, pat, nested, cmd, forceit, group)
    EVENT_T event;
    char_u *pat;
    int nested;
    char_u *cmd;
    int forceit;
    int group;
{
    AutoPat *ap;
    AutoPat **prev_ap;
    AutoCmd *ac;
    AutoCmd **prev_ac;
    int brace_level;
    char_u *endpat;
    int findgroup;
    int allgroups;
    int patlen;
    if (group == -3)
        findgroup = current_augroup;
    else
        findgroup = group;
    allgroups = (group == -3 && !forceit && *cmd == '\000');
    if (*pat == '\000')
    {
        for (ap = first_autopat[(int)event]; ap != ((void *)0); ap = ap->next)
        {
            if (forceit)
            {
                if (ap->group == findgroup)
                    au_remove_pat(ap);
            }
            else if (group == -3 || ap->group == group)
                show_autocmd(ap, event);
        }
    }
    for ( ; *pat; pat = (*endpat == ',' ? endpat + 1 : endpat))
    {
        brace_level = 0;
        for (endpat = pat; *endpat && (*endpat != ',' || brace_level
                                             || endpat[-1] == '\\'); ++endpat)
        {
            if (*endpat == '{')
                brace_level++;
            else if (*endpat == '}')
                brace_level--;
        }
        if (pat == endpat)
            continue;
        patlen = (int)(endpat - pat);
        prev_ap = &first_autopat[(int)event];
        while ((ap = *prev_ap) != ((void *)0))
        {
            if (ap->pat != ((void *)0))
            {
                if ((allgroups || ap->group == findgroup)
                        && ap->patlen == patlen
                        && strncmp((char *)(pat), (char *)(ap->pat), (size_t)(patlen)) == 0)
                {
                    if (forceit)
                    {
                        if (*cmd != '\000' && ap->next == ((void *)0))
                        {
                            au_remove_cmds(ap);
                            break;
                        }
                        au_remove_pat(ap);
                    }
                    else if (*cmd == '\000')
                        show_autocmd(ap, event);
                    else if (ap->next == ((void *)0))
                        break;
                }
            }
            prev_ap = &ap->next;
        }
        if (*cmd != '\000')
        {
            if (ap == ((void *)0))
            {
                ap = (AutoPat *)alloc((unsigned)sizeof(AutoPat));
                if (ap == ((void *)0))
                    return 0;
                ap->pat = vim_strnsave(pat, patlen);
                ap->patlen = patlen;
                if (ap->pat == ((void *)0))
                {
                    vim_free(ap);
                    return 0;
                }
                ap->reg_pat = file_pat_to_reg_pat(pat, endpat,
                                                       &ap->allow_dirs, 1);
                if (ap->reg_pat == ((void *)0))
                {
                    vim_free(ap->pat);
                    vim_free(ap);
                    return 0;
                }
                ap->cmds = ((void *)0);
                *prev_ap = ap;
                ap->next = ((void *)0);
                if (group == -3)
                    ap->group = current_augroup;
                else
                    ap->group = group;
            }
            prev_ac = &(ap->cmds);
            while ((ac = *prev_ac) != ((void *)0))
                prev_ac = &ac->next;
            ac = (AutoCmd *)alloc((unsigned)sizeof(AutoCmd));
            if (ac == ((void *)0))
                return 0;
            ac->cmd = vim_strsave(cmd);
            ac->scriptID = current_SID;
            if (ac->cmd == ((void *)0))
            {
                vim_free(ac);
                return 0;
            }
            ac->next = ((void *)0);
            *prev_ac = ac;
            ac->nested = nested;
        }
    }
    au_cleanup();
    return 1;
}
    int do_doautocmd(arg, do_msg)
    char_u *arg;
    int do_msg;
{
    char_u *fname;
    int nothing_done = 1;
    int group;
    group = au_get_grouparg(&arg);
    if (arg == ((void *)0))
        return 0;
    if (*arg == '*')
    {
        emsg((char_u *)(((char *)("E217: Can't execute autocommands for ALL events"))));
        return 0;
    }
    fname = find_end_event(arg);
    if (fname == ((void *)0))
        return 0;
    fname = skipwhite(fname);
    while (*arg && !((*arg) == ' ' || (*arg) == '\t'))
        if (apply_autocmds_group(event_name2nr(arg, &arg),
                                      fname, ((void *)0), 1, group, curbuf, ((void *)0)))
            nothing_done = 0;
    if (nothing_done && do_msg)
        msg((char_u *)(((char *)("No matching autocommands"))));
    return aborting() ? 0 : 1;
}
    void ex_doautoall(eap)
    exarg_T *eap;
{
    int retval;
    aco_save_T aco;
    buf_T *buf;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (curbuf->b_ml.ml_mfp != ((void *)0))
        {
            aucmd_prepbuf(&aco, buf);
            retval = do_doautocmd(eap->arg, 0);
            do_modelines();
            aucmd_restbuf(&aco);
            if (retval == 0 || !buf_valid(buf))
                break;
        }
    }
    check_cursor();
}
    void aucmd_prepbuf(aco, buf)
    aco_save_T *aco;
    buf_T *buf;
{
    win_T *win;
    aco->new_curbuf = buf;
    if (buf == curbuf)
        win = curwin;
    else
        for (win = firstwin; win != ((void *)0); win = win->w_next)
            if (win->w_buffer == buf)
                break;
    if (win != ((void *)0))
    {
        aco->save_curwin = curwin;
        curwin = win;
        aco->save_buf = win->w_buffer;
        aco->new_curwin = win;
    }
    else
    {
        aco->save_curwin = ((void *)0);
        aco->save_buf = curbuf;
        --curbuf->b_nwindows;
        curwin->w_buffer = buf;
        ++buf->b_nwindows;
        aco->save_cursor = curwin->w_cursor;
        curwin->w_cursor.lnum = 1;
        curwin->w_cursor.col = 0;
        aco->save_topline = curwin->w_topline;
        curwin->w_topline = 1;
        aco->save_topfill = curwin->w_topfill;
        curwin->w_topfill = 0;
    }
    curbuf = buf;
}
    void aucmd_restbuf(aco)
    aco_save_T *aco;
{
    if (aco->save_curwin != ((void *)0))
    {
        if (win_valid(aco->save_curwin))
        {
            if (curwin == aco->new_curwin
                    && buf_valid(aco->save_buf)
                    && aco->save_buf->b_ml.ml_mfp != ((void *)0))
            {
                --curbuf->b_nwindows;
                curbuf = aco->save_buf;
                curwin->w_buffer = curbuf;
                ++curbuf->b_nwindows;
            }
            curwin = aco->save_curwin;
            curbuf = curwin->w_buffer;
        }
    }
    else
    {
        if (buf_valid(aco->save_buf) && aco->save_buf->b_ml.ml_mfp != ((void *)0))
        {
            --curbuf->b_nwindows;
            curbuf = aco->save_buf;
            curwin->w_buffer = curbuf;
            ++curbuf->b_nwindows;
            curwin->w_cursor = aco->save_cursor;
            check_cursor();
            if (aco->save_topline <= curbuf->b_ml.ml_line_count)
            {
                curwin->w_topline = aco->save_topline;
                curwin->w_topfill = aco->save_topfill;
            }
            else
            {
                curwin->w_topline = curbuf->b_ml.ml_line_count;
                curwin->w_topfill = 0;
            }
        }
    }
}
static int autocmd_nested = 0;
    int apply_autocmds(event, fname, fname_io, force, buf)
    EVENT_T event;
    char_u *fname;
    char_u *fname_io;
    int force;
    buf_T *buf;
{
    return apply_autocmds_group(event, fname, fname_io, force,
                                                      -3, buf, ((void *)0));
}
    static int apply_autocmds_exarg(event, fname, fname_io, force, buf, eap)
    EVENT_T event;
    char_u *fname;
    char_u *fname_io;
    int force;
    buf_T *buf;
    exarg_T *eap;
{
    return apply_autocmds_group(event, fname, fname_io, force,
                                                       -3, buf, eap);
}
    int apply_autocmds_retval(event, fname, fname_io, force, buf, retval)
    EVENT_T event;
    char_u *fname;
    char_u *fname_io;
    int force;
    buf_T *buf;
    int *retval;
{
    int did_cmd;
    if (should_abort(*retval))
        return 0;
    did_cmd = apply_autocmds_group(event, fname, fname_io, force,
                                                      -3, buf, ((void *)0));
    if (did_cmd && aborting())
        *retval = 0;
    return did_cmd;
}
    int has_cursorhold()
{
    return (first_autopat[(int)EVENT_CURSORHOLD] != ((void *)0));
}
    static int apply_autocmds_group(event, fname, fname_io, force, group, buf, eap)
    EVENT_T event;
    char_u *fname;
    char_u *fname_io;
    int force;
    int group;
    buf_T *buf;
    exarg_T *eap;
{
    char_u *sfname = ((void *)0);
    char_u *tail;
    int save_changed;
    buf_T *old_curbuf;
    int retval = 0;
    char_u *save_sourcing_name;
    linenr_T save_sourcing_lnum;
    char_u *save_autocmd_fname;
    int save_autocmd_bufnr;
    char_u *save_autocmd_match;
    int save_autocmd_busy;
    int save_autocmd_nested;
    static int nesting = 0;
    AutoPatCmd patcmd;
    AutoPat *ap;
    scid_T save_current_SID;
    void *save_funccalp;
    char_u *save_cmdarg;
    static int filechangeshell_busy = 0;
    if (first_autopat[(int)event] == ((void *)0) || autocmd_block > 0)
        return retval;
    if (autocmd_busy && !(force || autocmd_nested))
        return retval;
    if (aborting())
        return retval;
    if (filechangeshell_busy && event == EVENT_FILECHANGEDSHELL)
        return retval;
    if (event_ignored(event))
        return retval;
    if (nesting == 10)
    {
        emsg((char_u *)(((char *)("E218: autocommand nesting too deep"))));
        return retval;
    }
    if ( (autocmd_no_enter
                && (event == EVENT_WINENTER || event == EVENT_BUFENTER))
            || (autocmd_no_leave
                && (event == EVENT_WINLEAVE || event == EVENT_BUFLEAVE)))
        return retval;
    save_autocmd_fname = autocmd_fname;
    save_autocmd_bufnr = autocmd_bufnr;
    save_autocmd_match = autocmd_match;
    save_autocmd_busy = autocmd_busy;
    save_autocmd_nested = autocmd_nested;
    save_changed = curbuf->b_changed;
    old_curbuf = curbuf;
    if (fname_io == ((void *)0))
    {
        if (fname != ((void *)0) && *fname != '\000')
            autocmd_fname = fname;
        else if (buf != ((void *)0))
            autocmd_fname = buf->b_fname;
        else
            autocmd_fname = ((void *)0);
    }
    else
        autocmd_fname = fname_io;
    if (buf == ((void *)0))
        autocmd_bufnr = 0;
    else
        autocmd_bufnr = buf->b_fnum;
    if (fname == ((void *)0) || *fname == '\000')
    {
        if (buf == ((void *)0))
            fname = ((void *)0);
        else
        {
            if (event == EVENT_SYNTAX)
                fname = buf->b_p_syn;
            else
                if (event == EVENT_FILETYPE)
                    fname = buf->b_p_ft;
                else
                {
                    if (buf->b_sfname != ((void *)0))
                        sfname = vim_strsave(buf->b_sfname);
                    fname = buf->b_ffname;
                }
        }
        if (fname == ((void *)0))
            fname = (char_u *)"";
        fname = vim_strsave(fname);
    }
    else
    {
        sfname = vim_strsave(fname);
        if (event == EVENT_FILETYPE || event == EVENT_SYNTAX
                || event == EVENT_REMOTEREPLY)
            fname = vim_strsave(fname);
        else
            fname = FullName_save(fname, 0);
    }
    if (fname == ((void *)0))
    {
        vim_free(sfname);
        return 0;
    }
    autocmd_match = fname;
    ++RedrawingDisabled;
    save_sourcing_name = sourcing_name;
    sourcing_name = ((void *)0);
    save_sourcing_lnum = sourcing_lnum;
    sourcing_lnum = 0;
    save_current_SID = current_SID;
    save_funccalp = save_funccal();
    if (!autocmd_busy)
    {
        save_search_patterns();
        saveRedobuff();
        did_filetype = keep_filetype;
    }
    autocmd_busy = 1;
    filechangeshell_busy = (event == EVENT_FILECHANGEDSHELL);
    ++nesting;
    if (event == EVENT_FILETYPE)
        did_filetype = 1;
    tail = gettail(fname);
    patcmd.curpat = first_autopat[(int)event];
    patcmd.nextcmd = ((void *)0);
    patcmd.group = group;
    patcmd.fname = fname;
    patcmd.sfname = sfname;
    patcmd.tail = tail;
    patcmd.event = event;
    auto_next_pat(&patcmd, 0);
    if (patcmd.curpat != ((void *)0))
    {
        if (eap != ((void *)0))
            save_cmdarg = set_cmdarg(eap, ((void *)0));
        else
            save_cmdarg = ((void *)0);
        retval = 1;
        for (ap = patcmd.curpat; ap->next != ((void *)0); ap = ap->next)
            ap->last = 0;
        ap->last = 1;
        check_lnums(1);
        do_cmdline(((void *)0), getnextac, (void *)&patcmd,
                                     0x02|0x01|0x04);
        if (eap != ((void *)0))
            (void)set_cmdarg(((void *)0), save_cmdarg);
    }
    --RedrawingDisabled;
    autocmd_busy = save_autocmd_busy;
    filechangeshell_busy = 0;
    autocmd_nested = save_autocmd_nested;
    vim_free(sourcing_name);
    sourcing_name = save_sourcing_name;
    sourcing_lnum = save_sourcing_lnum;
    autocmd_fname = save_autocmd_fname;
    autocmd_bufnr = save_autocmd_bufnr;
    autocmd_match = save_autocmd_match;
    current_SID = save_current_SID;
    restore_funccal(save_funccalp);
    vim_free(fname);
    vim_free(sfname);
    --nesting;
    if (!autocmd_busy)
    {
        restore_search_patterns();
        restoreRedobuff();
        did_filetype = 0;
    }
    if (curbuf == old_curbuf
            && (event == EVENT_BUFREADPOST
                || event == EVENT_BUFWRITEPOST
                || event == EVENT_FILEAPPENDPOST
                || event == EVENT_VIMLEAVE
                || event == EVENT_VIMLEAVEPRE))
    {
        if (curbuf->b_changed != save_changed)
            need_maketitle = 1;
        curbuf->b_changed = save_changed;
    }
    au_cleanup();
    return retval;
}
    static void auto_next_pat(apc, stop_at_last)
    AutoPatCmd *apc;
    int stop_at_last;
{
    AutoPat *ap;
    AutoCmd *cp;
    char_u *name;
    char *s;
    vim_free(sourcing_name);
    sourcing_name = ((void *)0);
    for (ap = apc->curpat; ap != ((void *)0) && !got_int; ap = ap->next)
    {
        apc->curpat = ((void *)0);
        if (ap->pat != ((void *)0) && ap->cmds != ((void *)0)
                && (apc->group == -3 || apc->group == ap->group))
        {
            if (match_file_pat(ap->reg_pat, apc->fname, apc->sfname, apc->tail,
                                                              ap->allow_dirs))
            {
                name = event_nr2name(apc->event);
                s = ((char *)("%s Auto commands for \"%s\""));
                sourcing_name = alloc((unsigned)(strlen((char *)(s))
                                            + strlen((char *)(name)) + ap->patlen + 1));
                if (sourcing_name != ((void *)0))
                {
                    sprintf((char *)sourcing_name, s,
                                               (char *)name, (char *)ap->pat);
                    if (p_verbose >= 8)
                        msg_str((char_u *)((char *)("Executing %s")), sourcing_name);
                }
                apc->curpat = ap;
                apc->nextcmd = ap->cmds;
                for (cp = ap->cmds; cp->next != ((void *)0); cp = cp->next)
                    cp->last = 0;
                cp->last = 1;
            }
            line_breakcheck();
            if (apc->curpat != ((void *)0))
                break;
        }
        if (stop_at_last && ap->last)
            break;
    }
}
    static char_u * getnextac(c, cookie, indent)
    int c;
    void *cookie;
    int indent;
{
    AutoPatCmd *acp = (AutoPatCmd *)cookie;
    char_u *retval;
    AutoCmd *ac;
    if (acp->curpat == ((void *)0))
        return ((void *)0);
    for (;;)
    {
        while (acp->nextcmd != ((void *)0) && acp->nextcmd->cmd == ((void *)0))
            if (acp->nextcmd->last)
                acp->nextcmd = ((void *)0);
            else
                acp->nextcmd = acp->nextcmd->next;
        if (acp->nextcmd != ((void *)0))
            break;
        if (acp->curpat->last)
            acp->curpat = ((void *)0);
        else
            acp->curpat = acp->curpat->next;
        if (acp->curpat != ((void *)0))
            auto_next_pat(acp, 1);
        if (acp->curpat == ((void *)0))
            return ((void *)0);
    }
    ac = acp->nextcmd;
    if (p_verbose >= 9)
    {
        msg_scroll = 1;
        msg_str((char_u *)((char *)("autocommand %s")), ac->cmd);
        msg_puts((char_u *)"\n");
        cmdline_row = msg_row;
    }
    retval = vim_strsave(ac->cmd);
    autocmd_nested = ac->nested;
    current_SID = ac->scriptID;
    if (ac->last)
        acp->nextcmd = ((void *)0);
    else
        acp->nextcmd = ac->next;
    return retval;
}
    int has_autocmd(event, sfname)
    EVENT_T event;
    char_u *sfname;
{
    AutoPat *ap;
    char_u *fname;
    char_u *tail = gettail(sfname);
    int retval = 0;
    fname = FullName_save(sfname, 0);
    if (fname == ((void *)0))
        return 0;
    for (ap = first_autopat[(int)event]; ap != ((void *)0); ap = ap->next)
        if (ap->pat != ((void *)0) && ap->cmds != ((void *)0)
                && match_file_pat(ap->reg_pat, fname, sfname, tail,
                                                              ap->allow_dirs))
        {
            retval = 1;
            break;
        }
    vim_free(fname);
    return retval;
}
    char_u * get_augroup_name(xp, idx)
    expand_T *xp;
    int idx;
{
    if (idx == augroups.ga_len)
        return (char_u *)"END";
    if (idx >= augroups.ga_len)
        return ((void *)0);
    if ((((char_u **)augroups.ga_data)[idx]) == ((void *)0))
        return (char_u *)"";
    return (((char_u **)augroups.ga_data)[idx]);
}
static int include_groups = 0;
    char_u * set_context_in_autocmd(xp, arg, doautocmd)
    expand_T *xp;
    char_u *arg;
    int doautocmd;
{
    char_u *p;
    int group;
    include_groups = 0;
    p = arg;
    group = au_get_grouparg(&arg);
    if (group == -2)
        return ((void *)0);
    if (*arg == '\000' && group != -3 && !((arg[-1]) == ' ' || (arg[-1]) == '\t'))
    {
        arg = p;
        group = -3;
    }
    for (p = arg; *p != '\000' && !((*p) == ' ' || (*p) == '\t'); ++p)
        if (*p == ',')
            arg = p + 1;
    if (*p == '\000')
    {
        if (group == -3)
            include_groups = 1;
        xp->xp_context = 10;
        xp->xp_pattern = arg;
        return ((void *)0);
    }
    arg = skipwhite(p);
    while (*arg && (!((*arg) == ' ' || (*arg) == '\t') || arg[-1] == '\\'))
        arg++;
    if (*arg)
        return arg;
    if (doautocmd)
        xp->xp_context = 2;
    else
        xp->xp_context = 0;
    return ((void *)0);
}
    char_u * get_event_name(xp, idx)
    expand_T *xp;
    int idx;
{
    if (idx < augroups.ga_len)
    {
        if (!include_groups || (((char_u **)augroups.ga_data)[idx]) == ((void *)0))
            return (char_u *)"";
        return (((char_u **)augroups.ga_data)[idx]);
    }
    return (char_u *)event_names[idx - augroups.ga_len].name;
}
    int au_exists(name, name_end, pattern)
    char_u *name;
    char_u *name_end;
    char_u *pattern;
{
    char_u *event_name;
    char_u *p;
    EVENT_T event;
    AutoPat *ap;
    event_name = vim_strnsave(name, (int)(name_end - name));
    if (event_name == ((void *)0))
        return 0;
    event = event_name2nr(event_name, &p);
    vim_free(event_name);
    if (event == NUM_EVENTS)
        return 0;
    ap = first_autopat[(int)event];
    if (ap == ((void *)0))
        return 0;
    if (pattern == ((void *)0))
        return 1;
    for ( ; ap != ((void *)0); ap = ap->next)
        if (ap->pat != ((void *)0) && ap->cmds != ((void *)0)
                                           && strcmp((char *)(ap->pat), (char *)(pattern)) == 0)
            return 1;
    return 0;
}
    int match_file_pat(pattern, fname, sfname, tail, allow_dirs)
    char_u *pattern;
    char_u *fname;
    char_u *sfname;
    char_u *tail;
    int allow_dirs;
{
    regmatch_T regmatch;
    int result = 0;
    regmatch.rm_ic = 0;
        regmatch.regprog = vim_regcomp(pattern, 1);
    if (
            (regmatch.regprog != ((void *)0)
             && ((allow_dirs
                     && (vim_regexec(&regmatch, fname, (colnr_T)0)
                         || (sfname != ((void *)0)
                             && vim_regexec(&regmatch, sfname, (colnr_T)0))))
                 || (!allow_dirs && vim_regexec(&regmatch, tail, (colnr_T)0)))))
        result = 1;
    vim_free(regmatch.regprog);
    return result;
}
    int match_file_list(list, sfname, ffname)
    char_u *list;
    char_u *sfname;
    char_u *ffname;
{
    char_u buf[100];
    char_u *tail;
    char_u *regpat;
    char allow_dirs;
    int match;
    char_u *p;
    tail = gettail(sfname);
    p = list;
    while (*p)
    {
        copy_option_part(&p, buf, 100, ",");
        regpat = file_pat_to_reg_pat(buf, ((void *)0), &allow_dirs, 0);
        if (regpat == ((void *)0))
            break;
        match = match_file_pat(regpat, ffname, sfname, tail, (int)allow_dirs);
        vim_free(regpat);
        if (match)
            return 1;
    }
    return 0;
}
    char_u * file_pat_to_reg_pat(pat, pat_end, allow_dirs, no_bslash)
    char_u *pat;
    char_u *pat_end;
    char *allow_dirs;
    int no_bslash;
{
    int size;
    char_u *endp;
    char_u *reg_pat;
    char_u *p;
    int i;
    int nested = 0;
    int add_dollar = 1;
    if (allow_dirs != ((void *)0))
        *allow_dirs = 0;
    if (pat_end == ((void *)0))
        pat_end = pat + strlen((char *)(pat));
    size = 2;
    for (p = pat; p < pat_end; p++)
    {
        switch (*p)
        {
            case '*':
            case '.':
            case ',':
            case '{':
            case '}':
            case '~':
                size += 2;
                break;
            default:
                size++;
                break;
        }
    }
    reg_pat = alloc(size + 1);
    if (reg_pat == ((void *)0))
        return ((void *)0);
    i = 0;
    if (pat[0] == '*')
        while (pat[0] == '*' && pat < pat_end - 1)
            pat++;
    else
        reg_pat[i++] = '^';
    endp = pat_end - 1;
    if (*endp == '*')
    {
        while (endp - pat > 0 && *endp == '*')
            endp--;
        add_dollar = 0;
    }
    for (p = pat; *p && nested >= 0 && p <= endp; p++)
    {
        switch (*p)
        {
            case '*':
                reg_pat[i++] = '.';
                reg_pat[i++] = '*';
                break;
            case '.':
            case '~':
                reg_pat[i++] = '\\';
                reg_pat[i++] = *p;
                break;
            case '?':
                reg_pat[i++] = '.';
                break;
            case '\\':
                if (p[1] == '\000')
                    break;
                if (*++p == '?'
                        )
                    reg_pat[i++] = '?';
                else
                    if (*p == ',')
                        reg_pat[i++] = ',';
                    else
                    {
                        if (allow_dirs != ((void *)0) && vim_ispathsep(*p)
                                )
                            *allow_dirs = 1;
                        reg_pat[i++] = '\\';
                        reg_pat[i++] = *p;
                    }
                break;
            case '{':
                reg_pat[i++] = '\\';
                reg_pat[i++] = '(';
                nested++;
                break;
            case '}':
                reg_pat[i++] = '\\';
                reg_pat[i++] = ')';
                --nested;
                break;
            case ',':
                if (nested)
                {
                    reg_pat[i++] = '\\';
                    reg_pat[i++] = '|';
                }
                else
                    reg_pat[i++] = ',';
                break;
            default:
                if (allow_dirs != ((void *)0) && vim_ispathsep(*p))
                    *allow_dirs = 1;
                reg_pat[i++] = *p;
                break;
        }
    }
    if (add_dollar)
        reg_pat[i++] = '$';
    reg_pat[i] = '\000';
    if (nested != 0)
    {
        if (nested < 0)
            emsg((char_u *)(((char *)("E219: Missing {."))));
        else
            emsg((char_u *)(((char *)("E220: Missing }."))));
        vim_free(reg_pat);
        reg_pat = ((void *)0);
    }
    return reg_pat;
}
