typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef int (*__compar_fn_t) (__const void *, __const void *);
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef signed char gint8;
typedef double gdouble;
typedef struct _GList GList;
typedef struct _GdkEventKey GdkEventKey;
typedef enum {
  GDK_VISIBILITY_UNOBSCURED,
  GDK_VISIBILITY_PARTIAL,
  GDK_VISIBILITY_FULLY_OBSCURED
} GdkVisibilityState;
typedef enum
{
  GDK_NOTHING = -1,
  GDK_DELETE = 0,
  GDK_DESTROY = 1,
  GDK_EXPOSE = 2,
  GDK_MOTION_NOTIFY = 3,
  GDK_BUTTON_PRESS = 4,
  GDK_2BUTTON_PRESS = 5,
  GDK_3BUTTON_PRESS = 6,
  GDK_BUTTON_RELEASE = 7,
  GDK_KEY_PRESS = 8,
  GDK_KEY_RELEASE = 9,
  GDK_ENTER_NOTIFY = 10,
  GDK_LEAVE_NOTIFY = 11,
  GDK_FOCUS_CHANGE = 12,
  GDK_CONFIGURE = 13,
  GDK_MAP = 14,
  GDK_UNMAP = 15,
  GDK_PROPERTY_NOTIFY = 16,
  GDK_SELECTION_CLEAR = 17,
  GDK_SELECTION_REQUEST = 18,
  GDK_SELECTION_NOTIFY = 19,
  GDK_PROXIMITY_IN = 20,
  GDK_PROXIMITY_OUT = 21,
  GDK_DRAG_ENTER = 22,
  GDK_DRAG_LEAVE = 23,
  GDK_DRAG_MOTION = 24,
  GDK_DRAG_STATUS = 25,
  GDK_DROP_START = 26,
  GDK_DROP_FINISHED = 27,
  GDK_CLIENT_EVENT = 28,
  GDK_VISIBILITY_NOTIFY = 29,
  GDK_NO_EXPOSE = 30
} GdkEventType;
GdkColormap* gtk_widget_get_colormap (GtkWidget *widget);
struct _GList
{
  gpointer data;
  GList *next;
  GList *prev;
};
struct _GdkEventKey
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  guint state;
  guint keyval;
  gint length;
  gchar *string;
};
typedef gint gboolean;
typedef const void *gconstpointer;
typedef void (*__gconv_trans_end_fct) (void *);
typedef int __io_close_fn (void *__cookie);
typedef gpointer (*GCacheNewFunc) (gpointer key);
typedef gpointer (*GCacheDupFunc) (gpointer value);
typedef void (*GCacheDestroyFunc) (gpointer value);
typedef gchar* (*GCompletionFunc) (gpointer);
typedef void (*GDestroyNotify) (gpointer data);
typedef guint (*GHashFunc) (gconstpointer key);
typedef void (*GFreeFunc) (gpointer data);
typedef void (*GHookFunc) (gpointer data);
typedef gboolean (*GHookCheckFunc) (gpointer data);
typedef gboolean (*GSourceFunc) (gpointer data);
typedef void (*GdkDestroyNotify) (gpointer data);
typedef void (*GtkClassInitFunc) (gpointer klass);
typedef gint (*GtkFunction) (gpointer data);
typedef void (*GtkDestroyNotify) (gpointer data);
typedef unsigned char char_u;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef long glong;
typedef unsigned char guchar;
typedef float gfloat;
typedef enum
{
  G_LOG_FLAG_RECURSION = 1 << 0,
  G_LOG_FLAG_FATAL = 1 << 1,
  G_LOG_LEVEL_ERROR = 1 << 2,
  G_LOG_LEVEL_CRITICAL = 1 << 3,
  G_LOG_LEVEL_WARNING = 1 << 4,
  G_LOG_LEVEL_MESSAGE = 1 << 5,
  G_LOG_LEVEL_INFO = 1 << 6,
  G_LOG_LEVEL_DEBUG = 1 << 7,
  G_LOG_LEVEL_MASK = ~(G_LOG_FLAG_RECURSION | G_LOG_FLAG_FATAL)
} GLogLevelFlags;
void g_free (gpointer mem);
typedef enum
{
  GTK_TYPE_INVALID,
  GTK_TYPE_NONE,
  GTK_TYPE_CHAR,
  GTK_TYPE_UCHAR,
  GTK_TYPE_BOOL,
  GTK_TYPE_INT,
  GTK_TYPE_UINT,
  GTK_TYPE_LONG,
  GTK_TYPE_ULONG,
  GTK_TYPE_FLOAT,
  GTK_TYPE_DOUBLE,
  GTK_TYPE_STRING,
  GTK_TYPE_ENUM,
  GTK_TYPE_FLAGS,
  GTK_TYPE_BOXED,
  GTK_TYPE_POINTER,
  GTK_TYPE_SIGNAL,
  GTK_TYPE_ARGS,
  GTK_TYPE_CALLBACK,
  GTK_TYPE_C_CALLBACK,
  GTK_TYPE_FOREIGN,
  GTK_TYPE_OBJECT
} GtkFundamentalType;
typedef guint GtkType;
typedef struct _GtkTypeObject GtkTypeObject;
typedef struct _GtkTypeClass GtkTypeClass;
typedef struct _GtkArg GtkArg;
typedef enum
{
  GTK_TOPLEVEL = 1 << 4,
  GTK_NO_WINDOW = 1 << 5,
  GTK_REALIZED = 1 << 6,
  GTK_MAPPED = 1 << 7,
  GTK_VISIBLE = 1 << 8,
  GTK_SENSITIVE = 1 << 9,
  GTK_PARENT_SENSITIVE = 1 << 10,
  GTK_CAN_FOCUS = 1 << 11,
  GTK_HAS_FOCUS = 1 << 12,
  GTK_CAN_DEFAULT = 1 << 13,
  GTK_HAS_DEFAULT = 1 << 14,
  GTK_HAS_GRAB = 1 << 15,
  GTK_RC_STYLE = 1 << 16,
  GTK_COMPOSITE_CHILD = 1 << 17,
  GTK_NO_REPARENT = 1 << 18,
  GTK_APP_PAINTABLE = 1 << 19,
  GTK_RECEIVES_DEFAULT = 1 << 20
} GtkWidgetFlags;
typedef struct _GtkContainer GtkContainer;
typedef struct _GtkForm GtkForm;
guint gtk_signal_connect (GtkObject *object,
                                           const gchar *name,
                                           GtkSignalFunc func,
                                           gpointer func_data);
void g_log (const gchar *log_domain,
                                         GLogLevelFlags log_level,
                                         const gchar *format,
                                         ...) __attribute__((format (printf, 3, 4)));
typedef void (*GtkCallbackMarshal) (GtkObject *object,
                                    gpointer data,
                                    guint n_args,
                                    GtkArg *args);
struct _GtkTypeObject
{
  GtkTypeClass *klass;
};
struct _GtkContainer
{
  GtkWidget widget;
  GtkWidget *focus_child;
  guint border_width : 16;
  guint need_resize : 1;
  guint resize_mode : 2;
  guint reallocate_redraws : 1;
  GSList *resize_widgets;
};
GtkType gtk_container_get_type (void);
GtkType gtk_form_get_type(void);
GtkTypeObject* gtk_type_check_object_cast (GtkTypeObject *type_object,
                                                 GtkType cast_type);
struct _GtkForm
{
    GtkContainer container;
    GList *children;
    guint width;
    guint height;
    GdkWindow *bin_window;
    GdkVisibilityState visibility;
    gulong configure_serial;
    gint freeze_count;
};
struct _GtkArg
{
  GtkType type;
  gchar *name;
  union {
    gchar char_data;
    guchar uchar_data;
    gboolean bool_data;
    gint int_data;
    guint uint_data;
    glong long_data;
    gulong ulong_data;
    gfloat float_data;
    gdouble double_data;
    gchar *string_data;
    gpointer pointer_data;
    GtkObject *object_data;
    struct {
      GtkSignalFunc f;
      gpointer d;
    } signal_data;
    struct {
      gint n_args;
      GtkArg *args;
    } args_data;
    struct {
      GtkCallbackMarshal marshal;
      gpointer data;
      GtkDestroyNotify notify;
    } callback_data;
    struct {
      GtkFunction func;
      gpointer func_data;
    } c_callback_data;
    struct {
      gpointer data;
      GtkDestroyNotify notify;
    } foreign_data;
  } d;
};
struct _GtkObjectClass
{
  GtkType type;
  guint *signals;
  guint nsignals;
  guint n_args;
  GSList *construct_args;
  void (*set_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (*get_arg) (GtkObject *object,
                   GtkArg *arg,
                   guint arg_id);
  void (* shutdown) (GtkObject *object);
  void (* destroy) (GtkObject *object);
  void (* finalize) (GtkObject *object);
};
GList* g_list_remove_link (GList *list,
                                 GList *llink);
struct _GtkTypeClass
{
  GtkType type;
}
;
gboolean gtk_type_is_a (GtkType type,
                                                 GtkType is_a_type);
typedef enum
{
  GTK_ACCEL_VISIBLE = 1 << 0,
  GTK_ACCEL_SIGNAL_VISIBLE = 1 << 1,
  GTK_ACCEL_LOCKED = 1 << 2,
  GTK_ACCEL_MASK = 0x07
} GtkAccelFlags;
GtkType gtk_widget_get_type (void);
void gtk_widget_unparent (GtkWidget *widget);
void gtk_widget_realize (GtkWidget *widget);
void gtk_widget_size_request (GtkWidget *widget,
                                           GtkRequisition *requisition);
typedef enum
{
  GTK_STATE_NORMAL,
  GTK_STATE_ACTIVE,
  GTK_STATE_PRELIGHT,
  GTK_STATE_SELECTED,
  GTK_STATE_INSENSITIVE
} GtkStateType;
typedef struct _XDisplay Display;
typedef unsigned long XID;
typedef XID Window;
typedef gulong GdkAtom;
typedef struct _GdkRectangle GdkRectangle;
typedef enum
{
  GDK_EXPOSURE_MASK = 1 << 1,
  GDK_POINTER_MOTION_MASK = 1 << 2,
  GDK_POINTER_MOTION_HINT_MASK = 1 << 3,
  GDK_BUTTON_MOTION_MASK = 1 << 4,
  GDK_BUTTON1_MOTION_MASK = 1 << 5,
  GDK_BUTTON2_MOTION_MASK = 1 << 6,
  GDK_BUTTON3_MOTION_MASK = 1 << 7,
  GDK_BUTTON_PRESS_MASK = 1 << 8,
  GDK_BUTTON_RELEASE_MASK = 1 << 9,
  GDK_KEY_PRESS_MASK = 1 << 10,
  GDK_KEY_RELEASE_MASK = 1 << 11,
  GDK_ENTER_NOTIFY_MASK = 1 << 12,
  GDK_LEAVE_NOTIFY_MASK = 1 << 13,
  GDK_FOCUS_CHANGE_MASK = 1 << 14,
  GDK_STRUCTURE_MASK = 1 << 15,
  GDK_PROPERTY_CHANGE_MASK = 1 << 16,
  GDK_VISIBILITY_NOTIFY_MASK = 1 << 17,
  GDK_PROXIMITY_IN_MASK = 1 << 18,
  GDK_PROXIMITY_OUT_MASK = 1 << 19,
  GDK_SUBSTRUCTURE_MASK = 1 << 20,
  GDK_ALL_EVENTS_MASK = 0x0FFFFF
} GdkEventMask;
struct _GdkRectangle
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
typedef short gshort;
typedef struct _GdkDragContext GdkDragContext;
typedef struct _GdkEventAny GdkEventAny;
typedef struct _GdkEventExpose GdkEventExpose;
typedef struct _GdkEventNoExpose GdkEventNoExpose;
typedef struct _GdkEventVisibility GdkEventVisibility;
typedef struct _GdkEventMotion GdkEventMotion;
typedef struct _GdkEventButton GdkEventButton;
typedef struct _GdkEventFocus GdkEventFocus;
typedef struct _GdkEventCrossing GdkEventCrossing;
typedef struct _GdkEventConfigure GdkEventConfigure;
typedef struct _GdkEventProperty GdkEventProperty;
typedef struct _GdkEventSelection GdkEventSelection;
typedef struct _GdkEventProximity GdkEventProximity;
typedef struct _GdkEventClient GdkEventClient;
typedef struct _GdkEventDND GdkEventDND;
typedef union _GdkEvent GdkEvent;
typedef enum
{
  GDK_NOTIFY_ANCESTOR = 0,
  GDK_NOTIFY_VIRTUAL = 1,
  GDK_NOTIFY_INFERIOR = 2,
  GDK_NOTIFY_NONLINEAR = 3,
  GDK_NOTIFY_NONLINEAR_VIRTUAL = 4,
  GDK_NOTIFY_UNKNOWN = 5
} GdkNotifyType;
typedef enum
{
  GDK_CROSSING_NORMAL,
  GDK_CROSSING_GRAB,
  GDK_CROSSING_UNGRAB
} GdkCrossingMode;
typedef enum
{
  GDK_SOURCE_MOUSE,
  GDK_SOURCE_PEN,
  GDK_SOURCE_ERASER,
  GDK_SOURCE_CURSOR
} GdkInputSource;
typedef enum {
  GDK_ACTION_DEFAULT = 1 << 0,
  GDK_ACTION_COPY = 1 << 1,
  GDK_ACTION_MOVE = 1 << 2,
  GDK_ACTION_LINK = 1 << 3,
  GDK_ACTION_PRIVATE = 1 << 4,
  GDK_ACTION_ASK = 1 << 5
} GdkDragAction;
typedef enum {
  GDK_DRAG_PROTO_MOTIF,
  GDK_DRAG_PROTO_XDND,
  GDK_DRAG_PROTO_ROOTWIN,
  GDK_DRAG_PROTO_NONE
} GdkDragProtocol;
struct _GdkDragContext {
  GdkDragProtocol protocol;
  gboolean is_source;
  GdkWindow *source_window;
  GdkWindow *dest_window;
  GList *targets;
  GdkDragAction actions;
  GdkDragAction suggested_action;
  GdkDragAction action;
  guint32 start_time;
};
struct _GdkEventAny
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
};
struct _GdkEventExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkRectangle area;
  gint count;
};
struct _GdkEventNoExpose
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
};
struct _GdkEventVisibility
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkVisibilityState state;
};
struct _GdkEventMotion
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  gint16 is_hint;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
struct _GdkEventButton
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble pressure;
  gdouble xtilt;
  gdouble ytilt;
  guint state;
  guint button;
  GdkInputSource source;
  guint32 deviceid;
  gdouble x_root, y_root;
};
struct _GdkEventCrossing
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkWindow *subwindow;
  guint32 time;
  gdouble x;
  gdouble y;
  gdouble x_root;
  gdouble y_root;
  GdkCrossingMode mode;
  GdkNotifyType detail;
  gboolean focus;
  guint state;
};
struct _GdkEventFocus
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 in;
};
struct _GdkEventConfigure
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  gint16 x, y;
  gint16 width;
  gint16 height;
};
struct _GdkEventProperty
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom atom;
  guint32 time;
  guint state;
};
struct _GdkEventSelection
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom selection;
  GdkAtom target;
  GdkAtom property;
  guint32 requestor;
  guint32 time;
};
struct _GdkEventProximity
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  guint32 time;
  GdkInputSource source;
  guint32 deviceid;
};
struct _GdkEventClient
{
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkAtom message_type;
  gushort data_format;
  union {
    char b[20];
    short s[10];
    long l[5];
  } data;
};
struct _GdkEventDND {
  GdkEventType type;
  GdkWindow *window;
  gint8 send_event;
  GdkDragContext *context;
  guint32 time;
  gshort x_root, y_root;
};
union _GdkEvent
{
  GdkEventType type;
  GdkEventAny any;
  GdkEventExpose expose;
  GdkEventNoExpose no_expose;
  GdkEventVisibility visibility;
  GdkEventMotion motion;
  GdkEventButton button;
  GdkEventKey key;
  GdkEventCrossing crossing;
  GdkEventFocus focus_change;
  GdkEventConfigure configure;
  GdkEventProperty property;
  GdkEventSelection selection;
  GdkEventProximity proximity;
  GdkEventClient client;
  GdkEventDND dnd;
};
typedef struct _GdkVisual GdkVisual;
typedef enum
{
  GDK_VISUAL_STATIC_GRAY,
  GDK_VISUAL_GRAYSCALE,
  GDK_VISUAL_STATIC_COLOR,
  GDK_VISUAL_PSEUDO_COLOR,
  GDK_VISUAL_TRUE_COLOR,
  GDK_VISUAL_DIRECT_COLOR
} GdkVisualType;
typedef enum {
  GDK_FILTER_CONTINUE,
  GDK_FILTER_TRANSLATE,
  GDK_FILTER_REMOVE
} GdkFilterReturn;
typedef enum
{
  GDK_LSB_FIRST,
  GDK_MSB_FIRST
} GdkByteOrder;
typedef void GdkXEvent;
typedef struct _GtkSelectionData GtkSelectionData;
typedef struct _GdkWindowPrivate GdkWindowPrivate;
typedef struct _GdkWindowPrivate GdkPixmapPrivate;
struct _GdkVisual
{
  GdkVisualType type;
  gint depth;
  GdkByteOrder byte_order;
  gint colormap_size;
  gint bits_per_rgb;
  guint32 red_mask;
  gint red_shift;
  gint red_prec;
  guint32 green_mask;
  gint green_shift;
  gint green_prec;
  guint32 blue_mask;
  gint blue_shift;
  gint blue_prec;
};
typedef GdkFilterReturn (*GdkFilterFunc) (GdkXEvent *xevent,
                                          GdkEvent *event,
                                          gpointer data);
struct _GtkSelectionData
{
  GdkAtom selection;
  GdkAtom target;
  GdkAtom type;
  gint format;
  guchar *data;
  gint length;
};
struct _GdkWindowPrivate
{
  GdkWindow window;
  GdkWindow *parent;
  Window xwindow;
  Display *xdisplay;
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
  guint8 resize_count;
  guint8 window_type;
  guint ref_count;
  guint destroyed : 2;
  guint mapped : 1;
  guint guffaw_gravity : 1;
  gint extension_events;
  GList *filters;
  GdkColormap *colormap;
  GList *children;
};
GdkVisual* gtk_widget_get_visual (GtkWidget *widget);
typedef unsigned long Atom;
typedef unsigned long Time;
typedef XID Drawable;
typedef XID Colormap;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;
} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;
        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;
        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;
        int new;
        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
extern int remove (__const char *__filename) ;
typedef gint (*GCompareFunc) (gconstpointer a,
                                                 gconstpointer b);
void g_list_free_1 (GList *list);
GList* g_list_append (GList *list,
                                 gpointer data);
gpointer g_malloc (gulong size);
typedef struct _GdkWindowAttr GdkWindowAttr;
typedef enum
{
  GDK_WINDOW_ROOT,
  GDK_WINDOW_TOPLEVEL,
  GDK_WINDOW_CHILD,
  GDK_WINDOW_DIALOG,
  GDK_WINDOW_TEMP,
  GDK_WINDOW_PIXMAP,
  GDK_WINDOW_FOREIGN
} GdkWindowType;
typedef enum
{
  GDK_INPUT_OUTPUT,
  GDK_INPUT_ONLY
} GdkWindowClass;
typedef enum
{
  GDK_WA_TITLE = 1 << 1,
  GDK_WA_X = 1 << 2,
  GDK_WA_Y = 1 << 3,
  GDK_WA_CURSOR = 1 << 4,
  GDK_WA_COLORMAP = 1 << 5,
  GDK_WA_VISUAL = 1 << 6,
  GDK_WA_WMCLASS = 1 << 7,
  GDK_WA_NOREDIR = 1 << 8
} GdkWindowAttributesType;
void gdk_window_destroy (GdkWindow *window);
void gdk_window_show (GdkWindow *window);
void gdk_window_hide (GdkWindow *window);
void gdk_window_move_resize (GdkWindow *window,
                                      gint x,
                                      gint y,
                                      gint width,
                                      gint height);
void gdk_window_set_user_data (GdkWindow *window,
                                          gpointer user_data);
void gdk_window_add_filter (GdkWindow *window,
                                         GdkFilterFunc function,
                                         gpointer data);
typedef struct _GtkTypeInfo GtkTypeInfo;
gpointer gtk_type_class (GtkType type);
gpointer gtk_type_new (GtkType type);
GtkTypeClass* gtk_type_check_class_cast (GtkTypeClass *klass,
                                                 GtkType cast_type);
typedef enum
{
  GTK_DIR_TAB_FORWARD,
  GTK_DIR_TAB_BACKWARD,
  GTK_DIR_UP,
  GTK_DIR_DOWN,
  GTK_DIR_LEFT,
  GTK_DIR_RIGHT
} GtkDirectionType;
GtkStyle* gtk_style_attach (GtkStyle *style,
                                              GdkWindow *window);
void gtk_style_set_background (GtkStyle *style,
                                              GdkWindow *window,
                                              GtkStateType state_type);
typedef struct _GtkWidgetClass GtkWidgetClass;
typedef void (*GtkCallback) (GtkWidget *widget,
                             gpointer data);
void gtk_widget_map (GtkWidget *widget);
void gtk_widget_unmap (GtkWidget *widget);
void gtk_widget_draw (GtkWidget *widget,
                                           GdkRectangle *area);
void gtk_widget_size_allocate (GtkWidget *widget,
                                           GtkAllocation *allocation);
gint gtk_widget_event (GtkWidget *widget,
                                           GdkEvent *event);
gint gtk_widget_intersect (GtkWidget *widget,
                                           GdkRectangle *area,
                                           GdkRectangle *intersection);
void gtk_widget_set_parent (GtkWidget *widget,
                                           GtkWidget *parent);
void gtk_widget_set_parent_window (GtkWidget *widget,
                                           GdkWindow *parent_window);
GdkWindow *gtk_widget_get_parent_window (GtkWidget *widget);
gint gtk_widget_get_events (GtkWidget *widget);
typedef XID Pixmap;
typedef XID Cursor;
typedef struct _GtkContainerClass GtkContainerClass;
void gtk_container_queue_resize (GtkContainer *container);
void gtk_signal_disconnect_by_func (GtkObject *object,
                                           GtkSignalFunc func,
                                           gpointer data);
typedef struct _GtkFormClass GtkFormClass;
void gtk_form_move(GtkForm *form, GtkWidget * widget,
        gint x, gint y);
typedef struct _GtkFormChild GtkFormChild;
typedef void (*GFunc) (gpointer data,
                                                 gpointer user_data);
struct _GdkWindowAttr
{
  gchar *title;
  gint event_mask;
  gint16 x, y;
  gint16 width;
  gint16 height;
  GdkWindowClass wclass;
  GdkVisual *visual;
  GdkColormap *colormap;
  GdkWindowType window_type;
  GdkCursor *cursor;
  gchar *wmclass_name;
  gchar *wmclass_class;
  gboolean override_redirect;
};
struct _GtkWidgetClass
{
  GtkObjectClass parent_class;
  guint activate_signal;
  guint set_scroll_adjustments_signal;
  void (* show) (GtkWidget *widget);
  void (* show_all) (GtkWidget *widget);
  void (* hide) (GtkWidget *widget);
  void (* hide_all) (GtkWidget *widget);
  void (* map) (GtkWidget *widget);
  void (* unmap) (GtkWidget *widget);
  void (* realize) (GtkWidget *widget);
  void (* unrealize) (GtkWidget *widget);
  void (* draw) (GtkWidget *widget,
                                GdkRectangle *area);
  void (* draw_focus) (GtkWidget *widget);
  void (* draw_default) (GtkWidget *widget);
  void (* size_request) (GtkWidget *widget,
                                GtkRequisition *requisition);
  void (* size_allocate) (GtkWidget *widget,
                                GtkAllocation *allocation);
  void (* state_changed) (GtkWidget *widget,
                                GtkStateType previous_state);
  void (* parent_set) (GtkWidget *widget,
                                GtkWidget *previous_parent);
  void (* style_set) (GtkWidget *widget,
                                GtkStyle *previous_style);
  gint (* add_accelerator) (GtkWidget *widget,
                                guint accel_signal_id,
                                GtkAccelGroup *accel_group,
                                guint accel_key,
                                GdkModifierType accel_mods,
                                GtkAccelFlags accel_flags);
  void (* remove_accelerator) (GtkWidget *widget,
                                GtkAccelGroup *accel_group,
                                guint accel_key,
                                GdkModifierType accel_mods);
  void (* grab_focus) (GtkWidget *widget);
  gint (* event) (GtkWidget *widget,
                                    GdkEvent *event);
  gint (* button_press_event) (GtkWidget *widget,
                                    GdkEventButton *event);
  gint (* button_release_event) (GtkWidget *widget,
                                    GdkEventButton *event);
  gint (* motion_notify_event) (GtkWidget *widget,
                                    GdkEventMotion *event);
  gint (* delete_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* destroy_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* expose_event) (GtkWidget *widget,
                                    GdkEventExpose *event);
  gint (* key_press_event) (GtkWidget *widget,
                                    GdkEventKey *event);
  gint (* key_release_event) (GtkWidget *widget,
                                    GdkEventKey *event);
  gint (* enter_notify_event) (GtkWidget *widget,
                                    GdkEventCrossing *event);
  gint (* leave_notify_event) (GtkWidget *widget,
                                    GdkEventCrossing *event);
  gint (* configure_event) (GtkWidget *widget,
                                    GdkEventConfigure *event);
  gint (* focus_in_event) (GtkWidget *widget,
                                    GdkEventFocus *event);
  gint (* focus_out_event) (GtkWidget *widget,
                                    GdkEventFocus *event);
  gint (* map_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* unmap_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  gint (* property_notify_event) (GtkWidget *widget,
                                    GdkEventProperty *event);
  gint (* selection_clear_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* selection_request_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* selection_notify_event) (GtkWidget *widget,
                                    GdkEventSelection *event);
  gint (* proximity_in_event) (GtkWidget *widget,
                                    GdkEventProximity *event);
  gint (* proximity_out_event) (GtkWidget *widget,
                                    GdkEventProximity *event);
  gint (* visibility_notify_event) (GtkWidget *widget,
                                     GdkEventVisibility *event);
  gint (* client_event) (GtkWidget *widget,
                                    GdkEventClient *event);
  gint (* no_expose_event) (GtkWidget *widget,
                                    GdkEventAny *event);
  void (* selection_get) (GtkWidget *widget,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);
  void (* selection_received) (GtkWidget *widget,
                                    GtkSelectionData *selection_data,
                                    guint time);
  void (* drag_begin) (GtkWidget *widget,
                                    GdkDragContext *context);
  void (* drag_end) (GtkWidget *widget,
                                    GdkDragContext *context);
  void (* drag_data_get) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);
  void (* drag_data_delete) (GtkWidget *widget,
                                    GdkDragContext *context);
  void (* drag_leave) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    guint time);
  gboolean (* drag_motion) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    guint time);
  gboolean (* drag_drop) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    guint time);
  void (* drag_data_received) (GtkWidget *widget,
                                    GdkDragContext *context,
                                    gint x,
                                    gint y,
                                    GtkSelectionData *selection_data,
                                    guint info,
                                    guint time);
  void (* debug_msg) (GtkWidget *widget,
                                    const gchar *string);
  GtkFunction pad1;
  GtkFunction pad2;
  GtkFunction pad3;
  GtkFunction pad4;
};
typedef struct {
    Pixmap background_pixmap;
    unsigned long background_pixel;
    Pixmap border_pixmap;
    unsigned long border_pixel;
    int bit_gravity;
    int win_gravity;
    int backing_store;
    unsigned long backing_planes;
    unsigned long backing_pixel;
    int save_under;
    long event_mask;
    long do_not_propagate_mask;
    int override_redirect;
    Colormap colormap;
    Cursor cursor;
} XSetWindowAttributes;
struct _GtkFormChild
{
    GtkWidget *widget;
    GdkWindow *window;
    gint x;
    gint y;
    gint mapped;
};
typedef gint (*GSearchFunc) (gpointer key,
                                                 gpointer data);
GdkWindow* gdk_window_new (GdkWindow *parent,
                                      GdkWindowAttr *attributes,
                                      gint attributes_mask);
extern int XChangeWindowAttributes(
    Display* ,
    Window ,
    unsigned long ,
    XSetWindowAttributes*
);
struct _GtkContainerClass
{
  GtkWidgetClass parent_class;
  guint n_child_args;
  void (* add) (GtkContainer *container,
                                 GtkWidget *widget);
  void (* remove) (GtkContainer *container,
                                 GtkWidget *widget);
  void (* check_resize) (GtkContainer *container);
  void (* forall) (GtkContainer *container,
                                 gboolean include_internals,
                                 GtkCallback callback,
                                 gpointer callbabck_data);
  gint (* focus) (GtkContainer *container,
                                 GtkDirectionType direction);
  void (* set_focus_child) (GtkContainer *container,
                                 GtkWidget *widget);
  GtkType (*child_type) (GtkContainer *container);
  void (*set_child_arg) (GtkContainer *container,
                                 GtkWidget *child,
                                 GtkArg *arg,
                                 guint arg_id);
  void (*get_child_arg) (GtkContainer *container,
                                 GtkWidget *child,
                                 GtkArg *arg,
                                 guint arg_id);
  gchar* (*composite_name) (GtkContainer *container,
                                 GtkWidget *child);
  GtkFunction pad1;
  GtkFunction pad2;
};
typedef void (*GtkObjectInitFunc) (gpointer object,
                                    gpointer klass);
struct _GtkFormClass
{
    GtkContainerClass parent_class;
};
struct _GtkTypeInfo
{
  gchar *type_name;
  guint object_size;
  guint class_size;
  GtkClassInitFunc class_init_func;
  GtkObjectInitFunc object_init_func;
  gpointer reserved_1;
  gpointer reserved_2;
  GtkClassInitFunc base_class_init_func;
};
GtkType gtk_type_unique (GtkType parent_type,
                                                 const GtkTypeInfo *type_info);
static void gtk_form_class_init(GtkFormClass *klass);
static void gtk_form_init(GtkForm *form);
static void gtk_form_realize(GtkWidget *widget);
static void gtk_form_unrealize(GtkWidget *widget);
static void gtk_form_map(GtkWidget *widget);
static void gtk_form_size_request(GtkWidget *widget,
                                  GtkRequisition *requisition);
static void gtk_form_size_allocate(GtkWidget *widget,
                                   GtkAllocation *allocation);
static void gtk_form_draw(GtkWidget *widget,
                          GdkRectangle *area);
static gint gtk_form_expose(GtkWidget *widget,
                            GdkEventExpose *event);
static void gtk_form_remove(GtkContainer *container,
                            GtkWidget *widget);
static void gtk_form_forall(GtkContainer *container,
                            gboolean include_internals,
                            GtkCallback callback,
                            gpointer callback_data);
static void gtk_form_attach_child_window(GtkForm *form,
                                         GtkFormChild *child);
static void gtk_form_realize_child(GtkForm *form,
                                   GtkFormChild *child);
static void gtk_form_position_child(GtkForm *form,
                                    GtkFormChild *child,
                                    gboolean force_allocate);
static void gtk_form_position_children(GtkForm *form);
static GdkFilterReturn gtk_form_filter(GdkXEvent *gdk_xevent,
                                       GdkEvent *event,
                                       gpointer data);
static GdkFilterReturn gtk_form_main_filter(GdkXEvent *gdk_xevent,
                                            GdkEvent *event,
                                            gpointer data);
static void gtk_form_set_static_gravity(GdkWindow *window,
                                        gboolean use_static);
static void gtk_form_send_configure(GtkForm *form);
static void gtk_form_child_map(GtkWidget *widget, gpointer user_data);
static void gtk_form_child_unmap(GtkWidget *widget, gpointer user_data);
static GtkWidgetClass *parent_class = ((void *)0);
    GtkWidget * gtk_form_new(void)
{
    GtkForm *form;
    form = gtk_type_new(gtk_form_get_type());
    return (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));
}
    void gtk_form_put(GtkForm *form,
             GtkWidget *child_widget,
             gint x,
             gint y)
{
    GtkFormChild *child;
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 120, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });
    child = ((GtkFormChild *) g_malloc ((unsigned) sizeof (GtkFormChild) * (1)));
    child->widget = child_widget;
    child->window = ((void *)0);
    child->x = x;
    child->y = y;
    child->widget->requisition.width = 0;
    child->widget->requisition.height = 0;
    child->mapped = 0;
    form->children = g_list_append(form->children, child);
    if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
        gtk_form_attach_child_window(form, child);
    gtk_widget_set_parent(child_widget, (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ()))))));
    gtk_widget_size_request(child->widget, ((void *)0));
    if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0) && !((((( ( (child_widget) != ((void *)0) && ( (((GtkObject*) (child_widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child_widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child_widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child_widget), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
        gtk_form_realize_child(form, child);
    gtk_form_position_child(form, child, 1);
}
    void gtk_form_move(GtkForm *form,
              GtkWidget *child_widget,
              gint x,
              gint y)
{
    GList *tmp_list;
    GtkFormChild *child;
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 160, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });
    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        child = tmp_list->data;
        if (child->widget == child_widget)
        {
            child->x = x;
            child->y = y;
            gtk_form_position_child(form, child, 1);
            return;
        }
    }
}
    void gtk_form_set_size(GtkForm *form, guint width, guint height)
{
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 179, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });
    if (form->width == width && form->height == height)
        return;
    form->width = width;
    form->height = height;
    gtk_container_queue_resize((((GtkContainer*) gtk_type_check_object_cast ((GtkTypeObject*) (((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))))->parent)), ((gtk_container_get_type ()))))));
}
    void gtk_form_freeze(GtkForm *form)
{
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 198, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });
    ++form->freeze_count;
}
    void gtk_form_thaw(GtkForm *form)
{
    (void)({ if (!((( ((GtkTypeObject*) ((form))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((form)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 206, __PRETTY_FUNCTION__, "GTK_IS_FORM(form)"); return; }; });
    if (form->freeze_count)
    {
        if (!(--form->freeze_count))
        {
            gtk_form_position_children(form);
            gtk_widget_draw((((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ()))))), ((void *)0));
        }
    }
}
    GtkType gtk_form_get_type(void)
{
    static GtkType form_type = 0;
    if (!form_type)
    {
        GtkTypeInfo form_info =
        {
            "GtkForm",
            sizeof(GtkForm),
            sizeof(GtkFormClass),
            (GtkClassInitFunc) gtk_form_class_init,
            (GtkObjectInitFunc) gtk_form_init
        };
        form_type = gtk_type_unique((gtk_container_get_type ()), &form_info);
    }
    return form_type;
}
    static void gtk_form_class_init(GtkFormClass *klass)
{
    GtkWidgetClass *widget_class;
    GtkContainerClass *container_class;
    widget_class = (GtkWidgetClass *) klass;
    container_class = (GtkContainerClass *) klass;
    parent_class = gtk_type_class(gtk_container_get_type());
    widget_class->realize = gtk_form_realize;
    widget_class->unrealize = gtk_form_unrealize;
    widget_class->map = gtk_form_map;
    widget_class->size_request = gtk_form_size_request;
    widget_class->size_allocate = gtk_form_size_allocate;
    widget_class->draw = gtk_form_draw;
    widget_class->expose_event = gtk_form_expose;
    container_class->remove = gtk_form_remove;
    container_class->forall = gtk_form_forall;
}
    static void gtk_form_init(GtkForm *form)
{
    form->children = ((void *)0);
    form->width = 1;
    form->height = 1;
    form->bin_window = ((void *)0);
    form->configure_serial = 0;
    form->visibility = GDK_VISIBILITY_PARTIAL;
    form->freeze_count = 0;
}
    static void gtk_form_realize(GtkWidget *widget)
{
    GList *tmp_list;
    GtkForm *form;
    GdkWindowAttr attributes;
    gint attributes_mask;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 298, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    (void)({ (((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) |= (GTK_REALIZED)); });
    attributes.window_type = GDK_WINDOW_CHILD;
    attributes.x = widget->allocation.x;
    attributes.y = widget->allocation.y;
    attributes.width = widget->allocation.width;
    attributes.height = widget->allocation.height;
    attributes.wclass = GDK_INPUT_OUTPUT;
    attributes.visual = gtk_widget_get_visual(widget);
    attributes.colormap = gtk_widget_get_colormap(widget);
    attributes.event_mask = GDK_VISIBILITY_NOTIFY_MASK;
    attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;
    widget->window = gdk_window_new(gtk_widget_get_parent_window(widget),
                                    &attributes, attributes_mask);
    gdk_window_set_user_data(widget->window, widget);
    attributes.x = 0;
    attributes.y = 0;
    attributes.event_mask = gtk_widget_get_events(widget);
    form->bin_window = gdk_window_new(widget->window,
                                      &attributes, attributes_mask);
    gdk_window_set_user_data(form->bin_window, widget);
    gtk_form_set_static_gravity(form->bin_window, 1);
    widget->style = gtk_style_attach(widget->style, widget->window);
    gtk_style_set_background(widget->style, widget->window, GTK_STATE_NORMAL);
    gtk_style_set_background(widget->style, form->bin_window, GTK_STATE_NORMAL);
    gdk_window_add_filter(widget->window, gtk_form_main_filter, form);
    gdk_window_add_filter(form->bin_window, gtk_form_filter, form);
    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        GtkFormChild *child = tmp_list->data;
        gtk_form_attach_child_window(form, child);
        if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
            gtk_form_realize_child(form, child);
    }
}
    static void gtk_form_map(GtkWidget *widget)
{
    GList *tmp_list;
    GtkForm *form;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 362, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    (void)({ (((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) |= (GTK_MAPPED)); });
    gdk_window_show(widget->window);
    gdk_window_show(form->bin_window);
    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        GtkFormChild *child = tmp_list->data;
        if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0)
                && !((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
            gtk_widget_map(child->widget);
    }
}
    static void gtk_form_unrealize(GtkWidget *widget)
{
    GList *tmp_list;
    GtkForm *form;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 387, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    tmp_list = form->children;
    gdk_window_set_user_data(form->bin_window, ((void *)0));
    gdk_window_destroy(form->bin_window);
    form->bin_window = ((void *)0);
    while (tmp_list)
    {
        GtkFormChild *child = tmp_list->data;
        if (child->window != ((void *)0))
        {
            gtk_signal_disconnect_by_func(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ),
                                          ((GtkSignalFunc) gtk_form_child_map),
                                          child);
            gtk_signal_disconnect_by_func(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ),
                                          ((GtkSignalFunc) gtk_form_child_unmap),
                                          child);
            gdk_window_set_user_data(child->window, ((void *)0));
            gdk_window_destroy(child->window);
            child->window = ((void *)0);
        }
        tmp_list = tmp_list->next;
    }
    if ((((GtkWidgetClass*) gtk_type_check_class_cast ((GtkTypeClass*) ((parent_class)), ((gtk_widget_get_type ())))))->unrealize)
         (* (((GtkWidgetClass*) gtk_type_check_class_cast ((GtkTypeClass*) ((parent_class)), ((gtk_widget_get_type ())))))->unrealize) (widget);
}
    static void gtk_form_draw(GtkWidget *widget, GdkRectangle *area)
{
    GtkForm *form;
    GList *children;
    GtkFormChild *child;
    GdkRectangle child_area;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 432, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    if ((((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0)))
    {
        form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
        children = form->children;
        while (children)
        {
            child = children->data;
            if ((((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0) && ((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                    && gtk_widget_intersect(child->widget, area, &child_area))
                gtk_widget_draw(child->widget, &child_area);
            children = children->next;
        }
    }
}
    static void gtk_form_size_request(GtkWidget *widget, GtkRequisition *requisition)
{
    GList *tmp_list;
    GtkForm *form;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 460, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    requisition->width = form->width;
    requisition->height = form->height;
    tmp_list = form->children;
    while (tmp_list)
    {
        GtkFormChild *child = tmp_list->data;
        gtk_widget_size_request(child->widget, ((void *)0));
        tmp_list = tmp_list->next;
    }
}
    static void gtk_form_size_allocate(GtkWidget *widget, GtkAllocation *allocation)
{
    GList *tmp_list;
    GtkForm *form;
    gboolean need_reposition;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 484, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return; }; });
    if (widget->allocation.x == allocation->x
            && widget->allocation.y == allocation->y
            && widget->allocation.width == allocation->width
            && widget->allocation.height == allocation->height)
        return;
    need_reposition = widget->allocation.width != allocation->width
                   || widget->allocation.height != allocation->height;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    if (need_reposition)
    {
        tmp_list = form->children;
        while (tmp_list)
        {
            GtkFormChild *child = tmp_list->data;
            gtk_form_position_child(form, child, 1);
            tmp_list = tmp_list->next;
        }
    }
    if (((((( ( (widget) != ((void *)0) && ( (((GtkObject*) (widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (widget), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
    {
        gdk_window_move_resize(widget->window,
                               allocation->x, allocation->y,
                               allocation->width, allocation->height);
        gdk_window_move_resize((((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))))->bin_window,
                               0, 0,
                               allocation->width, allocation->height);
    }
    widget->allocation = *allocation;
    if (need_reposition)
        gtk_form_send_configure(form);
}
    static gint gtk_form_expose(GtkWidget *widget, GdkEventExpose *event)
{
    GList *tmp_list;
    GtkForm *form;
    (void)({ if (!((( ((GtkTypeObject*) ((widget))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((widget)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 529, __PRETTY_FUNCTION__, "GTK_IS_FORM(widget)"); return 0; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((widget)), ((gtk_form_get_type ())))));
    if (event->window == form->bin_window)
        return 0;
    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
    {
        GtkFormChild *child = tmp_list->data;
        if (event->window == child->window)
            return gtk_widget_event(child->widget, (GdkEvent *) event);
    }
    return 0;
}
    static void gtk_form_remove(GtkContainer *container, GtkWidget *widget)
{
    GList *tmp_list;
    GtkForm *form;
    GtkFormChild *child = ((void *)0);
    (void)({ if (!((( ((GtkTypeObject*) ((container))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 579, __PRETTY_FUNCTION__, "GTK_IS_FORM(container)"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((container)), ((gtk_form_get_type ())))));
    tmp_list = form->children;
    while (tmp_list)
    {
        child = tmp_list->data;
        if (child->widget == widget)
            break;
        tmp_list = tmp_list->next;
    }
    if (tmp_list)
    {
        if (child->window)
        {
            gtk_signal_disconnect_by_func(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ),
                                          ((GtkSignalFunc) &gtk_form_child_map), child);
            gtk_signal_disconnect_by_func(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ),
                                          ((GtkSignalFunc) &gtk_form_child_unmap), child);
            gdk_window_set_user_data(child->window, ((void *)0));
            gdk_window_destroy(child->window);
        }
        gtk_widget_unparent(widget);
        form->children = g_list_remove_link(form->children, tmp_list);
        g_list_free_1(tmp_list);
        g_free(child);
    }
}
    static void gtk_form_forall(GtkContainer *container,
                gboolean include_internals,
                GtkCallback callback,
                gpointer callback_data)
{
    GtkForm *form;
    GtkFormChild *child;
    GList *tmp_list;
    (void)({ if (!((( ((GtkTypeObject*) ((container))) != ((void *)0) && ( ((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass)) != ((void *)0) && gtk_type_is_a (((GtkTypeClass*) (((GtkTypeObject*) ((container)))->klass))->type, (((gtk_form_get_type ())))) ) )))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 626, __PRETTY_FUNCTION__, "GTK_IS_FORM(container)"); return; }; });
    (void)({ if (!(callback != ((void *)0))) { g_log (((gchar*) 0), G_LOG_LEVEL_CRITICAL, "file %s: line %d (%s): assertion `%s' failed.", "gui_gtk_f.c", 627, __PRETTY_FUNCTION__, "callback != NULL"); return; }; });
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((container)), ((gtk_form_get_type ())))));
    tmp_list = form->children;
    while (tmp_list)
    {
        child = tmp_list->data;
        tmp_list = tmp_list->next;
        (*callback) (child->widget, callback_data);
    }
}
    static void gtk_form_attach_child_window(GtkForm *form, GtkFormChild *child)
{
    if (child->window != ((void *)0))
        return;
    if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_NO_WINDOW) != 0))
    {
        GtkWidget *widget;
        GdkWindowAttr attributes;
        gint attributes_mask;
        widget = (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));
        attributes.window_type = GDK_WINDOW_CHILD;
        attributes.x = child->x;
        attributes.y = child->y;
        attributes.width = child->widget->requisition.width;
        attributes.height = child->widget->requisition.height;
        attributes.wclass = GDK_INPUT_OUTPUT;
        attributes.visual = gtk_widget_get_visual(widget);
        attributes.colormap = gtk_widget_get_colormap(widget);
        attributes.event_mask = GDK_EXPOSURE_MASK;
        attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL | GDK_WA_COLORMAP;
        child->window = gdk_window_new(form->bin_window,
                                       &attributes, attributes_mask);
        gdk_window_set_user_data(child->window, widget);
        gtk_style_set_background(widget->style,
                                 child->window,
                                 GTK_STATE_NORMAL);
        gtk_widget_set_parent_window(child->widget, child->window);
        gtk_form_set_static_gravity(child->window, 1);
        gtk_signal_connect(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ), "map",
                           ((GtkSignalFunc) &gtk_form_child_map), child);
        gtk_signal_connect(( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) ), "unmap",
                           ((GtkSignalFunc) &gtk_form_child_unmap), child);
    }
    else if (!((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_REALIZED) != 0))
    {
        gtk_widget_set_parent_window(child->widget, form->bin_window);
    }
}
    static void gtk_form_realize_child(GtkForm *form, GtkFormChild *child)
{
    gtk_form_attach_child_window(form, child);
    gtk_widget_realize(child->widget);
    if (child->window == ((void *)0))
        gtk_form_set_static_gravity(child->widget->window, 1);
}
    static void gtk_form_position_child(GtkForm *form, GtkFormChild *child,
                        gboolean force_allocate)
{
    gint x;
    gint y;
    x = child->x;
    y = child->y;
    if ((x >= (-32767-1)) && (x <= 32767) &&
        (y >= (-32767-1)) && (y <= 32767))
    {
        if (!child->mapped)
        {
            if (((((( ( (form) != ((void *)0) && ( (((GtkObject*) (form))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (form))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (form) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (form), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0) && ((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_VISIBLE) != 0))
            {
                if (!((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                    gtk_widget_map(child->widget);
                child->mapped = 1;
                force_allocate = 1;
            }
        }
        if (force_allocate)
        {
            GtkAllocation allocation;
            if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_NO_WINDOW) != 0))
            {
                if (child->window)
                {
                    gdk_window_move_resize(child->window,
                            x, y,
                            child->widget->requisition.width,
                            child->widget->requisition.height);
                }
                allocation.x = 0;
                allocation.y = 0;
            }
            else
            {
                allocation.x = x;
                allocation.y = y;
            }
            allocation.width = child->widget->requisition.width;
            allocation.height = child->widget->requisition.height;
            gtk_widget_size_allocate(child->widget, &allocation);
        }
    }
    else
    {
        if (child->mapped)
        {
            child->mapped = 0;
            if (((((( ( (child->widget) != ((void *)0) && ( (((GtkObject*) (child->widget))->klass) != ((void *)0) && ((GtkFundamentalType) ((((GtkObjectClass*) (((GtkObject*) (child->widget))->klass))->type) & 0xFF)) == GTK_TYPE_OBJECT ) ) ? (GtkObject*) (child->widget) : (GtkObject*) gtk_type_check_object_cast ((GtkTypeObject*) (child->widget), GTK_TYPE_OBJECT) )->flags)) & GTK_MAPPED) != 0))
                gtk_widget_unmap(child->widget);
        }
    }
}
    static void gtk_form_position_children(GtkForm *form)
{
    GList *tmp_list;
    for (tmp_list = form->children; tmp_list; tmp_list = tmp_list->next)
        gtk_form_position_child(form, tmp_list->data, 0);
}
    static GdkFilterReturn gtk_form_filter(GdkXEvent *gdk_xevent, GdkEvent *event, gpointer data)
{
    XEvent *xevent;
    GtkForm *form;
    xevent = (XEvent *) gdk_xevent;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((data)), ((gtk_form_get_type ())))));
    switch (xevent->type)
    {
    case 12:
        if (xevent->xexpose.serial == form->configure_serial)
        {
            if (form->visibility == GDK_VISIBILITY_UNOBSCURED)
                return GDK_FILTER_REMOVE;
            else
                break;
        }
        break;
    case 22:
        if ((xevent->xconfigure.x != 0) || (xevent->xconfigure.y != 0))
            form->configure_serial = xevent->xconfigure.serial;
        break;
    }
    return GDK_FILTER_CONTINUE;
}
    static GdkFilterReturn gtk_form_main_filter(GdkXEvent *gdk_xevent, GdkEvent *event, gpointer data)
{
    XEvent *xevent;
    GtkForm *form;
    xevent = (XEvent *) gdk_xevent;
    form = (((GtkForm*) gtk_type_check_object_cast ((GtkTypeObject*) ((data)), ((gtk_form_get_type ())))));
    if (xevent->type == 15)
    {
        switch (xevent->xvisibility.state)
        {
        case 2:
            form->visibility = GDK_VISIBILITY_FULLY_OBSCURED;
            break;
        case 1:
            form->visibility = GDK_VISIBILITY_PARTIAL;
            break;
        case 0:
            form->visibility = GDK_VISIBILITY_UNOBSCURED;
            break;
        }
        return GDK_FILTER_REMOVE;
    }
    return GDK_FILTER_CONTINUE;
}
    static void gtk_form_set_static_gravity(GdkWindow *window, gboolean use_static)
{
    XSetWindowAttributes xattributes;
    xattributes.win_gravity = (use_static) ? 10 : 1;
    xattributes.bit_gravity = (use_static) ? 10 : 1;
    XChangeWindowAttributes((((GdkWindowPrivate*) window)->xdisplay),
                            (((GdkWindowPrivate*) window)->xwindow),
                            (1L<<4) | (1L<<5),
                            &xattributes);
}
    void gtk_form_move_resize(GtkForm *form, GtkWidget *widget,
                     gint x, gint y, gint w, gint h)
{
    widget->requisition.width = w;
    widget->requisition.height = h;
    gtk_form_move(form, widget, x, y);
}
    static void gtk_form_send_configure(GtkForm *form)
{
    GtkWidget *widget;
    GdkEventConfigure event;
    widget = (((GtkWidget*) gtk_type_check_object_cast ((GtkTypeObject*) ((form)), ((gtk_widget_get_type ())))));
    event.type = GDK_CONFIGURE;
    event.window = widget->window;
    event.x = widget->allocation.x;
    event.y = widget->allocation.y;
    event.width = widget->allocation.width;
    event.height = widget->allocation.height;
    gtk_widget_event(widget, (GdkEvent*)&event);
}
    static void gtk_form_child_map(GtkWidget *widget, gpointer user_data)
{
    GtkFormChild *child;
    child = (GtkFormChild *)user_data;
    child->mapped = 1;
    gdk_window_show(child->window);
}
    static void gtk_form_child_unmap(GtkWidget *widget, gpointer user_data)
{
    GtkFormChild *child;
    child = (GtkFormChild *)user_data;
    child->mapped = 0;
    gdk_window_hide(child->window);
}
