typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
int bufIsChanged (buf_T *buf);
char *buf_spname (buf_T *buf);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
int emsgn (char_u *s, long n);
void expand_env (char_u *src, char_u *dst, int dstlen);
char_u *fix_fname (char_u *fname);
int fullpathcmp (char_u *s1, char_u *s2, int checkname);
int get_fileformat (buf_T *buf);
void getout (int exitval);
char_u *gettail (char_u *fname);
void home_replace (buf_T *buf, char_u *src, char_u *dst, int dstlen, int one);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
void ml_close (buf_T *buf, int del_file);
int ml_delete (linenr_T lnum, int message);
long ml_find_line_or_offset (buf_T *buf, linenr_T line, long *offp);
char_u *ml_get (linenr_T lnum);
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
int ml_open (void);int msg (char_u *s);
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_start (void);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
int open_buffer (int read_stdin, exarg_T *eap);
void out_flush (void);
int readfile (char_u *fname, char_u *sfname, linenr_T from, linenr_T lines_to_skip, linenr_T lines_to_read, exarg_T *eap, int flags);
void set_keep_msg (char_u *s);
void setpcmark (void);
typedef __u_int __mode_t;
typedef long int __off_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void vim_free (void *x);
int vim_ispathsep (int c);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
extern char_u *IObuff;
extern char_u *NameBuff;
extern int cmdline_row;
extern buf_T *curbuf ;
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern buf_T *firstbuf ;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int keep_msg_attr ;
extern int msg_row;
extern int msg_scrolled;
extern int need_wait_return ;
extern char_u no_lines_msg[] ;
extern int swap_exists_action ;
extern int usingNetbeans ;
void check_cursor (void);
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
extern int unlink (__const char *__name) ;
void FreeWild (int count, char_u **files);
int coladvance (colnr_T wcol);
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
int expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
void line_breakcheck (void);
int ml_replace (linenr_T lnum, char_u *line, int copy);
void redraw_curbuf_later (int type);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern int need_check_timestamps ;
extern int did_check_timestamps ;
int do_dialog (int type, char_u *title, char_u *message, char_u *buttons, int dfltbutton, char_u *textfield);
void mch_get_host_name (char_u *s, int len);
long mch_getperm (char_u *name);
int msg_end (void);
void msg_outnum (long n);
void msg_str (char_u *s, char_u *arg);
int vim_rename (char_u *from, char_u *to);
extern int no_wait_return ;
extern int starting ;
char_u *buf_modname (int shortname, char_u *fname, char_u *ext, int prepend_dot);
int setfname (char_u *ffname, char_u *sfname, int message);
typedef __mode_t mode_t;
typedef __time_t time_t;
extern char *ctime (__const time_t *__timer) ;
void redraw_all_later (int type);
void ml_preserve (buf_T *buf, int message);
extern int recoverymode ;
int msg_outtrans_attr (char_u *str, int attr);
int vim_FullName (char_u *fname, char_u *buf, int len, int force);
extern char_u *p_shm;
void buf_store_time (buf_T *buf, struct stat *st, char_u *fname);
char_u *get_file_in_dir (char_u *fname, char_u *dname);
extern int close (int __fd) ;
typedef __off_t off_t;
extern __off_t lseek (int __fd, __off_t __offset, int __whence) ;
extern int lstat (__const char *__restrict __file,
                  struct stat *__restrict __buf) ;
long mch_get_pid (void);
extern int open (__const char *__file, int __oflag, ...) ;
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
extern long p_uc;
void gui_start (void);
typedef __pid_t pid_t;
char_u *concat_fnames (char_u *fname1, char_u *fname2, int sep);
int recover_names (char_u **fname, int list, int nr);
extern int fstat (int __fd, struct stat *__buf) ;
void mf_set_ffname (memfile_T *mfp);
int ui_char_avail (void);void ml_open_file (buf_T *buf);
int get_number (int colon);
extern char_u *p_dir;
char_u *modname (char_u *fname, char_u *ext, int prepend_dot);
void vim_deltempdir (void);
memfile_T *mf_open (char_u *fname, int flags);
int mf_open_file (memfile_T *mfp, char_u *fname);
void mf_close (memfile_T *mfp, int del_file);
void mf_close_file (buf_T *buf, int getlines);
void mf_new_page_size (memfile_T *mfp, unsigned new_size);
bhdr_T *mf_new (memfile_T *mfp, int negative, int page_count);
bhdr_T *mf_get (memfile_T *mfp, blocknr_T nr, int page_count);
void mf_put (memfile_T *mfp, bhdr_T *hp, int dirty, int infile);
void mf_free (memfile_T *mfp, bhdr_T *hp);
int mf_sync (memfile_T *mfp, int flags);
blocknr_T mf_trans_del (memfile_T *mfp, blocknr_T old_nr);
int mf_need_trans (memfile_T *mfp);
int get_user_name (char_u *buf, int len);
void netbeans_inserted (buf_T *bufp, linenr_T linenr, colnr_T col, int oldlen, char_u *txt, int newlen);
extern char *Version;
extern int netbeansSuppressNoLines ;
typedef struct block0 ZERO_BL;
typedef struct pointer_block PTR_BL;
typedef struct data_block DATA_BL;
typedef struct pointer_entry PTR_EN;
struct pointer_entry
{
    blocknr_T pe_bnum;
    linenr_T pe_line_count;
    linenr_T pe_old_lnum;
    int pe_page_count;
};
struct data_block
{
    short_u db_id;
    unsigned db_free;
    unsigned db_txt_start;
    unsigned db_txt_end;
    linenr_T db_line_count;
    unsigned db_index[1];
};
struct block0
{
    char_u b0_id[2];
    char_u b0_version[10];
    char_u b0_page_size[4];
    char_u b0_mtime[4];
    char_u b0_ino[4];
    char_u b0_pid[4];
    char_u b0_uname[40];
    char_u b0_hname[40];
    char_u b0_fname[900];
    long b0_magic_long;
    int b0_magic_int;
    short b0_magic_short;
    char_u b0_magic_char;
};
struct pointer_block
{
    short_u pb_id;
    short_u pb_count;
    short_u pb_count_max;
    PTR_EN pb_pointer[1];
};
typedef __uid_t uid_t;
extern int kill (__pid_t __pid, int __sig) ;
int mch_get_uname (uid_t uid, char_u *s, int len);
void msg_home_replace (char_u *fname);
void netbeans_removed (buf_T *bufp, linenr_T linenr, colnr_T col, long len);
extern void *realloc (void *__ptr, size_t __size) __attribute__ ((__malloc__));
static linenr_T lowest_marked = 0;
static void set_b0_fname (ZERO_BL *, buf_T *buf);
static time_t swapfile_info (char_u *);
static int recov_file_names (char_u **, char_u *, int prepend_dot);
static int ml_append_int (buf_T *, linenr_T, char_u *, colnr_T, int, int);
static int ml_delete_int (buf_T *, linenr_T, int);
static char_u *findswapname (buf_T *, char_u **, char_u *);
static void ml_flush_line (buf_T *);
static bhdr_T *ml_new_data (memfile_T *, int, int);
static bhdr_T *ml_new_ptr (memfile_T *);
static bhdr_T *ml_find_line (buf_T *, linenr_T, int);
static int ml_add_stack (buf_T *);
static char_u *makeswapname (buf_T *, char_u *);
static void ml_lineadd (buf_T *, int);
static int b0_magic_wrong (ZERO_BL *);
static int fnamecmp_ino (char_u *, char_u *, long);
static void long_to_char (long, char_u *);
static long char_to_long (char_u *);
static char_u *make_percent_swname (char_u *dir, char_u *name);
static void ml_updatechunk (buf_T *buf, long line, long len, int updtype);
    int ml_open()
{
    memfile_T *mfp;
    bhdr_T *hp = ((void *)0);
    ZERO_BL *b0p;
    PTR_BL *pp;
    DATA_BL *dp;
    curbuf->b_ml.ml_stack_size = 0;
    curbuf->b_ml.ml_stack = ((void *)0);
    curbuf->b_ml.ml_stack_top = 0;
    curbuf->b_ml.ml_locked = ((void *)0);
    curbuf->b_ml.ml_line_lnum = 0;
    curbuf->b_ml.ml_chunksize = ((void *)0);
    if (p_uc && curbuf->b_p_swf)
        curbuf->b_may_swap = 1;
    else
        curbuf->b_may_swap = 0;
    mfp = mf_open(((void *)0), 0);
    if (mfp == ((void *)0))
        goto error;
    curbuf->b_ml.ml_mfp = mfp;
    curbuf->b_ml.ml_flags = 1;
    curbuf->b_ml.ml_line_count = 1;
    if ((hp = mf_new(mfp, 0, 1)) == ((void *)0))
        goto error;
    if (hp->bh_bnum != 0)
    {
        emsg((char_u *)(((char *)("E298: Didn't get block nr 0?"))));
        goto error;
    }
    b0p = (ZERO_BL *)(hp->bh_data);
    b0p->b0_id[0] = 'b';
    b0p->b0_id[1] = '0';
    b0p->b0_fname[900 -1] = curbuf->b_changed ? 0x55 : 0;
    b0p->b0_magic_long = (long)0x30313233L;
    b0p->b0_magic_int = (int)0x20212223L;
    b0p->b0_magic_short = (short)0x10111213L;
    b0p->b0_magic_char = 0x55;
    strncpy((char *)(b0p->b0_version), (char *)("VIM "), (size_t)(4));
    strncpy((char *)(b0p->b0_version + 4), (char *)(Version), (size_t)(6));
    set_b0_fname(b0p, curbuf);
    long_to_char((long)mfp->mf_page_size, b0p->b0_page_size);
    (void)get_user_name(b0p->b0_uname, 40);
    b0p->b0_uname[40 - 1] = '\000';
    mch_get_host_name(b0p->b0_hname, 40);
    b0p->b0_hname[40 - 1] = '\000';
    long_to_char(mch_get_pid(), b0p->b0_pid);
    mf_put(mfp, hp, 1, 0);
    if (!curbuf->b_help)
        (void)mf_sync(mfp, 0);
    if ((hp = ml_new_ptr(mfp)) == ((void *)0))
        goto error;
    if (hp->bh_bnum != 1)
    {
        emsg((char_u *)(((char *)("E298: Didn't get block nr 1?"))));
        goto error;
    }
    pp = (PTR_BL *)(hp->bh_data);
    pp->pb_count = 1;
    pp->pb_pointer[0].pe_bnum = 2;
    pp->pb_pointer[0].pe_page_count = 1;
    pp->pb_pointer[0].pe_old_lnum = 1;
    pp->pb_pointer[0].pe_line_count = 1;
    mf_put(mfp, hp, 1, 0);
    if ((hp = ml_new_data(mfp, 0, 1)) == ((void *)0))
        goto error;
    if (hp->bh_bnum != 2)
    {
        emsg((char_u *)(((char *)("E298: Didn't get block nr 2?"))));
        goto error;
    }
    dp = (DATA_BL *)(hp->bh_data);
    dp->db_index[0] = --dp->db_txt_start;
    dp->db_free -= 1 + (sizeof(unsigned));
    dp->db_line_count = 1;
    *((char_u *)dp + dp->db_txt_start) = '\000';
    return 1;
error:
    if (mfp != ((void *)0))
    {
        if (hp)
            mf_put(mfp, hp, 0, 0);
        mf_close(mfp, 1);
    }
    curbuf->b_ml.ml_mfp = ((void *)0);
    return 0;
}
    void ml_setname()
{
    int success = 0;
    memfile_T *mfp;
    char_u *fname;
    char_u *dirp;
    mfp = curbuf->b_ml.ml_mfp;
    if (mfp->mf_fd < 0)
    {
        if (p_uc != 0)
            ml_open_file(curbuf);
        return;
    }
    dirp = p_dir;
    for (;;)
    {
        if (*dirp == '\000')
            break;
        fname = findswapname(curbuf, &dirp, mfp->mf_fname);
        if (fname == ((void *)0))
            continue;
        if (strcmp((char *)(fname), (char *)(mfp->mf_fname)) == 0)
        {
            vim_free(fname);
            success = 1;
            break;
        }
        if (mfp->mf_fd >= 0)
        {
            close(mfp->mf_fd);
            mfp->mf_fd = -1;
        }
        if (vim_rename(mfp->mf_fname, fname) == 0)
        {
            success = 1;
            vim_free(mfp->mf_fname);
            mfp->mf_fname = fname;
            vim_free(mfp->mf_ffname);
            mf_set_ffname(mfp);
            break;
        }
        vim_free(fname);
    }
    if (mfp->mf_fd == -1)
    {
        mfp->mf_fd = open(((char *)mfp->mf_fname), (02 | 0), (0));
        if (mfp->mf_fd < 0)
        {
            emsg((char_u *)(((char *)("E301: Oops, lost the swap file!!!"))));
            return;
        }
    }
    if (!success)
        emsg((char_u *)(((char *)("E302: Could not rename swap file"))));
}
    void ml_open_files()
{
    buf_T *buf;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        if (!buf->b_p_ro || buf->b_changed)
            ml_open_file(buf);
}
    void ml_open_file(buf)
    buf_T *buf;
{
    memfile_T *mfp;
    char_u *fname;
    char_u *dirp;
    mfp = buf->b_ml.ml_mfp;
    if (mfp == ((void *)0) || mfp->mf_fd >= 0 || !buf->b_p_swf)
        return;
    dirp = p_dir;
    for (;;)
    {
        if (*dirp == '\000')
            break;
        fname = findswapname(buf, &dirp, ((void *)0));
        if (fname == ((void *)0))
            continue;
        if (mf_open_file(mfp, fname) == 1)
        {
            if (mf_sync(mfp, 8) == 1)
                break;
            mf_close_file(buf, 0);
        }
    }
    if (mfp->mf_fname == ((void *)0))
    {
        need_wait_return = 1;
        ++no_wait_return;
        (void)emsg2((char_u *)(((char *)("E303: Unable to open swap file for \"%s\", recovery impossible"))), (char_u *)(buf_spname(buf) != ((void *)0) ? (char_u *)buf_spname(buf) : buf->b_fname));
        --no_wait_return;
    }
    buf->b_may_swap = 0;
}
    void check_need_swap(newfile)
    int newfile;
{
    if (curbuf->b_may_swap && (!curbuf->b_p_ro || !newfile))
        ml_open_file(curbuf);
}
    void ml_close(buf, del_file)
    buf_T *buf;
    int del_file;
{
    if (buf->b_ml.ml_mfp == ((void *)0))
        return;
    mf_close(buf->b_ml.ml_mfp, del_file);
    if (buf->b_ml.ml_line_lnum != 0 && (buf->b_ml.ml_flags & 2))
        vim_free(buf->b_ml.ml_line_ptr);
    vim_free(buf->b_ml.ml_stack);
    vim_free(buf->b_ml.ml_chunksize);
    buf->b_ml.ml_chunksize = ((void *)0);
    buf->b_ml.ml_mfp = ((void *)0);
    buf->b_flags &= ~0x01;
}
    void ml_close_all(del_file)
    int del_file;
{
    buf_T *buf;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        ml_close(buf, del_file);
    vim_deltempdir();
}
    void ml_close_notmod()
{
    buf_T *buf;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        if (!bufIsChanged(buf))
            ml_close(buf, 1);
}
    void ml_timestamp(buf)
    buf_T *buf;
{
    memfile_T *mfp;
    bhdr_T *hp;
    ZERO_BL *b0p;
    mfp = buf->b_ml.ml_mfp;
    if (mfp == ((void *)0) || (hp = mf_get(mfp, (blocknr_T)0, 1)) == ((void *)0))
        return;
    b0p = (ZERO_BL *)(hp->bh_data);
    if (b0p->b0_id[0] != 'b' || b0p->b0_id[1] != '0')
        emsg((char_u *)(((char *)("E304: ml_timestamp: Didn't get block 0??"))));
    else
        set_b0_fname(b0p, buf);
    mf_put(mfp, hp, 1, 0);
}
    static void set_b0_fname(b0p, buf)
    ZERO_BL *b0p;
    buf_T *buf;
{
    struct stat st;
    if (buf->b_ffname == ((void *)0))
        b0p->b0_fname[0] = '\000';
    else
    {
        size_t flen, ulen;
        char_u uname[40];
        home_replace(((void *)0), buf->b_ffname, b0p->b0_fname, 900, 1);
        if (b0p->b0_fname[0] == '~')
        {
            flen = strlen((char *)(b0p->b0_fname));
            if (get_user_name(uname, 40) == 0
                         || (ulen = strlen((char *)(uname))) + flen > 900 - 1)
                strncpy((char *)(b0p->b0_fname), (char *)(buf->b_ffname), (size_t)(900));
            else
            {
                memmove((char *)(b0p->b0_fname + ulen + 1), (char *)(b0p->b0_fname + 1), flen);
                memmove((char *)(b0p->b0_fname + 1), (char *)(uname), ulen);
            }
        }
        if (stat(((char *)buf->b_ffname), (&st)) >= 0)
        {
            long_to_char((long)st.st_mtime, b0p->b0_mtime);
            long_to_char((long)st.st_ino, b0p->b0_ino);
            buf_store_time(buf, &st, buf->b_ffname);
            buf->b_mtime_read = buf->b_mtime;
        }
        else
        {
            long_to_char(0L, b0p->b0_mtime);
            long_to_char(0L, b0p->b0_ino);
            buf->b_mtime = 0;
            buf->b_mtime_read = 0;
            buf->b_orig_size = 0;
            buf->b_orig_mode = 0;
        }
    }
}
    void ml_recover()
{
    buf_T *buf = ((void *)0);
    memfile_T *mfp = ((void *)0);
    char_u *fname;
    bhdr_T *hp = ((void *)0);
    ZERO_BL *b0p;
    PTR_BL *pp;
    DATA_BL *dp;
    infoptr_T *ip;
    blocknr_T bnum;
    int page_count;
    struct stat org_stat, swp_stat;
    int len;
    int directly;
    linenr_T lnum;
    char_u *p;
    int i;
    long error;
    int cannot_open;
    linenr_T line_count;
    int has_error;
    int idx;
    int top;
    int txt_start;
    off_t size;
    int called_from_main;
    int serious_error = 1;
    long mtime;
    int attr;
    recoverymode = 1;
    called_from_main = (curbuf->b_ml.ml_mfp == ((void *)0));
    attr = highlight_attr[(int)(HLF_E)];
    fname = curbuf->b_fname;
    if (fname == ((void *)0))
        fname = (char_u *)"";
    len = (int)strlen((char *)(fname));
    if (len >= 4 &&
            strncasecmp((char *)(fname + len - 4), (char *)(".sw"), (size_t)(3))
                == 0)
    {
        directly = 1;
        fname = vim_strsave(fname);
    }
    else
    {
        directly = 0;
        len = recover_names(&fname, 0, 0);
        if (len == 0)
        {
            emsg2((char_u *)(((char *)("E305: No swap file found for %s"))), (char_u *)(fname));
            goto theend;
        }
        if (len == 1)
            i = 1;
        else
        {
            (void)recover_names(&fname, 1, 0);
            msg_putchar('\n');
            msg_puts((char_u *)(((char *)("Enter number of swap file to use (0 to quit): "))));
            i = get_number(0);
            if (i < 1 || i > len)
                goto theend;
        }
        (void)recover_names(&fname, 0, i);
    }
    if (fname == ((void *)0))
        goto theend;
    if (called_from_main && ml_open() == 0)
        getout(1);
    buf = (buf_T *)alloc((unsigned)sizeof(buf_T));
    if (buf == ((void *)0))
    {
        vim_free(fname);
        goto theend;
    }
    buf->b_ml.ml_stack_size = 0;
    buf->b_ml.ml_stack = ((void *)0);
    buf->b_ml.ml_stack_top = 0;
    buf->b_ml.ml_line_lnum = 0;
    buf->b_ml.ml_locked = ((void *)0);
    buf->b_ml.ml_flags = 0;
    p = vim_strsave(fname);
    mfp = mf_open(fname, 00);
    if (mfp == ((void *)0) || mfp->mf_fd < 0)
    {
        if (p != ((void *)0))
        {
            emsg2((char_u *)(((char *)("E306: Cannot open %s"))), (char_u *)(p));
            vim_free(p);
        }
        goto theend;
    }
    vim_free(p);
    buf->b_ml.ml_mfp = mfp;
    mfp->mf_page_size = 1048;
    if ((hp = mf_get(mfp, (blocknr_T)0, 1)) == ((void *)0))
    {
        msg_start();
        msg_puts_attr((char_u *)(((char *)("Unable to read block 0 from "))), (attr | 0x1000));
        msg_outtrans_attr(mfp->mf_fname, attr | 0x1000);
        msg_puts_attr((char_u *)(((char *)("\nMaybe no changes were made or Vim did not update the swap file."))), (attr | 0x1000));
        msg_end();
        goto theend;
    }
    b0p = (ZERO_BL *)(hp->bh_data);
    if (strncmp((char *)(b0p->b0_version), (char *)("VIM 3.0"), (size_t)(7)) == 0)
    {
        msg_start();
        msg_outtrans_attr(mfp->mf_fname, 0x1000);
        msg_puts_attr((char_u *)(((char *)(" cannot be used with this version of Vim.\n"))), (0x1000));
        msg_puts_attr((char_u *)(((char *)("Use Vim version 3.0.\n"))), (0x1000));
        msg_end();
        goto theend;
    }
    if (b0p->b0_id[0] != 'b' || b0p->b0_id[1] != '0')
    {
        emsg2((char_u *)(((char *)("E307: %s does not look like a Vim swap file"))), (char_u *)(mfp->mf_fname));
        goto theend;
    }
    if (b0_magic_wrong(b0p))
    {
        msg_start();
        msg_outtrans_attr(mfp->mf_fname, attr | 0x1000);
            msg_puts_attr((char_u *)(((char *)(" cannot be used on this computer.\n"))), (attr | 0x1000));
        msg_puts_attr((char_u *)(((char *)("The file was created on "))), (attr | 0x1000));
        b0p->b0_fname[0] = '\000';
        msg_puts_attr((char_u *)(b0p->b0_hname), (attr | 0x1000));
        msg_puts_attr((char_u *)(((char *)(",\nor the file has been damaged."))), (attr | 0x1000));
        msg_end();
        goto theend;
    }
    if (mfp->mf_page_size != (unsigned)char_to_long(b0p->b0_page_size))
    {
        mf_new_page_size(mfp, (unsigned)char_to_long(b0p->b0_page_size));
        if ((size = lseek(mfp->mf_fd, (off_t)0L, 2)) <= 0)
            mfp->mf_blocknr_max = 0;
        else
            mfp->mf_blocknr_max = (blocknr_T)(size / mfp->mf_page_size);
        mfp->mf_infile_count = mfp->mf_blocknr_max;
    }
    if (directly)
    {
        expand_env(b0p->b0_fname, NameBuff, 1024);
        if (setfname(NameBuff, ((void *)0), 1) == 0)
            goto theend;
    }
    home_replace(((void *)0), mfp->mf_fname, NameBuff, 1024, 1);
    msg_str((char_u *)((char *)("Using swap file \"%s\"")), NameBuff);
    if (buf_spname(curbuf) != ((void *)0))
        strcpy((char *)(NameBuff), (char *)(buf_spname(curbuf)));
    else
        home_replace(((void *)0), curbuf->b_ffname, NameBuff, 1024, 1);
    msg_str((char_u *)((char *)("Original file \"%s\"")), NameBuff);
    msg_putchar('\n');
    mtime = char_to_long(b0p->b0_mtime);
    if (curbuf->b_ffname != ((void *)0)
            && stat(((char *)curbuf->b_ffname), (&org_stat)) != -1
            && ((stat(((char *)mfp->mf_fname), (&swp_stat)) != -1
                    && org_stat.st_mtime > swp_stat.st_mtime)
                || org_stat.st_mtime != mtime))
    {
        emsg((char_u *)(((char *)("E308: Warning: Original file may have been changed"))));
    }
    out_flush();
    mf_put(mfp, hp, 0, 0);
    hp = ((void *)0);
    while (!(curbuf->b_ml.ml_flags & 1))
        ml_delete((linenr_T)1, 0);
    bnum = 1;
    page_count = 1;
    lnum = 0;
    line_count = 0;
    idx = 0;
    error = 0;
    buf->b_ml.ml_stack_top = 0;
    buf->b_ml.ml_stack = ((void *)0);
    buf->b_ml.ml_stack_size = 0;
    if (curbuf->b_ffname == ((void *)0))
        cannot_open = 1;
    else
        cannot_open = 0;
    serious_error = 0;
    for ( ; !got_int; line_breakcheck())
    {
        if (hp != ((void *)0))
            mf_put(mfp, hp, 0, 0);
        if ((hp = mf_get(mfp, (blocknr_T)bnum, page_count)) == ((void *)0))
        {
            if (bnum == 1)
            {
                emsg2((char_u *)(((char *)("E309: Unable to read block 1 from %s"))), (char_u *)(mfp->mf_fname));
                goto theend;
            }
            ++error;
            ml_append(lnum++, (char_u *)((char *)("???MANY LINES MISSING")),
                                                            (colnr_T)0, 1);
        }
        else
        {
            pp = (PTR_BL *)(hp->bh_data);
            if (pp->pb_id == (('p' << 8) + 't'))
            {
                if (idx == 0 && line_count != 0)
                {
                    for (i = 0; i < (int)pp->pb_count; ++i)
                        line_count -= pp->pb_pointer[i].pe_line_count;
                    if (line_count != 0)
                    {
                        ++error;
                        ml_append(lnum++, (char_u *)((char *)("???LINE COUNT WRONG")),
                                                            (colnr_T)0, 1);
                    }
                }
                if (pp->pb_count == 0)
                {
                    ml_append(lnum++, (char_u *)((char *)("???EMPTY BLOCK")),
                                                            (colnr_T)0, 1);
                    ++error;
                }
                else if (idx < (int)pp->pb_count)
                {
                    if (pp->pb_pointer[idx].pe_bnum < 0)
                    {
                        if (!cannot_open)
                        {
                            line_count = pp->pb_pointer[idx].pe_line_count;
                            if (readfile(curbuf->b_ffname, ((void *)0), lnum,
                                        pp->pb_pointer[idx].pe_old_lnum - 1,
                                        line_count, ((void *)0), 0) == 0)
                                cannot_open = 1;
                            else
                                lnum += line_count;
                        }
                        if (cannot_open)
                        {
                            ++error;
                            ml_append(lnum++, (char_u *)((char *)("???LINES MISSING")),
                                                            (colnr_T)0, 1);
                        }
                        ++idx;
                        continue;
                    }
                    if ((top = ml_add_stack(buf)) < 0)
                    {
                        ++error;
                        break;
                    }
                    ip = &(buf->b_ml.ml_stack[top]);
                    ip->ip_bnum = bnum;
                    ip->ip_index = idx;
                    bnum = pp->pb_pointer[idx].pe_bnum;
                    line_count = pp->pb_pointer[idx].pe_line_count;
                    page_count = pp->pb_pointer[idx].pe_page_count;
                    continue;
                }
            }
            else
            {
                dp = (DATA_BL *)(hp->bh_data);
                if (dp->db_id != (('d' << 8) + 'a'))
                {
                    if (bnum == 1)
                    {
                        emsg2((char_u *)(((char *)("E310: Block 1 ID wrong (%s not a .swp file?)"))), (char_u *)(mfp->mf_fname));
                        goto theend;
                    }
                    ++error;
                    ml_append(lnum++, (char_u *)((char *)("???BLOCK MISSING")),
                                                            (colnr_T)0, 1);
                }
                else
                {
                    has_error = 0;
                    if (page_count * mfp->mf_page_size != dp->db_txt_end)
                    {
                        ml_append(lnum++, (char_u *)((char *)("??? from here until ???END lines may be messed up")),
                                                            (colnr_T)0, 1);
                        ++error;
                        has_error = 1;
                        dp->db_txt_end = page_count * mfp->mf_page_size;
                    }
                    *((char_u *)dp + dp->db_txt_end - 1) = '\000';
                    if (line_count != dp->db_line_count)
                    {
                        ml_append(lnum++, (char_u *)((char *)("??? from here until ???END lines may have been inserted/deleted")),
                                                            (colnr_T)0, 1);
                        ++error;
                        has_error = 1;
                    }
                    for (i = 0; i < dp->db_line_count; ++i)
                    {
                        txt_start = (dp->db_index[i] & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
                        if (txt_start <= (sizeof(DATA_BL) - (sizeof(unsigned)))
                                          || txt_start >= (int)dp->db_txt_end)
                        {
                            p = (char_u *)"???";
                            ++error;
                        }
                        else
                            p = (char_u *)dp + txt_start;
                        ml_append(lnum++, p, (colnr_T)0, 1);
                    }
                    if (has_error)
                        ml_append(lnum++, (char_u *)((char *)("???END")), (colnr_T)0, 1);
                }
            }
        }
        if (buf->b_ml.ml_stack_top == 0)
            break;
        ip = &(buf->b_ml.ml_stack[--(buf->b_ml.ml_stack_top)]);
        bnum = ip->ip_bnum;
        idx = ip->ip_index + 1;
        page_count = 1;
    }
    ml_delete(curbuf->b_ml.ml_line_count, 0);
    curbuf->b_flags |= 0x01;
    recoverymode = 0;
    if (got_int)
        emsg((char_u *)(((char *)("E311: Recovery Interrupted"))));
    else if (error)
        emsg((char_u *)(((char *)("E312: Errors detected while recovering; look for lines starting with ???"))));
    else
    {
        msg((char_u *)(((char *)("Recovery completed. You should check if everything is OK."))));
        msg_puts((char_u *)(((char *)("\n(You might want to write out this file under another name\n"))));
        msg_puts((char_u *)(((char *)("and run diff with the original file to check for changes)\n"))));
        msg_puts((char_u *)(((char *)("Delete the .swp file afterwards.\n\n"))));
        cmdline_row = msg_row;
    }
    redraw_curbuf_later(40);
theend:
    recoverymode = 0;
    if (mfp != ((void *)0))
    {
        if (hp != ((void *)0))
            mf_put(mfp, hp, 0, 0);
        mf_close(mfp, 0);
    }
    vim_free(buf);
    if (serious_error && called_from_main)
        ml_close(curbuf, 1);
    else
    {
        apply_autocmds(EVENT_BUFREADPOST, ((void *)0), curbuf->b_fname, 0, curbuf);
        apply_autocmds(EVENT_BUFWINENTER, ((void *)0), curbuf->b_fname, 0, curbuf);
    }
    return;
}
    int recover_names(fname, list, nr)
    char_u **fname;
    int list;
    int nr;
{
    int num_names;
    char_u *(names[6]);
    char_u *tail;
    char_u *p;
    int num_files;
    int file_count = 0;
    char_u **files;
    int i;
    char_u *dirp;
    char_u *dir_name;
    if (list)
    {
        msg((char_u *)((char *)("Swap files found:")));
        msg_putchar('\n');
    }
    dir_name = alloc((unsigned)strlen((char *)(p_dir)) + 1);
    dirp = p_dir;
    while (dir_name != ((void *)0) && *dirp)
    {
        (void)copy_option_part(&dirp, dir_name, 31000, ",");
        if (dir_name[0] == '.' && dir_name[1] == '\000')
        {
            if (fname == ((void *)0) || *fname == ((void *)0))
            {
                names[0] = vim_strsave((char_u *)"*.sw?");
                names[1] = vim_strsave((char_u *)".*.sw?");
                names[2] = vim_strsave((char_u *)".sw?");
                num_names = 3;
            }
            else
                num_names = recov_file_names(names, *fname, 1);
        }
        else
        {
            if (fname == ((void *)0) || *fname == ((void *)0))
            {
                names[0] = concat_fnames(dir_name, (char_u *)"*.sw?", 1);
                names[1] = concat_fnames(dir_name, (char_u *)".*.sw?", 1);
                names[2] = concat_fnames(dir_name, (char_u *)".sw?", 1);
                num_names = 3;
            }
            else
            {
                p = dir_name + strlen((char *)(dir_name));
                if (vim_ispathsep(p[-1]) && p[-1] == p[-2])
                {
                    tail = make_percent_swname(dir_name, *fname);
                }
                else
                {
                    tail = gettail(*fname);
                    tail = concat_fnames(dir_name, tail, 1);
                }
                if (tail == ((void *)0))
                    num_names = 0;
                else
                {
                    num_names = recov_file_names(names, tail, 0);
                    vim_free(tail);
                }
            }
        }
        for (i = 0; i < num_names; ++i)
        {
            if (names[i] == ((void *)0))
            {
                for (i = 0; i < num_names; ++i)
                    vim_free(names[i]);
                num_names = 0;
            }
        }
        if (num_names == 0)
            num_files = 0;
        else if (expand_wildcards(num_names, names, &num_files, &files,
                                        16|2|32) == 0)
            num_files = 0;
        if (*dirp == '\000' && file_count + num_files == 0
                                           && fname != ((void *)0) && *fname != ((void *)0))
        {
            struct stat st;
            char_u *swapname;
            swapname = modname(*fname, (char_u *)".swp", 1);
            if (swapname != ((void *)0))
            {
                if (stat(((char *)swapname), (&st)) != -1)
                {
                    files = (char_u **)alloc((unsigned)sizeof(char_u *));
                    if (files != ((void *)0))
                    {
                        files[0] = swapname;
                        swapname = ((void *)0);
                        num_files = 1;
                    }
                }
                vim_free(swapname);
            }
        }
        if (curbuf->b_ml.ml_mfp != ((void *)0)
                               && (p = curbuf->b_ml.ml_mfp->mf_fname) != ((void *)0))
        {
            for (i = 0; i < num_files; ++i)
                if (fullpathcmp(p, files[i], 1) & 1)
                {
                    vim_free(files[i]);
                    --num_files;
                    for ( ; i < num_files; ++i)
                        files[i] = files[i + 1];
                }
        }
        if (nr)
        {
            file_count += num_files;
            if (nr <= file_count)
            {
                *fname = vim_strsave(files[nr - 1 + num_files - file_count]);
                dirp = (char_u *)"";
            }
        }
        else if (list)
        {
            if (dir_name[0] == '.' && dir_name[1] == '\000')
            {
                if (fname == ((void *)0) || *fname == ((void *)0))
                    msg_puts((char_u *)(((char *)("   In current directory:\n"))));
                else
                    msg_puts((char_u *)(((char *)("   Using specified name:\n"))));
            }
            else
            {
                msg_puts((char_u *)(((char *)("   In directory "))));
                msg_home_replace(dir_name);
                msg_puts((char_u *)(":\n"));
            }
            if (num_files)
            {
                for (i = 0; i < num_files; ++i)
                {
                    msg_outnum((long)++file_count);
                    msg_puts((char_u *)(".    "));
                    msg_puts(gettail(files[i]));
                    msg_putchar('\n');
                    (void)swapfile_info(files[i]);
                }
            }
            else
                msg_puts((char_u *)(((char *)("      -- none --\n"))));
            out_flush();
        }
        else
            file_count += num_files;
        for (i = 0; i < num_names; ++i)
            vim_free(names[i]);
        FreeWild(num_files, files);
    }
    vim_free(dir_name);
    return file_count;
}
    static char_u * make_percent_swname(dir, name)
    char_u *dir;
    char_u *name;
{
    char_u *d, *s, *f, *p;
    f = fix_fname(name != ((void *)0) ? name : (char_u *) "");
    d = ((void *)0);
    if (f != ((void *)0))
    {
        s = alloc((unsigned)(strlen((char *)(f)) + 1));
        if (s != ((void *)0))
        {
            for (d = s, p = f; *p; p++, d++)
                *d = vim_ispathsep(*p) ? '%' : *p;
            *d = 0;
            d = concat_fnames(dir, s, 1);
            vim_free(s);
        }
        vim_free(f);
    }
    return d;
}
static int process_still_running;
    static time_t swapfile_info(fname)
    char_u *fname;
{
    struct stat st;
    int fd;
    struct block0 b0;
    time_t x = (time_t)0;
    char_u uname[40];
    if (stat(((char *)fname), (&st)) != -1)
    {
        if (mch_get_uname(st.st_uid, uname, 40) == 1)
        {
            msg_puts((char_u *)(((char *)("          owned by: "))));
            msg_outtrans(uname);
            msg_puts((char_u *)(((char *)("   dated: "))));
        }
        else
            msg_puts((char_u *)(((char *)("             dated: "))));
        x = st.st_mtime;
        msg_puts((char_u *)(ctime(&x)));
    }
    fd = open(((char *)fname), (00 | 0), (0));
    if (fd >= 0)
    {
        if (read(fd, (char *)&b0, sizeof(b0)) == sizeof(b0))
        {
            if (strncmp((char *)(b0.b0_version), (char *)("VIM 3.0"), (size_t)(7)) == 0)
            {
                msg_puts((char_u *)(((char *)("         [from Vim version 3.0]"))));
            }
            else if (b0.b0_id[0] != 'b' || b0.b0_id[1] != '0')
            {
                msg_puts((char_u *)(((char *)("         [does not look like a Vim swap file]"))));
            }
            else
            {
                msg_puts((char_u *)(((char *)("         file name: "))));
                if (b0.b0_fname[0] == '\000')
                    msg_puts((char_u *)(((char *)("[No File]"))));
                else
                    msg_outtrans(b0.b0_fname);
                msg_puts((char_u *)(((char *)("\n          modified: "))));
                msg_puts((char_u *)(b0.b0_fname[900 -1] ? ((char *)("YES")) : ((char *)("no"))));
                if (*(b0.b0_uname) != '\000')
                {
                    msg_puts((char_u *)(((char *)("\n         user name: "))));
                    msg_outtrans(b0.b0_uname);
                }
                if (*(b0.b0_hname) != '\000')
                {
                    if (*(b0.b0_uname) != '\000')
                        msg_puts((char_u *)(((char *)("   host name: "))));
                    else
                        msg_puts((char_u *)(((char *)("\n         host name: "))));
                    msg_outtrans(b0.b0_hname);
                }
                if (char_to_long(b0.b0_pid) != 0L)
                {
                    msg_puts((char_u *)(((char *)("\n        process ID: "))));
                    msg_outnum(char_to_long(b0.b0_pid));
                    if (kill((pid_t)char_to_long(b0.b0_pid), 0) == 0)
                    {
                        msg_puts((char_u *)(((char *)(" (still running)"))));
                        process_still_running = 1;
                    }
                }
                if (b0_magic_wrong(&b0))
                {
                        msg_puts((char_u *)(((char *)("\n         [not usable on this computer]"))));
                }
            }
        }
        else
            msg_puts((char_u *)(((char *)("         [cannot be read]"))));
        close(fd);
    }
    else
        msg_puts((char_u *)(((char *)("         [cannot be opened]"))));
    msg_putchar('\n');
    return x;
}
    static int recov_file_names(names, path, prepend_dot)
    char_u **names;
    char_u *path;
    int prepend_dot;
{
    int num_names;
    char_u *p;
    int i;
    int shortname = curbuf->b_shortname;
    curbuf->b_shortname = 0;
    num_names = 0;
    if (prepend_dot)
    {
        names[num_names] = modname(path, (char_u *)".sw?", 1);
        if (names[num_names] == ((void *)0))
            goto end;
        ++num_names;
    }
    names[num_names] = concat_fnames(path, (char_u *)".sw?", 0);
    if (names[num_names] == ((void *)0))
        goto end;
    if (num_names >= 1)
    {
        p = names[num_names - 1];
        i = (int)strlen((char *)(names[num_names - 1])) - (int)strlen((char *)(names[num_names]));
        if (i > 0)
            p += i;
        if (strcmp((char *)(p), (char *)(names[num_names])) != 0)
            ++num_names;
        else
            vim_free(names[num_names]);
    }
    else
        ++num_names;
    curbuf->b_shortname = 1;
    names[num_names] = modname(path, (char_u *)".sw?", 0);
    if (names[num_names] == ((void *)0))
        goto end;
    p = names[num_names];
    i = strlen((char *)(names[num_names])) - strlen((char *)(names[num_names - 1]));
    if (i > 0)
        p += i;
    if (strcmp((char *)(names[num_names - 1]), (char *)(p)) == 0)
        vim_free(names[num_names]);
    else
        ++num_names;
end:
    curbuf->b_shortname = shortname;
    return num_names;
}
    void ml_sync_all(check_file, check_char)
    int check_file;
    int check_char;
{
    buf_T *buf;
    struct stat st;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
    {
        if (buf->b_ml.ml_mfp == ((void *)0) || buf->b_ml.ml_mfp->mf_fname == ((void *)0))
            continue;
        ml_flush_line(buf);
        (void)ml_find_line(buf, (linenr_T)0, 0x02);
        if (bufIsChanged(buf) && check_file && mf_need_trans(buf->b_ml.ml_mfp)
                                                     && buf->b_ffname != ((void *)0))
        {
            if (stat(((char *)buf->b_ffname), (&st)) == -1
                    || st.st_mtime != buf->b_mtime_read
                    || (size_t)st.st_size != buf->b_orig_size)
            {
                ml_preserve(buf, 0);
                did_check_timestamps = 0;
                need_check_timestamps = 1;
            }
        }
        if (buf->b_ml.ml_mfp->mf_dirty)
        {
            (void)mf_sync(buf->b_ml.ml_mfp, (check_char ? 2 : 0)
                                        | (bufIsChanged(buf) ? 4 : 0));
            if (check_char && ui_char_avail())
                break;
        }
    }
}
    void ml_preserve(buf, message)
    buf_T *buf;
    int message;
{
    bhdr_T *hp;
    linenr_T lnum;
    memfile_T *mfp = buf->b_ml.ml_mfp;
    int status;
    int got_int_save = got_int;
    if (mfp == ((void *)0) || mfp->mf_fname == ((void *)0))
    {
        if (message)
            emsg((char_u *)(((char *)("E313: Cannot preserve, there is no swap file"))));
        return;
    }
    got_int = 0;
    ml_flush_line(buf);
    (void)ml_find_line(buf, (linenr_T)0, 0x02);
    status = mf_sync(mfp, 1 | 4);
    buf->b_ml.ml_stack_top = 0;
    if (mf_need_trans(mfp) && !got_int)
    {
        lnum = 1;
        while (mf_need_trans(mfp) && lnum <= buf->b_ml.ml_line_count)
        {
            hp = ml_find_line(buf, lnum, 0x13);
            if (hp == ((void *)0))
            {
                status = 0;
                goto theend;
            }
                                                                 ;
            lnum = buf->b_ml.ml_locked_high + 1;
        }
        (void)ml_find_line(buf, (linenr_T)0, 0x02);
        if (mf_sync(mfp, 1 | 4) == 0)
            status = 0;
        buf->b_ml.ml_stack_top = 0;
    }
theend:
    got_int |= got_int_save;
    if (message)
    {
        if (status == 1)
            msg((char_u *)(((char *)("File preserved"))));
        else
            emsg((char_u *)(((char *)("E314: Preserve failed"))));
    }
}
    char_u * ml_get(lnum)
    linenr_T lnum;
{
    return ml_get_buf(curbuf, lnum, 0);
}
    char_u * ml_get_pos(pos)
    pos_T *pos;
{
    return (ml_get_buf(curbuf, pos->lnum, 0) + pos->col);
}
    char_u * ml_get_curline()
{
    return ml_get_buf(curbuf, curwin->w_cursor.lnum, 0);
}
    char_u * ml_get_cursor()
{
    return (ml_get_buf(curbuf, curwin->w_cursor.lnum, 0) +
                                                        curwin->w_cursor.col);
}
    char_u * ml_get_buf(buf, lnum, will_change)
    buf_T *buf;
    linenr_T lnum;
    int will_change;
{
    bhdr_T *hp;
    DATA_BL *dp;
    char_u *ptr;
    if (lnum > buf->b_ml.ml_line_count)
    {
        emsgn((char_u *)(((char *)("E315: ml_get: invalid lnum: %ld"))), (long)(lnum));
errorret:
        strcpy((char *)(IObuff), (char *)("???"));
        return IObuff;
    }
    if (lnum <= 0)
        lnum = 1;
    if (buf->b_ml.ml_mfp == ((void *)0))
        return (char_u *)"";
    if (buf->b_ml.ml_line_lnum != lnum)
    {
        ml_flush_line(buf);
        if ((hp = ml_find_line(buf, lnum, 0x13)) == ((void *)0))
        {
            emsgn((char_u *)(((char *)("E316: ml_get: cannot find line %ld"))), (long)(lnum));
            goto errorret;
        }
        dp = (DATA_BL *)(hp->bh_data);
        ptr = (char_u *)dp + ((dp->db_index[lnum - buf->b_ml.ml_locked_low]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
        buf->b_ml.ml_line_ptr = ptr;
        buf->b_ml.ml_line_lnum = lnum;
        buf->b_ml.ml_flags &= ~2;
    }
    if (will_change)
        buf->b_ml.ml_flags |= (4 | 8);
    return buf->b_ml.ml_line_ptr;
}
    int ml_line_alloced()
{
    return (curbuf->b_ml.ml_flags & 2);
}
    int ml_append(lnum, line, len, newfile)
    linenr_T lnum;
    char_u *line;
    colnr_T len;
    int newfile;
{
    if (curbuf->b_ml.ml_mfp == ((void *)0) && open_buffer(0, ((void *)0)) == 0)
        return 0;
    if (curbuf->b_ml.ml_line_lnum != 0)
        ml_flush_line(curbuf);
    return ml_append_int(curbuf, lnum, line, len, newfile, 0);
}
    static int ml_append_int(buf, lnum, line, len, newfile, mark)
    buf_T *buf;
    linenr_T lnum;
    char_u *line;
    colnr_T len;
    int newfile;
    int mark;
{
    int i;
    int line_count;
    int offset;
    int from, to;
    int space_needed;
    int page_size;
    int page_count;
    int db_idx;
    bhdr_T *hp;
    memfile_T *mfp;
    DATA_BL *dp;
    PTR_BL *pp;
    infoptr_T *ip;
    if (lnum > buf->b_ml.ml_line_count || buf->b_ml.ml_mfp == ((void *)0))
        return 0;
    if (lowest_marked && lowest_marked > lnum)
        lowest_marked = lnum + 1;
    if (len == 0)
        len = (colnr_T)strlen((char *)(line)) + 1;
    space_needed = len + (sizeof(unsigned));
    mfp = buf->b_ml.ml_mfp;
    page_size = mfp->mf_page_size;
    if ((hp = ml_find_line(buf, lnum == 0 ? (linenr_T)1 : lnum,
                                                          0x12)) == ((void *)0))
        return 0;
    buf->b_ml.ml_flags &= ~1;
    if (lnum == 0)
        db_idx = -1;
    else
        db_idx = lnum - buf->b_ml.ml_locked_low;
    line_count = buf->b_ml.ml_locked_high - buf->b_ml.ml_locked_low;
    dp = (DATA_BL *)(hp->bh_data);
    if ((int)dp->db_free < space_needed && db_idx == line_count - 1
                                            && lnum < buf->b_ml.ml_line_count)
    {
        --(buf->b_ml.ml_locked_lineadd);
        --(buf->b_ml.ml_locked_high);
        if ((hp = ml_find_line(buf, lnum + 1, 0x12)) == ((void *)0))
            return 0;
        db_idx = -1;
        line_count = buf->b_ml.ml_locked_high - buf->b_ml.ml_locked_low;
                                                                            ;
        dp = (DATA_BL *)(hp->bh_data);
    }
    ++buf->b_ml.ml_line_count;
    if ((int)dp->db_free >= space_needed)
    {
        dp->db_txt_start -= len;
        dp->db_free -= space_needed;
        ++(dp->db_line_count);
        if (line_count > db_idx + 1)
        {
            if (db_idx < 0)
                offset = dp->db_txt_end;
            else
                offset = ((dp->db_index[db_idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
            memmove((char *)((char *)dp + dp->db_txt_start), (char *)((char *)dp + dp->db_txt_start + len), (size_t)(offset - (dp->db_txt_start + len)));
            for (i = line_count - 1; i > db_idx; --i)
                dp->db_index[i + 1] = dp->db_index[i] - len;
            dp->db_index[db_idx + 1] = offset - len;
        }
        else
            dp->db_index[db_idx + 1] = dp->db_txt_start;
        memmove((char *)((char *)dp + dp->db_index[db_idx + 1]), (char *)(line), (size_t)len);
        if (mark)
            dp->db_index[db_idx + 1] |= ((unsigned)1 << ((sizeof(unsigned) * 8) - 1));
        buf->b_ml.ml_flags |= 4;
        if (!newfile)
            buf->b_ml.ml_flags |= 8;
    }
    else
    {
        long line_count_left, line_count_right;
        int page_count_left, page_count_right;
        bhdr_T *hp_left;
        bhdr_T *hp_right;
        bhdr_T *hp_new;
        int lines_moved;
        int data_moved = 0;
        int total_moved = 0;
        DATA_BL *dp_right, *dp_left;
        int stack_idx;
        int in_left;
        int lineadd;
        blocknr_T bnum_left, bnum_right;
        linenr_T lnum_left, lnum_right;
        int pb_idx;
        PTR_BL *pp_new;
        if (db_idx < 0)
        {
            lines_moved = 0;
            in_left = 1;
        }
        else
        {
            lines_moved = line_count - db_idx - 1;
            if (lines_moved == 0)
                in_left = 0;
            else
            {
                data_moved = ((dp->db_index[db_idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))) -
                                                            dp->db_txt_start;
                total_moved = data_moved + lines_moved * (sizeof(unsigned));
                if ((int)dp->db_free + total_moved >= space_needed)
                {
                    in_left = 1;
                    space_needed = total_moved;
                }
                else
                {
                    in_left = 0;
                    space_needed += total_moved;
                }
            }
        }
        page_count = ((space_needed + (sizeof(DATA_BL) - (sizeof(unsigned)))) + page_size - 1) / page_size;
        if ((hp_new = ml_new_data(mfp, newfile, page_count)) == ((void *)0))
        {
            --(buf->b_ml.ml_locked_lineadd);
            --(buf->b_ml.ml_locked_high);
            return 0;
        }
        if (db_idx < 0)
        {
            hp_left = hp_new;
            hp_right = hp;
            line_count_left = 0;
            line_count_right = line_count;
        }
        else
        {
            hp_left = hp;
            hp_right = hp_new;
            line_count_left = line_count;
            line_count_right = 0;
        }
        dp_right = (DATA_BL *)(hp_right->bh_data);
        dp_left = (DATA_BL *)(hp_left->bh_data);
        bnum_left = hp_left->bh_bnum;
        bnum_right = hp_right->bh_bnum;
        page_count_left = hp_left->bh_page_count;
        page_count_right = hp_right->bh_page_count;
        if (!in_left)
        {
            dp_right->db_txt_start -= len;
            dp_right->db_free -= len + (sizeof(unsigned));
            dp_right->db_index[0] = dp_right->db_txt_start;
            if (mark)
                dp_right->db_index[0] |= ((unsigned)1 << ((sizeof(unsigned) * 8) - 1));
            memmove((char *)((char *)dp_right + dp_right->db_txt_start), (char *)(line), (size_t)len);
            ++line_count_right;
        }
        if (lines_moved)
        {
            dp_right->db_txt_start -= data_moved;
            dp_right->db_free -= total_moved;
            memmove((char *)((char *)dp_right + dp_right->db_txt_start), (char *)((char *)dp_left + dp_left->db_txt_start), (size_t)data_moved);
            offset = dp_right->db_txt_start - dp_left->db_txt_start;
            dp_left->db_txt_start += data_moved;
            dp_left->db_free += total_moved;
            for (to = line_count_right, from = db_idx + 1;
                                         from < line_count_left; ++from, ++to)
                dp_right->db_index[to] = dp->db_index[from] + offset;
            line_count_right += lines_moved;
            line_count_left -= lines_moved;
        }
        if (in_left)
        {
            dp_left->db_txt_start -= len;
            dp_left->db_free -= len + (sizeof(unsigned));
            dp_left->db_index[line_count_left] = dp_left->db_txt_start;
            if (mark)
                dp_left->db_index[line_count_left] |= ((unsigned)1 << ((sizeof(unsigned) * 8) - 1));
            memmove((char *)((char *)dp_left + dp_left->db_txt_start), (char *)(line), (size_t)len);
            ++line_count_left;
        }
        if (db_idx < 0)
        {
            lnum_left = lnum + 1;
            lnum_right = 0;
        }
        else
        {
            lnum_left = 0;
            if (in_left)
                lnum_right = lnum + 2;
            else
                lnum_right = lnum + 1;
        }
        dp_left->db_line_count = line_count_left;
        dp_right->db_line_count = line_count_right;
        if (lines_moved || in_left)
            buf->b_ml.ml_flags |= 4;
        if (!newfile && db_idx >= 0 && in_left)
            buf->b_ml.ml_flags |= 8;
        mf_put(mfp, hp_new, 1, 0);
        lineadd = buf->b_ml.ml_locked_lineadd;
        buf->b_ml.ml_locked_lineadd = 0;
        ml_find_line(buf, (linenr_T)0, 0x02);
        for (stack_idx = buf->b_ml.ml_stack_top - 1; stack_idx >= 0;
                                                                  --stack_idx)
        {
            ip = &(buf->b_ml.ml_stack[stack_idx]);
            pb_idx = ip->ip_index;
            if ((hp = mf_get(mfp, ip->ip_bnum, 1)) == ((void *)0))
                return 0;
            pp = (PTR_BL *)(hp->bh_data);
            if (pp->pb_id != (('p' << 8) + 't'))
            {
                emsg((char_u *)(((char *)("E317: pointer block id wrong 3"))));
                mf_put(mfp, hp, 0, 0);
                return 0;
            }
            if (pp->pb_count < pp->pb_count_max)
            {
                if (pb_idx + 1 < (int)pp->pb_count)
                    memmove((char *)(&pp->pb_pointer[pb_idx + 2]), (char *)(&pp->pb_pointer[pb_idx + 1]), (size_t)(pp->pb_count - pb_idx - 1) * sizeof(PTR_EN));
                ++pp->pb_count;
                pp->pb_pointer[pb_idx].pe_line_count = line_count_left;
                pp->pb_pointer[pb_idx].pe_bnum = bnum_left;
                pp->pb_pointer[pb_idx].pe_page_count = page_count_left;
                pp->pb_pointer[pb_idx + 1].pe_line_count = line_count_right;
                pp->pb_pointer[pb_idx + 1].pe_bnum = bnum_right;
                pp->pb_pointer[pb_idx + 1].pe_page_count = page_count_right;
                if (lnum_left != 0)
                    pp->pb_pointer[pb_idx].pe_old_lnum = lnum_left;
                if (lnum_right != 0)
                    pp->pb_pointer[pb_idx + 1].pe_old_lnum = lnum_right;
                mf_put(mfp, hp, 1, 0);
                buf->b_ml.ml_stack_top = stack_idx + 1;
                if (lineadd)
                {
                    --(buf->b_ml.ml_stack_top);
                    ml_lineadd(buf, lineadd);
                    buf->b_ml.ml_stack[buf->b_ml.ml_stack_top].ip_high +=
                                                                      lineadd;
                    ++(buf->b_ml.ml_stack_top);
                }
                break;
            }
            else
            {
                for (;;)
                {
                    hp_new = ml_new_ptr(mfp);
                    if (hp_new == ((void *)0))
                        return 0;
                    pp_new = (PTR_BL *)(hp_new->bh_data);
                    if (hp->bh_bnum != 1)
                        break;
                    memmove((char *)(pp_new), (char *)(pp), (size_t)page_size);
                    pp->pb_count = 1;
                    pp->pb_pointer[0].pe_bnum = hp_new->bh_bnum;
                    pp->pb_pointer[0].pe_line_count = buf->b_ml.ml_line_count;
                    pp->pb_pointer[0].pe_old_lnum = 1;
                    pp->pb_pointer[0].pe_page_count = 1;
                    mf_put(mfp, hp, 1, 0);
                    hp = hp_new;
                    pp = pp_new;
                                                                     ;
                    ip->ip_index = 0;
                    ++stack_idx;
                }
                total_moved = pp->pb_count - pb_idx - 1;
                if (total_moved)
                {
                    memmove((char *)(&pp_new->pb_pointer[0]), (char *)(&pp->pb_pointer[pb_idx + 1]), (size_t)(total_moved) * sizeof(PTR_EN));
                    pp_new->pb_count = total_moved;
                    pp->pb_count -= total_moved - 1;
                    pp->pb_pointer[pb_idx + 1].pe_bnum = bnum_right;
                    pp->pb_pointer[pb_idx + 1].pe_line_count = line_count_right;
                    pp->pb_pointer[pb_idx + 1].pe_page_count = page_count_right;
                    if (lnum_right)
                        pp->pb_pointer[pb_idx + 1].pe_old_lnum = lnum_right;
                }
                else
                {
                    pp_new->pb_count = 1;
                    pp_new->pb_pointer[0].pe_bnum = bnum_right;
                    pp_new->pb_pointer[0].pe_line_count = line_count_right;
                    pp_new->pb_pointer[0].pe_page_count = page_count_right;
                    pp_new->pb_pointer[0].pe_old_lnum = lnum_right;
                }
                pp->pb_pointer[pb_idx].pe_bnum = bnum_left;
                pp->pb_pointer[pb_idx].pe_line_count = line_count_left;
                pp->pb_pointer[pb_idx].pe_page_count = page_count_left;
                if (lnum_left)
                    pp->pb_pointer[pb_idx].pe_old_lnum = lnum_left;
                lnum_left = 0;
                lnum_right = 0;
                line_count_right = 0;
                for (i = 0; i < (int)pp_new->pb_count; ++i)
                    line_count_right += pp_new->pb_pointer[i].pe_line_count;
                line_count_left = 0;
                for (i = 0; i < (int)pp->pb_count; ++i)
                    line_count_left += pp->pb_pointer[i].pe_line_count;
                bnum_left = hp->bh_bnum;
                bnum_right = hp_new->bh_bnum;
                page_count_left = 1;
                page_count_right = 1;
                mf_put(mfp, hp, 1, 0);
                mf_put(mfp, hp_new, 1, 0);
            }
        }
        if (stack_idx < 0)
        {
            emsg((char_u *)(((char *)("E318: Updated too many blocks?"))));
            buf->b_ml.ml_stack_top = 0;
        }
    }
    ml_updatechunk(buf, lnum + 1, (long)len, 1);
    if (usingNetbeans)
    {
        if (strlen((char *)(line)) > 0)
            netbeans_inserted(buf, lnum+1, (colnr_T)0, 0, line, strlen((char *)(line)));
        netbeans_inserted(buf, lnum+1, (colnr_T)strlen((char *)(line)), 0,
                                                           (char_u *)"\n", 1);
    }
    return 1;
}
    int ml_replace(lnum, line, copy)
    linenr_T lnum;
    char_u *line;
    int copy;
{
    if (line == ((void *)0))
        return 0;
    if (curbuf->b_ml.ml_mfp == ((void *)0) && open_buffer(0, ((void *)0)) == 0)
        return 0;
    if (copy && (line = vim_strsave(line)) == ((void *)0))
        return 0;
    if (usingNetbeans)
    {
        netbeans_removed(curbuf, lnum, 0, (long)strlen((char *)(ml_get(lnum))));
        netbeans_inserted(curbuf, lnum, 0, 0, line, strlen((char *)(line)));
    }
    if (curbuf->b_ml.ml_line_lnum != lnum)
        ml_flush_line(curbuf);
    else if (curbuf->b_ml.ml_flags & 2)
        vim_free(curbuf->b_ml.ml_line_ptr);
    curbuf->b_ml.ml_line_ptr = line;
    curbuf->b_ml.ml_line_lnum = lnum;
    curbuf->b_ml.ml_flags = (curbuf->b_ml.ml_flags | 2) & ~1;
    return 1;
}
    int ml_delete(lnum, message)
    linenr_T lnum;
    int message;
{
    ml_flush_line(curbuf);
    return ml_delete_int(curbuf, lnum, message);
}
    static int ml_delete_int(buf, lnum, message)
    buf_T *buf;
    linenr_T lnum;
    int message;
{
    bhdr_T *hp;
    memfile_T *mfp;
    DATA_BL *dp;
    PTR_BL *pp;
    infoptr_T *ip;
    int count;
    int idx;
    int stack_idx;
    int text_start;
    int line_start;
    long line_size;
    int i;
    if (lnum < 1 || lnum > buf->b_ml.ml_line_count)
        return 0;
    if (lowest_marked && lowest_marked > lnum)
        lowest_marked--;
    if (buf->b_ml.ml_line_count == 1)
    {
        if (message
                && !netbeansSuppressNoLines
           )
        {
            set_keep_msg((char_u *)((char *)(no_lines_msg)));
            keep_msg_attr = 0;
        }
        i = ml_replace((linenr_T)1, (char_u *)"", 1);
        buf->b_ml.ml_flags |= 1;
        return i;
    }
    mfp = buf->b_ml.ml_mfp;
    if (mfp == ((void *)0))
        return 0;
    if ((hp = ml_find_line(buf, lnum, 0x11)) == ((void *)0))
        return 0;
    dp = (DATA_BL *)(hp->bh_data);
    count = (long)(buf->b_ml.ml_locked_high)
                                        - (long)(buf->b_ml.ml_locked_low) + 2;
    idx = lnum - buf->b_ml.ml_locked_low;
    --buf->b_ml.ml_line_count;
    line_start = ((dp->db_index[idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
    if (idx == 0)
        line_size = dp->db_txt_end - line_start;
    else
        line_size = ((dp->db_index[idx - 1]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))) - line_start;
    if (usingNetbeans)
        netbeans_removed(buf, lnum, 0, line_size);
    if (count == 1)
    {
        mf_free(mfp, hp);
        buf->b_ml.ml_locked = ((void *)0);
        for (stack_idx = buf->b_ml.ml_stack_top - 1; stack_idx >= 0; --stack_idx)
        {
            buf->b_ml.ml_stack_top = 0;
            ip = &(buf->b_ml.ml_stack[stack_idx]);
            idx = ip->ip_index;
            if ((hp = mf_get(mfp, ip->ip_bnum, 1)) == ((void *)0))
                return 0;
            pp = (PTR_BL *)(hp->bh_data);
            if (pp->pb_id != (('p' << 8) + 't'))
            {
                emsg((char_u *)(((char *)("E317: pointer block id wrong 4"))));
                mf_put(mfp, hp, 0, 0);
                return 0;
            }
            count = --(pp->pb_count);
            if (count == 0)
                mf_free(mfp, hp);
            else
            {
                if (count != idx)
                    memmove((char *)(&pp->pb_pointer[idx]), (char *)(&pp->pb_pointer[idx + 1]), (size_t)(count - idx) * sizeof(PTR_EN));
                mf_put(mfp, hp, 1, 0);
                buf->b_ml.ml_stack_top = stack_idx;
                if (buf->b_ml.ml_locked_lineadd)
                {
                    ml_lineadd(buf, buf->b_ml.ml_locked_lineadd);
                    buf->b_ml.ml_stack[buf->b_ml.ml_stack_top].ip_high +=
                                                buf->b_ml.ml_locked_lineadd;
                }
                ++(buf->b_ml.ml_stack_top);
                break;
            }
        }
                                                   ;
    }
    else
    {
        text_start = dp->db_txt_start;
        memmove((char *)((char *)dp + text_start + line_size), (char *)((char *)dp + text_start), (size_t)(line_start - text_start));
        for (i = idx; i < count - 1; ++i)
            dp->db_index[i] = dp->db_index[i + 1] + line_size;
        dp->db_free += line_size + (sizeof(unsigned));
        dp->db_txt_start += line_size;
        --(dp->db_line_count);
        buf->b_ml.ml_flags |= (4 | 8);
    }
    ml_updatechunk(buf, lnum, line_size, 2);
    return 1;
}
    void ml_setmarked(lnum)
    linenr_T lnum;
{
    bhdr_T *hp;
    DATA_BL *dp;
    if (lnum < 1 || lnum > curbuf->b_ml.ml_line_count
                                               || curbuf->b_ml.ml_mfp == ((void *)0))
        return;
    if (lowest_marked == 0 || lowest_marked > lnum)
        lowest_marked = lnum;
    if ((hp = ml_find_line(curbuf, lnum, 0x13)) == ((void *)0))
        return;
    dp = (DATA_BL *)(hp->bh_data);
    dp->db_index[lnum - curbuf->b_ml.ml_locked_low] |= ((unsigned)1 << ((sizeof(unsigned) * 8) - 1));
    curbuf->b_ml.ml_flags |= 4;
}
    linenr_T ml_firstmarked()
{
    bhdr_T *hp;
    DATA_BL *dp;
    linenr_T lnum;
    int i;
    if (curbuf->b_ml.ml_mfp == ((void *)0))
        return (linenr_T) 0;
    for (lnum = lowest_marked; lnum <= curbuf->b_ml.ml_line_count; )
    {
        if ((hp = ml_find_line(curbuf, lnum, 0x13)) == ((void *)0))
            return (linenr_T)0;
        dp = (DATA_BL *)(hp->bh_data);
        for (i = lnum - curbuf->b_ml.ml_locked_low;
                            lnum <= curbuf->b_ml.ml_locked_high; ++i, ++lnum)
            if ((dp->db_index[i]) & ((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))
            {
                (dp->db_index[i]) &= (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)));
                curbuf->b_ml.ml_flags |= 4;
                lowest_marked = lnum + 1;
                return lnum;
            }
    }
    return (linenr_T) 0;
}
    void ml_clearmarked()
{
    bhdr_T *hp;
    DATA_BL *dp;
    linenr_T lnum;
    int i;
    if (curbuf->b_ml.ml_mfp == ((void *)0))
        return;
    for (lnum = lowest_marked; lnum <= curbuf->b_ml.ml_line_count; )
    {
        if ((hp = ml_find_line(curbuf, lnum, 0x13)) == ((void *)0))
            return;
        dp = (DATA_BL *)(hp->bh_data);
        for (i = lnum - curbuf->b_ml.ml_locked_low;
                            lnum <= curbuf->b_ml.ml_locked_high; ++i, ++lnum)
            if ((dp->db_index[i]) & ((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))
            {
                (dp->db_index[i]) &= (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)));
                curbuf->b_ml.ml_flags |= 4;
            }
    }
    lowest_marked = 0;
    return;
}
    static void ml_flush_line(buf)
    buf_T *buf;
{
    bhdr_T *hp;
    DATA_BL *dp;
    linenr_T lnum;
    char_u *new_line;
    char_u *old_line;
    colnr_T new_len;
    int old_len;
    int extra;
    int idx;
    int start;
    int count;
    int i;
    if (buf->b_ml.ml_line_lnum == 0 || buf->b_ml.ml_mfp == ((void *)0))
        return;
    if (buf->b_ml.ml_flags & 2)
    {
        lnum = buf->b_ml.ml_line_lnum;
        new_line = buf->b_ml.ml_line_ptr;
        hp = ml_find_line(buf, lnum, 0x13);
        if (hp == ((void *)0))
            emsgn((char_u *)(((char *)("E320: Cannot find line %ld"))), (long)(lnum));
        else
        {
            dp = (DATA_BL *)(hp->bh_data);
            idx = lnum - buf->b_ml.ml_locked_low;
            start = ((dp->db_index[idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
            old_line = (char_u *)dp + start;
            if (idx == 0)
                old_len = dp->db_txt_end - start;
            else
                old_len = (dp->db_index[idx - 1] & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))) - start;
            new_len = (colnr_T)strlen((char *)(new_line)) + 1;
            extra = new_len - old_len;
            if ((int)dp->db_free >= extra)
            {
                count = buf->b_ml.ml_locked_high - buf->b_ml.ml_locked_low + 1;
                if (extra != 0 && idx < count - 1)
                {
                    memmove((char *)((char *)dp + dp->db_txt_start - extra), (char *)((char *)dp + dp->db_txt_start), (size_t)(start - dp->db_txt_start));
                    for (i = idx + 1; i < count; ++i)
                        dp->db_index[i] -= extra;
                }
                dp->db_index[idx] -= extra;
                dp->db_free -= extra;
                dp->db_txt_start -= extra;
                memmove((char *)(old_line - extra), (char *)(new_line), (size_t)new_len);
                buf->b_ml.ml_flags |= (4 | 8);
                ml_updatechunk(buf, lnum, (long)extra, 3);
            }
            else
            {
                (void)ml_append_int(buf, lnum, new_line, new_len, 0,
                                             (dp->db_index[idx] & ((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
                (void)ml_delete_int(buf, lnum, 0);
            }
        }
        vim_free(new_line);
    }
    buf->b_ml.ml_line_lnum = 0;
}
    static bhdr_T * ml_new_data(mfp, negative, page_count)
    memfile_T *mfp;
    int negative;
    int page_count;
{
    bhdr_T *hp;
    DATA_BL *dp;
    if ((hp = mf_new(mfp, negative, page_count)) == ((void *)0))
        return ((void *)0);
    dp = (DATA_BL *)(hp->bh_data);
    dp->db_id = (('d' << 8) + 'a');
    dp->db_txt_start = dp->db_txt_end = page_count * mfp->mf_page_size;
    dp->db_free = dp->db_txt_start - (sizeof(DATA_BL) - (sizeof(unsigned)));
    dp->db_line_count = 0;
    return hp;
}
    static bhdr_T * ml_new_ptr(mfp)
    memfile_T *mfp;
{
    bhdr_T *hp;
    PTR_BL *pp;
    if ((hp = mf_new(mfp, 0, 1)) == ((void *)0))
        return ((void *)0);
    pp = (PTR_BL *)(hp->bh_data);
    pp->pb_id = (('p' << 8) + 't');
    pp->pb_count = 0;
    pp->pb_count_max = (short_u)((mfp->mf_page_size - sizeof(PTR_BL)) / sizeof(PTR_EN) + 1);
    return hp;
}
    static bhdr_T * ml_find_line(buf, lnum, action)
    buf_T *buf;
    linenr_T lnum;
    int action;
{
    DATA_BL *dp;
    PTR_BL *pp;
    infoptr_T *ip;
    bhdr_T *hp;
    memfile_T *mfp;
    linenr_T t;
    blocknr_T bnum, bnum2;
    int dirty;
    linenr_T low, high;
    int top;
    int page_count;
    int idx;
    mfp = buf->b_ml.ml_mfp;
    if (buf->b_ml.ml_locked)
    {
        if ((action & 0x10) && buf->b_ml.ml_locked_low <= lnum
                                          && buf->b_ml.ml_locked_high >= lnum)
        {
            if (action == 0x12)
            {
                ++(buf->b_ml.ml_locked_lineadd);
                ++(buf->b_ml.ml_locked_high);
            }
            else if (action == 0x11)
            {
                --(buf->b_ml.ml_locked_lineadd);
                --(buf->b_ml.ml_locked_high);
            }
            return (buf->b_ml.ml_locked);
        }
        mf_put(mfp, buf->b_ml.ml_locked, buf->b_ml.ml_flags & 4,
                                            buf->b_ml.ml_flags & 8);
        buf->b_ml.ml_locked = ((void *)0);
        if (buf->b_ml.ml_locked_lineadd)
            ml_lineadd(buf, buf->b_ml.ml_locked_lineadd);
    }
    if (action == 0x02)
        return ((void *)0);
    bnum = 1;
    page_count = 1;
    low = 1;
    high = buf->b_ml.ml_line_count;
    if (action == 0x13)
    {
        for (top = buf->b_ml.ml_stack_top - 1; top >= 0; --top)
        {
            ip = &(buf->b_ml.ml_stack[top]);
            if (ip->ip_low <= lnum && ip->ip_high >= lnum)
            {
                bnum = ip->ip_bnum;
                low = ip->ip_low;
                high = ip->ip_high;
                buf->b_ml.ml_stack_top = top;
                break;
            }
        }
        if (top < 0)
            buf->b_ml.ml_stack_top = 0;
    }
    else
        buf->b_ml.ml_stack_top = 0;
    for (;;)
    {
        if ((hp = mf_get(mfp, bnum, page_count)) == ((void *)0))
            goto error_noblock;
        if (action == 0x12)
            ++high;
        else if (action == 0x11)
            --high;
        dp = (DATA_BL *)(hp->bh_data);
        if (dp->db_id == (('d' << 8) + 'a'))
        {
            buf->b_ml.ml_locked = hp;
            buf->b_ml.ml_locked_low = low;
            buf->b_ml.ml_locked_high = high;
            buf->b_ml.ml_locked_lineadd = 0;
            buf->b_ml.ml_flags &= ~(4 | 8);
            return hp;
        }
        pp = (PTR_BL *)(dp);
        if (pp->pb_id != (('p' << 8) + 't'))
        {
            emsg((char_u *)(((char *)("E317: pointer block id wrong"))));
            goto error_block;
        }
        if ((top = ml_add_stack(buf)) < 0)
            goto error_block;
        ip = &(buf->b_ml.ml_stack[top]);
        ip->ip_bnum = bnum;
        ip->ip_low = low;
        ip->ip_high = high;
        ip->ip_index = -1;
        dirty = 0;
        for (idx = 0; idx < (int)pp->pb_count; ++idx)
        {
            t = pp->pb_pointer[idx].pe_line_count;
                                                     ;
            if ((low += t) > lnum)
            {
                ip->ip_index = idx;
                bnum = pp->pb_pointer[idx].pe_bnum;
                page_count = pp->pb_pointer[idx].pe_page_count;
                high = low - 1;
                low -= t;
                if (bnum < 0)
                {
                    bnum2 = mf_trans_del(mfp, bnum);
                    if (bnum != bnum2)
                    {
                        bnum = bnum2;
                        pp->pb_pointer[idx].pe_bnum = bnum;
                        dirty = 1;
                    }
                }
                break;
            }
        }
        if (idx >= (int)pp->pb_count)
        {
            if (lnum > buf->b_ml.ml_line_count)
                emsgn((char_u *)(((char *)("E322: line number out of range: %ld past the end"))), (long)(lnum - buf->b_ml.ml_line_count));
            else
                emsgn((char_u *)(((char *)("E323: line count wrong in block %ld"))), (long)(bnum));
            goto error_block;
        }
        if (action == 0x11)
        {
            pp->pb_pointer[idx].pe_line_count--;
            dirty = 1;
        }
        else if (action == 0x12)
        {
            pp->pb_pointer[idx].pe_line_count++;
            dirty = 1;
        }
        mf_put(mfp, hp, dirty, 0);
    }
error_block:
    mf_put(mfp, hp, 0, 0);
error_noblock:
    if (action == 0x11)
        ml_lineadd(buf, 1);
    else if (action == 0x12)
        ml_lineadd(buf, -1);
    buf->b_ml.ml_stack_top = 0;
    return ((void *)0);
}
    static int ml_add_stack(buf)
    buf_T *buf;
{
    int top;
    infoptr_T *newstack;
    top = buf->b_ml.ml_stack_top;
    if (top == buf->b_ml.ml_stack_size)
    {
                                                 ;
        newstack = (infoptr_T *)alloc((unsigned)sizeof(infoptr_T) *
                                        (buf->b_ml.ml_stack_size + 5));
        if (newstack == ((void *)0))
            return -1;
        memmove((char *)(newstack), (char *)(buf->b_ml.ml_stack), (size_t)top * sizeof(infoptr_T));
        vim_free(buf->b_ml.ml_stack);
        buf->b_ml.ml_stack = newstack;
        buf->b_ml.ml_stack_size += 5;
    }
    buf->b_ml.ml_stack_top++;
    return top;
}
    static void ml_lineadd(buf, count)
    buf_T *buf;
    int count;
{
    int idx;
    infoptr_T *ip;
    PTR_BL *pp;
    memfile_T *mfp = buf->b_ml.ml_mfp;
    bhdr_T *hp;
    for (idx = buf->b_ml.ml_stack_top - 1; idx >= 0; --idx)
    {
        ip = &(buf->b_ml.ml_stack[idx]);
        if ((hp = mf_get(mfp, ip->ip_bnum, 1)) == ((void *)0))
            break;
        pp = (PTR_BL *)(hp->bh_data);
        if (pp->pb_id != (('p' << 8) + 't'))
        {
            mf_put(mfp, hp, 0, 0);
            emsg((char_u *)(((char *)("E317: pointer block id wrong 2"))));
            break;
        }
        pp->pb_pointer[ip->ip_index].pe_line_count += count;
        ip->ip_high += count;
        mf_put(mfp, hp, 1, 0);
    }
}
    static char_u * makeswapname(buf, dir_name)
    buf_T *buf;
    char_u *dir_name;
{
    char_u *r, *s;
    s = dir_name + strlen((char *)(dir_name));
    if (vim_ispathsep(s[-1]) && s[-1] == s[-2])
    {
        r = ((void *)0);
        if ((s = make_percent_swname(dir_name, buf->b_fname)) != ((void *)0))
        {
            r = modname(s, (char_u *)".swp", 0);
            vim_free(s);
        }
        return r;
    }
    r = buf_modname(
            (buf->b_p_sn || buf->b_shortname),
            buf->b_fname,
            (char_u *)
            ".swp",
            dir_name[0] == '.' && dir_name[1] == '\000'
               );
    if (r == ((void *)0))
        return ((void *)0);
    s = get_file_in_dir(r, dir_name);
    vim_free(r);
    return s;
}
    char_u * get_file_in_dir(fname, dname)
    char_u *fname;
    char_u *dname;
{
    char_u *t;
    char_u *tail;
    char_u *retval;
    int save_char;
    tail = gettail(fname);
    if (dname[0] == '.' && dname[1] == '\000')
        retval = vim_strsave(fname);
    else if (dname[0] == '.' && vim_ispathsep(dname[1]))
    {
        if (tail == fname)
            retval = concat_fnames(dname + 2, tail, 1);
        else
        {
            save_char = *tail;
            *tail = '\000';
            t = concat_fnames(fname, dname + 2, 1);
            *tail = save_char;
            if (t == ((void *)0))
                retval = ((void *)0);
            else
            {
                retval = concat_fnames(t, tail, 1);
                vim_free(t);
            }
        }
    }
    else
        retval = concat_fnames(dname, tail, 1);
    return retval;
}
    static char_u * findswapname(buf, dirp, old_fname)
    buf_T *buf;
    char_u **dirp;
    char_u *old_fname;
{
    char_u *fname;
    int n;
    time_t x, sx;
    char_u *dir_name;
    int r;
    dir_name = alloc((unsigned)strlen((char *)(*dirp)) + 1);
    if (dir_name != ((void *)0))
        (void)copy_option_part(dirp, dir_name, 31000, ",");
    if (dir_name == ((void *)0))
        fname = ((void *)0);
    else
        fname = makeswapname(buf, dir_name);
    for (;;)
    {
        if (fname == ((void *)0))
            break;
        if ((n = (int)strlen((char *)(fname))) == 0)
        {
            vim_free(fname);
            fname = ((void *)0);
            break;
        }
        if (fname[n - 2] == 'w' && fname[n - 1] == 'p'
                                        && !(buf->b_p_sn || buf->b_shortname))
        {
            char_u *tail;
            char_u *fname2;
            struct stat s1, s2;
            int f1, f2;
            int created1 = 0, created2 = 0;
            int same = 0;
            tail = gettail(buf->b_fname);
            if ( vim_strchr(tail, '.') != ((void *)0)
                    || strlen((char *)(tail)) > (size_t)8
                    || *gettail(fname) == '.')
            {
                fname2 = alloc(n + 2);
                if (fname2 != ((void *)0))
                {
                    strcpy((char *)(fname2), (char *)(fname));
                    if (vim_strchr(tail, '.') != ((void *)0))
                        fname2[n - 1] = 'x';
                    else if (*gettail(fname) == '.')
                    {
                        fname2[n] = 'x';
                        fname2[n + 1] = '\000';
                    }
                    else
                        fname2[n - 5] += 1;
                    f1 = open(((char *)fname), (00 | 0), (0));
                    if (f1 < 0)
                    {
                        f1 = open(
                                (char *)fname,
                                02|0100|0200|0
                                                              , (mode_t)0600
                                                                            );
                        created1 = 1;
                    }
                    if (f1 >= 0)
                    {
                        f2 = open(((char *)fname2), (00 | 0), (0));
                        if (f2 < 0)
                        {
                            f2 = open(
                                    (char *)fname2,
                                    02|0100|0200|0
                                                              , (mode_t)0600
                                                                            );
                            created2 = 1;
                        }
                        if (f2 >= 0)
                        {
                            if (fstat((f1), (&s1)) != -1
                                    && fstat((f2), (&s2)) != -1
                                    && s1.st_dev == s2.st_dev
                                    && s1.st_ino == s2.st_ino)
                                same = 1;
                            close(f2);
                            if (created2)
                                unlink((char *)(fname2));
                        }
                        close(f1);
                        if (created1)
                            unlink((char *)(fname));
                    }
                    vim_free(fname2);
                    if (same)
                    {
                        buf->b_shortname = 1;
                        vim_free(fname);
                        fname = makeswapname(buf, dir_name);
                        continue;
                    }
                }
            }
        }
        if (mch_getperm(fname) < 0)
        {
            struct stat sb;
            if (lstat(((char *)fname), (&sb)) < 0)
                break;
        }
        if (old_fname != ((void *)0) && strcmp((char *)(fname), (char *)(old_fname)) == 0)
            break;
        if (fname[n - 2] == 'w' && fname[n - 1] == 'p')
        {
            if (!(buf->b_p_sn || buf->b_shortname))
            {
                fname[n - 1] = 'x';
                r = mch_getperm(fname);
                fname[n - 1] = 'p';
                if (r >= 0)
                {
                    buf->b_shortname = 1;
                    vim_free(fname);
                    fname = makeswapname(buf, dir_name);
                    continue;
                }
            }
            if (!recoverymode && buf->b_fname != ((void *)0) && !buf->b_help)
            {
                int fd;
                struct block0 b0;
                int differ = 0;
                fd = open(((char *)fname), (00 | 0), (0));
                if (fd >= 0)
                {
                    if (read(fd, (char *)&b0, sizeof(b0)) == sizeof(b0))
                    {
                        expand_env(b0.b0_fname, NameBuff, 1024);
                        if (fnamecmp_ino(buf->b_ffname, NameBuff,
                                                     char_to_long(b0.b0_ino)))
                            differ = 1;
                    }
                    close(fd);
                }
                if (differ == 0 && !(curbuf->b_flags & 0x01)
                        && vim_strchr(p_shm, 'A') == ((void *)0))
                {
                    struct stat st;
                    if (gui.starting && !gui.in_use)
                        gui_start();
                    process_still_running = 0;
                    ++no_wait_return;
                    (void)emsg((char_u *)(((char *)("E325: ATTENTION"))));
                    msg_puts((char_u *)(((char *)("\nFound a swap file by the name \""))));
                    msg_home_replace(fname);
                    msg_puts((char_u *)(((char *)("\"\n"))));
                    sx = swapfile_info(fname);
                    msg_puts((char_u *)(((char *)("While opening file \""))));
                    msg_outtrans(buf->b_fname);
                    msg_puts((char_u *)(((char *)("\"\n"))));
                    if (stat(((char *)buf->b_fname), (&st)) != -1)
                    {
                        msg_puts((char_u *)(((char *)("             dated: "))));
                        x = st.st_mtime;
                        msg_puts((char_u *)(ctime(&x)));
                        if (sx != 0 && x > sx)
                            msg_puts((char_u *)(((char *)("      NEWER than swap file!\n"))));
                    }
                    msg_puts((char_u *)(((char *)("\n(1) Another program may be editing the same file.\n    If this is the case, be careful not to end up with two\n    different instances of the same file when making changes.\n"))));
                    msg_puts((char_u *)(((char *)("    Quit, or continue with caution.\n"))));
                    msg_puts((char_u *)(((char *)("\n(2) An edit session for this file crashed.\n"))));
                    msg_puts((char_u *)(((char *)("    If this is the case, use \":recover\" or \"vim -r "))));
                    msg_outtrans(buf->b_fname);
                    msg_puts((char_u *)(((char *)("\"\n    to recover the changes (see \":help recovery\").\n"))));
                    msg_puts((char_u *)(((char *)("    If you did this already, delete the swap file \""))));
                    msg_outtrans(fname);
                    msg_puts((char_u *)(((char *)("\"\n    to avoid this message.\n"))));
                    cmdline_row = msg_row;
                    --no_wait_return;
                    got_int = 0;
                    if (swap_exists_action)
                    {
                        char_u *name;
                        name = alloc((unsigned)(strlen((char *)(fname))
                                + strlen((char *)(((char *)("Swap file \""))))
                                + strlen((char *)(((char *)("\" already exists!")))) + 5));
                        if (name != ((void *)0))
                        {
                            strcpy((char *)(name), (char *)(((char *)("Swap file \""))));
                            home_replace(((void *)0), fname, name + strlen((char *)(name)),
                                                                  1000, 1);
                            strcat((char *)(name), (char *)(((char *)("\" already exists!"))));
                        }
                        switch (do_dialog(2,
                                    (char_u *)((char *)("VIM - ATTENTION")),
                                    name == ((void *)0)
                                        ? (char_u *)((char *)("Swap file already exists!"))
                                        : name,
                                    process_still_running
                                        ? (char_u *)((char *)("&Open Read-Only\n&Edit anyway\n&Recover\n&Quit")) :
                                        (char_u *)((char *)("&Open Read-Only\n&Edit anyway\n&Recover\n&Quit\n&Delete it")), 1, ((void *)0)))
                        {
                            case 1:
                                buf->b_p_ro = 1;
                                break;
                            case 2:
                                break;
                            case 3:
                                swap_exists_action = 3;
                                break;
                            case 4:
                                swap_exists_action = 2;
                                break;
                            case 5:
                                unlink((char *)(fname));
                                break;
                        }
                        vim_free(name);
                        msg_scrolled = 0;
                        redraw_all_later(40);
                        if (mch_getperm(fname) < 0)
                            break;
                    }
                    else
                    {
                        msg_puts((char_u *)("\n"));
                        need_wait_return = 1;
                    }
                }
            }
        }
        if (fname[n - 1] == 'a')
        {
            if (fname[n - 2] == 'a')
            {
                emsg((char_u *)(((char *)("E326: Too many swap files found"))));
                vim_free(fname);
                fname = ((void *)0);
                break;
            }
            --fname[n - 2];
            fname[n - 1] = 'z' + 1;
        }
        --fname[n - 1];
    }
    vim_free(dir_name);
    return fname;
}
    static int b0_magic_wrong(b0p)
    ZERO_BL *b0p;
{
    return (b0p->b0_magic_long != (long)0x30313233L
            || b0p->b0_magic_int != (int)0x20212223L
            || b0p->b0_magic_short != (short)0x10111213L
            || b0p->b0_magic_char != 0x55);
}
    static int fnamecmp_ino(fname_c, fname_s, ino_block0)
    char_u *fname_c;
    char_u *fname_s;
    long ino_block0;
{
    struct stat st;
    ino_t ino_c = 0;
    ino_t ino_s;
    char_u buf_c[1024];
    char_u buf_s[1024];
    int retval_c;
    int retval_s;
    if (stat(((char *)fname_c), (&st)) == 0)
        ino_c = (ino_t)st.st_ino;
    if (stat(((char *)fname_s), (&st)) == 0)
        ino_s = (ino_t)st.st_ino;
    else
        ino_s = (ino_t)ino_block0;
    if (ino_c && ino_s)
        return (ino_c != ino_s);
    retval_c = vim_FullName(fname_c, buf_c, 1024, 1);
    retval_s = vim_FullName(fname_s, buf_s, 1024, 1);
    if (retval_c == 1 && retval_s == 1)
        return (strcmp((char *)(buf_c), (char *)(buf_s)) != 0);
    if (ino_s == 0 && ino_c == 0 && retval_c == 0 && retval_s == 0)
        return 0;
    return 1;
}
    static void long_to_char(n, s)
    long n;
    char_u *s;
{
    s[0] = (char_u)(n & 0xff);
    n = (unsigned)n >> 8;
    s[1] = (char_u)(n & 0xff);
    n = (unsigned)n >> 8;
    s[2] = (char_u)(n & 0xff);
    n = (unsigned)n >> 8;
    s[3] = (char_u)(n & 0xff);
}
    static long char_to_long(s)
    char_u *s;
{
    long retval;
    retval = s[3];
    retval <<= 8;
    retval |= s[2];
    retval <<= 8;
    retval |= s[1];
    retval <<= 8;
    retval |= s[0];
    return retval;
}
    void ml_setdirty(buf, flag)
    buf_T *buf;
    int flag;
{
    bhdr_T *hp;
    ZERO_BL *b0p;
    if (!buf->b_ml.ml_mfp)
        return;
    for (hp = buf->b_ml.ml_mfp->mf_used_last; hp != ((void *)0); hp = hp->bh_prev)
    {
        if (hp->bh_bnum == 0)
        {
            b0p = (ZERO_BL *)(hp->bh_data);
            b0p->b0_fname[900 -1] = flag ? 0x55 : 0;
            hp->bh_flags |= 1;
            mf_sync(buf->b_ml.ml_mfp, 8);
            break;
        }
    }
}
    static void ml_updatechunk(buf, line, len, updtype)
    buf_T *buf;
    linenr_T line;
    long len;
    int updtype;
{
    static buf_T *ml_upd_lastbuf = ((void *)0);
    static linenr_T ml_upd_lastline;
    static linenr_T ml_upd_lastcurline;
    static int ml_upd_lastcurix;
    linenr_T curline = ml_upd_lastcurline;
    int curix = ml_upd_lastcurix;
    long size;
    chunksize_T *curchnk;
    int rest;
    bhdr_T *hp;
    DATA_BL *dp;
    if (buf->b_ml.ml_usedchunks == -1 || len == 0)
        return;
    if (buf->b_ml.ml_chunksize == ((void *)0))
    {
        buf->b_ml.ml_chunksize = (chunksize_T *)
                                  alloc((unsigned)sizeof(chunksize_T) * 100);
        if (buf->b_ml.ml_chunksize == ((void *)0))
        {
            buf->b_ml.ml_usedchunks = -1;
            return;
        }
        buf->b_ml.ml_numchunks = 100;
        buf->b_ml.ml_usedchunks = 1;
        buf->b_ml.ml_chunksize[0].mlcs_numlines = 1;
        buf->b_ml.ml_chunksize[0].mlcs_totalsize = 1;
    }
    if (updtype == 3 && buf->b_ml.ml_line_count == 1)
    {
        buf->b_ml.ml_usedchunks = 1;
        buf->b_ml.ml_chunksize[0].mlcs_numlines = 1;
        buf->b_ml.ml_chunksize[0].mlcs_totalsize =
                                  (long)strlen((char *)(buf->b_ml.ml_line_ptr)) + 1;
        return;
    }
    if (buf != ml_upd_lastbuf || line != ml_upd_lastline + 1
            || updtype != 1)
    {
        for (curline = 1, curix = 0;
             curix < buf->b_ml.ml_usedchunks - 1
             && line >= curline + buf->b_ml.ml_chunksize[curix].mlcs_numlines;
             curix++)
        {
            curline += buf->b_ml.ml_chunksize[curix].mlcs_numlines;
        }
    }
    else if (line >= curline + buf->b_ml.ml_chunksize[curix].mlcs_numlines
                 && curix < buf->b_ml.ml_usedchunks - 1)
    {
        curline += buf->b_ml.ml_chunksize[curix].mlcs_numlines;
        curix++;
    }
    curchnk = buf->b_ml.ml_chunksize + curix;
    if (updtype == 2)
        len *= -1;
    curchnk->mlcs_totalsize += len;
    if (updtype == 1)
    {
        curchnk->mlcs_numlines++;
        if (buf->b_ml.ml_usedchunks + 1 >= buf->b_ml.ml_numchunks)
        {
            buf->b_ml.ml_numchunks = buf->b_ml.ml_numchunks * 3 / 2;
            buf->b_ml.ml_chunksize = (chunksize_T *)
                realloc((buf->b_ml.ml_chunksize), (sizeof(chunksize_T) * buf->b_ml.ml_numchunks));
            if (buf->b_ml.ml_chunksize == ((void *)0))
            {
                buf->b_ml.ml_usedchunks = -1;
                return;
            }
        }
        if (buf->b_ml.ml_chunksize[curix].mlcs_numlines >= 800)
        {
            int count;
            int idx;
            int text_end;
            int linecnt;
            memmove((char *)(buf->b_ml.ml_chunksize + curix + 1), (char *)(buf->b_ml.ml_chunksize + curix), (buf->b_ml.ml_usedchunks - curix) * sizeof(chunksize_T));
            size = 0;
            linecnt = 0;
            while (curline < buf->b_ml.ml_line_count
                        && linecnt < 400)
            {
                if ((hp = ml_find_line(buf, curline, 0x13)) == ((void *)0))
                {
                    buf->b_ml.ml_usedchunks = -1;
                    return;
                }
                dp = (DATA_BL *)(hp->bh_data);
                count = (long)(buf->b_ml.ml_locked_high) -
                        (long)(buf->b_ml.ml_locked_low) + 1;
                idx = curline - buf->b_ml.ml_locked_low;
                curline = buf->b_ml.ml_locked_high + 1;
                if (idx == 0)
                    text_end = dp->db_txt_end;
                else
                    text_end = ((dp->db_index[idx - 1]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
                rest = count - idx;
                if (linecnt + rest > 400)
                {
                    idx += 400 - linecnt - 1;
                    linecnt = 400;
                }
                else
                {
                    idx = count - 1;
                    linecnt += rest;
                }
                size += text_end - ((dp->db_index[idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
            }
            buf->b_ml.ml_chunksize[curix].mlcs_numlines = linecnt;
            buf->b_ml.ml_chunksize[curix + 1].mlcs_numlines -= linecnt;
            buf->b_ml.ml_chunksize[curix].mlcs_totalsize = size;
            buf->b_ml.ml_chunksize[curix + 1].mlcs_totalsize -= size;
            buf->b_ml.ml_usedchunks++;
            ml_upd_lastbuf = ((void *)0);
            return;
        }
        else if (buf->b_ml.ml_chunksize[curix].mlcs_numlines >= 400
                     && curix == buf->b_ml.ml_usedchunks - 1
                     && buf->b_ml.ml_line_count - line <= 1)
        {
            curchnk = buf->b_ml.ml_chunksize + curix + 1;
            buf->b_ml.ml_usedchunks++;
            if (line == buf->b_ml.ml_line_count)
            {
                curchnk->mlcs_numlines = 0;
                curchnk->mlcs_totalsize = 0;
            }
            else
            {
                hp = ml_find_line(buf, buf->b_ml.ml_line_count, 0x13);
                if (hp == ((void *)0))
                {
                    buf->b_ml.ml_usedchunks = -1;
                    return;
                }
                dp = (DATA_BL *)(hp->bh_data);
                if (dp->db_line_count == 1)
                    rest = dp->db_txt_end - dp->db_txt_start;
                else
                    rest =
                        ((dp->db_index[dp->db_line_count - 2]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))))
                        - dp->db_txt_start;
                curchnk->mlcs_totalsize = rest;
                curchnk->mlcs_numlines = 1;
                curchnk[-1].mlcs_totalsize -= rest;
                curchnk[-1].mlcs_numlines -= 1;
            }
        }
    }
    else if (updtype == 2)
    {
        curchnk->mlcs_numlines--;
        ml_upd_lastbuf = ((void *)0);
        if (curix < (buf->b_ml.ml_usedchunks - 1)
                && (curchnk->mlcs_numlines + curchnk[1].mlcs_numlines)
                   <= 400)
        {
            curix++;
            curchnk = buf->b_ml.ml_chunksize + curix;
        }
        else if (curix == 0 && curchnk->mlcs_numlines <= 0)
        {
            buf->b_ml.ml_usedchunks--;
            memmove((char *)(buf->b_ml.ml_chunksize), (char *)(buf->b_ml.ml_chunksize + 1), buf->b_ml.ml_usedchunks * sizeof(chunksize_T));
            return;
        }
        else if (curix == 0 || (curchnk->mlcs_numlines > 10
                    && (curchnk->mlcs_numlines + curchnk[-1].mlcs_numlines)
                       > 400))
        {
            return;
        }
        curchnk[-1].mlcs_numlines += curchnk->mlcs_numlines;
        curchnk[-1].mlcs_totalsize += curchnk->mlcs_totalsize;
        buf->b_ml.ml_usedchunks--;
        if (curix < buf->b_ml.ml_usedchunks)
        {
            memmove((char *)(buf->b_ml.ml_chunksize + curix), (char *)(buf->b_ml.ml_chunksize + curix + 1), (buf->b_ml.ml_usedchunks - curix) * sizeof(chunksize_T));
        }
        return;
    }
    ml_upd_lastbuf = buf;
    ml_upd_lastline = line;
    ml_upd_lastcurline = curline;
    ml_upd_lastcurix = curix;
}
    long ml_find_line_or_offset(buf, line, offp)
    buf_T *buf;
    linenr_T line;
    long *offp;
{
    linenr_T curline;
    int curix;
    long size;
    bhdr_T *hp;
    DATA_BL *dp;
    int count;
    int idx;
    int start_idx;
    int text_end;
    long offset;
    int len;
    int ffdos = (get_fileformat(buf) == 1);
    int extra = 0;
    if (buf->b_ml.ml_usedchunks == -1
            || buf->b_ml.ml_chunksize == ((void *)0)
            || line < 0)
        return -1;
    if (offp == ((void *)0))
        offset = 0;
    else
        offset = *offp;
    if (line == 0 && offset <= 0)
        return 1;
    curline = 1;
    curix = size = 0;
    while (curix < buf->b_ml.ml_usedchunks - 1
            && ((line != 0
             && line >= curline + buf->b_ml.ml_chunksize[curix].mlcs_numlines)
                || (offset != 0
               && offset > size + buf->b_ml.ml_chunksize[curix].mlcs_totalsize
                      + ffdos * buf->b_ml.ml_chunksize[curix].mlcs_numlines)))
    {
        curline += buf->b_ml.ml_chunksize[curix].mlcs_numlines;
        size += buf->b_ml.ml_chunksize[curix].mlcs_totalsize;
        if (offset && ffdos)
            size += buf->b_ml.ml_chunksize[curix].mlcs_numlines;
        curix++;
    }
    while ((line != 0 && curline < line) || (offset != 0 && size < offset))
    {
        if (curline > buf->b_ml.ml_line_count
                || (hp = ml_find_line(buf, curline, 0x13)) == ((void *)0))
            return -1;
        dp = (DATA_BL *)(hp->bh_data);
        count = (long)(buf->b_ml.ml_locked_high) -
                (long)(buf->b_ml.ml_locked_low) + 1;
        start_idx = idx = curline - buf->b_ml.ml_locked_low;
        if (idx == 0)
            text_end = dp->db_txt_end;
        else
            text_end = ((dp->db_index[idx - 1]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
        if (line != 0)
        {
            if (curline + (count - idx) >= line)
                idx += line - curline - 1;
            else
                idx = count - 1;
        }
        else
        {
            extra = 0;
            while (offset >= size
                       + text_end - (int)((dp->db_index[idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))))
                                                                      + ffdos)
            {
                if (ffdos)
                    size++;
                if (idx == count - 1)
                {
                    extra = 1;
                    break;
                }
                idx++;
            }
        }
        len = text_end - ((dp->db_index[idx]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1))));
        size += len;
        if (offset != 0 && size >= offset)
        {
            if (size + ffdos == offset)
                *offp = 0;
            else if (idx == start_idx)
                *offp = offset - size + len;
            else
                *offp = offset - size + len
                     - (text_end - ((dp->db_index[idx - 1]) & (~((unsigned)1 << ((sizeof(unsigned) * 8) - 1)))));
            curline += idx - start_idx + extra;
            if (curline > buf->b_ml.ml_line_count)
                return -1;
            return curline;
        }
        curline = buf->b_ml.ml_locked_high + 1;
    }
    if (ffdos)
        size += line - 1;
    return size;
}
    void goto_byte(cnt)
    long cnt;
{
    long boff = cnt;
    linenr_T lnum;
    ml_flush_line(curbuf);
    setpcmark();
    if (boff)
        --boff;
    lnum = ml_find_line_or_offset(curbuf, (linenr_T)0, &boff);
    if (lnum < 1)
    {
        curwin->w_cursor.lnum = curbuf->b_ml.ml_line_count;
        curwin->w_curswant = (0x7fffffffL);
        coladvance((colnr_T)(0x7fffffffL));
    }
    else
    {
        curwin->w_cursor.lnum = lnum;
        curwin->w_cursor.col = (colnr_T)boff;
        curwin->w_set_curswant = 1;
    }
    check_cursor();
}
