typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
extern int atoi (__const char *__nptr) __attribute__ ((__pure__));
extern long int atol (__const char *__nptr) __attribute__ ((__pure__));
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
char_u *file_pat_to_reg_pat (char_u *pat, char_u *pat_end, char *allow_dirs, int no_bslash);
void getout (int exitval);
int mch_dirname (char_u *buf, int len);
void mch_settitle (char_u *title, char_u *icon);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int msg (char_u *s);
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_start (void);
void out_flush (void);
void resettitle (void);
char_u *skipwhite (char_u *p);
int smsg (char_u *, ...);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
typedef __u_int __mode_t;
typedef long int __off_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int stat (__const char *__restrict __file,
                 struct stat *__restrict __buf) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern int strcmp (__const char *__s1, __const char *__s2)
             __attribute__ ((__pure__));
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern int strncmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void vim_free (void *x);
regprog_T *vim_regcomp (char_u *expr, int re_flags);
typedef struct
{
    regprog_T *regprog;
    char_u *startp[10];
    char_u *endp[10];
    int rm_ic;
} regmatch_T;
int vim_regexec (regmatch_T *rmp, char_u *line, colnr_T col);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strrchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
typedef unsigned int int_u;
extern long Columns ;
extern char_u *IObuff;
extern long Rows
                            ;
extern int State ;
extern int cmdline_row;
extern buf_T *curbuf ;
extern int emsg_silent ;
extern int got_int ;
extern int msg_row;
void backslash_halve (char_u *p);
int rem_backslash (char_u *str);
int call_shell (char_u *cmd, int opt);
extern int chdir (__const char *__path) ;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int fclose (FILE *__stream) ;
extern FILE *fopen (__const char *__restrict __filename,
                    __const char *__restrict __modes) ;
extern int unlink (__const char *__name) ;
char_u *vim_tempname (int extra_char);
extern char_u e_prev_dir[] ;
extern int msg_col;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
void setcursor (void);void setmouse (void);
extern int strncasecmp (__const char *__s1, __const char *__s2, size_t __n)
             __attribute__ ((__pure__));
void update_screen (int type);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef void (*GtkItemFactoryCallback) ();
extern int need_check_timestamps ;
extern int did_check_timestamps ;
extern int intr_char ;
extern int mouse_col;
extern int mouse_row;
extern int access (__const char *__name, int __type) ;
void add_pathsep (char_u *p);
int check_restricted (void);
int check_secure (void);
extern char *getenv (__const char *__name) ;
long mch_getperm (char_u *name);
int mch_isFullName (char_u *fname);
int mch_isdir (char_u *name);
void msg_clr_eos (void);
void msg_outnum (long n);
extern char *strpbrk (__const char *__s, __const char *__accept)
             __attribute__ ((__pure__));
extern int msg_didout ;
extern long p_verbose;
typedef struct _XDisplay Display;
extern Display *xterm_dpy ;
void add_termcode (char_u *name, char_u *string, int use_8bit);
char_u *find_termcode (char_u *name);
void cursor_on (void);
extern __uid_t getuid (void) ;
typedef int (*__compar_fn_t) (__const void *, __const void *);
extern void qsort (void *__base, size_t __nmemb, size_t __size,
                   __compar_fn_t __compar);
void redraw_later_clear (void);
void stoptermcap (void);
int swapping_screen (void);void windgoto (int row, int col);
typedef __mode_t mode_t;
extern char_u e_notmp[] ;
extern char_u e_notread[] ;
extern int exiting ;
extern int restricted ;
extern int secure ;
extern size_t fread (void *__restrict __ptr, size_t __size,
                     size_t __n, FILE *__restrict __stream) ;
void settmode (int tmode);
enum SpecialKey
{
    KS_NAME = 0,
    KS_CE,
    KS_AL,
    KS_CAL,
    KS_DL,
    KS_CDL,
    KS_CS,
    KS_CL,
    KS_CD,
    KS_UT,
    KS_DA,
    KS_DB,
    KS_VI,
    KS_VE,
    KS_VS,
    KS_ME,
    KS_MR,
    KS_MD,
    KS_SE,
    KS_SO,
    KS_CZH,
    KS_CZR,
    KS_UE,
    KS_US,
    KS_MS,
    KS_CM,
    KS_SR,
    KS_CRI,
    KS_VB,
    KS_KS,
    KS_KE,
    KS_TI,
    KS_TE,
    KS_BC,
    KS_CCS,
    KS_CCO,
    KS_CSF,
    KS_CSB,
    KS_XS,
    KS_MB,
    KS_CAF,
    KS_CAB,
    KS_LE,
    KS_ND,
    KS_CIS,
    KS_CIE,
    KS_TS,
    KS_FS,
    KS_CWP,
    KS_CWS,
    KS_CRV,
    KS_CSV,
    KS_OP
};
extern char_u *(term_strings[]);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
void mch_restore_title (int which);
void do_fixdel (exarg_T *eap);
int mch_has_wildcard (char_u *p);
void out_char (unsigned c);
void shell_resized (void);
extern char_u *p_sh;
int msg_outtrans_len (char_u *str, int len);
typedef unsigned long Atom;
typedef gulong GdkAtom;
typedef struct VimClipboard
{
    int available;
    int owned;
    pos_T start;
    pos_T end;
    int vmode;
    short_u origin_row;
    short_u origin_start_col;
    short_u origin_end_col;
    short_u word_start_col;
    short_u word_end_col;
    pos_T prev;
    short_u state;
    short_u mode;
    Atom sel_atom;
    GdkAtom gtk_sel_atom;
} VimClipboard;
extern VimClipboard clip_star;
extern int *__errno_location (void) __attribute__ ((__const__));
typedef void *vim_acl_T;
extern int close (int __fd) ;
extern int dup (int __fd) ;
void mch_msg (char *str);
extern int open (__const char *__file, int __oflag, ...) ;
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
extern ssize_t write (int __fd, __const void *__buf, size_t __n) ;
void set_vim_var_nr (int idx, long val);
int get_real_state (void);
void ml_sync_all (int check_file, int check_char);
int ui_inchar (char_u *buf, int maxlen, long wtime);
void updatescript (int c);
extern int pipe (int __pipedes[2]) ;
extern void _exit (int __status) __attribute__ ((__noreturn__));
extern __pid_t setsid (void) ;
extern __pid_t fork (void) ;
extern long p_ut;
int has_cursorhold (void);
void add_to_input_buf (char_u *s, int len);
int check_col (int col);
int check_row (int row);
void clip_init (int can_use);
int input_available (void);
extern int isatty (int __fd) ;
void mch_errmsg (char *str);
void out_str (char_u *s);
typedef __pid_t pid_t;
extern int full_screen ;
extern FILE *stderr;
extern int newline_on_exit ;
extern int XFree(
    void*
);
typedef unsigned long XID;
typedef XID Window;
typedef unsigned long Time;
typedef XID Drawable;
typedef XID Colormap;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;
} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;
        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;
        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;
        int new;
        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
void serverEventProc (Display *dpy, XEvent *eventPtr);
extern Window commWindow ;
extern Atom commProperty ;
extern VimClipboard clip_plus;
extern FILE *stdout;
extern int XFlush(
    Display*
);
typedef long int __suseconds_t;
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
typedef long int __fd_mask;
extern __pid_t getpid (void) ;
typedef int (*XErrorHandler) (
    Display* ,
    XErrorEvent*
);
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
  } fd_set;
extern XErrorHandler XSetErrorHandler (
    XErrorHandler
);
extern int select (int __nfds, fd_set *__restrict __readfds,
                   fd_set *__restrict __writefds,
                   fd_set *__restrict __exceptfds,
                   struct timeval *__restrict __timeout) ;
extern int XSync(
    Display* ,
    int
);
void reset_signals (void);
void screen_start (void);int gui_get_x11_windis (Window *win, Display **dis);
typedef __uid_t uid_t;
extern int kill (__pid_t __pid, int __sig) ;
int mch_get_uname (uid_t uid, char_u *s, int len);
extern int p_more;
int msg_use_printf (void);
extern int info_message ;
extern void *malloc (size_t __size) __attribute__ ((__malloc__));
typedef char Boolean;
typedef void (*GPrintFunc) (const gchar *string);
typedef char *String;
typedef void (*GErrorFunc) (const gchar *str);
typedef void (*GWarningFunc) (const gchar *str);
typedef void (*XtErrorHandler)(
  String
);
typedef Boolean (*XtFilePredicate)(
   String
);
typedef unsigned int Cardinal;
void preserve_exit (void);
void clip_lose_selection (VimClipboard *cbd);
int vim_is_input_buf_full (void);
typedef unsigned long VisualID;
typedef char *XPointer;
typedef struct _XGC *GC;
typedef struct _XExtData {
        int number;
        struct _XExtData *next;
        int (*free_private)(
        struct _XExtData *extension
        );
        XPointer private_data;
} XExtData;
typedef struct {
        XExtData *ext_data;
        VisualID visualid;
        int class;
        unsigned long red_mask, green_mask, blue_mask;
        int bits_per_rgb;
        int map_entries;
} Visual;
typedef struct {
        XExtData *ext_data;
        int depth;
        int bits_per_pixel;
        int scanline_pad;
} ScreenFormat;
typedef struct {
        int depth;
        int nvisuals;
        Visual *visuals;
} Depth;
typedef struct {
        XExtData *ext_data;
        struct _XDisplay *display;
        Window root;
        int width, height;
        int mwidth, mheight;
        int ndepths;
        Depth *depths;
        int root_depth;
        Visual *root_visual;
        GC default_gc;
        Colormap cmap;
        unsigned long white_pixel;
        unsigned long black_pixel;
        int max_maps, min_maps;
        int backing_store;
        int save_unders;
        long root_input_mask;
} Screen;
typedef struct
{
        XExtData *ext_data;
        struct _XPrivate *private1;
        int fd;
        int private2;
        int proto_major_version;
        int proto_minor_version;
        char *vendor;
        XID private3;
        XID private4;
        XID private5;
        int private6;
        XID (*resource_alloc)(
                struct _XDisplay*
        );
        int byte_order;
        int bitmap_unit;
        int bitmap_pad;
        int bitmap_bit_order;
        int nformats;
        ScreenFormat *pixmap_format;
        int private8;
        int release;
        struct _XPrivate *private9, *private10;
        int qlen;
        unsigned long last_request_read;
        unsigned long request;
        XPointer private11;
        XPointer private12;
        XPointer private13;
        XPointer private14;
        unsigned max_request_size;
        struct _XrmHashBucketRec *db;
        int (*private15)(
                struct _XDisplay*
                );
        char *display_name;
        int default_screen;
        int nscreens;
        Screen *screens;
        unsigned long motion_buffer;
        unsigned long private16;
        int min_keycode;
        int max_keycode;
        XPointer private17;
        XPointer private18;
        int private19;
        char *xdefaults;
}
*_XPrivDisplay;
typedef struct
  {
    unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
  } __sigset_t;
extern void exit (int __status) __attribute__ ((__noreturn__));
typedef int __jmp_buf[6];
typedef struct __jmp_buf_tag
  {
    __jmp_buf __jmpbuf;
    int __mask_was_saved;
    __sigset_t __saved_mask;
  } jmp_buf[1];
extern int _setjmp (jmp_buf __env) ;
extern int fseek (FILE *__stream, long int __off, int __whence) ;
extern long int ftell (FILE *__stream) ;
extern int setenv (__const char *__name, __const char *__value, int __replace)
            ;
struct passwd
{
  char *pw_name;
  char *pw_passwd;
  __uid_t pw_uid;
  __gid_t pw_gid;
  char *pw_gecos;
  char *pw_dir;
  char *pw_shell;
};
int mch_has_exp_wildcard (char_u *p);
void ml_close_all (int del_file);
void addfile (garray_T *gap, char_u *f, int flags);
typedef struct _XtAppStruct *XtAppContext;
typedef struct {
    unsigned char *value;
    Atom encoding;
    int format;
    unsigned long nitems;
} XTextProperty;
typedef struct _WidgetRec *Widget;
extern Boolean XtDispatchEvent(
    XEvent*
);
void mch_delay (long msec, int ignoreinput);
int read_from_input_buf (char_u *buf, long maxlen);
void fill_input_buf (int exit_on_error);
extern int read_cmd_fd ;
extern XtAppContext app_context ;
struct timezone
  {
    int tz_minuteswest;
    int tz_dsttime;
  };
typedef struct timezone *__restrict __timezone_ptr_t;
extern char_u *p_mouse;
int vim_is_xterm (char_u *name);
int use_xterm_mouse (void);
int vim_is_iris (char_u *name);
void mch_setmouse (int on);
int term_is_8bit (char_u *name);
void out_str_nf (char_u *s);
typedef unsigned int speed_t;
extern int gettimeofday (struct timeval *__restrict __tv,
                         __timezone_ptr_t __tz) ;
typedef void (*__sighandler_t) (int);typedef __u_long __rlim_t;
extern FILE *stdin;
typedef __sigset_t sigset_t;
struct timespec
  {
    __time_t tv_sec;
    long int tv_nsec;
  };
extern int chmod (__const char *__file, __mode_t __mode) ;
extern int fchdir (int __fd) ;
extern char *getcwd (char *__buf, size_t __size) ;
extern int execvp (__const char *__file, char *__const __argv[]) ;
enum
  {
    _SC_ARG_MAX,
    _SC_CHILD_MAX,
    _SC_CLK_TCK,
    _SC_NGROUPS_MAX,
    _SC_OPEN_MAX,
    _SC_STREAM_MAX,
    _SC_TZNAME_MAX,
    _SC_JOB_CONTROL,
    _SC_SAVED_IDS,
    _SC_REALTIME_SIGNALS,
    _SC_PRIORITY_SCHEDULING,
    _SC_TIMERS,
    _SC_ASYNCHRONOUS_IO,
    _SC_PRIORITIZED_IO,
    _SC_SYNCHRONIZED_IO,
    _SC_FSYNC,
    _SC_MAPPED_FILES,
    _SC_MEMLOCK,
    _SC_MEMLOCK_RANGE,
    _SC_MEMORY_PROTECTION,
    _SC_MESSAGE_PASSING,
    _SC_SEMAPHORES,
    _SC_SHARED_MEMORY_OBJECTS,
    _SC_AIO_LISTIO_MAX,
    _SC_AIO_MAX,
    _SC_AIO_PRIO_DELTA_MAX,
    _SC_DELAYTIMER_MAX,
    _SC_MQ_OPEN_MAX,
    _SC_MQ_PRIO_MAX,
    _SC_VERSION,
    _SC_PAGESIZE,
    _SC_RTSIG_MAX,
    _SC_SEM_NSEMS_MAX,
    _SC_SEM_VALUE_MAX,
    _SC_SIGQUEUE_MAX,
    _SC_TIMER_MAX,
    _SC_BC_BASE_MAX,
    _SC_BC_DIM_MAX,
    _SC_BC_SCALE_MAX,
    _SC_BC_STRING_MAX,
    _SC_COLL_WEIGHTS_MAX,
    _SC_EQUIV_CLASS_MAX,
    _SC_EXPR_NEST_MAX,
    _SC_LINE_MAX,
    _SC_RE_DUP_MAX,
    _SC_CHARCLASS_NAME_MAX,
    _SC_2_VERSION,
    _SC_2_C_BIND,
    _SC_2_C_DEV,
    _SC_2_FORT_DEV,
    _SC_2_FORT_RUN,
    _SC_2_SW_DEV,
    _SC_2_LOCALEDEF,
    _SC_PII,
    _SC_PII_XTI,
    _SC_PII_SOCKET,
    _SC_PII_INTERNET,
    _SC_PII_OSI,
    _SC_POLL,
    _SC_SELECT,
    _SC_UIO_MAXIOV,
    _SC_IOV_MAX = _SC_UIO_MAXIOV,
    _SC_PII_INTERNET_STREAM,
    _SC_PII_INTERNET_DGRAM,
    _SC_PII_OSI_COTS,
    _SC_PII_OSI_CLTS,
    _SC_PII_OSI_M,
    _SC_T_IOV_MAX,
    _SC_THREADS,
    _SC_THREAD_SAFE_FUNCTIONS,
    _SC_GETGR_R_SIZE_MAX,
    _SC_GETPW_R_SIZE_MAX,
    _SC_LOGIN_NAME_MAX,
    _SC_TTY_NAME_MAX,
    _SC_THREAD_DESTRUCTOR_ITERATIONS,
    _SC_THREAD_KEYS_MAX,
    _SC_THREAD_STACK_MIN,
    _SC_THREAD_THREADS_MAX,
    _SC_THREAD_ATTR_STACKADDR,
    _SC_THREAD_ATTR_STACKSIZE,
    _SC_THREAD_PRIORITY_SCHEDULING,
    _SC_THREAD_PRIO_INHERIT,
    _SC_THREAD_PRIO_PROTECT,
    _SC_THREAD_PROCESS_SHARED,
    _SC_NPROCESSORS_CONF,
    _SC_NPROCESSORS_ONLN,
    _SC_PHYS_PAGES,
    _SC_AVPHYS_PAGES,
    _SC_ATEXIT_MAX,
    _SC_PASS_MAX,
    _SC_XOPEN_VERSION,
    _SC_XOPEN_XCU_VERSION,
    _SC_XOPEN_UNIX,
    _SC_XOPEN_CRYPT,
    _SC_XOPEN_ENH_I18N,
    _SC_XOPEN_SHM,
    _SC_2_CHAR_TERM,
    _SC_2_C_VERSION,
    _SC_2_UPE,
    _SC_XOPEN_XPG2,
    _SC_XOPEN_XPG3,
    _SC_XOPEN_XPG4,
    _SC_CHAR_BIT,
    _SC_CHAR_MAX,
    _SC_CHAR_MIN,
    _SC_INT_MAX,
    _SC_INT_MIN,
    _SC_LONG_BIT,
    _SC_WORD_BIT,
    _SC_MB_LEN_MAX,
    _SC_NZERO,
    _SC_SSIZE_MAX,
    _SC_SCHAR_MAX,
    _SC_SCHAR_MIN,
    _SC_SHRT_MAX,
    _SC_SHRT_MIN,
    _SC_UCHAR_MAX,
    _SC_UINT_MAX,
    _SC_ULONG_MAX,
    _SC_USHRT_MAX,
    _SC_NL_ARGMAX,
    _SC_NL_LANGMAX,
    _SC_NL_MSGMAX,
    _SC_NL_NMAX,
    _SC_NL_SETMAX,
    _SC_NL_TEXTMAX,
    _SC_XBS5_ILP32_OFF32,
    _SC_XBS5_ILP32_OFFBIG,
    _SC_XBS5_LP64_OFF64,
    _SC_XBS5_LPBIG_OFFBIG,
    _SC_XOPEN_LEGACY,
    _SC_XOPEN_REALTIME,
    _SC_XOPEN_REALTIME_THREADS,
    _SC_ADVISORY_INFO,
    _SC_BARRIERS,
    _SC_BASE,
    _SC_C_LANG_SUPPORT,
    _SC_C_LANG_SUPPORT_R,
    _SC_CLOCK_SELECTION,
    _SC_CPUTIME,
    _SC_THREAD_CPUTIME,
    _SC_DEVICE_IO,
    _SC_DEVICE_SPECIFIC,
    _SC_DEVICE_SPECIFIC_R,
    _SC_FD_MGMT,
    _SC_FIFO,
    _SC_PIPE,
    _SC_FILE_ATTRIBUTES,
    _SC_FILE_LOCKING,
    _SC_FILE_SYSTEM,
    _SC_MONOTONIC_CLOCK,
    _SC_MULTI_PROCESS,
    _SC_SINGLE_PROCESS,
    _SC_NETWORKING,
    _SC_READER_WRITER_LOCKS,
    _SC_SPIN_LOCKS,
    _SC_REGEXP,
    _SC_REGEX_VERSION,
    _SC_SHELL,
    _SC_SIGNALS,
    _SC_SPAWN,
    _SC_SPORADIC_SERVER,
    _SC_THREAD_SPORADIC_SERVER,
    _SC_SYSTEM_DATABASE,
    _SC_SYSTEM_DATABASE_R,
    _SC_TIMEOUTS,
    _SC_TYPED_MEMORY_OBJECTS,
    _SC_USER_GROUPS,
    _SC_USER_GROUPS_R,
    _SC_2_PBS,
    _SC_2_PBS_ACCOUNTING,
    _SC_2_PBS_LOCATE,
    _SC_2_PBS_MESSAGE,
    _SC_2_PBS_TRACK,
    _SC_SYMLOOP_MAX,
    _SC_STREAMS,
    _SC_2_PBS_CHECKPOINT,
    _SC_V6_ILP32_OFF32,
    _SC_V6_ILP32_OFFBIG,
    _SC_V6_LP64_OFF64,
    _SC_V6_LPBIG_OFFBIG,
    _SC_HOST_NAME_MAX,
    _SC_TRACE,
    _SC_TRACE_EVENT_FILTER,
    _SC_TRACE_INHERIT,
    _SC_TRACE_LOG
  };
extern long int sysconf (int __name) __attribute__ ((__const__));
struct dirent
  {
    __ino_t d_ino;
    __off_t d_off;
    unsigned short int d_reclen;
    unsigned char d_type;
    char d_name[256];
  };
typedef struct __dirstream DIR;
typedef union sigval
  {
    int sival_int;
    void *sival_ptr;
  } sigval_t;
typedef struct sigaltstack
  {
    void *ss_sp;
    int ss_flags;
    size_t ss_size;
  } stack_t;
extern struct passwd *getpwuid (__uid_t __uid) ;
extern char *strchr (__const char *__s, int __c) __attribute__ ((__pure__));
extern char *strerror (int __errnum) ;
extern void longjmp (jmp_buf __env, int __val)
             __attribute__ ((__noreturn__));
extern void (*sigset (int, void (*func) (int))) (int);
extern Display *XOpenDisplay(
    const char*
);
typedef int (*XIOErrorHandler) (
    Display*
);
extern int XCloseDisplay(
    Display*
);
extern int XGetErrorText(
    Display* ,
    int ,
    char* ,
    int
);
extern int XQueryPointer(
    Display* ,
    Window ,
    Window* ,
    Window* ,
    int* ,
    int* ,
    int* ,
    int* ,
    unsigned int*
);
extern int XQueryTree(
    Display* ,
    Window ,
    Window* ,
    Window* ,
    Window** ,
    unsigned int*
);
extern int XGetWMIconName(
    Display* ,
    Window ,
    XTextProperty*
);
extern int XGetWMName(
    Display* ,
    Window ,
    XTextProperty*
);
extern void XSetWMIconName(
    Display* ,
    Window ,
    XTextProperty*
);
extern void XSetWMName(
    Display* ,
    Window ,
    XTextProperty*
);
typedef enum {
    XrmoptionNoArg,
    XrmoptionIsArg,
    XrmoptionStickyArg,
    XrmoptionSepArg,
    XrmoptionResArg,
    XrmoptionSkipArg,
    XrmoptionSkipLine,
    XrmoptionSkipNArgs
} XrmOptionKind;
typedef struct _WidgetClassRec *WidgetClass;
typedef unsigned long XtInputMask;
extern void XtAppNextEvent(
    XtAppContext ,
    XEvent*
);
extern void XtRealizeWidget(
    Widget
);
extern void XtDestroyWidget(
    Widget
);
extern regprog_T *clip_exclude_prog ;
extern int p_guipty;
extern char_u *p_shcf;
extern char_u *p_titleold;
extern unsigned ttym_flags;
int vim_is_vt300 (char_u *name);
int pathcmp (const char *p, const char *q);
void x11_export_final_selection (void);
void set_mouse_termcode (int n, char_u *s);
void del_mouse_termcode (int n);
void getlinecol (long *cp, long *rp);
void term_set_winsize (int width, int height);
void term_settitle (char_u *title);
void ui_inchar_undo (char_u *s, int len);
void open_app_context (void);
void x11_setup_atoms (Display *dpy);
void clip_x11_request_selection (Widget myShell, Display *dpy, VimClipboard *cbd);
void clip_x11_lose_selection (Widget myShell, VimClipboard *cbd);
int clip_x11_own_selection (Widget myShell, VimClipboard *cbd);
void clip_x11_set_selection (VimClipboard *cbd);
void gui_exit (int rc);
int OpenPTY (char **ttyn);
int SetupSlavePTY (int fd);
void gui_mch_settitle (char_u *title, char_u *icon);
extern int x_no_connect ;
extern jmp_buf x_jump_env;
extern int lc_active ;
extern char *xterm_display ;
extern char_u e_libcall[] ;
extern char_u e_screenmode[] ;
extern char_u e_wildexpand[] ;
struct winsize
  {
    unsigned short int ws_row;
    unsigned short int ws_col;
    unsigned short int ws_xpixel;
    unsigned short int ws_ypixel;
  };
extern int ioctl (int __fd, unsigned long int __request, ...) ;
enum __rlimit_resource
{
  RLIMIT_CPU = 0,
  RLIMIT_FSIZE = 1,
  RLIMIT_DATA = 2,
  RLIMIT_STACK = 3,
  RLIMIT_CORE = 4,
  RLIMIT_RSS = 5,
  RLIMIT_NOFILE = 7,
  RLIMIT_OFILE = RLIMIT_NOFILE,
  RLIMIT_AS = 9,
  RLIMIT_NPROC = 6,
  RLIMIT_MEMLOCK = 8,
  RLIMIT_LOCKS = 10,
  RLIMIT_NLIMITS = 11,
  RLIM_NLIMITS = RLIMIT_NLIMITS
};
typedef int __rlimit_resource_t;
typedef union
  {
    union wait *__uptr;
    int *__iptr;
  } __WAIT_STATUS __attribute__ ((__transparent_union__));
extern __pid_t waitpid (__pid_t __pid, int *__stat_loc, int __options) ;
struct utsname
  {
    char sysname[65];
    char nodename[65];
    char release[65];
    char version[65];
    char machine[65];
    char __domainname[65];
  };
typedef unsigned char cc_t;
typedef unsigned int tcflag_t;
extern void *dlopen (__const char *__file, int __mode) ;
extern int dlclose (void *__handle) ;
extern void *dlsym (void *__restrict __handle,
                    __const char *__restrict __name) ;
typedef int (*IceHostBasedAuthProc) (
    char *
);
extern const char XtStrings[];
struct sysinfo {
        long uptime;
        unsigned long loads[3];
        unsigned long totalram;
        unsigned long freeram;
        unsigned long sharedram;
        unsigned long bufferram;
        unsigned long totalswap;
        unsigned long freeswap;
        unsigned short procs;
        unsigned short pad;
        unsigned long totalhigh;
        unsigned long freehigh;
        unsigned int mem_unit;
        char _f[20-2*sizeof(long)-sizeof(int)];
};
typedef char_u * (*INTPROCSTR)(int);
extern DIR *opendir (__const char *__name) ;
extern int closedir (DIR *__dirp) ;
extern struct dirent *readdir (DIR *__dirp) ;
extern int nanosleep (__const struct timespec *__requested_time,
                      struct timespec *__remaining) ;
extern int sigemptyset (sigset_t *__set) ;
extern int sigaltstack (__const struct sigaltstack *__restrict __ss,
                        struct sigaltstack *__restrict __oss) ;
extern XIOErrorHandler XSetIOErrorHandler (
    XIOErrorHandler
);
typedef struct {
        long flags;
        int x, y;
        int width, height;
        int min_width, min_height;
        int max_width, max_height;
        int width_inc, height_inc;
        struct {
                int x;
                int y;
        } min_aspect, max_aspect;
        int base_width, base_height;
        int win_gravity;
} XSizeHints;
typedef struct {
    char *option;
    char *specifier;
    XrmOptionKind argKind;
    XPointer value;
} XrmOptionDescRec, *XrmOptionDescList;
extern XtInputMask XtAppPending(
    XtAppContext
);
extern Widget XtVaCreatePopupShell(
    const char* ,
    WidgetClass ,
    Widget ,
    ...
);
extern Widget XtVaAppCreateShell(
    const char* ,
    const char* ,
    WidgetClass ,
    Display* ,
    ...
);
typedef __rlim_t rlim_t;
extern __pid_t wait (__WAIT_STATUS __stat_loc) ;
extern int uname (struct utsname *__name) ;
struct termios
  {
    tcflag_t c_iflag;
    tcflag_t c_oflag;
    tcflag_t c_cflag;
    tcflag_t c_lflag;
    cc_t c_line;
    cc_t c_cc[32];
    speed_t c_ispeed;
    speed_t c_ospeed;
  };
extern WidgetClass topLevelShellWidgetClass;
extern WidgetClass applicationShellWidgetClass;
extern int sysinfo (struct sysinfo *__info) ;
typedef char_u * (*STRPROCSTR)(char_u *);
typedef int (*INTPROCINT)(int);
extern int XGetWMNormalHints(
    Display* ,
    Window ,
    XSizeHints* ,
    long*
);
extern Display *XtOpenDisplay(
    XtAppContext ,
    const char* ,
    const char* ,
    const char* ,
    XrmOptionDescRec* ,
    Cardinal ,
    int* ,
    char**
);
struct rlimit
  {
    rlim_t rlim_cur;
    rlim_t rlim_max;
  };
extern int tcgetattr (int __fd, struct termios *__termios_p) ;
extern int tcsetattr (int __fd, int __optional_actions,
                      __const struct termios *__termios_p) ;
typedef int (*STRPROCINT)(char_u *);
typedef struct siginfo
  {
    int si_signo;
    int si_errno;
    int si_code;
    union
      {
        int _pad[((128 / sizeof (int)) - 3)];
        struct
          {
            __pid_t si_pid;
            __uid_t si_uid;
          } _kill;
        struct
          {
            unsigned int _timer1;
            unsigned int _timer2;
          } _timer;
        struct
          {
            __pid_t si_pid;
            __uid_t si_uid;
            sigval_t si_sigval;
          } _rt;
        struct
          {
            __pid_t si_pid;
            __uid_t si_uid;
            int si_status;
            __clock_t si_utime;
            __clock_t si_stime;
          } _sigchld;
        struct
          {
            void *si_addr;
          } _sigfault;
        struct
          {
            long int si_band;
            int si_fd;
          } _sigpoll;
      } _sifields;
  } siginfo_t;
extern int getrlimit (__rlimit_resource_t __resource,
                      struct rlimit *__rlimits) ;
struct sigaction
  {
    union
      {
        __sighandler_t sa_handler;
        void (*sa_sigaction) (int, siginfo_t *, void *);
      }
    __sigaction_handler;
    __sigset_t sa_mask;
    int sa_flags;
    void (*sa_restorer) (void);
  };
extern int sigaction (int __sig, __const struct sigaction *__restrict __act,
                      struct sigaction *__restrict __oact) ;
void mch_startjmp (void);
void mch_endjmp (void);
void mch_didjmp (void);
extern jmp_buf lc_jump_env;
extern int lc_signal;
void restore_cterm_colors (void);
extern long p_wd;
extern int cur_tmode ;
static Widget xterm_Shell = (Widget)0;
static void xterm_update (void);
Window x11_window = 0;
Display *x11_display = ((void *)0);
static int get_x11_windis (void);
static void set_x11_title (char_u *);
static void set_x11_icon (char_u *);
static int get_x11_title (int);
static int get_x11_icon (int);
static char_u *oldtitle = ((void *)0);
static int did_set_title = 0;
static char_u *oldicon = ((void *)0);
static int did_set_icon = 0;
static void may_core_dump (void);
static int WaitForChar (long);
static int RealWaitForChar (int, long, int *);
static int do_xterm_trace (void);
static void handle_resize (void);
static void sig_winch (int);
static void catch_sigint (int);
static void catch_sigpwr (int);
static void deathtrap (int);
static void set_signals (void);
static void catch_signals (void (*func_deadly)(), void (*func_other)());
static int have_wildcard (int, char_u **);
static int have_dollars (int, char_u **);
static int pstrcmp (const void *, const void *);
static int unix_expandpath (garray_T *gap, char_u *path, int wildoff, int flags);
static int save_patterns (int num_pat, char_u **pat, int *num_file, char_u ***file);
static int do_resize = 0;
static char_u *extra_shell_arg = ((void *)0);
static int show_shell_mess = 1;
static int deadly_signal = 0;
static int curr_tmode = 0;
static struct signalinfo
{
    int sig;
    char *name;
    char deadly;
} signal_info[] =
{
    {1, "HUP", 1},
    {3, "QUIT", 1},
    {4, "ILL", 1},
    {5, "TRAP", 1},
    {6, "ABRT", 1},
    {8, "FPE", 1},
    {7, "BUS", 1},
    {11, "SEGV", 1},
    {31, "SYS", 1},
    {14, "ALRM", 0},
    {15, "TERM", 1},
    {26, "VTALRM", 1},
    {27, "PROF", 1},
    {24, "XCPU", 1},
    {25, "XFSZ", 1},
    {10, "USR1", 1},
    {12, "USR2", 1},
    {2, "INT", 0},
    {28, "WINCH", 0},
    {20, "TSTP", 0},
    {13, "PIPE", 0},
    {-1, "Unknown!", 0}
};
    void mch_write(s, len)
    char_u *s;
    int len;
{
    write(1, (char *)s, len);
    if (p_wd)
        RealWaitForChar(read_cmd_fd, p_wd, ((void *)0));
}
    int mch_inchar(buf, maxlen, wtime)
    char_u *buf;
    int maxlen;
    long wtime;
{
    int len;
    static int once_already = 0;
    while (do_resize)
        handle_resize();
    if (wtime >= 0)
    {
        while (WaitForChar(wtime) == 0)
        {
            if (!do_resize)
            {
                once_already = 0;
                return 0;
            }
            handle_resize();
        }
    }
    else
    {
        if (once_already == 2)
            updatescript(0);
        else if (once_already == 1)
        {
            setcursor();
            once_already = 2;
            return 0;
        }
        else
        if (WaitForChar(p_ut) == 0)
        {
            if (has_cursorhold() && get_real_state() == (0x100 + 0x01))
            {
                apply_autocmds(EVENT_CURSORHOLD, ((void *)0), ((void *)0), 0, curbuf);
                update_screen(10);
                once_already = 1;
                return 0;
            }
            else
                updatescript(0);
        }
    }
    for (;;)
    {
        while (do_resize)
            handle_resize();
        WaitForChar(-1L);
        if (do_resize)
            continue;
        len = read_from_input_buf(buf, (long)maxlen);
        if (len > 0)
        {
            once_already = 0;
            return len;
        }
    }
}
    static void handle_resize()
{
    do_resize = 0;
    shell_resized();
}
    int mch_char_avail()
{
    return WaitForChar(0L);
}
    long_u mch_total_mem(special)
    int special;
{
    long_u mem = 0;
    if (mem == 0)
    {
        struct sysinfo sinfo;
        if (sysinfo(&sinfo) == 0)
            mem = sinfo.totalram;
    }
    if (mem == 0)
    {
        long pagesize, pagecount;
        pagesize = sysconf(_SC_PAGESIZE);
        pagecount = sysconf(_SC_PHYS_PAGES);
        if (pagesize > 0 && pagecount > 0)
            mem = (long_u)pagesize * pagecount;
    }
    {
        struct rlimit rlp;
        if (getrlimit(RLIMIT_DATA, &rlp) == 0
                && rlp.rlim_cur < ((rlim_t)1 << (sizeof(long_u) * 8 - 1))
                && rlp.rlim_cur != ((unsigned long int)(~0UL))
                && (long_u)rlp.rlim_cur < mem
           )
            return (long_u)rlp.rlim_cur;
    }
    if (mem > 0)
        return mem;
    return (long_u)0x7fffffff;
}
    void mch_delay(msec, ignoreinput)
    long msec;
    int ignoreinput;
{
    int old_tmode;
    if (ignoreinput)
    {
        old_tmode = curr_tmode;
        settmode(1);
        {
            struct timespec ts;
            ts.tv_sec = msec / 1000;
            ts.tv_nsec = (msec % 1000) * 1000000;
            (void)nanosleep(&ts, ((void *)0));
        }
        settmode(old_tmode);
    }
    else
        WaitForChar(msec);
}
static void check_stack_growth (char *p);
static int stack_grows_downwards;
    static void check_stack_growth(p)
    char *p;
{
    int i;
    stack_grows_downwards = (p > (char *)&i);
}
static char *stack_limit = ((void *)0);
    static void get_stack_limit()
{
    struct rlimit rlp;
    int i;
    if (getrlimit(RLIMIT_STACK, &rlp) == 0
            && rlp.rlim_cur < ((rlim_t)1 << (sizeof(long_u) * 8 - 1))
            && rlp.rlim_cur != ((unsigned long int)(~0UL))
       )
    {
        if (stack_grows_downwards)
        {
            stack_limit = (char *)((long)&i - ((long)rlp.rlim_cur / 16L * 15L));
            if (stack_limit >= (char *)&i)
                stack_limit = (char *)((long)&i / 16L);
        }
        else
        {
            stack_limit = (char *)((long)&i + ((long)rlp.rlim_cur / 16L * 15L));
            if (stack_limit <= (char *)&i)
                stack_limit = ((void *)0);
        }
    }
}
    int mch_stackcheck(p)
    char *p;
{
    if (stack_limit != ((void *)0))
    {
        if (stack_grows_downwards)
        {
            if (p < stack_limit)
                return 0;
        }
        else if (p > stack_limit)
            return 0;
    }
    return 1;
}
static stack_t sigstk;
static void init_signal_stack (void);
static char *signal_stack;
    static void init_signal_stack()
{
    if (signal_stack != ((void *)0))
    {
        sigstk.ss_sp = signal_stack;
        sigstk.ss_size = 8192;
        sigstk.ss_flags = 0;
        (void)sigaltstack(&sigstk, ((void *)0));
    }
}
    static void sig_winch (sigarg) int sigarg;
{
    sigset(28, (void (*)())sig_winch);
    do_resize = 1;
    return;
}
    static void catch_sigint (sigarg) int sigarg;
{
    sigset(2, (void (*)())catch_sigint);
    got_int = 1;
    return;
}
    static void catch_sigpwr (sigarg) int sigarg;
{
    ml_sync_all(0, 0);
    return;
}
    void mch_startjmp()
{
    lc_signal = 0;
    lc_active = 1;
}
    void mch_endjmp()
{
    lc_active = 0;
}
    void mch_didjmp()
{
    init_signal_stack();
}
    static void deathtrap (sigarg) int sigarg;
{
    static int entered = 0;
    int i;
    if (lc_active)
    {
        lc_signal = sigarg;
        lc_active = 0;
        longjmp(lc_jump_env, 1);
    }
    ++entered;
    set_vim_var_nr(28, (long)entered);
    get_stack_limit();
    for (i = 0; signal_info[i].sig != -1; i++)
        if (sigarg == signal_info[i].sig)
            break;
    deadly_signal = sigarg;
    full_screen = 0;
    if (entered >= 3)
    {
        reset_signals();
        may_core_dump();
        if (entered >= 4)
            _exit(8);
        exit(7);
    }
    if (entered == 2)
    {
        out_str((char_u *)(((char *)("Vim: Double signal, exiting\n"))));
        out_flush();
        getout(1);
    }
    sprintf((char *)IObuff, ((char *)("Vim: Caught deadly signal %s\n")),
                                                         signal_info[i].name);
    preserve_exit();
    return;
}
    void mch_suspend()
{
    out_flush();
    settmode(0);
    out_flush();
    if (clip_star.owned || clip_plus.owned)
    {
        x11_export_final_selection();
        if (clip_star.owned)
            clip_lose_selection(&clip_star);
        if (clip_plus.owned)
            clip_lose_selection(&clip_plus);
        if (x11_display != ((void *)0))
            XFlush(x11_display);
    }
    kill(0, 20);
    vim_free(oldtitle);
    oldtitle = ((void *)0);
    settmode(2);
    need_check_timestamps = 1;
    did_check_timestamps = 0;
}
    void mch_init()
{
    Columns = 80;
    Rows = 24;
    out_flush();
    set_signals();
}
    static void set_signals()
{
    sigset(28, (void (*)())sig_winch);
    sigset(20, restricted ? ((__sighandler_t) 1) : ((__sighandler_t) 0));
    sigset(13, ((__sighandler_t) 1));
    sigset(2, (void (*)())catch_sigint);
    sigset(14, ((__sighandler_t) 1));
    sigset(30, (void (*)())catch_sigpwr);
    catch_signals(deathtrap, ((__sighandler_t) -1));
    if (gui.in_use)
        sigset(1, ((__sighandler_t) 1));
}
    void reset_signals()
{
    catch_signals(((__sighandler_t) 0), ((__sighandler_t) 0));
}
    static void catch_signals(func_deadly, func_other)
    void (*func_deadly)();
    void (*func_other)();
{
    int i;
    for (i = 0; signal_info[i].sig != -1; i++)
        if (signal_info[i].deadly)
        {
            struct sigaction sa;
            sa.__sigaction_handler.sa_handler = func_deadly;
            sigemptyset(&sa.sa_mask);
            sa.sa_flags = 0x08000000;
            sigaction(signal_info[i].sig, &sa, ((void *)0));
        }
        else if (func_other != ((__sighandler_t) -1))
            sigset(signal_info[i].sig, func_other);
}
    int mch_check_win(argc, argv)
    int argc;
    char **argv;
{
    if (isatty(1))
        return 1;
    return 0;
}
    int mch_input_isatty()
{
    if (isatty(read_cmd_fd))
        return 1;
    return 0;
}
static void xopen_message (struct timeval *tvp);
    static void xopen_message(tvp)
    struct timeval *tvp;
{
    struct timeval end_tv;
    gettimeofday(&end_tv, ((void *)0));
    smsg((char_u *)((char *)("Opening the X display took %ld msec")),
            (end_tv.tv_sec - tvp->tv_sec) * 1000L
            + (end_tv.tv_usec - tvp->tv_usec) / 1000L);
}
static int x_error_handler (Display *dpy, XErrorEvent *error_event);
static int x_error_check (Display *dpy, XErrorEvent *error_event);
static int x_connect_to_server (void);
static int test_x11_window (Display *dpy);
static int got_x_error = 0;
    static int x_error_handler(dpy, error_event)
    Display *dpy;
    XErrorEvent *error_event;
{
    XGetErrorText(dpy, error_event->error_code, (char *)IObuff, (1024+1));
    strcat((char *)(IObuff), (char *)(((char *)("\nVim: Got X error\n"))));
    preserve_exit();
    return 0;
}
    static int x_error_check(dpy, error_event)
    Display *dpy;
    XErrorEvent *error_event;
{
    got_x_error = 1;
    return 0;
}
static int x_IOerror_check (Display *dpy);
    static int x_IOerror_check(dpy)
    Display *dpy;
{
    longjmp(lc_jump_env, 1);
    return 0;
}
static int x_IOerror_handler (Display *dpy);
    static int x_IOerror_handler(dpy)
    Display *dpy;
{
    xterm_dpy = ((void *)0);
    x11_window = 0;
    x11_display = ((void *)0);
    xterm_Shell = (Widget)0;
    longjmp(x_jump_env, 1);
    return 0;
}
    static int x_connect_to_server()
{
    regmatch_T regmatch;
    if (x_no_connect)
        return 0;
    if (clip_exclude_prog != ((void *)0))
    {
        regmatch.rm_ic = 0;
        regmatch.regprog = clip_exclude_prog;
        if (vim_regexec(&regmatch, (term_strings[(int)(KS_NAME)]), (colnr_T)0))
            return 0;
    }
    return 1;
}
    static int test_x11_window(dpy)
    Display *dpy;
{
    int (*old_handler)();
    XTextProperty text_prop;
    old_handler = XSetErrorHandler(x_error_check);
    got_x_error = 0;
    if (XGetWMName(dpy, x11_window, &text_prop))
        XFree((void *)text_prop.value);
    XSync(dpy, 0);
    (void)XSetErrorHandler(old_handler);
    if (p_verbose > 0 && got_x_error)
        msg((char_u *)(((char *)("Testing the X display failed"))));
    return (got_x_error ? 0 : 1);
}
static int get_x11_thing (int get_title, int test_only);
    static int get_x11_windis()
{
    char *winid;
    static int result = -1;
    static int x11_display_from = 0;
    static int did_set_error_handler = 0;
    if (!did_set_error_handler)
    {
        (void)XSetErrorHandler(x_error_handler);
        did_set_error_handler = 1;
    }
    if (gui.in_use)
    {
        if (x11_display_from == 1 && x11_display != ((void *)0))
        {
            XCloseDisplay(x11_display);
            x11_display_from = 0;
        }
        if (gui_get_x11_windis(&x11_window, &x11_display) == 1)
        {
            x11_display_from = 2;
            return 1;
        }
        x11_display = ((void *)0);
        return 0;
    }
    else if (x11_display_from == 2)
    {
        x11_window = 0;
        x11_display = ((void *)0);
        x11_display_from = 0;
    }
    if (!x_connect_to_server())
        return 0;
    if (x11_window == 0 && (winid = getenv("WINDOWID")) != ((void *)0))
        x11_window = (Window)atol(winid);
    if (xterm_dpy != ((void *)0) && x11_window != 0)
    {
        if (x11_display_from == 3)
            return 1;
        if (x11_display_from == 1 && x11_display != ((void *)0))
            XCloseDisplay(x11_display);
        x11_display = xterm_dpy;
        x11_display_from = 3;
        if (test_x11_window(x11_display) == 0)
        {
            x11_window = 0;
            x11_display = ((void *)0);
            x11_display_from = 0;
            return 0;
        }
        return 1;
    }
    if (x11_window == 0 || x11_display == ((void *)0))
        result = -1;
    if (result != -1)
        return result;
    if (x11_window != 0 && x11_display == ((void *)0))
    {
        struct timeval start_tv;
        if (p_verbose > 0)
            gettimeofday(&start_tv, ((void *)0));
        x11_display = XOpenDisplay(((void *)0));
        if (x11_display != ((void *)0))
        {
            if (p_verbose > 0)
                xopen_message(&start_tv);
            if (test_x11_window(x11_display) == 0)
            {
                x11_window = 0;
                XCloseDisplay(x11_display);
                x11_display = ((void *)0);
            }
            else
                x11_display_from = 1;
        }
    }
    if (x11_window == 0 || x11_display == ((void *)0))
        return (result = 0);
    return (result = 1);
}
    static int get_x11_title(test_only)
    int test_only;
{
    int retval;
    retval = get_x11_thing(1, test_only);
    return retval;
}
    static int get_x11_icon(test_only)
    int test_only;
{
    int retval = 0;
    retval = get_x11_thing(0, test_only);
    if (oldicon == ((void *)0) && !test_only)
    {
        if (strncmp((char *)((term_strings[(int)(KS_NAME)])), (char *)("builtin_"), (size_t)(8)) == 0)
            oldicon = (term_strings[(int)(KS_NAME)]) + 8;
        else
            oldicon = (term_strings[(int)(KS_NAME)]);
    }
    return retval;
}
    static int get_x11_thing(get_title, test_only)
    int get_title;
    int test_only;
{
    XTextProperty text_prop;
    int retval = 0;
    int status;
    if (get_x11_windis() == 1)
    {
        if (get_title)
            status = XGetWMName(x11_display, x11_window, &text_prop);
        else
            status = XGetWMIconName(x11_display, x11_window, &text_prop);
        {
            Window root;
            Window parent;
            Window win = x11_window;
            Window *children;
            unsigned int num_children;
            while (!status || text_prop.value == ((void *)0))
            {
                if (!XQueryTree(x11_display, win, &root, &parent, &children,
                                                               &num_children))
                    break;
                if (children)
                    XFree((void *)children);
                if (parent == root || parent == 0)
                    break;
                win = parent;
                if (get_title)
                    status = XGetWMName(x11_display, win, &text_prop);
                else
                    status = XGetWMIconName(x11_display, win, &text_prop);
            }
        }
        if (status && text_prop.value != ((void *)0))
        {
            retval = 1;
            if (!test_only)
            {
                    if (get_title)
                        oldtitle = vim_strsave((char_u *)text_prop.value);
                    else
                        oldicon = vim_strsave((char_u *)text_prop.value);
            }
            XFree((void *)text_prop.value);
        }
    }
    return retval;
}
    static void set_x11_title(title)
    char_u *title;
{
    XTextProperty text_prop;
    {
        text_prop.value = title;
        text_prop.nitems = strlen((char *)(title));
        text_prop.encoding = ((Atom) 31);
        text_prop.format = 8;
    }
    XSetWMName(x11_display, x11_window, &text_prop);
    XFlush(x11_display);
}
    static void set_x11_icon(icon)
    char_u *icon;
{
    XTextProperty text_prop;
    {
        text_prop.value = icon;
        text_prop.nitems = strlen((char *)(icon));
        text_prop.encoding = ((Atom) 31);
        text_prop.format = 8;
    }
    XSetWMIconName(x11_display, x11_window, &text_prop);
    XFlush(x11_display);
}
    int mch_can_restore_title()
{
    return get_x11_title(1);
}
    int mch_can_restore_icon()
{
    return get_x11_icon(1);
}
    void mch_settitle(title, icon)
    char_u *title;
    char_u *icon;
{
    int type = 0;
    static int recursive = 0;
    if ((term_strings[(int)(KS_NAME)]) == ((void *)0))
        return;
    if (title == ((void *)0) && icon == ((void *)0))
        return;
    if (recursive)
        return;
    ++recursive;
    if (get_x11_windis() == 1)
        type = 1;
    if ((type || *(term_strings[(int)(KS_TS)]) != '\000') && title != ((void *)0))
    {
        if (oldtitle == ((void *)0)
                && !gui.in_use
                )
            (void)get_x11_title(0);
        if (*(term_strings[(int)(KS_TS)]) != '\000')
            term_settitle(title);
        else
        if (!gui.in_use)
            set_x11_title(title);
        else
            gui_mch_settitle(title, icon);
        did_set_title = 1;
    }
    if ((type || *(term_strings[(int)(KS_CIS)]) != '\000') && icon != ((void *)0))
    {
        if (oldicon == ((void *)0)
                && !gui.in_use
                )
            get_x11_icon(0);
        if (*(term_strings[(int)(KS_CIS)]) != '\000')
        {
            out_str((term_strings[(int)(KS_CIS)]));
            out_str_nf(icon);
            out_str((term_strings[(int)(KS_CIE)]));
            out_flush();
        }
        else
        if (!gui.in_use)
            set_x11_icon(icon);
        did_set_icon = 1;
    }
    --recursive;
}
    void mch_restore_title(which)
    int which;
{
    mch_settitle(((which & 1) && did_set_title) ?
                        (oldtitle ? oldtitle : p_titleold) : ((void *)0),
                              ((which & 2) && did_set_icon) ? oldicon : ((void *)0));
}
    int vim_is_xterm(name)
    char_u *name;
{
    if (name == ((void *)0))
        return 0;
    return (strncasecmp((char *)(name), (char *)("xterm"), (size_t)(5)) == 0
                || strncasecmp((char *)(name), (char *)("nxterm"), (size_t)(6)) == 0
                || strncasecmp((char *)(name), (char *)("kterm"), (size_t)(5)) == 0
                || strncasecmp((char *)(name), (char *)("rxvt"), (size_t)(4)) == 0
                || strcmp((char *)(name), (char *)("builtin_xterm")) == 0);
}
    int use_xterm_mouse()
{
    if (ttym_flags == 0x02)
        return 2;
    if (ttym_flags == 0x01)
        return 1;
    return 0;
}
    int vim_is_iris(name)
    char_u *name;
{
    if (name == ((void *)0))
        return 0;
    return (strncasecmp((char *)(name), (char *)("iris-ansi"), (size_t)(9)) == 0
            || strcmp((char *)(name), (char *)("builtin_iris-ansi")) == 0);
}
    int vim_is_vt300(name)
    char_u *name;
{
    if (name == ((void *)0))
        return 0;
    return (strncasecmp((char *)(name), (char *)("vt3"), (size_t)(3)) == 0
            || strncasecmp((char *)(name), (char *)("vt2"), (size_t)(3)) == 0
            || strncasecmp((char *)(name), (char *)("vt1"), (size_t)(3)) == 0
            || strcmp((char *)(name), (char *)("builtin_vt320")) == 0);
}
    int vim_is_fastterm(name)
    char_u *name;
{
    if (name == ((void *)0))
        return 0;
    if (vim_is_xterm(name) || vim_is_vt300(name) || vim_is_iris(name))
        return 1;
    return ( strncasecmp((char *)(name), (char *)("hpterm"), (size_t)(6)) == 0
            || strncasecmp((char *)(name), (char *)("sun-cmd"), (size_t)(7)) == 0
            || strncasecmp((char *)(name), (char *)("screen"), (size_t)(6)) == 0
            || strncasecmp((char *)(name), (char *)("dtterm"), (size_t)(6)) == 0);
}
    int mch_get_user_name(s, len)
    char_u *s;
    int len;
{
    return mch_get_uname(getuid(), s, len);
}
    int mch_get_uname(uid, s, len)
    uid_t uid;
    char_u *s;
    int len;
{
    struct passwd *pw;
    if ((pw = getpwuid(uid)) != ((void *)0)
            && pw->pw_name != ((void *)0) && *(pw->pw_name) != '\000')
    {
        strncpy((char *)(s), (char *)(pw->pw_name), (size_t)(len));
        return 1;
    }
    sprintf((char *)s, "%d", (int)uid);
    return 0;
}
    void mch_get_host_name(s, len)
    char_u *s;
    int len;
{
    struct utsname vutsname;
    if (uname(&vutsname) < 0)
        *s = '\000';
    else
        strncpy((char *)(s), (char *)(vutsname.nodename), (size_t)(len));
    s[len - 1] = '\000';
}
    long mch_get_pid()
{
    return (long)getpid();
}
    int mch_dirname(buf, len)
    char_u *buf;
    int len;
{
    if (getcwd((char *)buf, len) == ((void *)0))
    {
        strcpy((char *)(buf), (char *)(strerror((*__errno_location ()))));
        return 0;
    }
    return 1;
}
    int mch_FullName(fname, buf, len, force)
    char_u *fname, *buf;
    int len;
    int force;
{
    int l;
    int fd = -1;
    static int dont_fchdir = 0;
    char_u olddir[1024];
    char_u *p;
    int retval = 1;
    if (force || !mch_isFullName(fname))
    {
        if ((p = vim_strrchr(fname, '/')) != ((void *)0))
        {
            if (!dont_fchdir)
            {
                fd = open(".", 00 | 0, 0);
                if (fd >= 0 && fchdir(fd) < 0)
                {
                    close(fd);
                    fd = -1;
                    dont_fchdir = 1;
                }
            }
            if (
                fd < 0 &&
                        (mch_dirname(olddir, 1024) == 0
                                           || chdir((char *)olddir) != 0))
            {
                p = ((void *)0);
                retval = 0;
            }
            else
            {
                if (p - fname >= len)
                    retval = 0;
                else
                {
                    strncpy((char *)(buf), (char *)(fname), (size_t)(p - fname));
                    buf[p - fname] = '\000';
                    if (chdir((char *)buf))
                        retval = 0;
                    else
                        fname = p + 1;
                    *buf = '\000';
                }
            }
        }
        if (mch_dirname(buf, len) == 0)
        {
            retval = 0;
            *buf = '\000';
        }
        if (p != ((void *)0))
        {
            if (fd >= 0)
            {
                l = fchdir(fd);
                close(fd);
            }
            else
                l = chdir((char *)olddir);
            if (l != 0)
                emsg((char_u *)(((char *)(e_prev_dir))));
        }
        l = strlen((char *)(buf));
        if (l >= len)
            retval = 0;
        else
        {
            if (l > 0 && buf[l - 1] != '/' && *fname != '\000')
                strcat((char *)(buf), (char *)("/"));
        }
    }
    if (retval == 0 || strlen((char *)(buf)) + strlen((char *)(fname)) >= len)
        return 0;
    strcat((char *)(buf), (char *)(fname));
    return 1;
}
    int mch_isFullName(fname)
    char_u *fname;
{
    return (*fname == '/' || *fname == '~');
}
    long mch_getperm(name)
    char_u *name;
{
    struct stat statb;
    if (stat((char *)
                    name,
                    &statb))
        return -1;
    return statb.st_mode;
}
    int mch_setperm(name, perm)
    char_u *name;
    long perm;
{
    return (chmod((char *)
                    name,
                    (mode_t)perm) == 0 ? 1 : 0);
}
    vim_acl_T mch_get_acl(fname)
    char_u *fname;
{
    vim_acl_T ret = ((void *)0);
    return ret;
}
    void mch_set_acl(fname, aclent)
    char_u *fname;
    vim_acl_T aclent;
{
    if (aclent == ((void *)0))
        return;
}
    void mch_free_acl(aclent)
    vim_acl_T aclent;
{
    if (aclent == ((void *)0))
        return;
}
    void mch_hide(name)
    char_u *name;
{
}
    int mch_isdir(name)
    char_u *name;
{
    struct stat statb;
    if (*name == '\000')
        return 0;
    if (stat((char *)name, &statb))
        return 0;
    return (((((statb.st_mode)) & 0170000) == (0040000)) ? 1 : 0);
}
static int executable_file (char_u *name);
    static int executable_file(name)
    char_u *name;
{
    struct stat st;
    if (stat((char *)name, &st))
        return 0;
    return ((((st.st_mode)) & 0170000) == (0100000)) && access(((char *)name), (1)) == 0;
}
    int mch_can_exe(name)
    char_u *name;
{
    char_u *buf;
    char_u *p, *e;
    int retval;
    if (mch_isFullName(name) || (name[0] == '.' && (name[1] == '/'
                                      || (name[1] == '.' && name[2] == '/'))))
        return executable_file(name);
    p = (char_u *)getenv("PATH");
    if (p == ((void *)0) || *p == '\000')
        return -1;
    buf = alloc((unsigned)(strlen((char *)(name)) + strlen((char *)(p)) + 2));
    if (buf == ((void *)0))
        return -1;
    for (;;)
    {
        e = (char_u *)strchr((char *)p, ':');
        if (e == ((void *)0))
            e = p + strlen((char *)(p));
        if (e - p <= 1)
            strcpy((char *)(buf), (char *)("./"));
        else
        {
            strncpy((char *)(buf), (char *)(p), (size_t)(e - p));
            buf[e - p] = '\000';
            add_pathsep(buf);
        }
        strcat((char *)(buf), (char *)(name));
        retval = executable_file(buf);
        if (retval == 1)
            break;
        if (*e != ':')
            break;
        p = e + 1;
    }
    vim_free(buf);
    return retval;
}
    int mch_nodetype(name)
    char_u *name;
{
    struct stat st;
    if (stat((char *)name, &st))
        return 0;
    if (((((st.st_mode)) & 0170000) == (0100000)) || ((((st.st_mode)) & 0170000) == (0040000)))
        return 0;
    if (((((st.st_mode)) & 0170000) == (0060000)))
        return 2;
    return 1;
}
    void mch_early_init()
{
    int i;
    check_stack_growth((char *)&i);
    get_stack_limit();
    signal_stack = malloc(8192);
    init_signal_stack();
}
static void exit_scroll (void);
    static void exit_scroll()
{
    if (msg_use_printf())
    {
        if (info_message)
            mch_msg("\n");
        else
            mch_errmsg("\r\n");
    }
    else
        out_char('\n');
}
    void mch_exit(r)
    int r;
{
    exiting = 1;
    x11_export_final_selection();
    if (!gui.in_use)
    {
        settmode(0);
        mch_restore_title(3);
        if (swapping_screen() && !newline_on_exit && msg_didout)
            exit_scroll();
        stoptermcap();
        if (!swapping_screen() || newline_on_exit)
        {
            if (newline_on_exit || msg_didout)
                exit_scroll();
            else
            {
                restore_cterm_colors();
                msg_clr_eos();
                windgoto((int)Rows - 1, 0);
            }
        }
        if (full_screen)
            cursor_on();
    }
    out_flush();
    ml_close_all(1);
    may_core_dump();
    if (gui.in_use)
        gui_exit(r);
    exit(r);
}
    static void may_core_dump()
{
    if (deadly_signal != 0)
    {
        sigset(deadly_signal, ((__sighandler_t) 0));
        kill(getpid(), deadly_signal);
    }
}
    void mch_settmode(tmode)
    int tmode;
{
    static int first = 1;
    static struct termios told;
           struct termios tnew;
    if (first)
    {
        first = 0;
        tcgetattr(read_cmd_fd, &told);
    }
    tnew = told;
    if (tmode == 2)
    {
        tnew.c_iflag &= ~0000400;
        tnew.c_lflag &= ~(0000002 | 0000010 | 0000001 | 0000020
                    | 0100000
                                );
        tnew.c_oflag &= ~0000004;
        tnew.c_cc[6] = 1;
        tnew.c_cc[5] = 0;
    }
    else if (tmode == 1)
        tnew.c_lflag &= ~(0000010);
    {
        int n = 10;
        while (tcsetattr(read_cmd_fd, 0, &tnew) == -1
                                                   && (*__errno_location ()) == 4 && n > 0)
            --n;
    }
    curr_tmode = tmode;
}
    void get_stty()
{
    char_u buf[2];
    char_u *p;
    struct termios keys;
    if (tcgetattr(read_cmd_fd, &keys) != -1)
    {
        buf[0] = keys.c_cc[2];
        intr_char = keys.c_cc[0];
        buf[1] = '\000';
        add_termcode((char_u *)"kb", buf, 0);
        p = find_termcode((char_u *)"kD");
        if (p != ((void *)0) && p[0] == buf[0] && p[1] == buf[1])
            do_fixdel(((void *)0));
    }
}
    void mch_setmouse(on)
    int on;
{
    static int ison = 0;
    int xterm_mouse_vers;
    if (on == ison)
        return;
    xterm_mouse_vers = use_xterm_mouse();
    if (xterm_mouse_vers > 0)
    {
        if (on)
            out_str_nf((char_u *)
                       (xterm_mouse_vers > 1
                        ? "\033[?1002h"
                        : "\033[?1000h"));
        else
            out_str_nf((char_u *)
                       (xterm_mouse_vers > 1
                        ? "\033[?1002l"
                        : "\033[?1000l"));
        ison = on;
    }
}
    void check_mouse_termcode()
{
    if (use_xterm_mouse()
            && !gui.in_use
            )
    {
        set_mouse_termcode(251, (char_u *)(term_is_8bit((term_strings[(int)(KS_NAME)]))
                  ? "\233M" : "\033[M"));
        if (*p_mouse != '\000')
        {
            mch_setmouse(0);
            setmouse();
        }
    }
    else
        del_mouse_termcode(251);
}
    int mch_screenmode(arg)
    char_u *arg;
{
    emsg((char_u *)(((char *)(e_screenmode))));
    return 0;
}
    int mch_get_shellsize()
{
    long rows = 0;
    long columns = 0;
    char_u *p;
    {
        struct winsize ws;
        if (ioctl(1, 0x5413, &ws) == 0)
        {
            columns = ws.ws_col;
            rows = ws.ws_row;
        }
    }
    if (columns == 0 || rows == 0)
    {
        if ((p = (char_u *)getenv("LINES")))
            rows = atoi((char *)p);
        if ((p = (char_u *)getenv("COLUMNS")))
            columns = atoi((char *)p);
    }
    if (columns == 0 || rows == 0)
        getlinecol(&columns, &rows);
    if (columns <= 0 || rows <= 0)
        return 0;
    Rows = rows;
    Columns = columns;
    return 1;
}
    void mch_set_shellsize()
{
    if (*(term_strings[(int)(KS_CWS)]))
    {
        term_set_winsize((int)Rows, (int)Columns);
        out_flush();
        screen_start();
    }
}
    void mch_new_shellsize()
{
}
    int mch_call_shell(cmd, options)
    char_u *cmd;
    int options;
{
    int tmode = cur_tmode;
    char_u *newcmd = ((void *)0);
    pid_t pid;
    pid_t wait_pid = 0;
    int status = -1;
    int retval = -1;
    char **argv = ((void *)0);
    int argc;
    int i;
    char_u *p;
    int inquote;
    int pty_master_fd = -1;
    int pty_slave_fd = -1;
    char *tty_name;
    int fd_toshell[2];
    int fd_fromshell[2];
    int pipe_error = 0;
    char envbuf[50];
    int did_settmode = 0;
    out_flush();
    if (options & 4)
        settmode(0);
    newcmd = vim_strsave(p_sh);
    if (newcmd == ((void *)0))
        goto error;
    for (i = 0; i < 2; ++i)
    {
        p = newcmd;
        inquote = 0;
        argc = 0;
        for (;;)
        {
            if (i == 1)
                argv[argc] = (char *)p;
            ++argc;
            while (*p && (inquote || (*p != ' ' && *p != '\011')))
            {
                if (*p == '"')
                    inquote = !inquote;
                ++p;
            }
            if (*p == '\000')
                break;
            if (i == 1)
                *p++ = '\000';
            p = skipwhite(p);
        }
        if (i == 0)
        {
            argv = (char **)alloc((unsigned)((argc + 4) * sizeof(char *)));
            if (argv == ((void *)0))
                goto error;
        }
    }
    if (cmd != ((void *)0))
    {
        if (extra_shell_arg != ((void *)0))
            argv[argc++] = (char *)extra_shell_arg;
        argv[argc++] = (char *)p_shcf;
        argv[argc++] = (char *)cmd;
    }
    argv[argc] = ((void *)0);
    if (gui.in_use && show_shell_mess)
    {
        if (p_guipty)
        {
            pty_master_fd = OpenPTY(&tty_name);
            if (pty_master_fd >= 0 && ((pty_slave_fd =
                                    open(tty_name, 02 | 0, 0)) < 0))
            {
                close(pty_master_fd);
                pty_master_fd = -1;
            }
        }
        if (pty_master_fd < 0)
        {
            pipe_error = (pipe(fd_toshell) < 0);
            if (!pipe_error)
            {
                pipe_error = (pipe(fd_fromshell) < 0);
                if (pipe_error)
                {
                    close(fd_toshell[0]);
                    close(fd_toshell[1]);
                }
            }
            if (pipe_error)
            {
                msg_puts((char_u *)(((char *)("\nCannot create pipes\n"))));
                out_flush();
            }
        }
    }
    if (!pipe_error)
    {
        if ((pid = fork()) == -1)
        {
            msg_puts((char_u *)(((char *)("\nCannot fork\n"))));
            if (gui.in_use && show_shell_mess)
            {
                if (pty_master_fd >= 0)
                {
                    close(pty_master_fd);
                    close(pty_slave_fd);
                }
                else
                {
                    close(fd_toshell[0]);
                    close(fd_toshell[1]);
                    close(fd_fromshell[0]);
                    close(fd_fromshell[1]);
                }
            }
        }
        else if (pid == 0)
        {
            reset_signals();
            if (!show_shell_mess || (options & 2))
            {
                int fd;
                fd = open("/dev/null", 02 | 0, 0);
                fclose(stdin);
                fclose(stdout);
                fclose(stderr);
                if (fd >= 0)
                {
                    dup(fd);
                    dup(fd);
                    dup(fd);
                    close(fd);
                }
            }
            else if (gui.in_use)
            {
                (void)setsid();
                if (options & 4)
                    SetupSlavePTY(pty_slave_fd);
                ioctl(pty_slave_fd, 0x540E, (char *)((void *)0));
                setenv("TERM", "dumb", 1);
                sprintf((char *)envbuf, "%ld", Rows);
                setenv("ROWS", (char *)envbuf, 1);
                sprintf((char *)envbuf, "%ld", Rows);
                setenv("LINES", (char *)envbuf, 1);
                sprintf((char *)envbuf, "%ld", Columns);
                setenv("COLUMNS", (char *)envbuf, 1);
                if (pty_master_fd >= 0)
                {
                    close(pty_master_fd);
                    close(0);
                    dup(pty_slave_fd);
                    close(1);
                    dup(pty_slave_fd);
                    close(2);
                    dup(pty_slave_fd);
                    close(pty_slave_fd);
                }
                else
                {
                    close(fd_toshell[1]);
                    close(0);
                    dup(fd_toshell[0]);
                    close(fd_toshell[0]);
                    close(fd_fromshell[0]);
                    close(1);
                    dup(fd_fromshell[1]);
                    close(fd_fromshell[1]);
                    close(2);
                    dup(1);
                }
            }
            execvp(argv[0], argv);
            _exit(122);
        }
        else
        {
            catch_signals(((__sighandler_t) 1), ((__sighandler_t) -1));
            if (gui.in_use && show_shell_mess)
            {
                char_u buffer[100 + 1];
                char_u ta_buf[100 + 1];
                int ta_len = 0;
                int len;
                int p_more_save;
                int old_State;
                int c;
                int toshell_fd;
                int fromshell_fd;
                if (pty_master_fd >= 0)
                {
                    close(pty_slave_fd);
                    fromshell_fd = pty_master_fd;
                    toshell_fd = dup(pty_master_fd);
                }
                else
                {
                    close(fd_toshell[0]);
                    close(fd_fromshell[1]);
                    toshell_fd = fd_toshell[1];
                    fromshell_fd = fd_fromshell[0];
                }
                p_more_save = p_more;
                p_more = 0;
                old_State = State;
                State = 0x600;
                for (;;)
                {
                    len = 0;
                    if (!(options & 2)
                            && (ta_len > 0
                                || (len = ui_inchar(ta_buf, 100, 10L)) > 0))
                    {
                        if (len == 1 && (pty_master_fd < 0 || cmd != ((void *)0)))
                        {
                            if (ta_buf[ta_len] == 3
                                               || ta_buf[ta_len] == intr_char)
                                kill(-pid, 2);
                            if (pty_master_fd < 0 && toshell_fd >= 0
                                               && ta_buf[ta_len] == 4)
                            {
                                close(toshell_fd);
                                toshell_fd = -1;
                            }
                        }
                        for (i = ta_len; i < ta_len + len; ++i)
                        {
                            if (ta_buf[i] == 0x9b && len - i > 2)
                            {
                                c = (-((ta_buf[i + 1]) + ((int)(ta_buf[i + 2]) << 8)));
                                if (c == (-(('k') + ((int)('D') << 8))) || c == (-((253) + ((int)(KE_KDEL) << 8))) || c == (-(('k') + ((int)('b') << 8))))
                                {
                                    memmove((char *)(ta_buf + i + 1), (char *)(ta_buf + i + 3), (size_t)(len - i - 2));
                                    if (c == (-(('k') + ((int)('D') << 8))) || c == (-((253) + ((int)(KE_KDEL) << 8))))
                                        ta_buf[i] = 0x7f;
                                    else
                                        ta_buf[i] = 8;
                                    len -= 2;
                                }
                            }
                            else if (ta_buf[i] == '\r')
                                ta_buf[i] = '\n';
                        }
                        if (pty_master_fd < 0)
                        {
                            for (i = ta_len; i < ta_len + len; ++i)
                            {
                                if (ta_buf[i] == '\n' || ta_buf[i] == '\b')
                                    msg_putchar(ta_buf[i]);
                                else
                                    msg_outtrans_len(ta_buf + i, 1);
                            }
                            windgoto(msg_row, msg_col);
                            out_flush();
                        }
                        ta_len += len;
                        if (toshell_fd >= 0)
                        {
                            len = write(toshell_fd, (char *)ta_buf, (size_t)1);
                            if (len > 0)
                            {
                                ta_len -= len;
                                memmove((char *)(ta_buf), (char *)(ta_buf + len), ta_len);
                            }
                        }
                    }
                    while (RealWaitForChar(fromshell_fd, 10L, ((void *)0)))
                    {
                        len = read(fromshell_fd, (char *)buffer
                                , (size_t)100
                                );
                        if (len <= 0)
                            goto finished;
                        {
                            buffer[len] = '\000';
                            msg_puts(buffer);
                        }
                        windgoto(msg_row, msg_col);
                        cursor_on();
                        out_flush();
                        if (got_int)
                            break;
                    }
                    wait_pid = waitpid(pid, &status, 1);
                    if ((wait_pid == (pid_t)-1 && (*__errno_location ()) == 10)
                            || (wait_pid == pid && ((((__extension__ ({ union { int __in; int __i; } __u; __u.__in = (status); __u.__i; }))) & 0x7f) == 0)))
                    {
                        wait_pid = pid;
                        break;
                    }
                    wait_pid = 0;
                }
finished:
                p_more = p_more_save;
                if (ta_len)
                    ui_inchar_undo(ta_buf, ta_len);
                State = old_State;
                if (toshell_fd >= 0)
                    close(toshell_fd);
                close(fromshell_fd);
            }
            while (wait_pid != pid)
            {
                wait_pid = wait(&status);
                if (wait_pid <= 0
                        && (*__errno_location ()) == 10
                   )
                    break;
            }
            if (tmode == 2)
                settmode(2);
            did_settmode = 1;
            set_signals();
            if (((((__extension__ ({ union { int __in; int __i; } __u; __u.__in = (status); __u.__i; }))) & 0x7f) == 0))
            {
                retval = ((((__extension__ ({ union { int __in; int __i; } __u; __u.__in = (status); __u.__i; }))) & 0xff00) >> 8);
                if (retval && !emsg_silent)
                {
                    if (retval == 122)
                    {
                        msg_puts((char_u *)(((char *)("\nCannot execute shell "))));
                        msg_outtrans(p_sh);
                        msg_putchar('\n');
                    }
                    else if (!(options & 16))
                    {
                        msg_puts((char_u *)(((char *)("\nshell returned "))));
                        msg_outnum((long)retval);
                        msg_putchar('\n');
                    }
                }
            }
            else
                msg_puts((char_u *)(((char *)("\nCommand terminated\n"))));
        }
    }
    vim_free(argv);
error:
    if (!did_settmode)
        if (tmode == 2)
            settmode(2);
    resettitle();
    vim_free(newcmd);
    return retval;
}
    void mch_breakcheck()
{
    if (curr_tmode == 2 && RealWaitForChar(read_cmd_fd, 0L, ((void *)0)))
        fill_input_buf(0);
}
    static int WaitForChar(msec)
    long msec;
{
    int rest;
    int avail;
    if (input_available())
        return 1;
    rest = 0;
    if (do_xterm_trace())
        rest = msec;
    do
    {
        if (rest != 0)
        {
            msec = 50;
            if (rest >= 0 && rest < 50)
                msec = rest;
            if (rest >= 0)
                rest -= msec;
        }
        avail = RealWaitForChar(read_cmd_fd, msec, ((void *)0));
        if (!avail)
        {
            if (input_available())
                return 1;
            if (rest == 0 || !do_xterm_trace())
                break;
        }
    }
    while (0
           || (!avail && rest != 0)
          );
    return avail;
}
    static int RealWaitForChar(fd, msec, check_for_gpm)
    int fd;
    long msec;
    int *check_for_gpm;
{
    int ret;
    struct timeval start_tv;
    if (msec > 0 && (
            xterm_Shell != (Widget)0
            ))
        gettimeofday(&start_tv, ((void *)0));
    while (1)
    {
        int finished = 1;
        struct timeval tv;
        fd_set rfds, efds;
        int maxfd;
        if (msec >= 0)
        {
            tv.tv_sec = msec / 1000;
            tv.tv_usec = (msec % 1000) * (1000000/1000);
        }
        do { int __d0, __d1; __asm__ __volatile__ ("cld; rep; stosl" : "=c" (__d0), "=D" (__d1) : "a" (0), "0" (sizeof (fd_set) / sizeof (__fd_mask)), "1" (&((&rfds)->__fds_bits)[0]) : "memory"); } while (0);
        do { int __d0, __d1; __asm__ __volatile__ ("cld; rep; stosl" : "=c" (__d0), "=D" (__d1) : "a" (0), "0" (sizeof (fd_set) / sizeof (__fd_mask)), "1" (&((&efds)->__fds_bits)[0]) : "memory"); } while (0);
        __asm__ __volatile__ ("btsl %1,%0" : "=m" (((&rfds)->__fds_bits)[((fd) / (8 * sizeof (__fd_mask)))]) : "r" (((int) (fd)) % (8 * sizeof (__fd_mask))) : "cc","memory");
        __asm__ __volatile__ ("btsl %1,%0" : "=m" (((&efds)->__fds_bits)[((fd) / (8 * sizeof (__fd_mask)))]) : "r" (((int) (fd)) % (8 * sizeof (__fd_mask))) : "cc","memory");
        maxfd = fd;
        if (xterm_Shell != (Widget)0)
        {
            __asm__ __volatile__ ("btsl %1,%0" : "=m" (((&rfds)->__fds_bits)[(((((_XPrivDisplay)xterm_dpy)->fd)) / (8 * sizeof (__fd_mask)))]) : "r" (((int) ((((_XPrivDisplay)xterm_dpy)->fd))) % (8 * sizeof (__fd_mask))) : "cc","memory");
            if (maxfd < (((_XPrivDisplay)xterm_dpy)->fd))
                maxfd = (((_XPrivDisplay)xterm_dpy)->fd);
        }
        ret = select(maxfd + 1, &rfds, ((void *)0), &efds, (msec >= 0) ? &tv : ((void *)0));
        if (ret > 0 && xterm_Shell != (Widget)0
                && (__extension__ ({register char __result; __asm__ __volatile__ ("btl %1,%2 ; setcb %b0" : "=q" (__result) : "r" (((int) ((((_XPrivDisplay)xterm_dpy)->fd))) % (8 * sizeof (__fd_mask))), "m" (((&rfds)->__fds_bits)[(((((_XPrivDisplay)xterm_dpy)->fd)) / (8 * sizeof (__fd_mask)))]) : "cc"); __result; })))
        {
            xterm_update();
            if (--ret == 0 && !input_available())
            {
                finished = 0;
            }
        }
        if (finished)
            break;
        if (msec >= 0)
        {
            struct timeval tv;
            gettimeofday(&tv, ((void *)0));
            msec -= (tv.tv_sec - start_tv.tv_sec) * 1000L
                                    + (tv.tv_usec - start_tv.tv_usec) / 1000L;
            if (msec <= 0)
                break;
        }
    }
    return (ret > 0);
}
    static int pstrcmp(a, b)
    const void *a, *b;
{
    return (pathcmp(*(char **)a, *(char **)b));
}
    int mch_expandpath(gap, path, flags)
    garray_T *gap;
    char_u *path;
    int flags;
{
    return unix_expandpath(gap, path, 0, flags);
}
    static int unix_expandpath(gap, path, wildoff, flags)
    garray_T *gap;
    char_u *path;
    int wildoff;
    int flags;
{
    char_u *buf;
    char_u *path_end;
    char_u *p, *s, *e;
    int start_len, c;
    char_u *pat;
    DIR *dirp;
    regmatch_T regmatch;
    struct dirent *dp;
    int starts_with_dot;
    int matches;
    int len;
    start_len = gap->ga_len;
    buf = alloc(strlen((char *)(path)) + (255 - 5) + 5);
    if (buf == ((void *)0))
        return 0;
    p = buf;
    s = buf;
    e = ((void *)0);
    path_end = path;
    while (*path_end != '\000')
    {
        if (path_end >= path + wildoff && rem_backslash(path_end))
            *p++ = *path_end++;
        else if (*path_end == '/')
        {
            if (e != ((void *)0))
                break;
            s = p + 1;
        }
        else if (path_end >= path + wildoff
                         && vim_strchr((char_u *)"*?[{~$", *path_end) != ((void *)0))
            e = p;
            *p++ = *path_end++;
    }
    e = p;
    *e = '\000';
    for (p = buf + wildoff; p < s; ++p)
        if (rem_backslash(p))
        {
            strcpy((char *)(p), (char *)(p + 1));
            --e;
            --s;
        }
    starts_with_dot = (*s == '.');
    pat = file_pat_to_reg_pat(s, e, ((void *)0), 0);
    if (pat == ((void *)0))
    {
        vim_free(buf);
        return 0;
    }
    regmatch.rm_ic = 0;
    regmatch.regprog = vim_regcomp(pat, 1);
    vim_free(pat);
    if (regmatch.regprog == ((void *)0))
    {
        vim_free(buf);
        return 0;
    }
    c = *s;
    *s = '\000';
    dirp = opendir(*buf == '\000' ? "." : (char *)buf);
    *s = c;
    if (dirp != ((void *)0))
    {
        for (;;)
        {
            dp = readdir(dirp);
            if (dp == ((void *)0))
                break;
            if ((dp->d_name[0] != '.' || starts_with_dot)
                    && vim_regexec(&regmatch, (char_u *)dp->d_name, (colnr_T)0))
            {
                strcpy((char *)(s), (char *)(dp->d_name));
                len = strlen((char *)(buf));
                strcpy((char *)(buf + len), (char *)(path_end));
                if (mch_has_exp_wildcard(path_end))
                {
                    (void)unix_expandpath(gap, buf, len + 1, flags);
                }
                else
                {
                    if (*path_end != '\000')
                        backslash_halve(buf + len + 1);
                    if (mch_getperm(buf) >= 0)
                        addfile(gap, buf, flags);
                }
            }
        }
        closedir(dirp);
    }
    vim_free(buf);
    vim_free(regmatch.regprog);
    matches = gap->ga_len - start_len;
    if (matches > 0)
        qsort(((char_u **)gap->ga_data) + start_len, matches,
                                                   sizeof(char_u *), pstrcmp);
    return matches;
}
    int mch_expand_wildcards(num_pat, pat, num_file, file, flags)
    int num_pat;
    char_u **pat;
    int *num_file;
    char_u ***file;
    int flags;
{
    int i;
    size_t len;
    char_u *p;
    int dir;
    int j;
    char_u *tempname;
    char_u *command;
    FILE *fd;
    char_u *buffer;
    int shell_style = 0;
    int check_spaces;
    static int did_find_nul = 0;
    int ampersent = 0;
    *num_file = 0;
    *file = ((void *)0);
    if (!have_wildcard(num_pat, pat))
        return save_patterns(num_pat, pat, num_file, file);
    if (secure || restricted)
        for (i = 0; i < num_pat; ++i)
            if (vim_strchr(pat[i], '`') != ((void *)0)
                    && (check_restricted() || check_secure()))
                return 0;
    if ((tempname = vim_tempname('o')) == ((void *)0))
    {
        emsg((char_u *)(((char *)(e_notmp))));
        return 0;
    }
    if (num_pat == 1 && *pat[0] == '`'
            && (len = strlen((char *)(pat[0]))) > 2
            && *(pat[0] + len - 1) == '`')
        shell_style = 3;
    else if ((len = strlen((char *)(p_sh))) >= 3)
    {
        if (strcmp((char *)(p_sh + len - 3), (char *)("csh")) == 0)
            shell_style = 1;
        else if (strcmp((char *)(p_sh + len - 3), (char *)("zsh")) == 0)
            shell_style = 2;
    }
    len = strlen((char *)(tempname)) + 29;
    for (i = 0; i < num_pat; ++i)
        len += strlen((char *)(pat[i])) + 3;
    command = alloc(len);
    if (command == ((void *)0))
    {
        vim_free(tempname);
        return 0;
    }
    if (shell_style == 3)
    {
        strcpy((char *)(command), (char *)(pat[0] + 1));
        p = command + strlen((char *)(command)) - 1;
        *p = ' ';
        while (p > command && ((*p) == ' ' || (*p) == '\t'))
            --p;
        if (*p == '&')
        {
            ampersent = 1;
            *p = ' ';
        }
        strcat((char *)(command), (char *)(">"));
    }
    else
    {
        if (flags & 4)
            strcpy((char *)(command), (char *)("set nonomatch; "));
        else
            strcpy((char *)(command), (char *)("unset nonomatch; "));
        if (shell_style == 1)
            strcat((char *)(command), (char *)("glob >"));
        else if (shell_style == 2)
            strcat((char *)(command), (char *)("print -N >"));
        else
            strcat((char *)(command), (char *)("echo >"));
    }
    strcat((char *)(command), (char *)(tempname));
    if (shell_style != 3)
        for (i = 0; i < num_pat; ++i)
        {
            if ((char_u *)strpbrk((char *)(pat[i]), (char *)(" '")) != ((void *)0))
            {
                strcat((char *)(command), (char *)(" \""));
                strcat((char *)(command), (char *)(pat[i]));
                strcat((char *)(command), (char *)("\""));
            }
            else
            {
                strcat((char *)(command), (char *)(" "));
                strcat((char *)(command), (char *)(pat[i]));
            }
        }
    if (flags & 32)
        show_shell_mess = 0;
    if (ampersent)
        strcat((char *)(command), (char *)("&"));
    if (shell_style == 2)
        extra_shell_arg = (char_u *)"-G";
    else if (shell_style == 1 && !have_dollars(num_pat, pat))
        extra_shell_arg = (char_u *)"-f";
    i = call_shell(command, 2 | 16);
    if (ampersent)
        mch_delay(10L, 1);
    extra_shell_arg = ((void *)0);
    show_shell_mess = 1;
    vim_free(command);
    if (i)
    {
        unlink((char *)(tempname));
        vim_free(tempname);
        if (!(flags & 32))
        {
            redraw_later_clear();
            msg_putchar('\n');
            cmdline_row = Rows - 1;
            {
                msg((char_u *)(((char *)(e_wildexpand))));
                msg_start();
            }
        }
        if (shell_style == 3)
            return 0;
        goto notfound;
    }
    fd = fopen((char *)tempname, "r");
    if (fd == ((void *)0))
    {
        if (!(flags & 32))
        {
            msg((char_u *)(((char *)(e_wildexpand))));
            msg_start();
        }
        vim_free(tempname);
        goto notfound;
    }
    fseek(fd, 0L, 2);
    len = ftell(fd);
    fseek(fd, 0L, 0);
    buffer = alloc(len + 1);
    if (buffer == ((void *)0))
    {
        unlink((char *)(tempname));
        vim_free(tempname);
        fclose(fd);
        return 0;
    }
    i = fread((char *)buffer, 1, len, fd);
    fclose(fd);
    unlink((char *)(tempname));
    if (i != len)
    {
        emsg2((char_u *)(((char *)(e_notread))), (char_u *)(tempname));
        vim_free(tempname);
        vim_free(buffer);
        return 0;
    }
    vim_free(tempname);
    if (shell_style == 0)
    {
        buffer[len] = '\n';
        p = buffer;
        for (i = 0; *p != '\n'; ++i)
        {
            while (*p != ' ' && *p != '\n')
                ++p;
            p = skipwhite(p);
        }
    }
    else if (shell_style == 3)
    {
        buffer[len] = '\000';
        p = buffer;
        for (i = 0; *p != '\000'; ++i)
        {
            while (*p != '\n' && *p != '\000')
                ++p;
            if (*p != '\000')
                ++p;
            p = skipwhite(p);
        }
    }
    else
    {
        check_spaces = 0;
        if (shell_style == 2 && !did_find_nul)
        {
            if (len && (int)strlen((char *)(buffer)) < len - 1)
                did_find_nul = 1;
            else
                check_spaces = 1;
        }
        if (len && buffer[len - 1] == '\000')
            --len;
        else
            buffer[len] = '\000';
        i = 0;
        for (p = buffer; p < buffer + len; ++p)
            if (*p == '\000' || (*p == ' ' && check_spaces))
            {
                ++i;
                *p = '\000';
            }
        if (len)
            ++i;
    }
    if (i == 0)
    {
        vim_free(buffer);
        goto notfound;
    }
    *num_file = i;
    *file = (char_u **)alloc(sizeof(char_u *) * i);
    if (*file == ((void *)0))
    {
        vim_free(buffer);
        return 0;
    }
    p = buffer;
    for (i = 0; i < *num_file; ++i)
    {
        (*file)[i] = p;
        if (shell_style == 0 || shell_style == 3)
        {
            while (!(shell_style == 0 && *p == ' ') && *p != '\n')
                ++p;
            if (p == buffer + len)
                *p = '\000';
            else
            {
                *p++ = '\000';
                p = skipwhite(p);
            }
        }
        else
        {
            while (*p && p < buffer + len)
                ++p;
            ++p;
        }
    }
    for (j = 0, i = 0; i < *num_file; ++i)
    {
        if (!(flags & 4) && mch_getperm((*file)[i]) < 0)
            continue;
        dir = (mch_isdir((*file)[i]));
        if ((dir && !(flags & 1)) || (!dir && !(flags & 2)))
            continue;
        p = alloc((unsigned)(strlen((char *)((*file)[i])) + 1 + dir));
        if (p)
        {
            strcpy((char *)(p), (char *)((*file)[i]));
            if (dir)
                strcat((char *)(p), (char *)("/"));
            (*file)[j++] = p;
        }
    }
    vim_free(buffer);
    *num_file = j;
    if (*num_file == 0)
    {
        vim_free(*file);
        *file = ((void *)0);
        goto notfound;
    }
    return 1;
notfound:
    if (flags & 4)
        return save_patterns(num_pat, pat, num_file, file);
    return 0;
}
    static int save_patterns(num_pat, pat, num_file, file)
    int num_pat;
    char_u **pat;
    int *num_file;
    char_u ***file;
{
    int i;
    *file = (char_u **)alloc(num_pat * sizeof(char_u *));
    if (*file == ((void *)0))
        return 0;
    for (i = 0; i < num_pat; i++)
        (*file)[i] = vim_strsave(pat[i]);
    *num_file = num_pat;
    return 1;
}
    int mch_has_exp_wildcard(p)
    char_u *p;
{
    for ( ; *p; ++p)
    {
        if (*p == '\\' && p[1] != '\000')
            ++p;
        else
            if (vim_strchr((char_u *)
                                    "*?[{'"
                                                , *p) != ((void *)0))
            return 1;
    }
    return 0;
}
    int mch_has_wildcard(p)
    char_u *p;
{
    for ( ; *p; ++p)
    {
        if (*p == '\\' && p[1] != '\000')
            ++p;
        else
            if (vim_strchr((char_u *)
                                    "*?[{`'$"
                                                , *p) != ((void *)0)
                || (*p == '~' && p[1] != '\000'))
            return 1;
    }
    return 0;
}
    static int have_wildcard(num, file)
    int num;
    char_u **file;
{
    int i;
    for (i = 0; i < num; i++)
        if (mch_has_wildcard(file[i]))
            return 1;
    return 0;
}
    static int have_dollars(num, file)
    int num;
    char_u **file;
{
    int i;
    for (i = 0; i < num; i++)
        if (vim_strchr(file[i], '$') != ((void *)0))
            return 1;
    return 0;
}
    int mch_libcall(libname, funcname, argstring, argint, string_result, number_result)
    char_u *libname;
    char_u *funcname;
    char_u *argstring;
    int argint;
    char_u **string_result;
    int *number_result;
{
    void *hinstLib;
    STRPROCSTR ProcAdd;
    INTPROCSTR ProcAddI;
    char_u *retval_str = ((void *)0);
    int retval_int = 0;
    int success = 0;
    hinstLib = dlopen((char *)libname, 0x00001
            | 0
            );
    if (hinstLib != ((void *)0))
    {
        mch_startjmp();
        if (_setjmp (lc_jump_env) != 0)
        {
            success = 0;
            mch_didjmp();
        }
        else
        {
            retval_str = ((void *)0);
            retval_int = 0;
            if (argstring != ((void *)0))
            {
                ProcAdd = (STRPROCSTR)dlsym(hinstLib, (const char *)funcname);
                if ((success = (ProcAdd != ((void *)0))))
                {
                    if (string_result == ((void *)0))
                        retval_int = ((STRPROCINT)ProcAdd)(argstring);
                    else
                        retval_str = (ProcAdd)(argstring);
                }
            }
            else
            {
                ProcAddI = (INTPROCSTR)dlsym(hinstLib, (const char *)funcname);
                if ((success = (ProcAddI != ((void *)0))))
                {
                    if (string_result == ((void *)0))
                        retval_int = ((INTPROCINT)ProcAddI)(argint);
                    else
                        retval_str = (ProcAddI)(argint);
                }
            }
            if (string_result == ((void *)0))
                *number_result = retval_int;
            else if (retval_str != ((void *)0)
                    && retval_str != (char_u *)1
                    && retval_str != (char_u *)-1)
                *string_result = vim_strsave(retval_str);
        }
        mch_endjmp();
        if (lc_signal != 0)
        {
            int i;
            for (i = 0; signal_info[i].sig != -1; i++)
                if (lc_signal == signal_info[i].sig)
                    break;
            emsg2((char_u *)("E368: got SIG%s in libcall()"), (char_u *)(signal_info[i].name));
        }
        (void)dlclose(hinstLib);
    }
    if (!success)
    {
        emsg2((char_u *)(((char *)(e_libcall))), (char_u *)(funcname));
        return 0;
    }
    return 1;
}
static int xterm_trace = -1;
static int xterm_button;
    void setup_term_clip()
{
    int z = 0;
    char *strp = "";
    Widget AppShell;
    if (!x_connect_to_server())
        return;
    open_app_context();
    if (app_context != ((void *)0) && xterm_Shell == (Widget)0)
    {
        int (*oldhandler)();
        int (*oldIOhandler)();
        struct timeval start_tv;
        if (p_verbose > 0)
            gettimeofday(&start_tv, ((void *)0));
        oldhandler = XSetErrorHandler(x_error_check);
        oldIOhandler = XSetIOErrorHandler(x_IOerror_check);
        mch_startjmp();
        if (_setjmp (lc_jump_env) != 0)
        {
            mch_didjmp();
            xterm_dpy = ((void *)0);
        }
        else
        {
            xterm_dpy = XtOpenDisplay(app_context, xterm_display,
                    "vim_xterm", "Vim_xterm", ((void *)0), 0, &z, &strp);
            mch_endjmp();
        }
        (void)XSetIOErrorHandler(oldIOhandler);
        (void)XSetErrorHandler(oldhandler);
        if (xterm_dpy == ((void *)0))
        {
            if (p_verbose > 0)
                msg((char_u *)(((char *)("Opening the X display failed"))));
            return;
        }
        (void)XSetIOErrorHandler(x_IOerror_handler);
        if (p_verbose > 0)
            xopen_message(&start_tv);
        AppShell = XtVaAppCreateShell("vim_xterm", "Vim_xterm",
                applicationShellWidgetClass, xterm_dpy,
                ((void *)0));
        if (AppShell == (Widget)0)
            return;
        xterm_Shell = XtVaCreatePopupShell("VIM",
                topLevelShellWidgetClass, AppShell,
                ((char*)&XtStrings[453]), 0,
                ((char*)&XtStrings[872]), 1,
                ((char*)&XtStrings[234]), 1,
                ((void *)0));
        if (xterm_Shell == (Widget)0)
            return;
        x11_setup_atoms(xterm_dpy);
        if (x11_display == ((void *)0))
            x11_display = xterm_dpy;
        XtRealizeWidget(xterm_Shell);
        XSync(xterm_dpy, 0);
        xterm_update();
    }
    if (xterm_Shell != (Widget)0)
    {
        clip_init(1);
        if (x11_window == 0 && (strp = getenv("WINDOWID")) != ((void *)0))
            x11_window = (Window)atol(strp);
        if (test_x11_window(xterm_dpy) == 0)
            x11_window = 0;
        if (x11_window != 0)
            xterm_trace = 0;
    }
}
    void start_xterm_trace(button)
    int button;
{
    if (x11_window == 0 || xterm_trace < 0 || xterm_Shell == (Widget)0)
        return;
    xterm_trace = 1;
    xterm_button = button;
    do_xterm_trace();
}
    void stop_xterm_trace()
{
    if (xterm_trace < 0)
        return;
    xterm_trace = 0;
}
    static int do_xterm_trace()
{
    Window root, child;
    int root_x, root_y;
    int win_x, win_y;
    int row, col;
    int_u mask_return;
    char_u buf[50];
    char_u *strp;
    long got_hints;
    static char_u *mouse_code;
    static char_u mouse_name[2] = {251, ('X')};
    static int prev_row = 0, prev_col = 0;
    static XSizeHints xterm_hints;
    if (xterm_trace <= 0)
        return 0;
    if (xterm_trace == 1)
    {
        XGetWMNormalHints(xterm_dpy, x11_window, &xterm_hints, &got_hints);
        if (!(got_hints & (1L << 6))
                || xterm_hints.width_inc <= 1
                || xterm_hints.height_inc <= 1)
        {
            xterm_trace = -1;
            return 0;
        }
        mouse_code = find_termcode(mouse_name);
        prev_row = mouse_row;
        prev_row = mouse_col;
        xterm_trace = 2;
        XQueryPointer(xterm_dpy, x11_window, &root, &child, &root_x, &root_y,
                      &win_x, &win_y, &mask_return);
        xterm_hints.y = win_y - (xterm_hints.height_inc * mouse_row)
                              - (xterm_hints.height_inc / 2);
        if (xterm_hints.y <= xterm_hints.height_inc / 2)
            xterm_hints.y = 2;
        xterm_hints.x = win_x - (xterm_hints.width_inc * mouse_col)
                              - (xterm_hints.width_inc / 2);
        if (xterm_hints.x <= xterm_hints.width_inc / 2)
            xterm_hints.x = 2;
        return 1;
    }
    if (mouse_code == ((void *)0))
    {
        xterm_trace = 0;
        return 0;
    }
    XQueryPointer(xterm_dpy, x11_window, &root, &child, &root_x, &root_y,
                  &win_x, &win_y, &mask_return);
    row = check_row((win_y - xterm_hints.y) / xterm_hints.height_inc);
    col = check_col((win_x - xterm_hints.x) / xterm_hints.width_inc);
    if (row == prev_row && col == prev_col)
        return 1;
    strcpy((char *)(buf), (char *)(mouse_code));
    strp = buf + strlen((char *)(buf));
    *strp++ = (xterm_button | (0x40 | 0x03)) & ~0x20;
    *strp++ = (char_u)(col + ' ' + 1);
    *strp++ = (char_u)(row + ' ' + 1);
    *strp = 0;
    add_to_input_buf(buf, strlen((char *)(buf)));
    prev_row = row;
    prev_col = col;
    return 1;
}
    void clear_xterm_clip()
{
    if (xterm_Shell != (Widget)0)
    {
        XtDestroyWidget(xterm_Shell);
        xterm_Shell = (Widget)0;
    }
    if (xterm_dpy != ((void *)0))
    {
        if (x11_display == xterm_dpy)
            x11_display = ((void *)0);
        xterm_dpy = ((void *)0);
    }
}
    static void xterm_update()
{
    XEvent event;
    while (XtAppPending(app_context) && !vim_is_input_buf_full())
    {
        XtAppNextEvent(app_context, &event);
        {
            XPropertyEvent *e = (XPropertyEvent *)&event;
            if (e->type == 28 && e->window == commWindow
                   && e->atom == commProperty && e->state == 0)
                serverEventProc(xterm_dpy, &event);
        }
        XtDispatchEvent(&event);
    }
}
    int clip_xterm_own_selection(cbd)
    VimClipboard *cbd;
{
    if (xterm_Shell != (Widget)0)
        return clip_x11_own_selection(xterm_Shell, cbd);
    return 0;
}
    void clip_xterm_lose_selection(cbd)
    VimClipboard *cbd;
{
    if (xterm_Shell != (Widget)0)
        clip_x11_lose_selection(xterm_Shell, cbd);
}
    void clip_xterm_request_selection(cbd)
    VimClipboard *cbd;
{
    if (xterm_Shell != (Widget)0)
        clip_x11_request_selection(xterm_Shell, xterm_dpy, cbd);
}
    void clip_xterm_set_selection(cbd)
    VimClipboard *cbd;
{
    clip_x11_set_selection(cbd);
}
