typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
extern long int atol (__const char *__nptr) __attribute__ ((__pure__));
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
typedef struct
{
    buf_T *save_buf;
    buf_T *new_curbuf;
    win_T *save_curwin;
    win_T *new_curwin;
    pos_T save_cursor;
    linenr_T save_topline;
    int save_topfill;
} aco_save_T;
void aucmd_prepbuf (aco_save_T *aco, buf_T *buf);
void aucmd_restbuf (aco_save_T *aco);
int bt_dontwrite (buf_T *buf);
int bt_quickfix (buf_T *buf);
buf_T *buflist_findnr (int nr);
enum CMD_index
{
CMD_append,
CMD_abbreviate,
CMD_abclear,
CMD_aboveleft,
CMD_all,
CMD_amenu,
CMD_anoremenu,
CMD_args,
CMD_argadd,
CMD_argdelete,
CMD_argdo,
CMD_argedit,
CMD_argglobal,
CMD_arglocal,
CMD_argument,
CMD_ascii,
CMD_autocmd,
CMD_augroup,
CMD_aunmenu,
CMD_buffer,
CMD_bNext,
CMD_ball,
CMD_badd,
CMD_bdelete,
CMD_behave,
CMD_belowright,
CMD_bfirst,
CMD_blast,
CMD_bmodified,
CMD_bnext,
CMD_botright,
CMD_bprevious,
CMD_brewind,
CMD_break,
CMD_breakadd,
CMD_breakdel,
CMD_breaklist,
CMD_browse,
CMD_buffers,
CMD_bufdo,
CMD_bunload,
CMD_bwipeout,
CMD_change,
CMD_cNext,
CMD_cabbrev,
CMD_cabclear,
CMD_call,
CMD_catch,
CMD_cc,
CMD_cclose,
CMD_cd,
CMD_center,
CMD_cfile,
CMD_cfirst,
CMD_cgetfile,
CMD_chdir,
CMD_checkpath,
CMD_checktime,
CMD_clist,
CMD_clast,
CMD_close,
CMD_cmap,
CMD_cmapclear,
CMD_cmenu,
CMD_cnext,
CMD_cnewer,
CMD_cnfile,
CMD_cnoremap,
CMD_cnoreabbrev,
CMD_cnoremenu,
CMD_copy,
CMD_colder,
CMD_colorscheme,
CMD_command,
CMD_comclear,
CMD_compiler,
CMD_continue,
CMD_confirm,
CMD_copen,
CMD_cprevious,
CMD_cquit,
CMD_crewind,
CMD_cscope,
CMD_cstag,
CMD_cunmap,
CMD_cunabbrev,
CMD_cunmenu,
CMD_cwindow,
CMD_delete,
CMD_debug,
CMD_debuggreedy,
CMD_delcommand,
CMD_delfunction,
CMD_display,
CMD_diffupdate,
CMD_diffget,
CMD_diffpatch,
CMD_diffput,
CMD_diffsplit,
CMD_diffthis,
CMD_digraphs,
CMD_djump,
CMD_dlist,
CMD_doautocmd,
CMD_doautoall,
CMD_drop,
CMD_dsearch,
CMD_dsplit,
CMD_edit,
CMD_echo,
CMD_echoerr,
CMD_echohl,
CMD_echomsg,
CMD_echon,
CMD_else,
CMD_elseif,
CMD_emenu,
CMD_endif,
CMD_endfunction,
CMD_endtry,
CMD_endwhile,
CMD_enew,
CMD_ex,
CMD_execute,
CMD_exit,
CMD_file,
CMD_files,
CMD_filetype,
CMD_find,
CMD_finally,
CMD_finish,
CMD_first,
CMD_fixdel,
CMD_fold,
CMD_foldclose,
CMD_folddoopen,
CMD_folddoclosed,
CMD_foldopen,
CMD_function,
CMD_global,
CMD_goto,
CMD_grep,
CMD_grepadd,
CMD_gui,
CMD_gvim,
CMD_help,
CMD_helpfind,
CMD_helpgrep,
CMD_helptags,
CMD_hardcopy,
CMD_highlight,
CMD_hide,
CMD_history,
CMD_insert,
CMD_iabbrev,
CMD_iabclear,
CMD_if,
CMD_ijump,
CMD_ilist,
CMD_imap,
CMD_imapclear,
CMD_imenu,
CMD_inoremap,
CMD_inoreabbrev,
CMD_inoremenu,
CMD_intro,
CMD_isearch,
CMD_isplit,
CMD_iunmap,
CMD_iunabbrev,
CMD_iunmenu,
CMD_join,
CMD_jumps,
CMD_k,
CMD_list,
CMD_last,
CMD_language,
CMD_lcd,
CMD_lchdir,
CMD_left,
CMD_leftabove,
CMD_let,
CMD_lmap,
CMD_lmapclear,
CMD_lnoremap,
CMD_loadview,
CMD_loadkeymap,
CMD_lunmap,
CMD_ls,
CMD_move,
CMD_mark,
CMD_make,
CMD_map,
CMD_mapclear,
CMD_marks,
CMD_match,
CMD_menu,
CMD_menutranslate,
CMD_messages,
CMD_mkexrc,
CMD_mksession,
CMD_mkvimrc,
CMD_mkview,
CMD_mode,
CMD_next,
CMD_new,
CMD_nmap,
CMD_nmapclear,
CMD_nmenu,
CMD_nnoremap,
CMD_nnoremenu,
CMD_noremap,
CMD_nohlsearch,
CMD_noreabbrev,
CMD_noremenu,
CMD_normal,
CMD_number,
CMD_nunmap,
CMD_nunmenu,
CMD_open,
CMD_omap,
CMD_omapclear,
CMD_omenu,
CMD_only,
CMD_onoremap,
CMD_onoremenu,
CMD_options,
CMD_ounmap,
CMD_ounmenu,
CMD_print,
CMD_pclose,
CMD_perl,
CMD_perldo,
CMD_pedit,
CMD_pop,
CMD_popup,
CMD_ppop,
CMD_preserve,
CMD_previous,
CMD_promptfind,
CMD_promptrepl,
CMD_psearch,
CMD_ptag,
CMD_ptNext,
CMD_ptfirst,
CMD_ptjump,
CMD_ptlast,
CMD_ptnext,
CMD_ptprevious,
CMD_ptrewind,
CMD_ptselect,
CMD_put,
CMD_pwd,
CMD_python,
CMD_pyfile,
CMD_quit,
CMD_quitall,
CMD_qall,
CMD_read,
CMD_recover,
CMD_redo,
CMD_redir,
CMD_redraw,
CMD_registers,
CMD_resize,
CMD_retab,
CMD_return,
CMD_rewind,
CMD_right,
CMD_rightbelow,
CMD_runtime,
CMD_ruby,
CMD_rubydo,
CMD_rubyfile,
CMD_rviminfo,
CMD_substitute,
CMD_sNext,
CMD_sargument,
CMD_sall,
CMD_saveas,
CMD_sbuffer,
CMD_sbNext,
CMD_sball,
CMD_sbfirst,
CMD_sblast,
CMD_sbmodified,
CMD_sbnext,
CMD_sbprevious,
CMD_sbrewind,
CMD_scriptnames,
CMD_scriptencoding,
CMD_scscope,
CMD_set,
CMD_setfiletype,
CMD_setglobal,
CMD_setlocal,
CMD_sfind,
CMD_sfirst,
CMD_shell,
CMD_simalt,
CMD_sign,
CMD_silent,
CMD_sleep,
CMD_slast,
CMD_smagic,
CMD_snext,
CMD_sniff,
CMD_snomagic,
CMD_source,
CMD_split,
CMD_sprevious,
CMD_srewind,
CMD_stop,
CMD_stag,
CMD_startinsert,
CMD_stopinsert,
CMD_stjump,
CMD_stselect,
CMD_sunhide,
CMD_suspend,
CMD_sview,
CMD_swapname,
CMD_syntax,
CMD_syncbind,
CMD_t,
CMD_tNext,
CMD_tag,
CMD_tags,
CMD_tcl,
CMD_tcldo,
CMD_tclfile,
CMD_tearoff,
CMD_tfirst,
CMD_throw,
CMD_tjump,
CMD_tlast,
CMD_tmenu,
CMD_tnext,
CMD_topleft,
CMD_tprevious,
CMD_trewind,
CMD_try,
CMD_tselect,
CMD_tunmenu,
CMD_undo,
CMD_unabbreviate,
CMD_unhide,
CMD_unlet,
CMD_unmap,
CMD_unmenu,
CMD_update,
CMD_vglobal,
CMD_version,
CMD_verbose,
CMD_vertical,
CMD_visual,
CMD_view,
CMD_vmap,
CMD_vmapclear,
CMD_vmenu,
CMD_vnoremap,
CMD_vnew,
CMD_vnoremenu,
CMD_vsplit,
CMD_vunmap,
CMD_vunmenu,
CMD_write,
CMD_wNext,
CMD_wall,
CMD_while,
CMD_winsize,
CMD_wincmd,
CMD_windo,
CMD_winpos,
CMD_wnext,
CMD_wprevious,
CMD_wq,
CMD_wqall,
CMD_wsverb,
CMD_wviminfo,
CMD_xit,
CMD_xall,
CMD_yank,
CMD_z,
CMD_bang,
CMD_pound,
CMD_and,
CMD_star,
CMD_lshift,
CMD_equal,
CMD_rshift,
CMD_at,
CMD_Next,
CMD_Print,
CMD_X,
CMD_tilde,
    CMD_SIZE,
    CMD_USER = -1,
    CMD_USER_BUF = -2
};
typedef enum CMD_index cmdidx_T;
typedef void (*GVoidFunc) (void);
typedef void (*GtkSignalFunc) ();
typedef struct eslist_elem eslist_T;
typedef struct exarg exarg_T;
struct eslist_elem
{
    int saved_emsg_silent;
    eslist_T *next;
};
struct condstack
{
    char cs_flags[50];
    char cs_pending[50];
    union {
        void *cs_pend_rv[50];
        void *cs_pend_ex[50];
    } cs_pend;
    int cs_line[50];
    int cs_idx;
    int cs_whilelevel;
    int cs_trylevel;
    eslist_T *cs_emsg_silent_list;
    char cs_had_while;
    char cs_had_continue;
    char cs_had_endwhile;
    char cs_had_finally;
};
struct exarg
{
    char_u *arg;
    char_u *nextcmd;
    char_u *cmd;
    char_u **cmdlinep;
    cmdidx_T cmdidx;
    long argt;
    int skip;
    int forceit;
    int addr_count;
    linenr_T line1;
    linenr_T line2;
    char_u *do_ecmd_cmd;
    linenr_T do_ecmd_lnum;
    int append;
    int usefilter;
    int amount;
    int regname;
    int force_ff;
    int useridx;
    char_u *errmsg;
    char_u *(*getline) (int, void *, int);
    void *cookie;
    struct condstack *cstack;
};
int do_ecmd (int fnum, char_u *ffname, char_u *sfname, exarg_T *eap, linenr_T newlnum, int flags);
int emsg (char_u *s);
int emsg2 (char_u *s, char_u *a1);
char_u *gettail (char_u *fname);
int ml_delete (linenr_T lnum, int message);
int msg (char_u *s);
int msg_outtrans (char_u *str);
void msg_putchar (int c);
void msg_puts (char_u *s);
void msg_puts_attr (char_u *s, int attr);
void msg_start (void);
void out_flush (void);
void redraw_later (int type);
void set_curbuf (buf_T *buf, int action);
void setpcmark (void);
int shortmess (int x);
char_u *skipwhite (char_u *p);
int smsg (char_u *, ...);
extern int sprintf (char *__restrict __s,
                    __const char *__restrict __format, ...) ;
extern char *strcat (char *__restrict __dest, __const char *__restrict __src)
            ;
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void ui_breakcheck (void);
void vim_free (void *x);
regprog_T *vim_regcomp (char_u *expr, int re_flags);
typedef struct
{
    regprog_T *regprog;
    char_u *startp[10];
    char_u *endp[10];
    int rm_ic;
} regmatch_T;
int vim_regexec (regmatch_T *rmp, char_u *line, colnr_T col);
char_u *vim_strchr (char_u *string, int c);
char_u *vim_strrchr (char_u *string, int c);
char_u *vim_strsave (char_u *string);
void win_close (win_T *win, int free_buf);
int win_split (int size, int flags);
int win_valid (win_T *win);
extern long Columns ;
extern char_u *IObuff;
extern char_u *NameBuff;
typedef struct
{
    int hide;
    int browse;
    int split;
    int confirm;
} cmdmod_T;
extern cmdmod_T cmdmod;
extern buf_T *curbuf ;
extern win_T *curwin;
extern char_u e_trailing[] ;
extern buf_T *firstbuf ;
extern win_T *firstwin;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern win_T *lastwin;
extern int msg_scroll ;
extern int msg_scrolled;
extern int need_mouse_correct ;
extern char_u *p_cpo;
extern char_u *p_swb;
char_u *skip_to_option_part (char_u *p);
void append_redir (char_u *buf, char_u *opt, char_u *fname);
void check_cursor (void);
typedef long int __off_t;
__extension__ typedef long long int __quad_t;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
typedef __quad_t __loff_t;
typedef __loff_t __off64_t;
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _blksize;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
extern int fclose (FILE *__stream) ;
extern FILE *fopen (__const char *__restrict __filename,
                    __const char *__restrict __modes) ;
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
void set_string_option_direct (char_u *name, int opt_idx, char_u *val, int opt_flags);
extern int unlink (__const char *__name) ;
int vim_fgets (char_u *buf, int size, FILE *fp);
char_u *vim_tempname (int extra_char);
extern int KeyTyped;
extern int msg_col;
void FreeWild (int count, char_u **files);
void beginline (int flags);
int copy_option_part (char_u **option, char_u *buf, int maxlen, char *sep_chars);
void foldOpenCursor (void);
void line_breakcheck (void);
char_u *ml_get_curline (void);
void redraw_curbuf_later (int type);
void update_topline (void);
int vim_isprintc (int c);
extern unsigned fdo_flags;
void add_pathsep (char_u *p);
long mch_getperm (char_u *name);
int mch_isdir (char_u *name);
void msg_prt_line (char_u *s);
void set_option_value (char_u *name, long number, char_u *string, int opt_flags);
int vim_isAbsName (char_u *name);
extern int msg_didout ;
void do_shell (char_u *cmd, int flags);
void autowrite_all (void);
void check_lnums (int do_curwin);
int gen_expand_wildcards (int num_pat, char_u **pat, int *num_file, char_u ***file, int flags);
void win_setheight (int height);
extern char_u e_notmp[] ;
extern char_u *p_rtp;
extern char_u *p_sp;
extern char_u *p_shq;
int buflist_add (char_u *fname, int flags);
extern int ferror (FILE *__stream) ;
extern char *fgets (char *__restrict __s, int __n, FILE *__restrict __stream)
            ;
void win_goto (win_T *wp);
void ex_cclose (exarg_T *eap);
void ex_copen (exarg_T *eap);
int msg_outtrans_attr (char_u *str, int attr);
int get_list_range (char_u **str, int *num1, int *num2);
typedef __u_int __mode_t;
typedef long int __time_t;
__extension__ typedef unsigned long long int __u_quad_t;
typedef __u_int __gid_t;
typedef __u_int __nlink_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __u_quad_t __dev_t;
struct stat
  {
    __dev_t st_dev;
    unsigned short int __pad1;
    __ino_t st_ino;
    __mode_t st_mode;
    __nlink_t st_nlink;
    __uid_t st_uid;
    __gid_t st_gid;
    __dev_t st_rdev;
    unsigned short int __pad2;
    __off_t st_size;
    __blksize_t st_blksize;
    __blkcnt_t st_blocks;
    __time_t st_atime;
    unsigned long int __unused1;
    __time_t st_mtime;
    unsigned long int __unused2;
    __time_t st_ctime;
    unsigned long int __unused3;
    unsigned long int __unused4;
    unsigned long int __unused5;
  };
extern int lstat (__const char *__restrict __file,
                  struct stat *__restrict __buf) ;
long mch_get_pid (void);
char_u *concat_fnames (char_u *fname1, char_u *fname2, int sep);
int qf_init (char_u *efile, char_u *errorformat, int newlist);
void qf_jump (int dir, int errornr, int forceit);
int buflist_getfile (int n, linenr_T lnum, int options, int forceit);
int msg_attr_keep (char_u *s, int attr, int keep);
extern int more_back ;
extern int more_back_used ;
void reset_VIsual_and_resel (void);
void update_topline_redraw (void);
void free_string_option (char_u *p);
extern char_u *p_ef;
extern char_u *p_efm;
extern char_u *p_gefm;
extern int p_hid;
extern char_u *p_mef;
extern char_u e_openerrf[] ;
extern char_u e_quickfix[] ;
extern char_u e_readerrf[] ;
struct dir_stack_T
{
    struct dir_stack_T *next;
    char_u *dirname;
};
struct qf_line
{
    struct qf_line *qf_next;
    struct qf_line *qf_prev;
    linenr_T qf_lnum;
    int qf_fnum;
    int qf_col;
    int qf_nr;
    char_u *qf_text;
    char_u qf_virt_col;
    char_u qf_cleared;
    char_u qf_type;
    char_u qf_valid;
};
struct eformat
{
    regprog_T *prog;
    struct eformat *next;
    char_u addr[9];
    char_u prefix;
    char_u flags;
};
extern char_u *empty_option ;
extern win_T *prevwin ;
static struct dir_stack_T *dir_stack = ((void *)0);
struct qf_list
{
    struct qf_line *qf_start;
    struct qf_line *qf_ptr;
    int qf_count;
    int qf_index;
    int qf_nonevalid;
} qf_lists[10];
static int qf_curlist = 0;
static int qf_listcount = 0;
static void qf_new_list (void);
static int qf_add_entry (struct qf_line **prevp, char_u *dir, char_u *fname, char_u *msg, long lnum, int col, int virt_col, int nr, int type, int valid);
static void qf_msg (void);
static void qf_free (int idx);
static char_u *qf_types (int, int);
static int qf_get_fnum (char_u *, char_u *);
static char_u *qf_push_dir (char_u *, struct dir_stack_T **);
static char_u *qf_pop_dir (struct dir_stack_T **);
static char_u *qf_guess_filepath (char_u *);
static void qf_fmt_text (char_u *text, char_u *buf, int bufsize);
static void qf_clean_dir_stack (struct dir_stack_T **);
static int qf_win_pos_update (int old_qf_index);
static buf_T *qf_find_buf (void);
static void qf_update_buffer (void);
static void qf_fill_buffer (void);
static char_u *get_mef_name (void);
    int qf_init(efile, errorformat, newlist)
    char_u *efile;
    char_u *errorformat;
    int newlist;
{
    char_u *namebuf;
    char_u *errmsg;
    char_u *fmtstr = ((void *)0);
    int col = 0;
    char_u use_virt_col = 0;
    int type = 0;
    int valid;
    long lnum = 0L;
    int enr = 0;
    FILE *fd;
    struct qf_line *qfprev = ((void *)0);
    char_u *efmp;
    struct eformat *fmt_first = ((void *)0);
    struct eformat *fmt_last = ((void *)0);
    struct eformat *fmt_ptr;
    char_u *efm;
    char_u *ptr;
    char_u *srcptr;
    int len;
    int i;
    int round;
    int idx = 0;
    int multiline = 0;
    int multiignore = 0;
    int multiscan = 0;
    int retval = -1;
    char_u *directory = ((void *)0);
    char_u *currfile = ((void *)0);
    char_u *tail = ((void *)0);
    struct dir_stack_T *file_stack = ((void *)0);
    regmatch_T regmatch;
    static struct fmtpattern
    {
        char_u convchar;
        char *pattern;
    } fmt_pat[9] =
                    {
                        {'f', "\\f\\+"},
                        {'n', "\\d\\+"},
                        {'l', "\\d\\+"},
                        {'c', "\\d\\+"},
                        {'t', "."},
                        {'m', ".\\+"},
                        {'r', ".*"},
                        {'p', "[- .]*"},
                        {'v', "\\d\\+"}
                    };
    if (efile == ((void *)0))
        return 0;
    namebuf = alloc(1024 + 1);
    errmsg = alloc(1024 + 1);
    if (namebuf == ((void *)0) || errmsg == ((void *)0))
        goto qf_init_end;
    if ((fd = fopen(((char *)efile), ("r"))) == ((void *)0))
    {
        emsg2((char_u *)(((char *)(e_openerrf))), (char_u *)(efile));
        goto qf_init_end;
    }
    if (newlist || qf_curlist == qf_listcount)
        qf_new_list();
    else if (qf_lists[qf_curlist].qf_count > 0)
        for (qfprev = qf_lists[qf_curlist].qf_start;
                            qfprev->qf_next != qfprev; qfprev = qfprev->qf_next)
            ;
    if (errorformat == p_efm && *curbuf->b_p_efm != '\000')
        efm = curbuf->b_p_efm;
    else
        efm = errorformat;
    i = (9 * 3) + ((int)strlen((char *)(efm)) << 2);
    for (round = 9; round > 0; )
        i += (int)strlen((char *)(fmt_pat[--round].pattern));
    i += 2;
    if ((fmtstr = alloc(i)) == ((void *)0))
        goto error2;
    while (efm[0])
    {
        fmt_ptr = (struct eformat *)alloc((unsigned)sizeof(struct eformat));
        if (fmt_ptr == ((void *)0))
            goto error2;
        if (fmt_first == ((void *)0))
            fmt_first = fmt_ptr;
        else
            fmt_last->next = fmt_ptr;
        fmt_last = fmt_ptr;
        fmt_ptr->prefix = '\000';
        fmt_ptr->flags = '\000';
        fmt_ptr->next = ((void *)0);
        fmt_ptr->prog = ((void *)0);
        for (round = 9; round > 0; )
            fmt_ptr->addr[--round] = '\000';
        for (len = 0; efm[len] != '\000' && efm[len] != ','; ++len)
            if (efm[len] == '\\' && efm[len + 1] != '\000')
                ++len;
        ptr = fmtstr;
        *ptr++ = '^';
        for (efmp = efm; efmp < efm + len; ++efmp)
        {
            if (*efmp == '%')
            {
                ++efmp;
                for (idx = 0; idx < 9; ++idx)
                    if (fmt_pat[idx].convchar == *efmp)
                        break;
                if (idx < 9)
                {
                    if (fmt_ptr->addr[idx])
                    {
                        sprintf((char *)errmsg,
                                ((char *)("E372: Too many %%%c in format string")), *efmp);
                        emsg((char_u *)(errmsg));
                        goto error2;
                    }
                    if ((idx
                                && idx < 6
                                && vim_strchr((char_u *)"DXOPQ",
                                                     fmt_ptr->prefix) != ((void *)0))
                            || (idx == 6
                                && vim_strchr((char_u *)"OPQ",
                                                    fmt_ptr->prefix) == ((void *)0)))
                    {
                        sprintf((char *)errmsg,
                                ((char *)("E373: Unexpected %%%c in format string")), *efmp);
                        emsg((char_u *)(errmsg));
                        goto error2;
                    }
                    fmt_ptr->addr[idx] = (char_u)++round;
                    *ptr++ = '\\';
                    *ptr++ = '(';
                    if (*efmp == 'f' && efmp[1] != '\000'
                                         && efmp[1] != '\\' && efmp[1] != '%')
                    {
                        *ptr++ = '[';
                        *ptr++ = '^';
                        *ptr++ = efmp[1];
                        *ptr++ = ']';
                        *ptr++ = '\\';
                        *ptr++ = '+';
                    }
                    else
                    {
                        srcptr = (char_u *)fmt_pat[idx].pattern;
                        while ((*ptr = *srcptr++) != '\000')
                            ++ptr;
                    }
                    *ptr++ = '\\';
                    *ptr++ = ')';
                }
                else if (*efmp == '*')
                {
                    if (*++efmp == '[' || *efmp == '\\')
                    {
                        if ((*ptr++ = *efmp) == '[')
                        {
                            if (efmp[1] == '^')
                                *ptr++ = *++efmp;
                            if (efmp < efm + len)
                            {
                                *ptr++ = *++efmp;
                                while (efmp < efm + len
                                        && (*ptr++ = *++efmp) != ']')
                                              ;
                                if (efmp == efm + len)
                                {
                                    emsg((char_u *)(((char *)("E374: Missing ] in format string"))));
                                    goto error2;
                                }
                            }
                        }
                        else if (efmp < efm + len)
                            *ptr++ = *++efmp;
                        *ptr++ = '\\';
                        *ptr++ = '+';
                    }
                    else
                    {
                        sprintf((char *)errmsg,
                                ((char *)("E375: Unsupported %%%c in format string")), *efmp);
                        emsg((char_u *)(errmsg));
                        goto error2;
                    }
                }
                else if (vim_strchr((char_u *)"%\\.^$~[", *efmp) != ((void *)0))
                    *ptr++ = *efmp;
                else if (*efmp == '#')
                    *ptr++ = '*';
                else if (efmp == efm + 1)
                {
                    if (vim_strchr((char_u *)"+-", *efmp) != ((void *)0))
                        fmt_ptr->flags = *efmp++;
                    if (vim_strchr((char_u *)"DXAEWICZGOPQ", *efmp) != ((void *)0))
                        fmt_ptr->prefix = *efmp;
                    else
                    {
                        sprintf((char *)errmsg,
                                ((char *)("E376: Invalid %%%c in format string prefix")), *efmp);
                        emsg((char_u *)(errmsg));
                        goto error2;
                    }
                }
                else
                {
                    sprintf((char *)errmsg,
                            ((char *)("E377: Invalid %%%c in format string")), *efmp);
                    emsg((char_u *)(errmsg));
                    goto error2;
                }
            }
            else
            {
                if (*efmp == '\\' && efmp + 1 < efm + len)
                    ++efmp;
                else if (vim_strchr((char_u *)".*^$~[", *efmp) != ((void *)0))
                    *ptr++ = '\\';
                if (*efmp)
                    *ptr++ = *efmp;
            }
        }
        *ptr++ = '$';
        *ptr = '\000';
        if ((fmt_ptr->prog = vim_regcomp(fmtstr, 1 + 2)) == ((void *)0))
            goto error2;
        efm = skip_to_option_part(efm + len);
    }
    if (fmt_first == ((void *)0))
    {
        emsg((char_u *)(((char *)("E378: 'errorformat' contains no pattern"))));
        goto error2;
    }
    got_int = 0;
    regmatch.rm_ic = 1;
    while (fgets((char *)IObuff, 1024, fd) != ((void *)0) && !got_int)
    {
        IObuff[1024] = '\000';
        if ((efmp = vim_strrchr(IObuff, '\n')) != ((void *)0))
            *efmp = '\000';
        valid = 1;
restofline:
        for (fmt_ptr = fmt_first; fmt_ptr != ((void *)0); fmt_ptr = fmt_ptr->next)
        {
            idx = fmt_ptr->prefix;
            if (multiscan && vim_strchr((char_u *)"OPQ", idx) == ((void *)0))
                continue;
            namebuf[0] = '\000';
            if (!multiscan)
                errmsg[0] = '\000';
            lnum = 0;
            col = 0;
            use_virt_col = 0;
            enr = -1;
            type = 0;
            tail = ((void *)0);
            regmatch.regprog = fmt_ptr->prog;
            if (vim_regexec(&regmatch, IObuff, (colnr_T)0))
            {
                if ((idx == 'C' || idx == 'Z') && !multiline)
                    continue;
                if (vim_strchr((char_u *)"EWI", idx) != ((void *)0))
                    type = idx;
                else
                    type = 0;
                if ((i = (int)fmt_ptr->addr[0]) > 0)
                {
                    len = (int)(regmatch.endp[i] - regmatch.startp[i]);
                    strncpy((char *)(namebuf), (char *)(regmatch.startp[i]), (size_t)(len));
                    namebuf[len] = '\000';
                    if (vim_strchr((char_u *)"OPQ", idx) != ((void *)0)
                            && mch_getperm(namebuf) == -1)
                        continue;
                }
                if ((i = (int)fmt_ptr->addr[1]) > 0)
                    enr = (int)atol((char *)regmatch.startp[i]);
                if ((i = (int)fmt_ptr->addr[2]) > 0)
                    lnum = atol((char *)regmatch.startp[i]);
                if ((i = (int)fmt_ptr->addr[3]) > 0)
                    col = (int)atol((char *)regmatch.startp[i]);
                if ((i = (int)fmt_ptr->addr[4]) > 0)
                    type = *regmatch.startp[i];
                if (fmt_ptr->flags == '+' && !multiscan)
                    strcpy((char *)(errmsg), (char *)(IObuff));
                else if ((i = (int)fmt_ptr->addr[5]) > 0)
                {
                    len = (int)(regmatch.endp[i] - regmatch.startp[i]);
                    strncpy((char *)(errmsg), (char *)(regmatch.startp[i]), (size_t)(len));
                    errmsg[len] = '\000';
                }
                if ((i = (int)fmt_ptr->addr[6]) > 0)
                    tail = regmatch.startp[i];
                if ((i = (int)fmt_ptr->addr[7]) > 0)
                    col = (int)(regmatch.endp[i] - regmatch.startp[i] + 1);
                if ((i = (int)fmt_ptr->addr[8]) > 0)
                {
                    col = (int)atol((char *)regmatch.startp[i]);
                    use_virt_col = 1;
                }
                break;
            }
        }
        multiscan = 0;
        if (!fmt_ptr || idx == 'D' || idx == 'X')
        {
            if (fmt_ptr)
            {
                if (idx == 'D')
                {
                    if (*namebuf == '\000')
                    {
                        emsg((char_u *)(((char *)("E379: Missing or empty directory name"))));
                        goto error2;
                    }
                    if ((directory = qf_push_dir(namebuf, &dir_stack)) == ((void *)0))
                        goto error2;
                }
                else if (idx == 'X')
                    directory = qf_pop_dir(&dir_stack);
            }
            namebuf[0] = '\000';
            lnum = 0;
            valid = 0;
            strcpy((char *)(errmsg), (char *)(IObuff));
            if (!fmt_ptr)
                multiline = multiignore = 0;
        }
        else if (fmt_ptr)
        {
            if (vim_strchr((char_u *)"AEWI", idx) != ((void *)0))
                multiline = 1;
            else if (vim_strchr((char_u *)"CZ", idx) != ((void *)0))
            {
                if (qfprev == ((void *)0))
                    goto error2;
                if (*errmsg && !multiignore)
                {
                    len = (int)strlen((char *)(qfprev->qf_text));
                    if ((ptr = alloc((unsigned)(len + strlen((char *)(errmsg)) + 2)))
                                                                    == ((void *)0))
                        goto error2;
                    strcpy((char *)(ptr), (char *)(qfprev->qf_text));
                    vim_free(qfprev->qf_text);
                    qfprev->qf_text = ptr;
                    *(ptr += len) = '\n';
                    strcpy((char *)(++ptr), (char *)(errmsg));
                }
                if (qfprev->qf_nr == -1)
                    qfprev->qf_nr = enr;
                if (vim_isprintc(type) && !qfprev->qf_type)
                    qfprev->qf_type = type;
                if (!qfprev->qf_lnum)
                    qfprev->qf_lnum = lnum;
                if (!qfprev->qf_col)
                    qfprev->qf_col = col;
                qfprev->qf_virt_col = use_virt_col;
                if (!qfprev->qf_fnum)
                    qfprev->qf_fnum = qf_get_fnum(directory,
                                        *namebuf || directory ? namebuf
                                          : currfile && valid ? currfile : 0);
                if (idx == 'Z')
                    multiline = multiignore = 0;
                line_breakcheck();
                continue;
            }
            else if (vim_strchr((char_u *)"OPQ", idx) != ((void *)0))
            {
                valid = 0;
                if (*namebuf == '\000' || mch_getperm(namebuf) >= 0)
                {
                    if (*namebuf && idx == 'P')
                        currfile = qf_push_dir(namebuf, &file_stack);
                    else if (idx == 'Q')
                        currfile = qf_pop_dir(&file_stack);
                    *namebuf = '\000';
                    if (tail && *tail)
                    {
                        strcpy((char *)(IObuff), (char *)(skipwhite(tail)));
                        multiscan = 1;
                        goto restofline;
                    }
                }
            }
            if (fmt_ptr->flags == '-')
            {
                if (multiline)
                    multiignore = 1;
                continue;
            }
        }
        if (qf_add_entry(&qfprev,
                        directory,
                        *namebuf || directory
                            ? namebuf
                            : currfile && valid ? currfile : ((void *)0),
                        errmsg,
                        lnum,
                        col,
                        use_virt_col,
                        enr,
                        type,
                        valid) == 0)
            goto error2;
        line_breakcheck();
    }
    if (!ferror(fd))
    {
        if (qf_lists[qf_curlist].qf_index == 0)
        {
            qf_lists[qf_curlist].qf_ptr = qf_lists[qf_curlist].qf_start;
            qf_lists[qf_curlist].qf_index = 1;
            qf_lists[qf_curlist].qf_nonevalid = 1;
        }
        else
        {
            qf_lists[qf_curlist].qf_nonevalid = 0;
            if (qf_lists[qf_curlist].qf_ptr == ((void *)0))
                qf_lists[qf_curlist].qf_ptr = qf_lists[qf_curlist].qf_start;
        }
        retval = qf_lists[qf_curlist].qf_count;
        goto qf_init_ok;
    }
    emsg((char_u *)(((char *)(e_readerrf))));
error2:
    qf_free(qf_curlist);
    qf_listcount--;
    if (qf_curlist > 0)
        --qf_curlist;
qf_init_ok:
    fclose(fd);
    for (fmt_ptr = fmt_first; fmt_ptr != ((void *)0); fmt_ptr = fmt_first)
    {
        fmt_first = fmt_ptr->next;
        vim_free(fmt_ptr->prog);
        vim_free(fmt_ptr);
    }
    qf_clean_dir_stack(&dir_stack);
    qf_clean_dir_stack(&file_stack);
qf_init_end:
    vim_free(namebuf);
    vim_free(errmsg);
    vim_free(fmtstr);
    qf_update_buffer();
    return retval;
}
    static void qf_new_list()
{
    int i;
    while (qf_listcount > qf_curlist + 1)
        qf_free(--qf_listcount);
    if (qf_listcount == 10)
    {
        qf_free(0);
        for (i = 1; i < 10; ++i)
            qf_lists[i - 1] = qf_lists[i];
        qf_curlist = 10 - 1;
    }
    else
        qf_curlist = qf_listcount++;
    qf_lists[qf_curlist].qf_index = 0;
    qf_lists[qf_curlist].qf_count = 0;
}
    static int qf_add_entry(prevp, dir, fname, msg, lnum, col, virt_col, nr, type, valid)
    struct qf_line **prevp;
    char_u *dir;
    char_u *fname;
    char_u *msg;
    long lnum;
    int col;
    int virt_col;
    int nr;
    int type;
    int valid;
{
    struct qf_line *qfp;
    if ((qfp = (struct qf_line *)alloc((unsigned)sizeof(struct qf_line)))
                                                                      == ((void *)0))
        return 0;
    qfp->qf_fnum = qf_get_fnum(dir, fname);
    if ((qfp->qf_text = vim_strsave(msg)) == ((void *)0))
    {
        vim_free(qfp);
        return 0;
    }
    qfp->qf_lnum = lnum;
    qfp->qf_col = col;
    qfp->qf_virt_col = virt_col;
    qfp->qf_nr = nr;
    if (type != 1 && !vim_isprintc(type))
        type = 0;
    qfp->qf_type = type;
    qfp->qf_valid = valid;
    if (qf_lists[qf_curlist].qf_count == 0)
    {
        qf_lists[qf_curlist].qf_start = qfp;
        qfp->qf_prev = qfp;
    }
    else
    {
        qfp->qf_prev = *prevp;
        (*prevp)->qf_next = qfp;
    }
    qfp->qf_next = qfp;
    qfp->qf_cleared = 0;
    *prevp = qfp;
    ++qf_lists[qf_curlist].qf_count;
    if (qf_lists[qf_curlist].qf_index == 0 && qfp->qf_valid)
    {
        qf_lists[qf_curlist].qf_index = qf_lists[qf_curlist].qf_count;
        qf_lists[qf_curlist].qf_ptr = qfp;
    }
    return 1;
}
    static int qf_get_fnum(directory, fname)
    char_u *directory;
    char_u *fname;
{
    if (fname == ((void *)0) || *fname == '\000')
        return 0;
    {
        char_u *ptr;
        int fnum;
        if (directory != ((void *)0) && !vim_isAbsName(fname)
                && (ptr = concat_fnames(directory, fname, 1)) != ((void *)0))
        {
            if (mch_getperm(ptr) < 0)
            {
                vim_free(ptr);
                directory = qf_guess_filepath(fname);
                if (directory)
                    ptr = concat_fnames(directory, fname, 1);
                else
                    ptr = vim_strsave(fname);
            }
            fnum = buflist_add(ptr, 0);
            vim_free(ptr);
            return fnum;
        }
        return buflist_add(fname, 0);
    }
}
    static char_u * qf_push_dir(dirbuf, stackptr)
    char_u *dirbuf;
    struct dir_stack_T **stackptr;
{
    struct dir_stack_T *ds_new;
    struct dir_stack_T *ds_ptr;
    ds_new = (struct dir_stack_T *)alloc((unsigned)sizeof(struct dir_stack_T));
    if (ds_new == ((void *)0))
        return ((void *)0);
    ds_new->next = *stackptr;
    *stackptr = ds_new;
    if (vim_isAbsName(dirbuf)
            || (*stackptr)->next == ((void *)0)
            || (*stackptr && dir_stack != *stackptr))
        (*stackptr)->dirname = vim_strsave(dirbuf);
    else
    {
        ds_new = (*stackptr)->next;
        (*stackptr)->dirname = ((void *)0);
        while (ds_new)
        {
            vim_free((*stackptr)->dirname);
            (*stackptr)->dirname = concat_fnames(ds_new->dirname, dirbuf,
                    1);
            if (mch_isdir((*stackptr)->dirname) == 1)
                break;
            ds_new = ds_new->next;
        }
        while ((*stackptr)->next != ds_new)
        {
            ds_ptr = (*stackptr)->next;
            (*stackptr)->next = (*stackptr)->next->next;
            vim_free(ds_ptr->dirname);
            vim_free(ds_ptr);
        }
        if (ds_new == ((void *)0))
        {
            vim_free((*stackptr)->dirname);
            (*stackptr)->dirname = vim_strsave(dirbuf);
        }
    }
    if ((*stackptr)->dirname != ((void *)0))
        return (*stackptr)->dirname;
    else
    {
        ds_ptr = *stackptr;
        *stackptr = (*stackptr)->next;
        vim_free(ds_ptr);
        return ((void *)0);
    }
}
    static char_u * qf_pop_dir(stackptr)
    struct dir_stack_T **stackptr;
{
    struct dir_stack_T *ds_ptr;
    if (*stackptr != ((void *)0))
    {
        ds_ptr = *stackptr;
        *stackptr = (*stackptr)->next;
        vim_free(ds_ptr->dirname);
        vim_free(ds_ptr);
    }
    return *stackptr ? (*stackptr)->dirname : ((void *)0);
}
    static void qf_clean_dir_stack(stackptr)
    struct dir_stack_T **stackptr;
{
    struct dir_stack_T *ds_ptr;
    while ((ds_ptr = *stackptr) != ((void *)0))
    {
        *stackptr = (*stackptr)->next;
        vim_free(ds_ptr->dirname);
        vim_free(ds_ptr);
    }
}
    static char_u * qf_guess_filepath(filename)
    char_u *filename;
{
    struct dir_stack_T *ds_ptr;
    struct dir_stack_T *ds_tmp;
    char_u *fullname;
    if (dir_stack == ((void *)0))
        return ((void *)0);
    ds_ptr = dir_stack->next;
    fullname = ((void *)0);
    while (ds_ptr)
    {
        vim_free(fullname);
        fullname = concat_fnames(ds_ptr->dirname, filename, 1);
        if ((fullname != ((void *)0)) && (mch_getperm(fullname) >= 0))
            break;
        ds_ptr = ds_ptr->next;
    }
    vim_free(fullname);
    while (dir_stack->next != ds_ptr)
    {
        ds_tmp = dir_stack->next;
        dir_stack->next = dir_stack->next->next;
        vim_free(ds_tmp->dirname);
        vim_free(ds_tmp);
    }
    return ds_ptr==((void *)0)? ((void *)0): ds_ptr->dirname;
}
    void qf_jump(dir, errornr, forceit)
    int dir;
    int errornr;
    int forceit;
{
    struct qf_line *qf_ptr;
    struct qf_line *old_qf_ptr;
    int qf_index;
    int old_qf_fnum;
    int old_qf_index;
    int prev_index;
    static char_u *e_no_more_items = (char_u *)"E553: No more items";
    char_u *err = e_no_more_items;
    linenr_T i;
    buf_T *old_curbuf;
    linenr_T old_lnum;
    char_u *old_swb = p_swb;
    colnr_T screen_col;
    colnr_T char_col;
    char_u *line;
    int opened_window = 0;
    win_T *win;
    win_T *altwin;
    int print_message = 1;
    int len;
    int old_KeyTyped = KeyTyped;
    if (qf_curlist >= qf_listcount || qf_lists[qf_curlist].qf_count == 0)
    {
        emsg((char_u *)(((char *)(e_quickfix))));
        return;
    }
    qf_ptr = qf_lists[qf_curlist].qf_ptr;
    old_qf_ptr = qf_ptr;
    qf_index = qf_lists[qf_curlist].qf_index;
    old_qf_index = qf_index;
    if (dir == 1 || dir == 3)
    {
        while (errornr--)
        {
            old_qf_ptr = qf_ptr;
            prev_index = qf_index;
            old_qf_fnum = qf_ptr->qf_fnum;
            do
            {
                if (qf_index == qf_lists[qf_curlist].qf_count
                                                   || qf_ptr->qf_next == ((void *)0))
                {
                    qf_ptr = old_qf_ptr;
                    qf_index = prev_index;
                    if (err != ((void *)0))
                    {
                        emsg((char_u *)(((char *)(err))));
                        goto theend;
                    }
                    errornr = 0;
                    break;
                }
                ++qf_index;
                qf_ptr = qf_ptr->qf_next;
            } while ((!qf_lists[qf_curlist].qf_nonevalid && !qf_ptr->qf_valid)
                  || (dir == 3 && qf_ptr->qf_fnum == old_qf_fnum));
            err = ((void *)0);
        }
    }
    else if (dir == (-1))
    {
        while (errornr--)
        {
            old_qf_ptr = qf_ptr;
            prev_index = qf_index;
            do
            {
                if (qf_index == 1 || qf_ptr->qf_prev == ((void *)0))
                {
                    qf_ptr = old_qf_ptr;
                    qf_index = prev_index;
                    if (err != ((void *)0))
                    {
                        emsg((char_u *)(((char *)(err))));
                        goto theend;
                    }
                    errornr = 0;
                    break;
                }
                --qf_index;
                qf_ptr = qf_ptr->qf_prev;
            } while (!qf_lists[qf_curlist].qf_nonevalid && !qf_ptr->qf_valid);
            err = ((void *)0);
        }
    }
    else if (errornr != 0)
    {
        while (errornr < qf_index && qf_index > 1 && qf_ptr->qf_prev != ((void *)0))
        {
            --qf_index;
            qf_ptr = qf_ptr->qf_prev;
        }
        while (errornr > qf_index && qf_index < qf_lists[qf_curlist].qf_count
                                                   && qf_ptr->qf_next != ((void *)0))
        {
            ++qf_index;
            qf_ptr = qf_ptr->qf_next;
        }
    }
    qf_lists[qf_curlist].qf_index = qf_index;
    if (qf_win_pos_update(old_qf_index))
        print_message = 0;
    if (bt_quickfix(curbuf))
    {
        if (qf_ptr->qf_fnum == 0)
            goto theend;
        if (firstwin == lastwin)
        {
            if (win_split(0, 64) == 0)
                goto failed;
            opened_window = 1;
            p_swb = empty_option;
            curwin->w_onebuf_opt.wo_scb = 0;
        }
        else
        {
            win = curwin;
            altwin = ((void *)0);
            for (;;)
            {
                if (win->w_buffer->b_fnum == qf_ptr->qf_fnum)
                    break;
                if (win->w_prev == ((void *)0))
                    win = lastwin;
                else
                    win = win->w_prev;
                if (bt_quickfix(win->w_buffer))
                {
                    if (altwin != ((void *)0))
                        win = altwin;
                    else if (curwin->w_prev != ((void *)0))
                        win = curwin->w_prev;
                    else
                        win = curwin->w_next;
                    break;
                }
                if (altwin == ((void *)0) && !win->w_onebuf_opt.wo_pvw
                                           && win->w_buffer->b_p_bt[0] == '\000')
                    altwin = win;
            }
            win_goto(win);
        }
    }
    old_curbuf = curbuf;
    old_lnum = curwin->w_cursor.lnum;
    if (qf_ptr->qf_fnum == 0 || buflist_getfile(qf_ptr->qf_fnum,
                    (linenr_T)1, 0x01 | 0x04, forceit) == 1)
    {
        if (curbuf == old_curbuf)
            setpcmark();
        i = qf_ptr->qf_lnum;
        if (i > 0)
        {
            if (i > curbuf->b_ml.ml_line_count)
                i = curbuf->b_ml.ml_line_count;
            curwin->w_cursor.lnum = i;
        }
        if (qf_ptr->qf_col > 0)
        {
            curwin->w_cursor.col = qf_ptr->qf_col - 1;
            if (qf_ptr->qf_virt_col == 1)
            {
                line = ml_get_curline();
                screen_col = 0;
                for (char_col = 0; char_col < curwin->w_cursor.col; ++char_col)
                {
                    if (*line == '\000')
                        break;
                    if (*line++ == '\t')
                    {
                        curwin->w_cursor.col -= 7 - (screen_col % 8);
                        screen_col += 8 - (screen_col % 8);
                    }
                    else
                        ++screen_col;
                }
            }
            check_cursor();
        }
        else
            beginline(1 | 4);
        if ((fdo_flags & 0x020) && old_KeyTyped)
            foldOpenCursor();
        if (print_message)
        {
            update_topline_redraw();
            sprintf((char *)IObuff, ((char *)("(%d of %d)%s%s: ")), qf_index,
                    qf_lists[qf_curlist].qf_count,
                    qf_ptr->qf_cleared ? ((char *)(" (line deleted)")) : "",
                    (char *)qf_types(qf_ptr->qf_type, qf_ptr->qf_nr));
            len = (int)strlen((char *)(IObuff));
            qf_fmt_text(qf_ptr->qf_text, IObuff + len, (1024+1) - len);
            i = msg_scroll;
            if (curbuf == old_curbuf && curwin->w_cursor.lnum == old_lnum)
                msg_scroll = 1;
            else if (!msg_scrolled && shortmess('O'))
                msg_scroll = 0;
            msg_attr_keep(IObuff, 0, 1);
            msg_scroll = i;
        }
    }
    else
    {
        if (opened_window)
            win_close(curwin, 1);
        if (qf_ptr->qf_fnum != 0)
        {
failed:
            qf_ptr = old_qf_ptr;
            qf_index = old_qf_index;
        }
    }
theend:
    qf_lists[qf_curlist].qf_ptr = qf_ptr;
    qf_lists[qf_curlist].qf_index = qf_index;
    if (p_swb != old_swb && opened_window)
    {
        if (p_swb == empty_option)
            p_swb = old_swb;
        else
            free_string_option(old_swb);
    }
}
    void qf_list(eap)
    exarg_T *eap;
{
    buf_T *buf;
    char_u *fname;
    struct qf_line *qfp;
    int i;
    int idx1 = 1;
    int idx2 = -1;
    int need_return = 1;
    int last_printed = 1;
    char_u *arg = eap->arg;
    int all = eap->forceit;
    if (qf_curlist >= qf_listcount || qf_lists[qf_curlist].qf_count == 0)
    {
        emsg((char_u *)(((char *)(e_quickfix))));
        return;
    }
    if (!get_list_range(&arg, &idx1, &idx2) || *arg != '\000')
    {
        emsg((char_u *)(((char *)(e_trailing))));
        return;
    }
    i = qf_lists[qf_curlist].qf_count;
    if (idx1 < 0)
        idx1 = (-idx1 > i) ? 0 : idx1 + i + 1;
    if (idx2 < 0)
        idx2 = (-idx2 > i) ? 0 : idx2 + i + 1;
    more_back_used = 1;
    if (qf_lists[qf_curlist].qf_nonevalid)
        all = 1;
    qfp = qf_lists[qf_curlist].qf_start;
    for (i = 1; !got_int && i <= qf_lists[qf_curlist].qf_count; )
    {
        if ((qfp->qf_valid || all) && idx1 <= i && i <= idx2)
        {
            if (need_return)
            {
                msg_putchar('\n');
                need_return = 0;
            }
            if (more_back == 0)
            {
                fname = ((void *)0);
                if (qfp->qf_fnum != 0
                              && (buf = buflist_findnr(qfp->qf_fnum)) != ((void *)0))
                {
                    fname = buf->b_fname;
                    if (qfp->qf_type == 1)
                        fname = gettail(fname);
                }
                if (fname == ((void *)0))
                    sprintf((char *)IObuff, "%2d", i);
                else
                    sprintf((char *)IObuff, "%2d %s", i, (char *)fname);
                msg_outtrans_attr(IObuff, i == qf_lists[qf_curlist].qf_index
                        ? highlight_attr[(int)(HLF_L)] : highlight_attr[(int)(HLF_D)]);
                if (qfp->qf_lnum == 0)
                    IObuff[0] = '\000';
                else if (qfp->qf_col == 0)
                    sprintf((char *)IObuff, ":%ld", qfp->qf_lnum);
                else
                    sprintf((char *)IObuff, ":%ld col %d",
                                                   qfp->qf_lnum, qfp->qf_col);
                sprintf((char *)IObuff + strlen((char *)(IObuff)), "%s: ",
                                  (char *)qf_types(qfp->qf_type, qfp->qf_nr));
                msg_puts_attr(IObuff, highlight_attr[(int)(HLF_N)]);
                qf_fmt_text(qfp->qf_text, IObuff, (1024+1));
                msg_prt_line(IObuff);
                out_flush();
                need_return = 1;
                last_printed = i;
            }
        }
        if (more_back)
        {
            more_back = more_back * 2 - 1;
            while (i > last_printed - more_back && i > idx1)
            {
                do
                {
                    qfp = qfp->qf_prev;
                    --i;
                }
                while (i > idx1 && !qfp->qf_valid && !all);
            }
            more_back = 0;
        }
        else
        {
            qfp = qfp->qf_next;
            ++i;
        }
        ui_breakcheck();
    }
    more_back_used = 0;
}
    static void qf_fmt_text(text, buf, bufsize)
    char_u *text;
    char_u *buf;
    int bufsize;
{
    int i;
    char_u *p = skipwhite(text);
    for (i = 0; *p != '\000' && i < bufsize - 1; ++i)
    {
        if (*p == '\n')
        {
            buf[i] = ' ';
            while (*++p != '\000')
                if (!((*p) == ' ' || (*p) == '\t') && *p != '\n')
                    break;
        }
        else
            buf[i] = *p++;
    }
    buf[i] = '\000';
}
    void qf_age(eap)
    exarg_T *eap;
{
    int count;
    if (eap->addr_count != 0)
        count = eap->line2;
    else
        count = 1;
    while (count--)
    {
        if (eap->cmdidx == CMD_colder)
        {
            if (qf_curlist == 0)
            {
                emsg((char_u *)(((char *)("E380: At bottom of quickfix stack"))));
                return;
            }
            --qf_curlist;
        }
        else
        {
            if (qf_curlist >= qf_listcount - 1)
            {
                emsg((char_u *)(((char *)("E381: At top of quickfix stack"))));
                return;
            }
            ++qf_curlist;
        }
    }
    qf_msg();
}
    static void qf_msg()
{
    smsg((char_u *)((char *)("error list %d of %d; %d errors")),
            qf_curlist + 1, qf_listcount, qf_lists[qf_curlist].qf_count);
    qf_update_buffer();
}
    static void qf_free(idx)
    int idx;
{
    struct qf_line *qfp;
    while (qf_lists[idx].qf_count)
    {
        qfp = qf_lists[idx].qf_start->qf_next;
        vim_free(qf_lists[idx].qf_start->qf_text);
        vim_free(qf_lists[idx].qf_start);
        qf_lists[idx].qf_start = qfp;
        --qf_lists[idx].qf_count;
    }
}
   void qf_mark_adjust(line1, line2, amount, amount_after)
    linenr_T line1;
    linenr_T line2;
    long amount;
    long amount_after;
{
    int i;
    struct qf_line *qfp;
    int idx;
    for (idx = 0; idx < qf_listcount; ++idx)
        if (qf_lists[idx].qf_count)
            for (i = 0, qfp = qf_lists[idx].qf_start;
                       i < qf_lists[idx].qf_count; ++i, qfp = qfp->qf_next)
                if (qfp->qf_fnum == curbuf->b_fnum)
                {
                    if (qfp->qf_lnum >= line1 && qfp->qf_lnum <= line2)
                    {
                        if (amount == (0x7fffffffL))
                            qfp->qf_cleared = 1;
                        else
                            qfp->qf_lnum += amount;
                    }
                    else if (amount_after && qfp->qf_lnum > line2)
                        qfp->qf_lnum += amount_after;
                }
}
    static char_u * qf_types(c, nr)
    int c, nr;
{
    static char_u buf[20];
    static char_u cc[3];
    char_u *p;
    if (c == 'W' || c == 'w')
        p = (char_u *)" warning";
    else if (c == 'I' || c == 'i')
        p = (char_u *)" info";
    else if (c == 'E' || c == 'e' || (c == 0 && nr > 0))
        p = (char_u *)" error";
    else if (c == 0 || c == 1)
        p = (char_u *)"";
    else
    {
        cc[0] = ' ';
        cc[1] = c;
        cc[2] = '\000';
        p = cc;
    }
    if (nr <= 0)
        return p;
    sprintf((char *)buf, "%s %3d", (char *)p, nr);
    return buf;
}
    void ex_cwindow(eap)
    exarg_T *eap;
{
    win_T *win;
    for (win = firstwin; win != ((void *)0); win = win->w_next)
        if (bt_quickfix(win->w_buffer))
            break;
    if (qf_lists[qf_curlist].qf_nonevalid || qf_curlist >= qf_listcount)
    {
        if (win != ((void *)0))
            ex_cclose(eap);
    }
    else if (win == ((void *)0))
        ex_copen(eap);
}
    void ex_cclose(eap)
    exarg_T *eap;
{
    win_T *win;
    for (win = firstwin; win != ((void *)0); win = win->w_next)
        if (bt_quickfix(win->w_buffer))
            break;
    if (win != ((void *)0))
        win_close(win, 0);
}
    void ex_copen(eap)
    exarg_T *eap;
{
    int height;
    buf_T *buf;
    win_T *win;
    if (eap->addr_count != 0)
        height = eap->line2;
    else
        height = 10;
    reset_VIsual_and_resel();
    need_mouse_correct = 1;
    for (win = firstwin; win != ((void *)0); win = win->w_next)
        if (bt_quickfix(win->w_buffer))
            break;
    if (win != ((void *)0))
        win_goto(win);
    else
    {
        win = curwin;
        win_goto(lastwin);
        if (win_split(height, 32) == 0)
            return;
        curwin->w_onebuf_opt.wo_scb = 0;
        buf = qf_find_buf();
        if (buf == ((void *)0))
        {
            (void)do_ecmd(0, ((void *)0), ((void *)0), ((void *)0), (linenr_T)1, 0x01);
            set_option_value((char_u *)"swf", 0L, ((void *)0), 4);
            set_option_value((char_u *)"bt", 0L, (char_u *)"quickfix",
                                                                   4);
            set_option_value((char_u *)"bh", 0L, (char_u *)"delete", 4);
            set_option_value((char_u *)"diff", 0L, (char_u *)"", 4);
        }
        else if (buf != curbuf)
            set_curbuf(buf, 0);
        if (curwin->w_width == Columns)
            win_setheight(height);
        curwin->w_onebuf_opt.wo_wfh = 1;
        if (win_valid(win))
            prevwin = win;
    }
    qf_fill_buffer();
    curwin->w_cursor.lnum = qf_lists[qf_curlist].qf_index;
    curwin->w_cursor.col = 0;
    check_cursor();
    update_topline();
}
     linenr_T qf_current_entry()
{
    return qf_lists[qf_curlist].qf_index;
}
    static int qf_win_pos_update(old_qf_index)
    int old_qf_index;
{
    win_T *win;
    int qf_index = qf_lists[qf_curlist].qf_index;
    for (win = firstwin; win != ((void *)0); win = win->w_next)
        if (bt_quickfix(win->w_buffer))
            break;
    if (win != ((void *)0)
            && qf_index <= win->w_buffer->b_ml.ml_line_count
            && old_qf_index != qf_index)
    {
        win_T *old_curwin = curwin;
        curwin = win;
        curbuf = win->w_buffer;
        if (qf_index > old_qf_index)
        {
            curwin->w_redraw_top = old_qf_index;
            curwin->w_redraw_bot = qf_index;
        }
        else
        {
            curwin->w_redraw_top = qf_index;
            curwin->w_redraw_bot = old_qf_index;
        }
        curwin->w_cursor.lnum = qf_index;
        curwin->w_cursor.col = 0;
        update_topline();
        redraw_later(10);
        curwin->w_redr_status = 1;
        curwin = old_curwin;
        curbuf = curwin->w_buffer;
    }
    return win != ((void *)0);
}
    static buf_T * qf_find_buf()
{
    buf_T *buf;
    for (buf = firstbuf; buf != ((void *)0); buf = buf->b_next)
        if (bt_quickfix(buf))
            break;
    return buf;
}
    static void qf_update_buffer()
{
    buf_T *buf;
    aco_save_T aco;
    buf = qf_find_buf();
    if (buf != ((void *)0))
    {
        aucmd_prepbuf(&aco, buf);
        qf_fill_buffer();
        aucmd_restbuf(&aco);
        (void)qf_win_pos_update(0);
    }
}
    static void qf_fill_buffer()
{
    linenr_T lnum;
    struct qf_line *qfp;
    buf_T *errbuf;
    int len;
    int old_KeyTyped = KeyTyped;
    while ((curbuf->b_ml.ml_flags & 1) == 0)
        (void)ml_delete((linenr_T)1, 0);
    if (qf_curlist < qf_listcount)
    {
        qfp = qf_lists[qf_curlist].qf_start;
        for (lnum = 0; lnum < qf_lists[qf_curlist].qf_count; ++lnum)
        {
            if (qfp->qf_fnum != 0
                    && (errbuf = buflist_findnr(qfp->qf_fnum)) != ((void *)0)
                    && errbuf->b_fname != ((void *)0))
            {
                if (qfp->qf_type == 1)
                    strcpy((char *)(IObuff), (char *)(gettail(errbuf->b_fname)));
                else
                    strcpy((char *)(IObuff), (char *)(errbuf->b_fname));
                len = (int)strlen((char *)(IObuff));
            }
            else
                len = 0;
            IObuff[len++] = '|';
            if (qfp->qf_lnum > 0)
            {
                sprintf((char *)IObuff + len, "%ld", qfp->qf_lnum);
                len += (int)strlen((char *)(IObuff + len));
                if (qfp->qf_col > 0)
                {
                    sprintf((char *)IObuff + len, " col %d", qfp->qf_col);
                    len += (int)strlen((char *)(IObuff + len));
                }
                sprintf((char *)IObuff + len, "%s",
                                  (char *)qf_types(qfp->qf_type, qfp->qf_nr));
                len += (int)strlen((char *)(IObuff + len));
            }
            IObuff[len++] = '|';
            IObuff[len++] = ' ';
            qf_fmt_text(qfp->qf_text, IObuff + len, (1024+1) - len);
            if (ml_append(lnum, IObuff, (colnr_T)strlen((char *)(IObuff)) + 1, 0)
                                                                      == 0)
                break;
            qfp = qfp->qf_next;
        }
        (void)ml_delete(lnum + 1, 0);
    }
    check_lnums(1);
    set_option_value((char_u *)"ft", 0L, (char_u *)"qf", 4);
    curbuf->b_p_ma = 0;
    apply_autocmds(EVENT_BUFREADPOST, (char_u *)"quickfix", ((void *)0),
                                                               0, curbuf);
    apply_autocmds(EVENT_BUFWINENTER, (char_u *)"quickfix", ((void *)0),
                                                               0, curbuf);
    redraw_curbuf_later(40);
    KeyTyped = old_KeyTyped;
}
    int bt_quickfix(buf)
    buf_T *buf;
{
    return (buf->b_p_bt[0] == 'q');
}
    int bt_nofile(buf)
    buf_T *buf;
{
    return (buf->b_p_bt[0] == 'n' && buf->b_p_bt[2] == 'f');
}
    int bt_dontwrite(buf)
    buf_T *buf;
{
    return (buf->b_p_bt[0] == 'n');
}
    int bt_dontwrite_msg(buf)
    buf_T *buf;
{
    if (bt_dontwrite(buf))
    {
        emsg((char_u *)(((char *)("E382: Cannot write, 'buftype' option is set"))));
        return 1;
    }
    return 0;
}
    int buf_hide(buf)
    buf_T *buf;
{
    switch (buf->b_p_bh[0])
    {
        case 'u':
        case 'w':
        case 'd': return 0;
        case 'h': return 1;
    }
    return (p_hid || cmdmod.hide);
}
    void ex_make(eap)
    exarg_T *eap;
{
    char_u *name;
    char_u *cmd;
    unsigned len;
    autowrite_all();
    name = get_mef_name();
    if (name == ((void *)0))
        return;
    unlink((char *)(name));
    len = (unsigned)strlen((char *)(p_shq)) * 2 + (unsigned)strlen((char *)(eap->arg)) + 1;
    if (*p_sp != '\000')
        len += (unsigned)strlen((char *)(p_sp)) + (unsigned)strlen((char *)(name)) + 3;
    cmd = alloc(len);
    if (cmd == ((void *)0))
        return;
    sprintf((char *)cmd, "%s%s%s", (char *)p_shq, (char *)eap->arg,
                                                               (char *)p_shq);
    if (*p_sp != '\000')
        append_redir(cmd, p_sp, name);
    if (msg_col == 0)
        msg_didout = 0;
    msg_start();
    msg_puts((char_u *)(":!"));
    msg_outtrans(cmd);
    do_shell(cmd, *p_sp != '\000' ? 8 : 0);
    if (qf_init(name, eap->cmdidx != CMD_make ? p_gefm : p_efm,
                                              eap->cmdidx != CMD_grepadd) > 0
            && !eap->forceit)
        qf_jump(0, 0, 0);
    unlink((char *)(name));
    vim_free(name);
    vim_free(cmd);
}
    static char_u * get_mef_name()
{
    char_u *p;
    char_u *name;
    static int start = -1;
    static int off = 0;
    struct stat sb;
    if (*p_mef == '\000')
    {
        name = vim_tempname('e');
        if (name == ((void *)0))
            emsg((char_u *)(((char *)(e_notmp))));
        return name;
    }
    for (p = p_mef; *p; ++p)
        if (p[0] == '#' && p[1] == '#')
            break;
    if (*p == '\000')
        return vim_strsave(p_mef);
    for (;;)
    {
        if (start == -1)
            start = mch_get_pid();
        else
            off += 19;
        name = alloc((unsigned)strlen((char *)(p_mef)) + 30);
        if (name == ((void *)0))
            break;
        strcpy((char *)(name), (char *)(p_mef));
        sprintf((char *)name + (p - p_mef), "%d%d", start, off);
        strcat((char *)(name), (char *)(p + 2));
        if (mch_getperm(name) < 0
                    && lstat(((char *)name), (&sb)) < 0
                )
            break;
        vim_free(name);
    }
    return name;
}
    void ex_cc(eap)
    exarg_T *eap;
{
    qf_jump(0,
            eap->addr_count > 0
            ? (int)eap->line2
            : eap->cmdidx == CMD_cc
                ? 0
                : (eap->cmdidx == CMD_crewind || eap->cmdidx == CMD_cfirst)
                    ? 1
                    : 32767,
            eap->forceit);
}
    void ex_cnext(eap)
    exarg_T *eap;
{
    qf_jump(eap->cmdidx == CMD_cnext
            ? 1
            : eap->cmdidx == CMD_cnfile
                ? 3
                : (-1),
            eap->addr_count > 0 ? (int)eap->line2 : 1, eap->forceit);
}
    void ex_cfile(eap)
    exarg_T *eap;
{
    if (*eap->arg != '\000')
        set_string_option_direct((char_u *)"ef", -1, eap->arg, 1);
    if (qf_init(p_ef, p_efm, 1) > 0 && eap->cmdidx == CMD_cfile)
        qf_jump(0, 0, eap->forceit);
}
    void ex_helpgrep(eap)
    exarg_T *eap;
{
    regmatch_T regmatch;
    char_u *save_cpo;
    char_u *p;
    int fcount;
    char_u **fnames;
    FILE *fd;
    int fi;
    struct qf_line *prevp = ((void *)0);
    long lnum;
    save_cpo = p_cpo;
    p_cpo = (char_u *)"";
    regmatch.regprog = vim_regcomp(eap->arg, 1 + 2);
    regmatch.rm_ic = 0;
    if (regmatch.regprog != ((void *)0))
    {
        qf_new_list();
        p = p_rtp;
        while (*p != '\000' && !got_int)
        {
            copy_option_part(&p, NameBuff, 1024, ",");
            add_pathsep(NameBuff);
            strcat((char *)(NameBuff), (char *)("doc/*.txt"));
            if (gen_expand_wildcards(1, &NameBuff, &fcount,
                                             &fnames, 2|32) == 1
                    && fcount > 0)
            {
                for (fi = 0; fi < fcount && !got_int; ++fi)
                {
                    fd = fopen((char *)fnames[fi], "r");
                    if (fd != ((void *)0))
                    {
                        lnum = 1;
                        while (!vim_fgets(IObuff, (1024+1), fd) && !got_int)
                        {
                            if (vim_regexec(&regmatch, IObuff, (colnr_T)0))
                                if (qf_add_entry(&prevp,
                                            ((void *)0),
                                            fnames[fi],
                                            IObuff,
                                            lnum,
                                            0,
                                            0,
                                            0,
                                            1,
                                            1
                                            ) == 0)
                                {
                                    got_int = 1;
                                    break;
                                }
                            ++lnum;
                            line_breakcheck();
                        }
                        fclose(fd);
                    }
                }
                FreeWild(fcount, fnames);
            }
        }
        vim_free(regmatch.regprog);
        qf_lists[qf_curlist].qf_nonevalid = 0;
        qf_lists[qf_curlist].qf_ptr = qf_lists[qf_curlist].qf_start;
        qf_lists[qf_curlist].qf_index = 1;
    }
    p_cpo = save_cpo;
    qf_update_buffer();
    if (qf_lists[qf_curlist].qf_count > 0)
        qf_jump(0, 0, 0);
}
