typedef unsigned char char_u;
char_u *alloc (unsigned size);
enum auto_event
{
    EVENT_BUFADD = 0,
    EVENT_BUFNEW,
    EVENT_BUFDELETE,
    EVENT_BUFWIPEOUT,
    EVENT_BUFENTER,
    EVENT_BUFFILEPOST,
    EVENT_BUFFILEPRE,
    EVENT_BUFLEAVE,
    EVENT_BUFNEWFILE,
    EVENT_BUFREADPOST,
    EVENT_BUFREADPRE,
    EVENT_BUFREADCMD,
    EVENT_BUFUNLOAD,
    EVENT_BUFHIDDEN,
    EVENT_BUFWINENTER,
    EVENT_BUFWINLEAVE,
    EVENT_BUFWRITEPOST,
    EVENT_BUFWRITEPRE,
    EVENT_BUFWRITECMD,
    EVENT_CMDWINENTER,
    EVENT_CMDWINLEAVE,
    EVENT_FILEAPPENDPOST,
    EVENT_FILEAPPENDPRE,
    EVENT_FILEAPPENDCMD,
    EVENT_FILECHANGEDSHELL,
    EVENT_FILECHANGEDRO,
    EVENT_FILEREADPOST,
    EVENT_FILEREADPRE,
    EVENT_FILEREADCMD,
    EVENT_FILETYPE,
    EVENT_FILEWRITEPOST,
    EVENT_FILEWRITEPRE,
    EVENT_FILEWRITECMD,
    EVENT_FILTERREADPOST,
    EVENT_FILTERREADPRE,
    EVENT_FILTERWRITEPOST,
    EVENT_FILTERWRITEPRE,
    EVENT_FOCUSGAINED,
    EVENT_FOCUSLOST,
    EVENT_GUIENTER,
    EVENT_STDINREADPOST,
    EVENT_STDINREADPRE,
    EVENT_SYNTAX,
    EVENT_TERMCHANGED,
    EVENT_TERMRESPONSE,
    EVENT_USER,
    EVENT_VIMENTER,
    EVENT_VIMLEAVE,
    EVENT_VIMLEAVEPRE,
    EVENT_WINENTER,
    EVENT_WINLEAVE,
    EVENT_ENCODINGCHANGED,
    EVENT_CURSORHOLD,
    EVENT_FUNCUNDEFINED,
    EVENT_REMOTEREPLY,
    NUM_EVENTS
};
typedef enum auto_event EVENT_T;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int apply_autocmds (EVENT_T event, char_u *fname, char_u *fname_io, int force, buf_T *buf);
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
int diff_check_fill (win_T *wp, linenr_T lnum);
void getout (int exitval);
char_u *lalloc (long_u size, int message);
void maketitle (void);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
char_u *ml_get_buf (buf_T *buf, linenr_T lnum, int will_change);
void out_flush (void);
void redraw_later (int type);
int smsg (char_u *, ...);
extern char *strcpy (char *__restrict __dest, __const char *__restrict __src)
            ;
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
extern char *strncpy (char *__restrict __dest,
                      __const char *__restrict __src, size_t __n) ;
void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
void win_enter (win_T *wp, int undo_sync);
extern long Columns ;
extern char_u *IObuff;
extern long Rows
                            ;
extern int State ;
extern int VIsual_reselect;
extern int cmdwin_type ;
extern buf_T *curbuf ;
extern win_T *curwin;
extern int got_int ;
enum hlf_value
{
    HLF_8 = 0
    , HLF_AT
    , HLF_D
    , HLF_E
    , HLF_H
    , HLF_I
    , HLF_L
    , HLF_M
    , HLF_CM
    , HLF_N
    , HLF_R
    , HLF_S
    , HLF_SNC
    , HLF_C
    , HLF_T
    , HLF_V
    , HLF_VNC
    , HLF_W
    , HLF_WM
    , HLF_FL
    , HLF_FC
    , HLF_ADD
    , HLF_CHD
    , HLF_DED
    , HLF_TXD
    , HLF_COUNT
};
extern int highlight_attr[HLF_COUNT];
extern int need_maketitle ;
extern int need_wait_return ;
extern int usingNetbeans ;
int win_col_off (win_T *wp);
int win_col_off2 (win_T *wp);
int win_lbr_chartabsize (win_T *wp, char_u *s, colnr_T col, int *headp);
extern int VIsual_active ;
void check_topfill (win_T *wp, int down);
int diff_check (win_T *wp, linenr_T lnum);
typedef struct foldinfo
{
    int fi_level;
    int fi_lnum;
    int fi_low_level;
} foldinfo_T;
int hasFoldingWin (win_T *win, linenr_T lnum, linenr_T *firstp, linenr_T *lastp, int cache, foldinfo_T *infop);
extern int KeyTyped;
extern int must_redraw ;
enum key_extra
{
    KE_NAME = 3
    , KE_S_UP
    , KE_S_DOWN
    , KE_S_F1
    , KE_S_F2
    , KE_S_F3
    , KE_S_F4
    , KE_S_F5
    , KE_S_F6
    , KE_S_F7
    , KE_S_F8
    , KE_S_F9
    , KE_S_F10
    , KE_S_F11
    , KE_S_F12
    , KE_S_F13
    , KE_S_F14
    , KE_S_F15
    , KE_S_F16
    , KE_S_F17
    , KE_S_F18
    , KE_S_F19
    , KE_S_F20
    , KE_S_F21
    , KE_S_F22
    , KE_S_F23
    , KE_S_F24
    , KE_S_F25
    , KE_S_F26
    , KE_S_F27
    , KE_S_F28
    , KE_S_F29
    , KE_S_F30
    , KE_S_F31
    , KE_S_F32
    , KE_S_F33
    , KE_S_F34
    , KE_S_F35
    , KE_S_F36
    , KE_S_F37
    , KE_MOUSE
    , KE_LEFTMOUSE
    , KE_LEFTDRAG
    , KE_LEFTRELEASE
    , KE_MIDDLEMOUSE
    , KE_MIDDLEDRAG
    , KE_MIDDLERELEASE
    , KE_RIGHTMOUSE
    , KE_RIGHTDRAG
    , KE_RIGHTRELEASE
    , KE_IGNORE
    , KE_TAB
    , KE_S_TAB_OLD
    , KE_SNIFF
    , KE_XF1
    , KE_XF2
    , KE_XF3
    , KE_XF4
    , KE_XEND
    , KE_XHOME
    , KE_LEFTMOUSE_NM
    , KE_LEFTRELEASE_NM
    , KE_S_XF1
    , KE_S_XF2
    , KE_S_XF3
    , KE_S_XF4
    , KE_MOUSEDOWN
    , KE_MOUSEUP
    , KE_KINS
    , KE_KDEL
    , KE_CSI
    , KE_SNR
    , KE_PLUG
    , KE_CMDWIN
    , KE_C_LEFT
    , KE_C_RIGHT
    , KE_C_HOME
    , KE_C_END
    , KE_X1MOUSE
    , KE_X1DRAG
    , KE_X1RELEASE
    , KE_X2MOUSE
    , KE_X2DRAG
    , KE_X2RELEASE
    , KE_DROP
};
int check_timestamps (int focus);
int coladvance (colnr_T wcol);
void gui_update_cursor (int force, int clear_selection);
int hasFolding (linenr_T lnum, linenr_T *firstp, linenr_T *lastp);
win_T *mouse_find_win (int *rowp, int *colp);
void redraw_curbuf_later (int type);
void setcursor (void);void setmouse (void);
void update_screen (int type);
int vim_iswordc (int c);
typedef struct _GdkCursor GdkCursor;
typedef enum
{
  GDK_SHIFT_MASK = 1 << 0,
  GDK_LOCK_MASK = 1 << 1,
  GDK_CONTROL_MASK = 1 << 2,
  GDK_MOD1_MASK = 1 << 3,
  GDK_MOD2_MASK = 1 << 4,
  GDK_MOD3_MASK = 1 << 5,
  GDK_MOD4_MASK = 1 << 6,
  GDK_MOD5_MASK = 1 << 7,
  GDK_BUTTON1_MASK = 1 << 8,
  GDK_BUTTON2_MASK = 1 << 9,
  GDK_BUTTON3_MASK = 1 << 10,
  GDK_BUTTON4_MASK = 1 << 11,
  GDK_BUTTON5_MASK = 1 << 12,
  GDK_RELEASE_MASK = 1 << 13,
  GDK_MODIFIER_MASK = 0x3fff
} GdkModifierType;
typedef struct _GtkAccelGroup GtkAccelGroup;
struct _GtkAccelGroup
{
  guint ref_count;
  guint lock_count;
  GdkModifierType modifier_mask;
  GSList *attach_objects;
};
typedef enum
{
GDK_NUM_GLYPHS = 154,
GDK_X_CURSOR = 0,
GDK_ARROW = 2,
GDK_BASED_ARROW_DOWN = 4,
GDK_BASED_ARROW_UP = 6,
GDK_BOAT = 8,
GDK_BOGOSITY = 10,
GDK_BOTTOM_LEFT_CORNER = 12,
GDK_BOTTOM_RIGHT_CORNER = 14,
GDK_BOTTOM_SIDE = 16,
GDK_BOTTOM_TEE = 18,
GDK_BOX_SPIRAL = 20,
GDK_CENTER_PTR = 22,
GDK_CIRCLE = 24,
GDK_CLOCK = 26,
GDK_COFFEE_MUG = 28,
GDK_CROSS = 30,
GDK_CROSS_REVERSE = 32,
GDK_CROSSHAIR = 34,
GDK_DIAMOND_CROSS = 36,
GDK_DOT = 38,
GDK_DOTBOX = 40,
GDK_DOUBLE_ARROW = 42,
GDK_DRAFT_LARGE = 44,
GDK_DRAFT_SMALL = 46,
GDK_DRAPED_BOX = 48,
GDK_EXCHANGE = 50,
GDK_FLEUR = 52,
GDK_GOBBLER = 54,
GDK_GUMBY = 56,
GDK_HAND1 = 58,
GDK_HAND2 = 60,
GDK_HEART = 62,
GDK_ICON = 64,
GDK_IRON_CROSS = 66,
GDK_LEFT_PTR = 68,
GDK_LEFT_SIDE = 70,
GDK_LEFT_TEE = 72,
GDK_LEFTBUTTON = 74,
GDK_LL_ANGLE = 76,
GDK_LR_ANGLE = 78,
GDK_MAN = 80,
GDK_MIDDLEBUTTON = 82,
GDK_MOUSE = 84,
GDK_PENCIL = 86,
GDK_PIRATE = 88,
GDK_PLUS = 90,
GDK_QUESTION_ARROW = 92,
GDK_RIGHT_PTR = 94,
GDK_RIGHT_SIDE = 96,
GDK_RIGHT_TEE = 98,
GDK_RIGHTBUTTON = 100,
GDK_RTL_LOGO = 102,
GDK_SAILBOAT = 104,
GDK_SB_DOWN_ARROW = 106,
GDK_SB_H_DOUBLE_ARROW = 108,
GDK_SB_LEFT_ARROW = 110,
GDK_SB_RIGHT_ARROW = 112,
GDK_SB_UP_ARROW = 114,
GDK_SB_V_DOUBLE_ARROW = 116,
GDK_SHUTTLE = 118,
GDK_SIZING = 120,
GDK_SPIDER = 122,
GDK_SPRAYCAN = 124,
GDK_STAR = 126,
GDK_TARGET = 128,
GDK_TCROSS = 130,
GDK_TOP_LEFT_ARROW = 132,
GDK_TOP_LEFT_CORNER = 134,
GDK_TOP_RIGHT_CORNER = 136,
GDK_TOP_SIDE = 138,
GDK_TOP_TEE = 140,
GDK_TREK = 142,
GDK_UL_ANGLE = 144,
GDK_UMBRELLA = 146,
GDK_UR_ANGLE = 148,
GDK_WATCH = 150,
GDK_XTERM = 152,
 GDK_LAST_CURSOR,
  GDK_CURSOR_IS_PIXMAP = -1
} GdkCursorType;
typedef long guicolor_T;
  typedef GdkFont *GuiFont;
struct _GdkCursor
{
  GdkCursorType type;
};
typedef struct Gui
{
    int in_focus;
    int in_use;
    int starting;
    int shell_created;
    int dying;
    int dofork;
    int dragged_sb;
    win_T *dragged_wp;
    int pointer_hidden;
    int col;
    int row;
    int cursor_col;
    int cursor_row;
    char cursor_is_valid;
    int num_cols;
    int num_rows;
    int scroll_region_top;
    int scroll_region_bot;
    int scroll_region_left;
    int scroll_region_right;
    int highlight_mask;
    int scrollbar_width;
    int scrollbar_height;
    int left_sbar_x;
    int right_sbar_x;
    char menu_is_active;
    scrollbar_T bottom_sbar;
    int which_scrollbars[3];
    int prev_wrap;
    int char_width;
    int char_height;
    int char_ascent;
    int border_width;
    int border_offset;
    GuiFont norm_font;
    GuiFont bold_font;
    GuiFont ital_font;
    GuiFont boldital_font;
    GuiFont menu_font;
    guicolor_T back_pixel;
    guicolor_T norm_pixel;
    guicolor_T def_back_pixel;
    guicolor_T def_norm_pixel;
    int visibility;
    GdkCursor *blank_pointer;
    char_u *geom;
    GtkWidget *mainwin;
    GtkWidget *formwin;
    GtkWidget *drawarea;
    GtkWidget *menubar;
    GtkWidget *toolbar;
    GdkColor *fgcolor;
    GdkColor *bgcolor;
    GuiFont current_font;
    GdkGC *text_gc;
    GtkAccelGroup *accel_group;
    GtkWidget *fontdlg;
    char_u *fontname;
    GtkWidget *filedlg;
    char_u *browse_fname;
    char *rsrc_input_method;
    char *rsrc_preedit_type_name;
} gui_T;
extern gui_T gui;
extern char_u *ScreenLines ;
extern pos_T VIsual;
extern int mod_mask ;
extern int mouse_col;
extern int mouse_row;
extern int p_smd;
extern int redraw_cmdline ;
typedef struct _XDisplay Display;
Display *gui_mch_get_display (void);
int no_console_input (void);
typedef long int __time_t;
typedef __time_t time_t;
extern time_t time (time_t *__timer) ;
extern int VIsual_mode ;
extern char_u *p_go;
extern long p_verbose;
extern int starting ;
extern Display *xterm_dpy ;
void cursor_on (void);
extern int exiting ;
extern int exmode_active ;
extern int silent_mode ;
void settmode (int tmode);
extern frame_T *topframe;
void clip_copy_modeless_selection (int both);
void redrawcmdline (void);
typedef unsigned long Atom;
typedef gulong GdkAtom;
typedef struct VimClipboard
{
    int available;
    int owned;
    pos_T start;
    pos_T end;
    int vmode;
    short_u origin_row;
    short_u origin_start_col;
    short_u origin_end_col;
    short_u word_start_col;
    short_u word_end_col;
    pos_T prev;
    short_u state;
    short_u mode;
    Atom sel_atom;
    GdkAtom gtk_sel_atom;
} VimClipboard;
extern VimClipboard clip_star;
typedef struct _GdkIC GdkIC;
extern int p_imdisable;
extern GdkIC *xic ;
extern int close (int __fd) ;
extern int dup (int __fd) ;
void gui_write (char_u *s, int len);
typedef int __ssize_t;
typedef __ssize_t ssize_t;
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
int get_real_state (void);
extern int KeyStuffed;
extern int mapped_ctrl_c ;
extern int vgetc_im_active;
extern int redo_VIsual_busy ;
void add_to_input_buf (char_u *s, int len);
int check_col (int col);
int check_row (int row);
void check_shellsize (void);
int stl_connected (win_T *wp);
void clip_clear_selection (void);
extern int screen_Rows ;
extern int screen_Columns ;
typedef unsigned int int_u;
void clip_start_selection (int col, int row, int repeated_click);
void clip_process_selection (int button, int col, int row, int_u repeated_click);
void gui_set_shellsize (int mustset, int fit_to_display);
extern linenr_T gui_prev_topline ;
extern int gui_prev_topfill ;
void gui_mch_update (void);
void gui_undraw_cursor (void);
void gui_update_scrollbars (int force);
int input_available (void);
extern int isatty (int __fd) ;
extern unsigned *LineOffset ;
extern int full_screen ;
typedef unsigned int Cardinal;
void preserve_exit (void);
void clip_lose_selection (VimClipboard *cbd);
int vim_is_input_buf_full (void);
extern char *XFetchBuffer(
    Display* ,
    int* ,
    int
);
extern char *XtMalloc(
    Cardinal
);
extern void XtFree(
    char*
);
void clip_yank_selection (int type, char_u *str, long len, VimClipboard *cbd);
void trash_input_buf (void);
void gui_mch_iconify (void);
extern int ctrl_c_interrupts ;
extern int XFree(
    void*
);
void clip_get_selection (VimClipboard *cbd);
int clip_convert_selection (char_u **str, long_u *len, VimClipboard *cbd);
extern VimClipboard clip_plus;
extern int XFlush(
    Display*
);
extern int XSync(
    Display* ,
    int
);
int gui_wait_for_chars (long wtime);
void update_curbuf (int type);
int plines_win (win_T *wp, linenr_T lnum, int winheight);
int plines_win_nofill (win_T *wp, linenr_T lnum, int winheight);
int plines (linenr_T lnum);
extern int mouse_dragging ;
void check_visual_highlight (void);
void end_visual_mode (void);
void may_start_select (int c);
extern int mouse_past_bottom ;
extern int mouse_past_eol ;
void clip_free_selection (VimClipboard *cbd);
void clip_own_selection (VimClipboard *cbd);
void clip_gen_set_selection (VimClipboard *cbd);
int clip_isautosel (void);
extern long p_wd;
extern int cur_tmode ;
void screen_draw_rectangle (int row, int col, int height, int width, int invert);
void clip_update_selection (void);
void repeat_message (void);
extern Atom XInternAtom(
    Display* ,
    const char* ,
    int
);
typedef void* XtPointer;
typedef char Boolean;
typedef unsigned long XID;
typedef XID Window;
typedef unsigned long Time;
typedef XID Drawable;
typedef XID Colormap;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int mode;
        int detail;
} XFocusChangeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        char key_vector[32];
} XKeymapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int x, y;
        int width, height;
        int count;
} XExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int state;
} XVisibilityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        int override_redirect;
} XCreateWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
} XDestroyWindowEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int from_configure;
} XUnmapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int override_redirect;
} XMapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
} XMapRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        Window parent;
        int x, y;
        int override_redirect;
} XReparentEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int override_redirect;
} XConfigureEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int x, y;
} XGravityEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int width, height;
} XResizeRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int x, y;
        int width, height;
        int border_width;
        Window above;
        int detail;
        unsigned long value_mask;
} XConfigureRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window event;
        Window window;
        int place;
} XCirculateEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window parent;
        Window window;
        int place;
} XCirculateRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        int request;
        int first_keycode;
        int count;
} XMappingEvent;
typedef struct {
        int type;
        Display *display;
        XID resourceid;
        unsigned long serial;
        unsigned char error_code;
        unsigned char request_code;
        unsigned char minor_code;
} XErrorEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
} XAnyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int keycode;
        int same_screen;
} XKeyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        unsigned int button;
        int same_screen;
} XButtonEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        unsigned int state;
        char is_hint;
        int same_screen;
} XMotionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Window root;
        Window subwindow;
        Time time;
        int x, y;
        int x_root, y_root;
        int mode;
        int detail;
        int same_screen;
        int focus;
        unsigned int state;
} XCrossingEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int x, y;
        int width, height;
        int count;
        int major_code;
        int minor_code;
} XGraphicsExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Drawable drawable;
        int major_code;
        int minor_code;
} XNoExposeEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom atom;
        Time time;
        int state;
} XPropertyEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom selection;
        Time time;
} XSelectionClearEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window owner;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionRequestEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window requestor;
        Atom selection;
        Atom target;
        Atom property;
        Time time;
} XSelectionEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Colormap colormap;
        int new;
        int state;
} XColormapEvent;
typedef struct {
        int type;
        unsigned long serial;
        int send_event;
        Display *display;
        Window window;
        Atom message_type;
        int format;
        union {
                char b[20];
                short s[10];
                long l[5];
                } data;
} XClientMessageEvent;
typedef union _XEvent {
        int type;
        XAnyEvent xany;
        XKeyEvent xkey;
        XButtonEvent xbutton;
        XMotionEvent xmotion;
        XCrossingEvent xcrossing;
        XFocusChangeEvent xfocus;
        XExposeEvent xexpose;
        XGraphicsExposeEvent xgraphicsexpose;
        XNoExposeEvent xnoexpose;
        XVisibilityEvent xvisibility;
        XCreateWindowEvent xcreatewindow;
        XDestroyWindowEvent xdestroywindow;
        XUnmapEvent xunmap;
        XMapEvent xmap;
        XMapRequestEvent xmaprequest;
        XReparentEvent xreparent;
        XConfigureEvent xconfigure;
        XGravityEvent xgravity;
        XResizeRequestEvent xresizerequest;
        XConfigureRequestEvent xconfigurerequest;
        XCirculateEvent xcirculate;
        XCirculateRequestEvent xcirculaterequest;
        XPropertyEvent xproperty;
        XSelectionClearEvent xselectionclear;
        XSelectionRequestEvent xselectionrequest;
        XSelectionEvent xselection;
        XColormapEvent xcolormap;
        XClientMessageEvent xclient;
        XMappingEvent xmapping;
        XErrorEvent xerror;
        XKeymapEvent xkeymap;
        long pad[24];
} XEvent;
typedef struct _XtAppStruct *XtAppContext;
typedef struct {
    unsigned char *value;
    Atom encoding;
    int format;
    unsigned long nitems;
} XTextProperty;
typedef struct _WidgetRec *Widget;
extern Boolean XtDispatchEvent(
    XEvent*
);
void mch_delay (long msec, int ignoreinput);
int read_from_input_buf (char_u *buf, long maxlen);
void fill_input_buf (int exit_on_error);
extern int read_cmd_fd ;
extern XtAppContext app_context ;
extern void XFreeStringList(
    char**
);
extern int XCheckTypedEvent(
    Display* ,
    int ,
    XEvent*
);
typedef enum {
    XStringStyle,
    XCompoundTextStyle,
    XTextStyle,
    XStdICCTextStyle,
    XUTF8StringStyle
} XICCEncodingStyle;
extern int XmbTextPropertyToTextList(
    Display* display,
    const XTextProperty* text_prop,
    char*** list_return,
    int* count_return
);
typedef Boolean (*XtConvertSelectionProc)(
    Widget ,
    Atom* ,
    Atom* ,
    Atom* ,
    XtPointer* ,
    unsigned long* ,
    int*
);
typedef void (*XtLoseSelectionProc)(
    Widget ,
    Atom*
);
typedef void (*XtSelectionDoneProc)(
    Widget ,
    Atom* ,
    Atom*
);
typedef void (*XtSelectionCallbackProc)(
    Widget ,
    XtPointer ,
    Atom* ,
    Atom* ,
    XtPointer ,
    unsigned long* ,
    int*
);
extern void XtToolkitInitialize(
    void
);
extern XtAppContext XtCreateApplicationContext(
    void
);
extern void XtDisownSelection(
    Widget ,
    Atom ,
    Time
);
extern int clip_autoselect ;
extern int clip_autoselectml ;
void mch_write (char_u *s, int len);
int mch_inchar (char_u *buf, int maxlen, long wtime);
int mch_char_avail (void);
void mch_suspend (void);
int mch_get_shellsize (void);
void mch_set_shellsize (void);
void mch_new_shellsize (void);
void mch_breakcheck (void);
int clip_xterm_own_selection (VimClipboard *cbd);
void clip_xterm_lose_selection (VimClipboard *cbd);
void clip_xterm_request_selection (VimClipboard *cbd);
void clip_xterm_set_selection (VimClipboard *cbd);
void set_number_default (char *name, long val);
void set_mouse_topline (win_T *wp);
void clip_copy_selection (void);
int clip_gen_own_selection (VimClipboard *cbd);
void clip_gen_lose_selection (VimClipboard *cbd);
void read_error_exit (void);
int mouse_comp_pos (win_T *win, int *rowp, int *colp, linenr_T *lnump);
int vcol2col (win_T *wp, linenr_T lnum, int vcol);
void win_drag_status_line (win_T *dragwin, int offset);
void win_drag_vsep_line (win_T *dragwin, int offset);
int gui_get_shellsize (void);
void gui_new_shellsize (void);
void gui_update_cursor_later (void);
void gui_mch_invert_rectangle (int r, int c, int nr, int nc);
void clip_mch_request_selection (VimClipboard *cbd);
void clip_mch_lose_selection (VimClipboard *cbd);
int clip_mch_own_selection (VimClipboard *cbd);
void clip_mch_set_selection (VimClipboard *cbd);
void netbeans_gutter_click (linenr_T lnum);
extern int XmbTextListToTextProperty(
    Display* display,
    char** list,
    int count,
    XICCEncodingStyle style,
    XTextProperty* text_prop_return
);
extern Boolean XtOwnSelection(
    Widget ,
    Atom ,
    Time ,
    XtConvertSelectionProc ,
    XtLoseSelectionProc ,
    XtSelectionDoneProc
);
extern void XtGetSelectionValue(
    Widget ,
    Atom ,
    Atom ,
    XtSelectionCallbackProc ,
    XtPointer ,
    Time
);
    void ui_write(s, len)
    char_u *s;
    int len;
{
    if (gui.in_use && !gui.dying && !gui.starting)
    {
        gui_write(s, len);
        if (p_wd)
            gui_wait_for_chars(p_wd);
        return;
    }
    if (!silent_mode)
    {
        mch_write(s, len);
    }
}
static char_u *ta_str = ((void *)0);
static int ta_off;
static int ta_len;
    void ui_inchar_undo(s, len)
    char_u *s;
    int len;
{
    char_u *new;
    int newlen;
    newlen = len;
    if (ta_str != ((void *)0))
        newlen += ta_len - ta_off;
    new = alloc(newlen);
    if (new != ((void *)0))
    {
        if (ta_str != ((void *)0))
        {
            memmove((char *)(new), (char *)(ta_str + ta_off), (size_t)(ta_len - ta_off));
            memmove((char *)(new + ta_len - ta_off), (char *)(s), (size_t)len);
            vim_free(ta_str);
        }
        else
            memmove((char *)(new), (char *)(s), (size_t)len);
        ta_str = new;
        ta_len = newlen;
        ta_off = 0;
    }
}
    int ui_inchar(buf, maxlen, wtime)
    char_u *buf;
    int maxlen;
    long wtime;
{
    int retval = 0;
    if (ta_str != ((void *)0))
    {
        if (maxlen >= ta_len - ta_off)
        {
            memmove((char *)(buf), (char *)(ta_str + ta_off), (size_t)ta_len);
            vim_free(ta_str);
            ta_str = ((void *)0);
            return ta_len;
        }
        memmove((char *)(buf), (char *)(ta_str + ta_off), (size_t)maxlen);
        ta_off += maxlen;
        return maxlen;
    }
    if (no_console_input())
    {
        static int count = 0;
        retval = mch_inchar(buf, maxlen, 10L);
        if (retval > 0)
            return retval;
        if (wtime == -1 && ++count == 1000)
            read_error_exit();
        buf[0] = '\015';
        return 1;
    }
    if (mapped_ctrl_c && (wtime == -1 || wtime > 100L))
        ctrl_c_interrupts = 0;
    if (gui.in_use)
    {
        if (gui_wait_for_chars(wtime))
            retval = read_from_input_buf(buf, (long)maxlen);
    }
    else
        retval = mch_inchar(buf, maxlen, wtime);
    ctrl_c_interrupts = 1;
    return retval;
}
    int ui_char_avail()
{
    if (gui.in_use)
    {
        gui_mch_update();
        return input_available();
    }
    if (no_console_input())
        return 0;
    return mch_char_avail();
}
    void ui_delay(msec, ignoreinput)
    long msec;
    int ignoreinput;
{
    if (gui.in_use && !ignoreinput)
        gui_wait_for_chars(msec);
    else
        mch_delay(msec, ignoreinput);
}
    void ui_suspend()
{
    if (gui.in_use)
    {
        gui_mch_iconify();
        return;
    }
    mch_suspend();
}
    int ui_get_shellsize()
{
    int retval;
    if (gui.in_use)
        retval = gui_get_shellsize();
    else
        retval = mch_get_shellsize();
    check_shellsize();
    if (retval == 1)
    {
        set_number_default("lines", Rows);
        set_number_default("columns", Columns);
    }
    return retval;
}
    void ui_set_shellsize(mustset)
    int mustset;
{
    if (gui.in_use)
        gui_set_shellsize(mustset,
                0
                );
    else
        mch_set_shellsize();
}
    void ui_new_shellsize()
{
    if (full_screen && !exiting)
    {
        if (gui.in_use)
            gui_new_shellsize();
        else
            mch_new_shellsize();
    }
}
    void ui_breakcheck()
{
    if (gui.in_use)
        gui_mch_update();
    else
        mch_breakcheck();
}
    void clip_init(can_use)
    int can_use;
{
    VimClipboard *cb;
    cb = &clip_star;
    for (;;)
    {
        cb->available = can_use;
        cb->owned = 0;
        cb->start.lnum = 0;
        cb->start.col = 0;
        cb->end.lnum = 0;
        cb->end.col = 0;
        cb->state = 0;
        if (cb == &clip_plus)
            break;
        cb = &clip_plus;
    }
}
    void clip_update_selection()
{
    pos_T start, end;
    if (!redo_VIsual_busy && VIsual_active && (State & 0x01))
    {
        if ((((VIsual).lnum != (curwin->w_cursor).lnum) ? (VIsual).lnum < (curwin->w_cursor).lnum : (VIsual).col != (curwin->w_cursor).col ? (VIsual).col < (curwin->w_cursor).col : (VIsual).coladd < (curwin->w_cursor).coladd))
        {
            start = VIsual;
            end = curwin->w_cursor;
        }
        else
        {
            start = curwin->w_cursor;
            end = VIsual;
        }
        if (!(((clip_star.start).lnum == (start).lnum) && ((clip_star.start).col == (start).col) && ((clip_star.start).coladd == (start).coladd)) || !(((clip_star.end).lnum == (end).lnum) && ((clip_star.end).col == (end).col) && ((clip_star.end).coladd == (end).coladd))
                                            || clip_star.vmode != VIsual_mode)
        {
            clip_clear_selection();
            clip_star.start = start;
            clip_star.end = end;
            clip_star.vmode = VIsual_mode;
            clip_free_selection(&clip_star);
            clip_own_selection(&clip_star);
            clip_gen_set_selection(&clip_star);
        }
    }
}
    void clip_own_selection(cbd)
    VimClipboard *cbd;
{
    if (!cbd->owned && cbd->available)
    {
        cbd->owned = (clip_gen_own_selection(cbd) == 1);
        if (cbd == &clip_star)
        {
            if (cbd->owned
                    && get_real_state() == 0x02
                    && clip_isautosel()
                    && highlight_attr[(int)(HLF_V)] != highlight_attr[(int)(HLF_VNC)])
                redraw_curbuf_later(25);
        }
    }
}
    void clip_lose_selection(cbd)
    VimClipboard *cbd;
{
    int was_owned = cbd->owned;
    int visual_selection = (cbd == &clip_star);
    clip_free_selection(cbd);
    cbd->owned = 0;
    if (visual_selection)
        clip_clear_selection();
    clip_gen_lose_selection(cbd);
    if (visual_selection)
    {
        if (was_owned
                && get_real_state() == 0x02
                && clip_isautosel()
                && highlight_attr[(int)(HLF_V)] != highlight_attr[(int)(HLF_VNC)])
        {
            update_curbuf(25);
            setcursor();
            cursor_on();
            out_flush();
            if (gui.in_use)
                gui_update_cursor(1, 0);
        }
    }
}
    void clip_copy_selection()
{
    if (VIsual_active && (State & 0x01) && clip_star.available)
    {
        if (clip_isautosel())
            clip_update_selection();
        clip_free_selection(&clip_star);
        clip_own_selection(&clip_star);
        if (clip_star.owned)
            clip_get_selection(&clip_star);
        clip_gen_set_selection(&clip_star);
    }
}
    void clip_auto_select()
{
    if (clip_isautosel())
        clip_copy_selection();
}
    int clip_isautosel()
{
    return (
            gui.in_use ? (vim_strchr(p_go, 'a') != ((void *)0)) :
            clip_autoselect);
}
static int clip_compare_pos (int row1, int col1, int row2, int col2);
static void clip_invert_area (int, int, int, int, int how);
static void clip_invert_rectangle (int row, int col, int height, int width, int invert);
static void clip_get_word_boundaries (VimClipboard *, int, int);
static int clip_get_line_end (int);
static void clip_update_modeless_selection (VimClipboard *, int, int, int, int);
    void clip_modeless(button, is_click, is_drag)
    int button;
    int is_click;
    int is_drag;
{
    int repeat;
    repeat = ((clip_star.mode == 0
                || clip_star.mode == 2)
                                              && (mod_mask & 0x10))
            || (clip_star.mode == 1
                                             && (mod_mask & 0x20));
    if (is_click && button == 0x02)
    {
        if (clip_star.state == 0)
            clip_start_selection(mouse_col, mouse_row, 0);
        clip_process_selection(button, mouse_col, mouse_row, repeat);
    }
    else if (is_click)
        clip_start_selection(mouse_col, mouse_row, repeat);
    else if (is_drag)
    {
        if (clip_star.state != 0)
            clip_process_selection(button, mouse_col, mouse_row, repeat);
    }
    else
        clip_process_selection(0x03, mouse_col, mouse_row, 0);
}
    static int clip_compare_pos(row1, col1, row2, col2)
    int row1;
    int col1;
    int row2;
    int col2;
{
    if (row1 > row2) return(1);
    if (row1 < row2) return(-1);
    if (col1 > col2) return(1);
    if (col1 < col2) return(-1);
                     return(0);
}
    void clip_start_selection(col, row, repeated_click)
    int col;
    int row;
    int repeated_click;
{
    VimClipboard *cb = &clip_star;
    if (cb->state == 2)
        clip_clear_selection();
    row = check_row(row);
    col = check_col(col);
    cb->start.lnum = row;
    cb->start.col = col;
    cb->end = cb->start;
    cb->origin_row = (short_u)cb->start.lnum;
    cb->state = 1;
    if (repeated_click)
    {
        if (++cb->mode > 2)
            cb->mode = 0;
    }
    else
        cb->mode = 0;
    if (gui.in_use)
        gui_undraw_cursor();
    switch (cb->mode)
    {
        case 0:
            cb->origin_start_col = cb->start.col;
            cb->word_end_col = clip_get_line_end((int)cb->start.lnum);
            break;
        case 1:
            clip_get_word_boundaries(cb, (int)cb->start.lnum, cb->start.col);
            cb->origin_start_col = cb->word_start_col;
            cb->origin_end_col = cb->word_end_col;
            clip_invert_area((int)cb->start.lnum, cb->word_start_col,
                            (int)cb->end.lnum, cb->word_end_col, 2);
            cb->start.col = cb->word_start_col;
            cb->end.col = cb->word_end_col;
            break;
        case 2:
            clip_invert_area((int)cb->start.lnum, 0, (int)cb->start.lnum,
                            (int)Columns, 2);
            cb->start.col = 0;
            cb->end.col = Columns;
            break;
    }
    cb->prev = cb->start;
}
    void clip_process_selection(button, col, row, repeated_click)
    int button;
    int col;
    int row;
    int_u repeated_click;
{
    VimClipboard *cb = &clip_star;
    int diff;
    int slen = 1;
    if (button == 0x03)
    {
        if (cb->start.lnum == cb->end.lnum && cb->start.col == cb->end.col)
        {
            if (gui.in_use)
                gui_update_cursor(0, 0);
            cb->state = 0;
            return;
        }
        if (clip_isautosel()
                || (
                    gui.in_use ? (vim_strchr(p_go, 'A') != ((void *)0)) :
                    clip_autoselectml))
            clip_copy_modeless_selection(0);
        if (gui.in_use)
            gui_update_cursor(0, 0);
        cb->state = 2;
        return;
    }
    row = check_row(row);
    col = check_col(col);
    if (col == (int)cb->prev.col && row == cb->prev.lnum && !repeated_click)
        return;
    if (cb->state == 2 && button == 0x02)
    {
        if (clip_compare_pos(row, col, (int)cb->start.lnum, cb->start.col) < 0
                || (clip_compare_pos(row, col,
                                           (int)cb->end.lnum, cb->end.col) < 0
                    && (((cb->start.lnum == cb->end.lnum
                            && cb->end.col - col > col - cb->start.col))
                        || ((diff = (cb->end.lnum - row) -
                                                   (row - cb->start.lnum)) > 0
                            || (diff == 0 && col < (int)(cb->start.col +
                                                         cb->end.col) / 2)))))
        {
            cb->origin_row = (short_u)cb->end.lnum;
            cb->origin_start_col = cb->end.col - 1;
            cb->origin_end_col = cb->end.col;
        }
        else
        {
            cb->origin_row = (short_u)cb->start.lnum;
            cb->origin_start_col = cb->start.col;
            cb->origin_end_col = cb->start.col;
        }
        if (cb->mode == 1 && !repeated_click)
            cb->mode = 0;
    }
    cb->state = 1;
    if (repeated_click && ++cb->mode > 2)
        cb->mode = 0;
    switch (cb->mode)
    {
        case 0:
            if (row != cb->prev.lnum)
                cb->word_end_col = clip_get_line_end(row);
            if (clip_compare_pos(row, col, cb->origin_row,
                                                   cb->origin_start_col) >= 0)
            {
                if (col >= (int)cb->word_end_col)
                    clip_update_modeless_selection(cb, cb->origin_row,
                            cb->origin_start_col, row, (int)Columns);
                else
                {
                    clip_update_modeless_selection(cb, cb->origin_row,
                            cb->origin_start_col, row, col + slen);
                }
            }
            else
            {
                if (col >= (int)cb->word_end_col)
                    clip_update_modeless_selection(cb, row, cb->word_end_col,
                            cb->origin_row, cb->origin_start_col + slen);
                else
                    clip_update_modeless_selection(cb, row, col,
                            cb->origin_row, cb->origin_start_col + slen);
            }
            break;
        case 1:
            if (row == cb->prev.lnum && col >= (int)cb->word_start_col
                    && col < (int)cb->word_end_col && !repeated_click)
                return;
            clip_get_word_boundaries(cb, row, col);
            if (clip_compare_pos(row, col, cb->origin_row,
                    cb->origin_start_col) >= 0)
                clip_update_modeless_selection(cb, cb->origin_row,
                        cb->origin_start_col, row, cb->word_end_col);
            else
                clip_update_modeless_selection(cb, row, cb->word_start_col,
                        cb->origin_row, cb->origin_end_col);
            break;
        case 2:
            if (row == cb->prev.lnum && !repeated_click)
                return;
            if (clip_compare_pos(row, col, cb->origin_row,
                    cb->origin_start_col) >= 0)
                clip_update_modeless_selection(cb, cb->origin_row, 0, row,
                        (int)Columns);
            else
                clip_update_modeless_selection(cb, row, 0, cb->origin_row,
                        (int)Columns);
            break;
    }
    cb->prev.lnum = row;
    cb->prev.col = col;
}
    void clip_may_redraw_selection(row, col, len)
    int row, col;
    int len;
{
    int start = col;
    int end = col + len;
    if (clip_star.state != 0
            && row >= clip_star.start.lnum
            && row <= clip_star.end.lnum)
    {
        if (row == clip_star.start.lnum && start < (int)clip_star.start.col)
            start = clip_star.start.col;
        if (row == clip_star.end.lnum && end > (int)clip_star.end.col)
            end = clip_star.end.col;
        if (end > start)
            clip_invert_area(row, start, row, end, 0);
    }
}
    void clip_clear_selection()
{
    VimClipboard *cb = &clip_star;
    if (cb->state == 0)
        return;
    clip_invert_area((int)cb->start.lnum, cb->start.col, (int)cb->end.lnum,
                                                     cb->end.col, 1);
    cb->state = 0;
}
    void clip_may_clear_selection(row1, row2)
    int row1, row2;
{
    if (clip_star.state == 2
            && row2 >= clip_star.start.lnum
            && row1 <= clip_star.end.lnum)
        clip_clear_selection();
}
    void clip_scroll_selection(rows)
    int rows;
{
    int lnum;
    if (clip_star.state == 0)
        return;
    lnum = clip_star.start.lnum - rows;
    if (lnum <= 0)
        clip_star.start.lnum = 0;
    else if (lnum >= screen_Rows)
        clip_star.state = 0;
    else
        clip_star.start.lnum = lnum;
    lnum = clip_star.end.lnum - rows;
    if (lnum < 0)
        clip_star.state = 0;
    else if (lnum >= screen_Rows)
        clip_star.end.lnum = screen_Rows - 1;
    else
        clip_star.end.lnum = lnum;
}
    static void clip_invert_area(row1, col1, row2, col2, how)
    int row1;
    int col1;
    int row2;
    int col2;
    int how;
{
    int invert = 0;
    if (how == 2)
        invert = 1;
    if (clip_compare_pos(row1, col1, row2, col2) > 0)
    {
        int tmp_row, tmp_col;
        tmp_row = row1;
        tmp_col = col1;
        row1 = row2;
        col1 = col2;
        row2 = tmp_row;
        col2 = tmp_col;
    }
    else if (how == 3)
        invert = 1;
    if (row1 == row2)
    {
        clip_invert_rectangle(row1, col1, 1, col2 - col1, invert);
    }
    else
    {
        if (col1 > 0)
        {
            clip_invert_rectangle(row1, col1, 1, (int)Columns - col1, invert);
            row1++;
        }
        if (col2 < Columns - 1)
        {
            clip_invert_rectangle(row2, 0, 1, col2, invert);
            row2--;
        }
        if (row2 >= row1)
            clip_invert_rectangle(row1, 0, row2 - row1 + 1, (int)Columns,
                                                                      invert);
    }
}
    static void clip_invert_rectangle(row, col, height, width, invert)
    int row;
    int col;
    int height;
    int width;
    int invert;
{
    if (gui.in_use)
        gui_mch_invert_rectangle(row, col, height, width);
    else
        screen_draw_rectangle(row, col, height, width, invert);
}
    void clip_copy_modeless_selection(both)
    int both;
{
    char_u *buffer;
    char_u *bufp;
    int row;
    int start_col;
    int end_col;
    int line_end_col;
    int add_newline_flag = 0;
    int len;
    int row1 = clip_star.start.lnum;
    int col1 = clip_star.start.col;
    int row2 = clip_star.end.lnum;
    int col2 = clip_star.end.col;
    if (row1 > row2)
    {
        row = row1; row1 = row2; row2 = row;
        row = col1; col1 = col2; col2 = row;
    }
    else if (row1 == row2 && col1 > col2)
    {
        row = col1; col1 = col2; col2 = row;
    }
    len = (row2 - row1 + 1) * Columns + 1;
    buffer = lalloc((long_u)len, 1);
    if (buffer == ((void *)0))
        return;
    for (bufp = buffer, row = row1; row <= row2; row++)
    {
        if (row == row1)
            start_col = col1;
        else
            start_col = 0;
        if (row == row2)
            end_col = col2;
        else
            end_col = Columns;
        line_end_col = clip_get_line_end(row);
        if (end_col >= Columns && (row < row2 || end_col > line_end_col))
        {
            end_col = line_end_col;
            if (end_col < start_col)
                end_col = start_col;
            if (row == row2)
                add_newline_flag = 1;
        }
        if (row > row1)
            *bufp++ = '\012';
        if (row < screen_Rows && end_col <= screen_Columns)
        {
            {
                strncpy((char *)(bufp), (char *)(ScreenLines + LineOffset[row] + start_col), (size_t)(end_col - start_col));
                bufp += end_col - start_col;
            }
        }
    }
    if (add_newline_flag)
        *bufp++ = '\012';
    clip_free_selection(&clip_star);
    clip_own_selection(&clip_star);
    clip_yank_selection(0, buffer, (long)(bufp - buffer), &clip_star);
    clip_gen_set_selection(&clip_star);
    if (both)
    {
        clip_free_selection(&clip_plus);
        clip_own_selection(&clip_plus);
        clip_yank_selection(0, buffer, (long)(bufp - buffer), &clip_plus);
        clip_gen_set_selection(&clip_plus);
    }
    vim_free(buffer);
}
    static void clip_get_word_boundaries(cb, row, col)
    VimClipboard *cb;
    int row;
    int col;
{
    int start_class;
    int temp_col;
    char_u *p;
    if (row >= screen_Rows || col >= screen_Columns)
        return;
    p = ScreenLines + LineOffset[row];
    start_class = (p[col] <= ' ' ? ' ' : vim_iswordc(p[col]));
    temp_col = col;
    for ( ; temp_col > 0; temp_col--)
        if ((p[temp_col - 1] <= ' ' ? ' ' : vim_iswordc(p[temp_col - 1])) != start_class
                )
            break;
    cb->word_start_col = temp_col;
    temp_col = col;
    for ( ; temp_col < screen_Columns; temp_col++)
        if ((p[temp_col] <= ' ' ? ' ' : vim_iswordc(p[temp_col])) != start_class
                )
            break;
    cb->word_end_col = temp_col;
}
    static int clip_get_line_end(row)
    int row;
{
    int i;
    if (row >= screen_Rows)
        return 0;
    for (i = screen_Columns; i > 0; i--)
        if (ScreenLines[LineOffset[row] + i - 1] != ' ')
            break;
    return i;
}
    static void clip_update_modeless_selection(cb, row1, col1, row2, col2)
    VimClipboard *cb;
    int row1;
    int col1;
    int row2;
    int col2;
{
    if (row1 != cb->start.lnum || col1 != (int)cb->start.col)
    {
        clip_invert_area(row1, col1, (int)cb->start.lnum, cb->start.col,
                                                                 3);
        cb->start.lnum = row1;
        cb->start.col = col1;
    }
    if (row2 != cb->end.lnum || col2 != (int)cb->end.col)
    {
        clip_invert_area((int)cb->end.lnum, cb->end.col, row2, col2,
                                                                 3);
        cb->end.lnum = row2;
        cb->end.col = col2;
    }
}
    int clip_gen_own_selection(cbd)
    VimClipboard *cbd;
{
    if (gui.in_use)
        return clip_mch_own_selection(cbd);
    else
        return clip_xterm_own_selection(cbd);
}
    void clip_gen_lose_selection(cbd)
    VimClipboard *cbd;
{
    if (gui.in_use)
        clip_mch_lose_selection(cbd);
    else
        clip_xterm_lose_selection(cbd);
}
    void clip_gen_set_selection(cbd)
    VimClipboard *cbd;
{
    if (gui.in_use)
        clip_mch_set_selection(cbd);
    else
        clip_xterm_set_selection(cbd);
}
    void clip_gen_request_selection(cbd)
    VimClipboard *cbd;
{
    if (gui.in_use)
        clip_mch_request_selection(cbd);
    else
        clip_xterm_request_selection(cbd);
}
static char_u inbuf[4096 + 6];
static int inbufcount = 0;
    int vim_is_input_buf_full()
{
    return (inbufcount >= 4096);
}
    int vim_is_input_buf_empty()
{
    return (inbufcount == 0);
}
    int vim_used_in_input_buf()
{
    return inbufcount;
}
    char_u * get_input_buf()
{
    garray_T *gap;
    gap = (garray_T *)alloc((unsigned)sizeof(garray_T));
    if (gap != ((void *)0))
    {
        gap->ga_data = alloc((unsigned)inbufcount + 1);
        if (gap->ga_data != ((void *)0))
            memmove((char *)(gap->ga_data), (char *)(inbuf), (size_t)inbufcount);
        gap->ga_len = inbufcount;
    }
    trash_input_buf();
    return (char_u *)gap;
}
    void set_input_buf(p)
    char_u *p;
{
    garray_T *gap = (garray_T *)p;
    if (gap != ((void *)0) && gap->ga_data != ((void *)0))
    {
        memmove((char *)(inbuf), (char *)(gap->ga_data), gap->ga_len);
        inbufcount = gap->ga_len;
    }
}
    void add_to_input_buf(s, len)
    char_u *s;
    int len;
{
    if (inbufcount + len > 4096 + 6)
        return;
    while (len--)
        inbuf[inbufcount++] = *s++;
}
    void add_to_input_buf_csi(char_u *str, int len)
{
    int i;
    char_u buf[2];
    for (i = 0; i < len; ++i)
    {
        add_to_input_buf(str + i, 1);
        if (str[i] == 0x9b)
        {
            buf[0] = 253;
            buf[1] = (int)KE_CSI;
            add_to_input_buf(buf, 2);
        }
    }
}
    void trash_input_buf()
{
    inbufcount = 0;
}
    int read_from_input_buf(buf, maxlen)
    char_u *buf;
    long maxlen;
{
    if (inbufcount == 0)
        fill_input_buf(1);
    if (maxlen > inbufcount)
        maxlen = inbufcount;
    memmove((char *)(buf), (char *)(inbuf), (size_t)maxlen);
    inbufcount -= maxlen;
    if (inbufcount)
        memmove((char *)(inbuf), (char *)(inbuf + maxlen), (size_t)inbufcount);
    return (int)maxlen;
}
    void fill_input_buf(exit_on_error)
    int exit_on_error;
{
    int len;
    int try;
    static int did_read_something = 0;
    if (gui.in_use)
    {
        gui_mch_update();
        return;
    }
    if (vim_is_input_buf_full())
        return;
    len = 0;
    for (try = 0; try < 100; ++try)
    {
        len = read(read_cmd_fd,
            (char *)inbuf + inbufcount, (size_t)((4096 - inbufcount)
                ));
        if (len > 0 || got_int)
            break;
        if (!did_read_something && !isatty(read_cmd_fd) && read_cmd_fd == 0)
        {
            int m = cur_tmode;
            settmode(0);
            close(0);
            dup(2);
            settmode(m);
        }
        if (!exit_on_error)
            return;
    }
    if (len <= 0 && !got_int)
        read_error_exit();
    if (len > 0)
        did_read_something = 1;
    if (got_int)
    {
        inbuf[inbufcount] = 3;
        inbufcount = 1;
    }
    else
    {
        while (len-- > 0)
        {
            if (inbuf[inbufcount] == 3 && ctrl_c_interrupts)
            {
                memmove((char *)(inbuf), (char *)(inbuf + inbufcount), (size_t)(len + 1));
                inbufcount = 0;
                got_int = 1;
            }
            ++inbufcount;
        }
    }
}
    void read_error_exit()
{
    if (silent_mode)
        getout(0);
    strcpy((char *)(IObuff), (char *)(((char *)("Vim: Error reading input, exiting...\n"))));
    preserve_exit();
}
    void ui_cursor_shape()
{
    if (gui.in_use)
        gui_update_cursor_later();
}
    int check_col(col)
    int col;
{
    if (col < 0)
        return 0;
    if (col >= (int)screen_Columns)
        return (int)screen_Columns - 1;
    return col;
}
    int check_row(row)
    int row;
{
    if (row < 0)
        return 0;
    if (row >= (int)screen_Rows)
        return (int)screen_Rows - 1;
    return row;
}
    void open_app_context()
{
    if (app_context == ((void *)0))
    {
        XtToolkitInitialize();
        app_context = XtCreateApplicationContext();
    }
}
static Atom vim_atom;
static Atom compound_text_atom;
static Atom text_atom;
static Atom targets_atom;
    void x11_setup_atoms(dpy)
    Display *dpy;
{
    vim_atom = XInternAtom(dpy, "_VIM_TEXT", 0);
    compound_text_atom = XInternAtom(dpy, "COMPOUND_TEXT", 0);
    text_atom = XInternAtom(dpy, "TEXT", 0);
    targets_atom = XInternAtom(dpy, "TARGETS", 0);
    clip_star.sel_atom = ((Atom) 1);
    clip_plus.sel_atom = XInternAtom(dpy, "CLIPBOARD", 0);
}
static void clip_x11_request_selection_cb (Widget, XtPointer, Atom *, Atom *, XtPointer, long_u *, int *);
    static void clip_x11_request_selection_cb(w, success, sel_atom, type, value, length,
                              format)
    Widget w;
    XtPointer success;
    Atom *sel_atom;
    Atom *type;
    XtPointer value;
    long_u *length;
    int *format;
{
    int motion_type;
    long_u len;
    char_u *p;
    char **text_list = ((void *)0);
    VimClipboard *cbd;
    if (*sel_atom == clip_plus.sel_atom)
        cbd = &clip_plus;
    else
        cbd = &clip_star;
    if (value == ((void *)0) || *length == 0)
    {
        clip_free_selection(cbd);
        *(int *)success = 0;
        return;
    }
    motion_type = 0;
    p = (char_u *)value;
    len = *length;
    if (*type == vim_atom)
    {
        motion_type = *p++;
        len--;
    }
    else if (*type == compound_text_atom || (
                *type == text_atom))
    {
        XTextProperty text_prop;
        int n_text = 0;
        int status;
        text_prop.value = (unsigned char *)value;
        text_prop.encoding = *type;
        text_prop.format = *format;
        text_prop.nitems = strlen((char *)(value));
        status = XmbTextPropertyToTextList(((gui.in_use) ? gui_mch_get_display() : xterm_dpy), &text_prop,
                                                         &text_list, &n_text);
        if (status != 0 || n_text < 1)
        {
            *(int *)success = 0;
            return;
        }
        p = (char_u *)text_list[0];
        len = strlen((char *)(p));
    }
    clip_yank_selection(motion_type, p, (long)len, cbd);
    if (text_list != ((void *)0))
        XFreeStringList(text_list);
    XtFree((char *)value);
    *(int *)success = 1;
}
    void clip_x11_request_selection(myShell, dpy, cbd)
    Widget myShell;
    Display *dpy;
    VimClipboard *cbd;
{
    XEvent event;
    Atom type;
    static int success;
    int i;
    int nbytes = 0;
    char_u *buffer;
    for (i = 0; i < 4; i++)
    {
        switch (i)
        {
            case 0: type = vim_atom; break;
            case 1: type = compound_text_atom; break;
            case 2: type = text_atom; break;
            default: type = ((Atom) 31);
        }
        XtGetSelectionValue(myShell, cbd->sel_atom, type,
            clip_x11_request_selection_cb, (XtPointer)&success, 0L);
        XFlush(dpy);
        for (;;)
        {
            if (XCheckTypedEvent(dpy, 31, &event))
                break;
            XSync(dpy, 0);
        }
        XtDispatchEvent(&event);
        if (success)
            return;
    }
    buffer = (char_u *)XFetchBuffer(dpy, &nbytes, 0);
    if (nbytes > 0)
    {
        clip_yank_selection(0, buffer, (long)nbytes, cbd);
        XFree((void *)buffer);
        if (p_verbose > 0)
            smsg((char_u *)((char *)("Used CUT_BUFFER0 instead of empty selection")) );
    }
}
static Boolean clip_x11_convert_selection_cb (Widget, Atom *, Atom *, Atom *, XtPointer *, long_u *, int *);
    static Boolean clip_x11_convert_selection_cb(w, sel_atom, target, type, value, length, format)
    Widget w;
    Atom *sel_atom;
    Atom *target;
    Atom *type;
    XtPointer *value;
    long_u *length;
    int *format;
{
    char_u *string;
    char_u *result;
    int motion_type;
    VimClipboard *cbd;
    if (*sel_atom == clip_plus.sel_atom)
        cbd = &clip_plus;
    else
        cbd = &clip_star;
    if (!cbd->owned)
        return 0;
    if (*target == targets_atom)
    {
        Atom *array;
        if ((array = (Atom *)XtMalloc((unsigned)(sizeof(Atom) * 5))) == ((void *)0))
            return 0;
        *value = (XtPointer)array;
        array[0] = ((Atom) 31);
        array[1] = targets_atom;
        array[2] = vim_atom;
        array[3] = text_atom;
        array[4] = compound_text_atom;
        *type = ((Atom) 4);
        *format = 32;
        *length = 5;
        return 1;
    }
    if ( *target != ((Atom) 31)
            && *target != vim_atom
            && *target != text_atom
            && *target != compound_text_atom)
        return 0;
    clip_get_selection(cbd);
    motion_type = clip_convert_selection(&string, length, cbd);
    if (motion_type < 0)
        return 0;
    if (*target == vim_atom)
        (*length)++;
    *value = XtMalloc((Cardinal)*length);
    result = (char_u *)*value;
    if (result == ((void *)0))
    {
        vim_free(string);
        return 0;
    }
    if (*target == ((Atom) 31))
    {
        memmove((char *)(result), (char *)(string), (size_t)(*length));
        *type = ((Atom) 31);
    }
    else if (*target == compound_text_atom
            || *target == text_atom)
    {
        XTextProperty text_prop;
        char *string_nt = (char *)alloc((unsigned)*length + 1);
        memmove((char *)(string_nt), (char *)(string), (size_t)*length);
        string_nt[*length] = '\000';
        XmbTextListToTextProperty(((gui.in_use) ? gui_mch_get_display() : xterm_dpy), (char **)&string_nt, 1,
                                              XCompoundTextStyle, &text_prop);
        vim_free(string_nt);
        XtFree(*value);
        *value = (XtPointer)(text_prop.value);
        *length = text_prop.nitems;
        *type = compound_text_atom;
    }
    else
    {
        result[0] = motion_type;
        memmove((char *)(result + 1), (char *)(string), (size_t)(*length - 1));
        *type = vim_atom;
    }
    *format = 8;
    vim_free(string);
    return 1;
}
static void clip_x11_lose_ownership_cb (Widget, Atom *);
    static void clip_x11_lose_ownership_cb(w, sel_atom)
    Widget w;
    Atom *sel_atom;
{
    if (*sel_atom == clip_plus.sel_atom)
        clip_lose_selection(&clip_plus);
    else
        clip_lose_selection(&clip_star);
}
    void clip_x11_lose_selection(myShell, cbd)
    Widget myShell;
    VimClipboard *cbd;
{
    XtDisownSelection(myShell, cbd->sel_atom, 0L);
}
    int clip_x11_own_selection(myShell, cbd)
    Widget myShell;
    VimClipboard *cbd;
{
    if (XtOwnSelection(myShell, cbd->sel_atom, 0L,
            clip_x11_convert_selection_cb, clip_x11_lose_ownership_cb,
                                                               ((void *)0)) == 0)
        return 0;
    return 1;
}
    void clip_x11_set_selection(cbd)
    VimClipboard *cbd;
{
}
    int jump_to_mouse(flags, inclusive, which_button)
    int flags;
    int *inclusive;
    int which_button;
{
    static int on_status_line = 0;
    static int on_sep_line = 0;
    static int prev_row = -1;
    static int prev_col = -1;
    static win_T *dragwin = ((void *)0);
    static int did_drag = 0;
    win_T *wp, *old_curwin;
    pos_T old_cursor;
    int count;
    int first;
    int row = mouse_row;
    int col = mouse_col;
    int mouse_char;
    mouse_past_bottom = 0;
    mouse_past_eol = 0;
    if (flags & 0x20)
    {
        if (dragwin != ((void *)0) && !did_drag)
            flags &= ~(0x01 | 0x04);
        dragwin = ((void *)0);
        did_drag = 0;
    }
    if ((flags & 0x04)
            && prev_row == mouse_row
            && prev_col == mouse_col)
    {
retnomove:
        if (on_status_line)
            return 2;
        if (on_sep_line)
            return 4;
        if (flags & 0x10)
        {
            end_visual_mode();
            redraw_curbuf_later(20);
        }
        if (cmdwin_type != 0 && row < (curwin->w_winrow))
            return 8;
        return 1;
    }
    prev_row = mouse_row;
    prev_col = mouse_col;
    if (flags & 0x08)
        goto retnomove;
    if (row >= 0 && row < Rows && col >= 0 && col <= Columns)
        mouse_char = ScreenLines[LineOffset[row] + col];
    else
        mouse_char = ' ';
    old_curwin = curwin;
    old_cursor = curwin->w_cursor;
    if (!(flags & 0x01))
    {
        if (row < 0 || col < 0)
            return 0;
        wp = mouse_find_win(&row, &col);
        dragwin = ((void *)0);
        if (row >= wp->w_height)
        {
            on_status_line = row - wp->w_height + 1;
            dragwin = wp;
        }
        else
            on_status_line = 0;
        if (col >= wp->w_width)
        {
            on_sep_line = col - wp->w_width + 1;
            dragwin = wp;
        }
        else
            on_sep_line = 0;
        if (on_status_line && on_sep_line)
        {
            if (stl_connected(wp))
                on_sep_line = 0;
            else
                on_status_line = 0;
        }
        if (VIsual_active
                && (wp->w_buffer != curwin->w_buffer
                    || (!on_status_line
                        && !on_sep_line
                        && (
                            col >= wp->w_onebuf_opt.wo_fdc
                                  + (cmdwin_type == 0 && wp == curwin ? 0 : 1)
                            )
                        && (flags & 0x10))))
        {
            end_visual_mode();
            redraw_curbuf_later(20);
        }
        if (cmdwin_type != 0 && wp != curwin)
        {
            if (wp != curwin->w_prev)
            {
                on_status_line = 0;
                dragwin = ((void *)0);
            }
            on_sep_line = 0;
            if (on_status_line)
                return 2;
            return 8;
        }
        if (dragwin == ((void *)0) || (flags & 0x20))
            win_enter(wp, 1);
        if (curwin != old_curwin)
            set_mouse_topline(curwin);
        if (on_status_line)
        {
            if (curwin == old_curwin)
                return 2;
            else
                return 2 | 0x100;
        }
        if (on_sep_line)
        {
            if (curwin == old_curwin)
                return 4;
            else
                return 4 | 0x100;
        }
        curwin->w_cursor.lnum = curwin->w_topline;
        gui_prev_topline = curwin->w_topline;
        gui_prev_topfill = curwin->w_topfill;
    }
    else if (on_status_line && which_button == 0x00)
    {
        if (dragwin != ((void *)0))
        {
            count = row - dragwin->w_winrow - dragwin->w_height + 1
                                                             - on_status_line;
            win_drag_status_line(dragwin, count);
            did_drag |= count;
        }
        return 2;
    }
    else if (on_sep_line && which_button == 0x00)
    {
        if (dragwin != ((void *)0))
        {
            count = col - dragwin->w_wincol - dragwin->w_width + 1
                                                                - on_sep_line;
            win_drag_vsep_line(dragwin, count);
            did_drag |= count;
        }
        return 4;
    }
    else
    {
        if (flags & 0x10)
        {
            end_visual_mode();
            redraw_curbuf_later(20);
        }
        if (cmdwin_type != 0 && row < (curwin->w_winrow))
            return 8;
        row -= (curwin->w_winrow);
        col -= (curwin->w_wincol);
        if (row < 0)
        {
            count = 0;
            for (first = 1; curwin->w_topline > 1; )
            {
                if (curwin->w_topfill < diff_check(curwin, curwin->w_topline))
                    ++count;
                else
                    count += plines(curwin->w_topline - 1);
                if (!first && count > -row)
                    break;
                first = 0;
                hasFolding(curwin->w_topline, &curwin->w_topline, ((void *)0));
                if (curwin->w_topfill < diff_check(curwin, curwin->w_topline))
                    ++curwin->w_topfill;
                else
                {
                    --curwin->w_topline;
                    curwin->w_topfill = 0;
                }
            }
            check_topfill(curwin, 0);
            curwin->w_valid &=
                      ~(0x01|0x10|0x20|0x40);
            redraw_later(10);
            row = 0;
        }
        else if (row >= curwin->w_height)
        {
            count = 0;
            for (first = 1; curwin->w_topline < curbuf->b_ml.ml_line_count; )
            {
                if (curwin->w_topfill > 0)
                    ++count;
                else
                    count += plines(curwin->w_topline);
                if (!first && count > row - curwin->w_height + 1)
                    break;
                first = 0;
                if (hasFolding(curwin->w_topline, ((void *)0), &curwin->w_topline)
                        && curwin->w_topline == curbuf->b_ml.ml_line_count)
                    break;
                if (curwin->w_topfill > 0)
                    --curwin->w_topfill;
                else
                {
                    ++curwin->w_topline;
                    curwin->w_topfill =
                                   diff_check_fill(curwin, curwin->w_topline);
                }
            }
            check_topfill(curwin, 0);
            redraw_later(10);
            curwin->w_valid &=
                      ~(0x01|0x10|0x20|0x40);
            row = curwin->w_height - 1;
        }
        else if (row == 0)
        {
            if (mouse_dragging
                    && curwin->w_cursor.lnum
                                       == curwin->w_buffer->b_ml.ml_line_count
                    && curwin->w_cursor.lnum == curwin->w_topline)
                curwin->w_valid &= ~(0x80);
        }
    }
    if (
            col >= curwin->w_onebuf_opt.wo_fdc
                                + (cmdwin_type == 0 ? 0 : 1)
       )
        mouse_char = ' ';
    if (mouse_comp_pos(curwin, &row, &col, &curwin->w_cursor.lnum))
        mouse_past_bottom = 1;
    if ((flags & 0x02) && !VIsual_active)
    {
        check_visual_highlight();
        VIsual = old_cursor;
        VIsual_active = 1;
        VIsual_reselect = 1;
        may_start_select('o');
        setmouse();
        if (p_smd)
            redraw_cmdline = 1;
    }
    curwin->w_curswant = col;
    curwin->w_set_curswant = 0;
    if (coladvance(col) == 0)
    {
        if (inclusive != ((void *)0))
            *inclusive = 1;
        mouse_past_eol = 1;
    }
    else if (inclusive != ((void *)0))
        *inclusive = 0;
    count = 1;
    if (curwin != old_curwin || curwin->w_cursor.lnum != old_cursor.lnum
            || curwin->w_cursor.col != old_cursor.col)
        count |= 0x100;
    if (mouse_char == '+')
        count |= 0x400;
    else if (mouse_char != ' ')
        count |= 0x200;
    return count;
}
    int mouse_comp_pos(win, rowp, colp, lnump)
    win_T *win;
    int *rowp;
    int *colp;
    linenr_T *lnump;
{
    int col = *colp;
    int row = *rowp;
    linenr_T lnum;
    int retval = 0;
    int off;
    int count;
    lnum = win->w_topline;
    while (row > 0)
    {
        if (win->w_onebuf_opt.wo_diff && !hasFoldingWin(win, lnum, ((void *)0), ((void *)0), 1, ((void *)0)))
        {
            if (lnum == win->w_topline)
                row -= win->w_topfill;
            else
                row -= diff_check_fill(win, lnum);
            count = plines_win_nofill(win, lnum, 1);
        }
        else
            count = plines_win(win, lnum, 1);
        if (count > row)
            break;
        (void)hasFoldingWin(win, lnum, ((void *)0), &lnum, 1, ((void *)0));
        if (lnum == win->w_buffer->b_ml.ml_line_count)
        {
            retval = 1;
            break;
        }
        row -= count;
        ++lnum;
    }
    if (!retval)
    {
        off = win_col_off(win) - win_col_off2(win);
        if (col < off)
            col = off;
        col += row * ((win->w_width) - off);
        col += win->w_skipcol;
    }
    if (!win->w_onebuf_opt.wo_wrap)
        col += win->w_leftcol;
    col -= win_col_off(win);
    if (col < 0)
    {
        if (usingNetbeans)
            netbeans_gutter_click(lnum);
        col = 0;
    }
    *colp = col;
    *rowp = row;
    *lnump = lnum;
    return retval;
}
    win_T * mouse_find_win(rowp, colp)
    int *rowp;
    int *colp;
{
    frame_T *fp;
    fp = topframe;
    for (;;)
    {
        if (fp->fr_layout == 0)
            break;
        if (fp->fr_layout == 1)
        {
            for (fp = fp->fr_child; fp->fr_next != ((void *)0); fp = fp->fr_next)
            {
                if (*colp < fp->fr_width)
                    break;
                *colp -= fp->fr_width;
            }
        }
        else
        {
            for (fp = fp->fr_child; fp->fr_next != ((void *)0); fp = fp->fr_next)
            {
                if (*rowp < fp->fr_height)
                    break;
                *rowp -= fp->fr_height;
            }
        }
    }
    return fp->fr_win;
}
    int get_fpos_of_mouse(mpos)
    pos_T *mpos;
{
    win_T *wp;
    int row = mouse_row;
    int col = mouse_col;
    if (row < 0 || col < 0)
        return 0;
    wp = mouse_find_win(&row, &col);
    if (row >= wp->w_height)
        return 2;
    if (col >= wp->w_width)
        return 4;
    if (wp != curwin)
        return 0;
    if (mouse_comp_pos(curwin, &row, &col, &mpos->lnum))
        return 2;
    mpos->col = vcol2col(wp, mpos->lnum, col);
    if (mpos->col > 0)
        --mpos->col;
    return 1;
}
    int vcol2col(wp, lnum, vcol)
    win_T *wp;
    linenr_T lnum;
    int vcol;
{
    int col = 0;
    int count = 0;
    char_u *ptr;
    ptr = ml_get_buf(wp->w_buffer, lnum, 0);
    while (count <= vcol && *ptr != '\000')
    {
        ++col;
        count += win_lbr_chartabsize(wp, ptr, count, ((void *)0));
            ++ptr;
    }
    return col;
}
    void ui_focus_change(in_focus)
    int in_focus;
{
    static time_t last_time = (time_t)0;
    int need_redraw = 0;
    if (in_focus && last_time + 2 < time(((void *)0)))
    {
        need_redraw = check_timestamps(
                gui.in_use
                );
        last_time = time(((void *)0));
    }
    need_redraw |= apply_autocmds(in_focus ? EVENT_FOCUSGAINED
                                : EVENT_FOCUSLOST, ((void *)0), ((void *)0), 0, curbuf);
    if (need_redraw)
    {
        need_wait_return = 0;
        if (State & 0x08)
            redrawcmdline();
        else if (State == (0x200 + 0x01) || State == 0x400 || State == 0x300
                || State == 0x600 || State == 0x800 || exmode_active)
            repeat_message();
        else if ((State & 0x01) || (State & 0x10))
        {
            if (must_redraw != 0)
                update_screen(0);
            setcursor();
        }
        cursor_on();
        out_flush();
        if (gui.in_use)
        {
            gui_update_cursor(0, 1);
            gui_update_scrollbars(0);
        }
    }
    if (need_maketitle)
        maketitle();
}
    void im_save_status(psave)
    long *psave;
{
    if (!p_imdisable && KeyTyped && !KeyStuffed
            && xic != ((void *)0)
            && (!gui.in_use || gui.in_focus)
        )
    {
        if (vgetc_im_active)
            *psave = 2;
        else if (*psave == 2)
            *psave = 0;
    }
}
