typedef unsigned char char_u;
typedef long linenr_T;
typedef struct
{
    short refcnt;
    char_u *matches[10];
} reg_extmatch_T;
typedef struct buf_state
{
    int bs_idx;
    long bs_flags;
    reg_extmatch_T *bs_extmatch;
} bufstate_T;
typedef struct growarray
{
    int ga_len;
    int ga_room;
    int ga_itemsize;
    int ga_growsize;
    void *ga_data;
} garray_T;
typedef unsigned int __u_int;
typedef int __pid_t;
typedef long int __clock_t;
typedef unsigned colnr_T;
typedef __u_int __uid_t;
typedef unsigned int size_t;
typedef struct window win_T;
typedef unsigned long __u_long;
typedef unsigned short short_u;
typedef unsigned long long_u;
typedef unsigned short disptick_T;
typedef struct
{
    linenr_T lnum;
    colnr_T col;
    colnr_T coladd;
} pos_T;
typedef struct
{
    int regstart;
    char_u reganch;
    char_u *regmust;
    int regmlen;
    unsigned regflags;
    char_u reghasz;
    char_u program[1];
} regprog_T;
typedef struct wininfo wininfo_T;
typedef struct
{
    int wo_diff;
    long wo_fdc;
    int wo_fen;
    char_u *wo_fdi;
    long wo_fdl;
    char_u *wo_fdm;
    long wo_fml;
    long wo_fdn;
    char_u *wo_fde;
    char_u *wo_fdt;
    char_u *wo_fmr;
    int wo_lbr;
    int wo_list;
    int wo_nu;
    int wo_wfh;
    int wo_pvw;
    long wo_scr;
    int wo_scb;
    int wo_wrap;
} winopt_T;
typedef struct u_entry u_entry_T;
typedef struct u_header u_header_T;
typedef struct m_info minfo_T;
typedef struct m_block mblock_T;
typedef struct block_hdr bhdr_T;
typedef struct memfile memfile_T;
typedef long blocknr_T;
typedef struct nr_trans NR_TRANS;
typedef struct ml_chunksize
{
    int mlcs_numlines;
    long mlcs_totalsize;
} chunksize_T;
typedef struct signlist signlist_T;
struct sp_syn
{
    int inc_tag;
    short id;
    short *cont_in_list;
};
typedef struct keyentry keyentry_T;
typedef struct syn_state synstate_T;
typedef struct mapblock mapblock_T;
typedef struct file_buffer buf_T;
typedef __u_long __ino_t;
struct wininfo
{
    wininfo_T *wi_next;
    wininfo_T *wi_prev;
    win_T *wi_win;
    pos_T wi_fpos;
    int wi_optset;
    winopt_T wi_opt;
    int wi_fold_manual;
    garray_T wi_folds;
};
struct u_entry
{
    u_entry_T *ue_next;
    linenr_T ue_top;
    linenr_T ue_bot;
    linenr_T ue_lcount;
    char_u **ue_array;
    long ue_size;
};
struct m_info
{
    long_u m_size;
    minfo_T *m_next;
};
struct block_hdr
{
    bhdr_T *bh_next;
    bhdr_T *bh_prev;
    bhdr_T *bh_hash_next;
    bhdr_T *bh_hash_prev;
    blocknr_T bh_bnum;
    char_u *bh_data;
    int bh_page_count;
    char bh_flags;
};
struct nr_trans
{
    NR_TRANS *nt_next;
    NR_TRANS *nt_prev;
    blocknr_T nt_old_bnum;
    blocknr_T nt_new_bnum;
};
typedef struct info_pointer
{
    blocknr_T ip_bnum;
    linenr_T ip_low;
    linenr_T ip_high;
    int ip_index;
} infoptr_T;
struct signlist
{
    int id;
    linenr_T lnum;
    int typenr;
    signlist_T *next;
    signlist_T *prev;
};
struct keyentry
{
    keyentry_T *next;
    struct sp_syn k_syn;
    short *next_list;
    short flags;
    char_u keyword[1];
};
struct syn_state
{
    synstate_T *sst_next;
    linenr_T sst_lnum;
    union
    {
        bufstate_T sst_stack[7];
        garray_T sst_ga;
    } sst_union;
    int sst_next_flags;
    short *sst_next_list;
    short sst_stacksize;
    disptick_T sst_tick;
    linenr_T sst_change_lnum;
};
struct mapblock
{
    mapblock_T *m_next;
    char_u *m_keys;
    int m_keylen;
    char_u *m_str;
    int m_mode;
    int m_noremap;
    char m_silent;
};
typedef __ino_t ino_t;
struct u_header
{
    u_header_T *uh_next;
    u_header_T *uh_prev;
    u_entry_T *uh_entry;
    u_entry_T *uh_getbot_entry;
    pos_T uh_cursor;
    long uh_cursor_vcol;
    int uh_flags;
    pos_T uh_namedm[('z' - 'a' + 1)];
};
struct m_block
{
    mblock_T *mb_next;
    size_t mb_size;
    minfo_T mb_info;
};
struct memfile
{
    char_u *mf_fname;
    char_u *mf_ffname;
    int mf_fd;
    bhdr_T *mf_free_first;
    bhdr_T *mf_used_first;
    bhdr_T *mf_used_last;
    unsigned mf_used_count;
    unsigned mf_used_count_max;
    bhdr_T *mf_hash[64];
    NR_TRANS *mf_trans[64];
    blocknr_T mf_blocknr_max;
    blocknr_T mf_blocknr_min;
    blocknr_T mf_neg_count;
    blocknr_T mf_infile_count;
    unsigned mf_page_size;
    int mf_dirty;
};
typedef struct memline
{
    linenr_T ml_line_count;
    memfile_T *ml_mfp;
    int ml_flags;
    infoptr_T *ml_stack;
    int ml_stack_top;
    int ml_stack_size;
    linenr_T ml_line_lnum;
    char_u *ml_line_ptr;
    bhdr_T *ml_locked;
    linenr_T ml_locked_low;
    linenr_T ml_locked_high;
    int ml_locked_lineadd;
    chunksize_T *ml_chunksize;
    int ml_numchunks;
    int ml_usedchunks;
} memline_T;
struct file_buffer
{
    memline_T b_ml;
    buf_T *b_next;
    buf_T *b_prev;
    int b_nwindows;
    int b_flags;
    char_u *b_ffname;
    char_u *b_sfname;
    char_u *b_fname;
    int b_dev;
    ino_t b_ino;
    int b_fnum;
    int b_changed;
    int b_changedtick;
    int b_saving;
    int b_mod_set;
    linenr_T b_mod_top;
    linenr_T b_mod_bot;
    long b_mod_xlines;
    wininfo_T *b_wininfo;
    long b_mtime;
    long b_mtime_read;
    size_t b_orig_size;
    int b_orig_mode;
    pos_T b_namedm[('z' - 'a' + 1)];
    pos_T b_visual_start;
    pos_T b_visual_end;
    int b_visual_mode;
    int b_visual_mode_eval;
    colnr_T b_visual_curswant;
    pos_T b_last_cursor;
    pos_T b_last_insert;
    pos_T b_last_change;
    char_u b_chartab[32];
    mapblock_T *(b_maphash[256]);
    mapblock_T *b_first_abbr;
    garray_T b_ucmds;
    pos_T b_op_start;
    pos_T b_op_end;
    int b_marks_read;
    u_header_T *b_u_oldhead;
    u_header_T *b_u_newhead;
    u_header_T *b_u_curhead;
    int b_u_numhead;
    int b_u_synced;
    char_u *b_u_line_ptr;
    linenr_T b_u_line_lnum;
    colnr_T b_u_line_colnr;
    mblock_T b_block_head;
    minfo_T *b_m_search;
    mblock_T *b_mb_current;
    int b_scanned;
    long b_p_iminsert;
    long b_p_imsearch;
    int b_p_initialized;
    int b_p_ai;
    int b_p_ai_nopaste;
    int b_p_ci;
    int b_p_bin;
    char_u *b_p_bh;
    char_u *b_p_bt;
    int b_p_bl;
    int b_p_cin;
    char_u *b_p_cino;
    char_u *b_p_cink;
    char_u *b_p_cinw;
    char_u *b_p_com;
    char_u *b_p_cms;
    char_u *b_p_cpt;
    int b_p_eol;
    int b_p_et;
    int b_p_et_nobin;
    char_u *b_p_ff;
    char_u *b_p_ft;
    char_u *b_p_fo;
    int b_p_inf;
    char_u *b_p_isk;
    char_u *b_p_def;
    char_u *b_p_inc;
    char_u *b_p_inex;
    char_u *b_p_inde;
    char_u *b_p_indk;
    char_u *b_p_key;
    char_u *b_p_kp;
    int b_p_lisp;
    char_u *b_p_mps;
    int b_p_ml;
    int b_p_ml_nobin;
    int b_p_ma;
    char_u *b_p_nf;
    int b_p_pi;
    int b_p_ro;
    long b_p_sw;
    int b_p_sn;
    int b_p_si;
    long b_p_sts;
    long b_p_sts_nopaste;
    char_u *b_p_sua;
    int b_p_swf;
    char_u *b_p_syn;
    long b_p_ts;
    int b_p_tx;
    long b_p_tw;
    long b_p_tw_nobin;
    long b_p_tw_nopaste;
    long b_p_wm;
    long b_p_wm_nobin;
    long b_p_wm_nopaste;
    char_u *b_p_gp;
    char_u *b_p_mp;
    char_u *b_p_efm;
    char_u *b_p_ep;
    char_u *b_p_path;
    int b_p_ar;
    char_u *b_p_tags;
    char_u *b_p_dict;
    char_u *b_p_tsr;
    int b_start_eol;
    int b_start_ffc;
    garray_T b_vars;
    int b_may_swap;
    int b_did_warn;
    int b_help;
    int b_shortname;
    keyentry_T **b_keywtab;
    keyentry_T **b_keywtab_ic;
    int b_syn_ic;
    garray_T b_syn_patterns;
    garray_T b_syn_clusters;
    int b_syn_containedin;
    int b_syn_sync_flags;
    short b_syn_sync_id;
    long b_syn_sync_minlines;
    long b_syn_sync_maxlines;
    long b_syn_sync_linebreaks;
    char_u *b_syn_linecont_pat;
    regprog_T *b_syn_linecont_prog;
    int b_syn_linecont_ic;
    int b_syn_topgrp;
    int b_syn_folditems;
    synstate_T *b_sst_array;
    int b_sst_len;
    synstate_T *b_sst_first;
    synstate_T *b_sst_firstfree;
    int b_sst_freecount;
    linenr_T b_sst_check_lnum;
    short_u b_sst_lasttick;
    signlist_T *b_signlist;
};
int bt_dontwrite (buf_T *buf);
void changed (void);
int emsg (char_u *s);
char_u *lalloc (long_u size, int message);
extern void *memmove (void *__dest, __const void *__src, size_t __n)
            ;
int ml_delete (linenr_T lnum, int message);
char_u *ml_get (linenr_T lnum);
int msg (char_u *s);
void setpcmark (void);
int smsg (char_u *, ...);
extern size_t strlen (__const char *__s) __attribute__ ((__pure__));
void u_sync (void);
void unchanged (buf_T *buf, int ff);void vim_free (void *x);
char_u *vim_strchr (char_u *string, int c);
extern char_u *IObuff;
extern buf_T *curbuf ;
typedef unsigned char guint8;
typedef signed short gint16;
typedef unsigned short guint16;
typedef unsigned int guint32;
typedef char gchar;
typedef int gint;
typedef unsigned short gushort;
typedef unsigned long gulong;
typedef unsigned int guint;
typedef void* gpointer;
typedef struct _GData GData;
typedef struct _GSList GSList;
typedef struct _GdkColor GdkColor;
typedef struct _GdkColormap GdkColormap;
typedef struct _GdkWindow GdkWindow;
typedef struct _GdkWindow GdkPixmap;
typedef struct _GdkWindow GdkBitmap;
typedef struct _GdkWindow GdkDrawable;
typedef struct _GdkGC GdkGC;
typedef struct _GdkFont GdkFont;
typedef enum
{
  GDK_FONT_FONT,
  GDK_FONT_FONTSET
} GdkFontType;
typedef struct _GtkObject GtkObject;
typedef struct _GtkObjectClass GtkObjectClass;
typedef struct _GtkStyle GtkStyle;
typedef struct _GtkStyleClass GtkStyleClass;
typedef struct _GtkThemeEngine GtkThemeEngine;
typedef struct _GtkRcStyle GtkRcStyle;
typedef struct _GtkWidget GtkWidget;
typedef struct _GtkRequisition GtkRequisition;
typedef struct _GtkAllocation GtkAllocation;
struct _GSList
{
  gpointer data;
  GSList *next;
};
struct _GdkColor
{
  gulong pixel;
  gushort red;
  gushort green;
  gushort blue;
};
struct _GdkWindow
{
  gpointer user_data;
};
struct _GdkGC
{
  gint dummy_var;
};
struct _GdkFont
{
  GdkFontType type;
  gint ascent;
  gint descent;
};
struct _GtkObject
{
  GtkObjectClass *klass;
  guint32 flags;
  guint ref_count;
  GData *object_data;
};
struct _GtkRequisition
{
  gint16 width;
  gint16 height;
};
struct _GtkAllocation
{
  gint16 x;
  gint16 y;
  guint16 width;
  guint16 height;
};
struct _GdkColormap
{
  gint size;
  GdkColor *colors;
};
struct _GtkStyle
{
  GtkStyleClass *klass;
  GdkColor fg[5];
  GdkColor bg[5];
  GdkColor light[5];
  GdkColor dark[5];
  GdkColor mid[5];
  GdkColor text[5];
  GdkColor base[5];
  GdkColor black;
  GdkColor white;
  GdkFont *font;
  GdkGC *fg_gc[5];
  GdkGC *bg_gc[5];
  GdkGC *light_gc[5];
  GdkGC *dark_gc[5];
  GdkGC *mid_gc[5];
  GdkGC *text_gc[5];
  GdkGC *base_gc[5];
  GdkGC *black_gc;
  GdkGC *white_gc;
  GdkPixmap *bg_pixmap[5];
  gint ref_count;
  gint attach_count;
  gint depth;
  GdkColormap *colormap;
  GtkThemeEngine *engine;
  gpointer engine_data;
  GtkRcStyle *rc_style;
  GSList *styles;
};
struct _GtkWidget
{
  GtkObject object;
  guint16 private_flags;
  guint8 state;
  guint8 saved_state;
  gchar *name;
  GtkStyle *style;
  GtkRequisition requisition;
  GtkAllocation allocation;
  GdkWindow *window;
  GtkWidget *parent;
};
typedef struct GuiScrollbar
{
    long ident;
    struct window *wp;
    int type;
    long value;
    long size;
    long max;
    int top;
    int height;
    int width;
    int status_height;
    GtkWidget *id;
    unsigned long handler_id;
} scrollbar_T;
typedef struct frame frame_T;
struct frame
{
    char fr_layout;
    int fr_width;
    int fr_height;
    int fr_newheight;
    frame_T *fr_parent;
    frame_T *fr_next;
    frame_T *fr_prev;
    frame_T *fr_child;
    win_T *fr_win;
};
typedef struct
{
    linenr_T lnum;
    colnr_T col;
} lpos_T;
typedef struct
{
    regprog_T *regprog;
    lpos_T startpos[10];
    lpos_T endpos[10];
    int rmm_ic;
} regmmatch_T;
typedef struct filemark
{
    pos_T mark;
    int fnum;
} fmark_T;
typedef struct arglist
{
    garray_T al_ga;
    int al_refcount;
} alist_T;
typedef struct w_line
{
    linenr_T wl_lnum;
    short_u wl_size;
    char wl_valid;
    char wl_folded;
    linenr_T wl_lastlnum;
} wline_T;
typedef struct xfilemark
{
    fmark_T fmark;
    char_u *fname;
} xfmark_T;
typedef struct taggy
{
    char_u *tagname;
    fmark_T fmark;
    int cur_match;
} taggy_T;
struct window
{
    buf_T *w_buffer;
    win_T *w_prev;
    win_T *w_next;
    frame_T *w_frame;
    pos_T w_cursor;
    colnr_T w_curswant;
    int w_set_curswant;
    char w_old_visual_mode;
    linenr_T w_old_cursor_lnum;
    colnr_T w_old_cursor_fcol;
    colnr_T w_old_cursor_lcol;
    linenr_T w_old_visual_lnum;
    colnr_T w_old_curswant;
    linenr_T w_topline;
    int w_topfill;
    int w_old_topfill;
    int w_botfill;
    int w_old_botfill;
    colnr_T w_leftcol;
    colnr_T w_skipcol;
    int w_winrow;
    int w_height;
    int w_status_height;
    int w_wincol;
    int w_width;
    int w_vsep_width;
    int w_valid;
    pos_T w_valid_cursor;
    colnr_T w_valid_leftcol;
    int w_cline_height;
    int w_cline_folded;
    int w_cline_row;
    colnr_T w_virtcol;
    int w_wrow, w_wcol;
    linenr_T w_botline;
    int w_empty_rows;
    int w_filler_rows;
    int w_lines_valid;
    wline_T *w_lines;
    garray_T w_folds;
    char w_fold_manual;
    char w_foldinvalid;
    int w_redr_type;
    int w_upd_rows;
    linenr_T w_redraw_top;
    linenr_T w_redraw_bot;
    int w_redr_status;
    pos_T w_ru_cursor;
    colnr_T w_ru_virtcol;
    linenr_T w_ru_topline;
    int w_ru_topfill;
    char w_ru_empty;
    int w_alt_fnum;
    alist_T *w_alist;
    int w_arg_idx;
    int w_arg_idx_invalid;
    char_u *w_localdir;
    winopt_T w_onebuf_opt;
    winopt_T w_allbuf_opt;
    long w_scbind_pos;
    garray_T w_vars;
    pos_T w_pcmark;
    pos_T w_prev_pcmark;
    xfmark_T w_jumplist[100];
    int w_jumplistlen;
    int w_jumplistidx;
    regmmatch_T w_match;
    int w_match_id;
    taggy_T w_tagstack[20];
    int w_tagstackidx;
    int w_tagstacklen;
    int w_fraction;
    int w_prev_fraction_row;
    scrollbar_T w_scrollbars[2];
};
extern win_T *curwin;
extern char_u *p_cpo;
extern long p_report;
extern int usingNetbeans ;
int virtual_active (void);
void changed_lines (linenr_T lnum, colnr_T col, linenr_T lnume, long xtra);
void check_cursor (void);
void mark_adjust (linenr_T line1, linenr_T line2, long amount, long amount_after);
int ml_append (linenr_T lnum, char_u *line, colnr_T len, int newfile);
int u_save (linenr_T top, linenr_T bot);
extern int KeyTyped;
void beginline (int flags);
void change_warning (int col);
void changed_bytes (linenr_T lnum, colnr_T col);
int coladvance (colnr_T wcol);
void foldOpenCursor (void);
int getviscol (void);
int ml_replace (linenr_T lnum, char_u *line, int copy);
extern char_u e_sandbox[] ;
extern unsigned fdo_flags;
extern int sandbox ;
void msgmore (long n);
void u_clearline (void);
extern int msg_silent ;
int ask_yesno (char_u *str, int direct);
void beep_flush (void);
extern char_u e_modifiable[] ;
void do_outofmem_msg (long_u size);
extern int undo_off ;
int file_ff_differs (buf_T *buf);
extern long p_ul;
void u_saveline (linenr_T lnum);
int netbeans_is_guarded (linenr_T top, linenr_T bot);
extern char_u e_guarded[] ;
static u_entry_T *u_get_headentry (void);
static void u_getbot (void);
static int u_savecommon (linenr_T, linenr_T, linenr_T);
static void u_doit (int count);
static void u_undoredo (void);
static void u_undo_end (void);
static void u_freelist (struct u_header *);
static void u_freeentry (u_entry_T *, long);
static char_u *u_blockalloc (long_u);
static void u_free_line (char_u *, int keep);
static char_u *u_alloc_line (unsigned);
static char_u *u_save_line (linenr_T);
static long u_newcount, u_oldcount;
static int undo_undoes = 0;
    int u_save_cursor()
{
    return (u_save((linenr_T)(curwin->w_cursor.lnum - 1),
                                      (linenr_T)(curwin->w_cursor.lnum + 1)));
}
    int u_save(top, bot)
    linenr_T top, bot;
{
    if (undo_off)
        return 1;
    if (top > curbuf->b_ml.ml_line_count ||
                            top >= bot || bot > curbuf->b_ml.ml_line_count + 1)
        return 0;
    if (top + 2 == bot)
        u_saveline((linenr_T)(top + 1));
    return (u_savecommon(top, bot, (linenr_T)0));
}
    int u_savesub(lnum)
    linenr_T lnum;
{
    if (undo_off)
        return 1;
    return (u_savecommon(lnum - 1, lnum + 1, lnum + 1));
}
    int u_inssub(lnum)
    linenr_T lnum;
{
    if (undo_off)
        return 1;
    return (u_savecommon(lnum - 1, lnum, lnum + 1));
}
    int u_savedel(lnum, nlines)
    linenr_T lnum;
    long nlines;
{
    if (undo_off)
        return 1;
    return (u_savecommon(lnum - 1, lnum + nlines,
                        nlines == curbuf->b_ml.ml_line_count ? 2 : lnum));
}
    static int u_savecommon(top, bot, newbot)
    linenr_T top, bot;
    linenr_T newbot;
{
    linenr_T lnum;
    long i;
    struct u_header *uhp;
    u_entry_T *uep;
    u_entry_T *prev_uep;
    long size;
    if (!curbuf->b_p_ma)
    {
        emsg((char_u *)(((char *)(e_modifiable))));
        return 0;
    }
    if (sandbox != 0)
    {
        emsg((char_u *)(((char *)(e_sandbox))));
        return 0;
    }
    if (usingNetbeans && netbeans_is_guarded(top, bot))
    {
        emsg((char_u *)(((char *)(e_guarded))));
        return 0;
    }
    change_warning(0);
    size = bot - top - 1;
    if (curbuf->b_u_synced)
    {
        while (curbuf->b_u_curhead != ((void *)0))
            u_freelist(curbuf->b_u_newhead);
        while (curbuf->b_u_numhead > p_ul && curbuf->b_u_oldhead != ((void *)0))
            u_freelist(curbuf->b_u_oldhead);
        if (p_ul < 0)
            return 1;
        uhp = (struct u_header *)u_alloc_line((unsigned)
                                                     sizeof(struct u_header));
        if (uhp == ((void *)0))
            goto nomem;
        uhp->uh_prev = ((void *)0);
        uhp->uh_next = curbuf->b_u_newhead;
        if (curbuf->b_u_newhead != ((void *)0))
            curbuf->b_u_newhead->uh_prev = uhp;
        uhp->uh_entry = ((void *)0);
        uhp->uh_getbot_entry = ((void *)0);
        uhp->uh_cursor = curwin->w_cursor;
        if (virtual_active() && curwin->w_cursor.coladd > 0)
            uhp->uh_cursor_vcol = getviscol();
        else
            uhp->uh_cursor_vcol = -1;
        uhp->uh_flags = (curbuf->b_changed ? 0x01 : 0) +
                       ((curbuf->b_ml.ml_flags & 1) ? 0x02 : 0);
        memmove((char *)(uhp->uh_namedm), (char *)(curbuf->b_namedm), sizeof(pos_T) * ('z' - 'a' + 1));
        curbuf->b_u_newhead = uhp;
        if (curbuf->b_u_oldhead == ((void *)0))
            curbuf->b_u_oldhead = uhp;
        ++curbuf->b_u_numhead;
    }
    else
    {
        if (size == 1)
        {
            uep = u_get_headentry();
            prev_uep = ((void *)0);
            for (i = 0; i < 10; ++i)
            {
                if (uep == ((void *)0))
                    break;
                if ((curbuf->b_u_newhead->uh_getbot_entry != uep
                            ? (uep->ue_top + uep->ue_size + 1
                                != (uep->ue_bot == 0
                                    ? curbuf->b_ml.ml_line_count + 1
                                    : uep->ue_bot))
                            : uep->ue_lcount != curbuf->b_ml.ml_line_count)
                        || (uep->ue_size > 1
                            && top >= uep->ue_top
                            && top + 2 <= uep->ue_top + uep->ue_size + 1))
                    break;
                if (uep->ue_size == 1 && uep->ue_top == top)
                {
                    if (i > 0)
                    {
                        u_getbot();
                        curbuf->b_u_synced = 0;
                        prev_uep->ue_next = uep->ue_next;
                        uep->ue_next = curbuf->b_u_newhead->uh_entry;
                        curbuf->b_u_newhead->uh_entry = uep;
                    }
                    if (newbot != 0)
                        uep->ue_bot = newbot;
                    else if (bot > curbuf->b_ml.ml_line_count)
                        uep->ue_bot = 0;
                    else
                    {
                        uep->ue_lcount = curbuf->b_ml.ml_line_count;
                        curbuf->b_u_newhead->uh_getbot_entry = uep;
                    }
                    return 1;
                }
                prev_uep = uep;
                uep = uep->ue_next;
            }
        }
        u_getbot();
    }
    uep = (u_entry_T *)u_alloc_line((unsigned)sizeof(u_entry_T));
    if (uep == ((void *)0))
        goto nomem;
    uep->ue_size = size;
    uep->ue_top = top;
    if (newbot != 0)
        uep->ue_bot = newbot;
    else if (bot > curbuf->b_ml.ml_line_count)
        uep->ue_bot = 0;
    else
    {
        uep->ue_lcount = curbuf->b_ml.ml_line_count;
        curbuf->b_u_newhead->uh_getbot_entry = uep;
    }
    if (size)
    {
        if ((uep->ue_array = (char_u **)u_alloc_line(
                                (unsigned)(sizeof(char_u *) * size))) == ((void *)0))
        {
            u_freeentry(uep, 0L);
            goto nomem;
        }
        for (i = 0, lnum = top + 1; i < size; ++i)
        {
            if ((uep->ue_array[i] = u_save_line(lnum++)) == ((void *)0))
            {
                u_freeentry(uep, i);
                goto nomem;
            }
        }
    }
    uep->ue_next = curbuf->b_u_newhead->uh_entry;
    curbuf->b_u_newhead->uh_entry = uep;
    curbuf->b_u_synced = 0;
    undo_undoes = 0;
    return 1;
nomem:
    msg_silent = 0;
    if (ask_yesno((char_u *)((char *)("No undo possible; continue anyway")), 1)
                                                                       == 'y')
    {
        undo_off = 1;
        return 1;
    }
    do_outofmem_msg((long_u)0);
    return 0;
}
    void u_undo(count)
    int count;
{
    if (curbuf->b_u_synced == 0)
    {
        u_sync();
        count = 1;
    }
    if (vim_strchr(p_cpo, 'u') == ((void *)0))
        undo_undoes = 1;
    else
        undo_undoes = !undo_undoes;
    u_doit(count);
}
    void u_redo(count)
    int count;
{
    if (vim_strchr(p_cpo, 'u') == ((void *)0))
        undo_undoes = 0;
    u_doit(count);
}
    static void u_doit(count)
    int count;
{
    if (!curbuf->b_p_ma)
    {
        emsg((char_u *)(((char *)(e_modifiable))));
        return;
    }
    if (sandbox != 0)
    {
        emsg((char_u *)(((char *)(e_sandbox))));
        return;
    }
    u_newcount = 0;
    u_oldcount = 0;
    while (count--)
    {
        if (undo_undoes)
        {
            if (curbuf->b_u_curhead == ((void *)0))
                curbuf->b_u_curhead = curbuf->b_u_newhead;
            else if (p_ul > 0)
                curbuf->b_u_curhead = curbuf->b_u_curhead->uh_next;
            if (curbuf->b_u_numhead == 0 || curbuf->b_u_curhead == ((void *)0))
            {
                curbuf->b_u_curhead = curbuf->b_u_oldhead;
                beep_flush();
                break;
            }
            u_undoredo();
        }
        else
        {
            if (curbuf->b_u_curhead == ((void *)0) || p_ul <= 0)
            {
                beep_flush();
                break;
            }
            u_undoredo();
            curbuf->b_u_curhead = curbuf->b_u_curhead->uh_prev;
        }
    }
    u_undo_end();
}
    static void u_undoredo()
{
    char_u **newarray = ((void *)0);
    linenr_T oldsize;
    linenr_T newsize;
    linenr_T top, bot;
    linenr_T lnum;
    linenr_T newlnum = (0x7fffffffL);
    long i;
    u_entry_T *uep, *nuep;
    u_entry_T *newlist = ((void *)0);
    int old_flags;
    int new_flags;
    pos_T namedm[('z' - 'a' + 1)];
    int empty_buffer;
    old_flags = curbuf->b_u_curhead->uh_flags;
    new_flags = (curbuf->b_changed ? 0x01 : 0) +
               ((curbuf->b_ml.ml_flags & 1) ? 0x02 : 0);
    setpcmark();
    memmove((char *)(namedm), (char *)(curbuf->b_namedm), sizeof(pos_T) * ('z' - 'a' + 1));
    curbuf->b_op_start.lnum = curbuf->b_ml.ml_line_count;
    curbuf->b_op_start.col = 0;
    curbuf->b_op_end.lnum = 0;
    curbuf->b_op_end.col = 0;
    for (uep = curbuf->b_u_curhead->uh_entry; uep != ((void *)0); uep = nuep)
    {
        top = uep->ue_top;
        bot = uep->ue_bot;
        if (bot == 0)
            bot = curbuf->b_ml.ml_line_count + 1;
        if (top > curbuf->b_ml.ml_line_count || top >= bot || bot > curbuf->b_ml.ml_line_count + 1)
        {
            emsg((char_u *)(((char *)("E438: u_undo: line numbers wrong"))));
            changed();
            return;
        }
        if (top < newlnum)
        {
            newlnum = top;
            curwin->w_cursor.lnum = top + 1;
        }
        oldsize = bot - top - 1;
        newsize = uep->ue_size;
        empty_buffer = 0;
        if (oldsize)
        {
            if ((newarray = (char_u **)u_alloc_line(
                            (unsigned)(sizeof(char_u *) * oldsize))) == ((void *)0))
            {
                do_outofmem_msg((long_u)(sizeof(char_u *) * oldsize));
                while (uep != ((void *)0))
                {
                    nuep = uep->ue_next;
                    u_freeentry(uep, uep->ue_size);
                    uep = nuep;
                }
                break;
            }
            for (lnum = bot - 1, i = oldsize; --i >= 0; --lnum)
            {
                if ((newarray[i] = u_save_line(lnum)) == ((void *)0))
                    do_outofmem_msg((long_u)0);
                if (curbuf->b_ml.ml_line_count == 1)
                    empty_buffer = 1;
                ml_delete(lnum, 0);
            }
        }
        if (newsize)
        {
            for (lnum = top, i = 0; i < newsize; ++i, ++lnum)
            {
                if (empty_buffer && lnum == 0)
                    ml_replace((linenr_T)1, uep->ue_array[i], 1);
                else
                    ml_append(lnum, uep->ue_array[i], (colnr_T)0, 0);
                u_free_line(uep->ue_array[i], 0);
            }
            u_free_line((char_u *)uep->ue_array, 0);
        }
        if (oldsize != newsize)
        {
            mark_adjust(top + 1, top + oldsize, (long)(0x7fffffffL),
                                               (long)newsize - (long)oldsize);
            if (curbuf->b_op_start.lnum > top + oldsize)
                curbuf->b_op_start.lnum += newsize - oldsize;
            if (curbuf->b_op_end.lnum > top + oldsize)
                curbuf->b_op_end.lnum += newsize - oldsize;
        }
        changed_lines(top + 1, 0, bot, newsize - oldsize);
        if (top + 1 < curbuf->b_op_start.lnum)
            curbuf->b_op_start.lnum = top + 1;
        if (newsize == 0 && top + 1 > curbuf->b_op_end.lnum)
            curbuf->b_op_end.lnum = top + 1;
        else if (top + newsize > curbuf->b_op_end.lnum)
            curbuf->b_op_end.lnum = top + newsize;
        u_newcount += newsize;
        u_oldcount += oldsize;
        uep->ue_size = oldsize;
        uep->ue_array = newarray;
        uep->ue_bot = top + newsize + 1;
        nuep = uep->ue_next;
        uep->ue_next = newlist;
        newlist = uep;
    }
    curbuf->b_u_curhead->uh_entry = newlist;
    curbuf->b_u_curhead->uh_flags = new_flags;
    if ((old_flags & 0x02) && (curbuf->b_ml.ml_line_count == 1 && *ml_get((linenr_T)1) == '\000'))
        curbuf->b_ml.ml_flags |= 1;
    if (old_flags & 0x01)
        changed();
    else
        unchanged(curbuf, 0);
    for (i = 0; i < ('z' - 'a' + 1); ++i)
        if (curbuf->b_u_curhead->uh_namedm[i].lnum)
        {
            curbuf->b_namedm[i] = curbuf->b_u_curhead->uh_namedm[i];
            curbuf->b_u_curhead->uh_namedm[i] = namedm[i];
        }
    if (curbuf->b_u_curhead->uh_cursor.lnum + 1 == curwin->w_cursor.lnum
                                                 && curwin->w_cursor.lnum > 1)
        --curwin->w_cursor.lnum;
    if (curbuf->b_u_curhead->uh_cursor.lnum == curwin->w_cursor.lnum)
    {
        curwin->w_cursor.col = curbuf->b_u_curhead->uh_cursor.col;
        if (virtual_active() && curbuf->b_u_curhead->uh_cursor_vcol >= 0)
            coladvance((colnr_T)curbuf->b_u_curhead->uh_cursor_vcol);
        else
            curwin->w_cursor.coladd = 0;
    }
    else if (curwin->w_cursor.lnum <= curbuf->b_ml.ml_line_count)
        beginline(2 | 4);
    else
    {
        curwin->w_cursor.col = 0;
        curwin->w_cursor.coladd = 0;
    }
    check_cursor();
}
    static void u_undo_end()
{
    if ((u_oldcount -= u_newcount) != 0)
        msgmore(-u_oldcount);
    else if (u_newcount > p_report)
    {
        if (u_newcount == 1)
            msg((char_u *)(((char *)("1 change"))));
        else
            smsg((char_u *)((char *)("%ld changes")), u_newcount);
    }
    if ((fdo_flags & 0x200) && KeyTyped)
        foldOpenCursor();
}
    void u_sync()
{
    if (curbuf->b_u_synced)
        return;
    u_getbot();
    curbuf->b_u_curhead = ((void *)0);
}
    void u_unchanged(buf)
    buf_T *buf;
{
    struct u_header *uh;
    for (uh = buf->b_u_newhead; uh; uh = uh->uh_next)
        uh->uh_flags |= 0x01;
    buf->b_did_warn = 0;
}
    static u_entry_T * u_get_headentry()
{
    if (curbuf->b_u_newhead == ((void *)0) || curbuf->b_u_newhead->uh_entry == ((void *)0))
    {
        emsg((char_u *)(((char *)("E439: undo list corrupt"))));
        return ((void *)0);
    }
    return curbuf->b_u_newhead->uh_entry;
}
    static void u_getbot()
{
    u_entry_T *uep;
    linenr_T extra;
    uep = u_get_headentry();
    if (uep == ((void *)0))
        return;
    uep = curbuf->b_u_newhead->uh_getbot_entry;
    if (uep != ((void *)0))
    {
        extra = curbuf->b_ml.ml_line_count - uep->ue_lcount;
        uep->ue_bot = uep->ue_top + uep->ue_size + 1 + extra;
        if (uep->ue_bot < 1 || uep->ue_bot > curbuf->b_ml.ml_line_count)
        {
            emsg((char_u *)(((char *)("E440: undo line missing"))));
            uep->ue_bot = uep->ue_top + 1;
        }
        curbuf->b_u_newhead->uh_getbot_entry = ((void *)0);
    }
    curbuf->b_u_synced = 1;
}
    static void u_freelist(uhp)
    struct u_header *uhp;
{
    u_entry_T *uep, *nuep;
    for (uep = uhp->uh_entry; uep != ((void *)0); uep = nuep)
    {
        nuep = uep->ue_next;
        u_freeentry(uep, uep->ue_size);
    }
    if (curbuf->b_u_curhead == uhp)
        curbuf->b_u_curhead = ((void *)0);
    if (uhp->uh_next == ((void *)0))
        curbuf->b_u_oldhead = uhp->uh_prev;
    else
        uhp->uh_next->uh_prev = uhp->uh_prev;
    if (uhp->uh_prev == ((void *)0))
        curbuf->b_u_newhead = uhp->uh_next;
    else
        uhp->uh_prev->uh_next = uhp->uh_next;
    u_free_line((char_u *)uhp, 0);
    --curbuf->b_u_numhead;
}
    static void u_freeentry(uep, n)
    u_entry_T *uep;
    long n;
{
    while (n)
        u_free_line(uep->ue_array[--n], 0);
    u_free_line((char_u *)uep, 0);
}
    void u_clearall(buf)
    buf_T *buf;
{
    buf->b_u_newhead = buf->b_u_oldhead = buf->b_u_curhead = ((void *)0);
    buf->b_u_synced = 1;
    buf->b_u_numhead = 0;
    buf->b_u_line_ptr = ((void *)0);
    buf->b_u_line_lnum = 0;
}
    void u_saveline(lnum)
    linenr_T lnum;
{
    if (lnum == curbuf->b_u_line_lnum)
        return;
    if (lnum < 1 || lnum > curbuf->b_ml.ml_line_count)
        return;
    u_clearline();
    curbuf->b_u_line_lnum = lnum;
    if (curwin->w_cursor.lnum == lnum)
        curbuf->b_u_line_colnr = curwin->w_cursor.col;
    else
        curbuf->b_u_line_colnr = 0;
    if ((curbuf->b_u_line_ptr = u_save_line(lnum)) == ((void *)0))
        do_outofmem_msg((long_u)0);
}
    void u_clearline()
{
    if (curbuf->b_u_line_ptr != ((void *)0))
    {
        u_free_line(curbuf->b_u_line_ptr, 0);
        curbuf->b_u_line_ptr = ((void *)0);
        curbuf->b_u_line_lnum = 0;
    }
}
    void u_undoline()
{
    colnr_T t;
    char_u *oldp;
    if (undo_off)
        return;
    if (curbuf->b_u_line_ptr == ((void *)0) ||
                        curbuf->b_u_line_lnum > curbuf->b_ml.ml_line_count)
    {
        beep_flush();
        return;
    }
    if (u_savecommon(curbuf->b_u_line_lnum - 1,
                                curbuf->b_u_line_lnum + 1, (linenr_T)0) == 0)
        return;
    oldp = u_save_line(curbuf->b_u_line_lnum);
    if (oldp == ((void *)0))
    {
        do_outofmem_msg((long_u)0);
        return;
    }
    ml_replace(curbuf->b_u_line_lnum, curbuf->b_u_line_ptr, 1);
    changed_bytes(curbuf->b_u_line_lnum, 0);
    u_free_line(curbuf->b_u_line_ptr, 0);
    curbuf->b_u_line_ptr = oldp;
    t = curbuf->b_u_line_colnr;
    if (curwin->w_cursor.lnum == curbuf->b_u_line_lnum)
        curbuf->b_u_line_colnr = curwin->w_cursor.col;
    curwin->w_cursor.col = t;
    curwin->w_cursor.lnum = curbuf->b_u_line_lnum;
}
    static char_u * u_blockalloc(size)
    long_u size;
{
    mblock_T *p;
    mblock_T *mp, *next;
    p = (mblock_T *)lalloc(size + sizeof(mblock_T), 0);
    if (p != ((void *)0))
    {
        for (mp = &curbuf->b_block_head;
                (next = mp->mb_next) != ((void *)0) && next < p;
                        mp = next)
            ;
        p->mb_next = next;
        p->mb_size = size;
        mp->mb_next = p;
        p->mb_info.m_next = ((void *)0);
        p->mb_info.m_size = 0;
        curbuf->b_mb_current = p;
        curbuf->b_m_search = ((void *)0);
        p++;
    }
    return (char_u *)p;
}
    void u_blockfree(buf)
    buf_T *buf;
{
    mblock_T *p, *np;
    for (p = buf->b_block_head.mb_next; p != ((void *)0); p = np)
    {
        np = p->mb_next;
        vim_free(p);
    }
    buf->b_block_head.mb_next = ((void *)0);
    buf->b_m_search = ((void *)0);
    buf->b_mb_current = ((void *)0);
}
    static void u_free_line(ptr, keep)
    char_u *ptr;
    int keep;
{
    minfo_T *next;
    minfo_T *prev, *curr;
    minfo_T *mp;
    mblock_T *nextb;
    mblock_T *prevb;
    if (ptr == ((void *)0) || ptr == IObuff)
        return;
    mp = (minfo_T *)(ptr - (sizeof(long_u)));
    if (curbuf->b_mb_current == ((void *)0) || mp < (minfo_T *)curbuf->b_mb_current)
    {
        curbuf->b_mb_current = curbuf->b_block_head.mb_next;
        curbuf->b_m_search = ((void *)0);
    }
    if ((nextb = curbuf->b_mb_current->mb_next) != ((void *)0)
                                                     && (minfo_T *)nextb < mp)
    {
        curbuf->b_mb_current = nextb;
        curbuf->b_m_search = ((void *)0);
    }
    while ((nextb = curbuf->b_mb_current->mb_next) != ((void *)0)
                                                     && (minfo_T *)nextb < mp)
        curbuf->b_mb_current = nextb;
    curr = ((void *)0);
    if (curbuf->b_m_search == ((void *)0) || mp < (curbuf->b_m_search->m_next))
        next = &(curbuf->b_mb_current->mb_info);
    else
        next = curbuf->b_m_search;
    do
    {
        prev = next->m_next;
        if (prev == ((void *)0) || mp <= prev)
        {
            prev = curr;
            curr = next;
            next = next->m_next;
            break;
        }
        curr = prev->m_next;
        if (curr == ((void *)0) || mp <= curr)
        {
            prev = next;
            curr = prev->m_next;
            next = curr->m_next;
            break;
        }
        next = curr->m_next;
    }
    while (mp > next && next != ((void *)0));
    if ((char_u *)mp + mp->m_size == (char_u *)next)
    {
        mp->m_size += next->m_size;
        mp->m_next = next->m_next;
    }
    else
        mp->m_next = next;
    if (prev != ((void *)0) && (char_u *)curr + curr->m_size == (char_u *)mp)
    {
        curr->m_size += mp->m_size;
        curr->m_next = mp->m_next;
        curbuf->b_m_search = prev;
    }
    else
    {
        curr->m_next = mp;
        curbuf->b_m_search = curr;
    }
    if (!keep && curbuf->b_mb_current->mb_size
                              == curbuf->b_mb_current->mb_info.m_next->m_size)
    {
        prevb = &curbuf->b_block_head;
        for (nextb = prevb->mb_next; nextb != curbuf->b_mb_current;
                                                       nextb = nextb->mb_next)
            prevb = nextb;
        prevb->mb_next = nextb->mb_next;
        vim_free(nextb);
        curbuf->b_mb_current = ((void *)0);
        curbuf->b_m_search = ((void *)0);
    }
}
    static char_u * u_alloc_line(size)
    unsigned size;
{
    minfo_T *mp, *mprev, *mp2;
    mblock_T *mbp;
    int size_align;
    size += (sizeof(long_u)) + 1;
    if (size < sizeof(minfo_T) + 1)
        size = sizeof(minfo_T) + 1;
    size_align = (size + ((sizeof(long)) - 1)) & ~((sizeof(long)) - 1);
    if (curbuf->b_mb_current == ((void *)0) || curbuf->b_m_search == ((void *)0))
    {
        curbuf->b_mb_current = &curbuf->b_block_head;
        curbuf->b_m_search = &(curbuf->b_block_head.mb_info);
    }
    mprev = curbuf->b_m_search;
    mbp = curbuf->b_mb_current;
    mp = curbuf->b_m_search->m_next;
    if (mp == ((void *)0))
    {
        if (mbp->mb_next)
            mbp = mbp->mb_next;
        else
            mbp = &curbuf->b_block_head;
        mp = curbuf->b_m_search = &(mbp->mb_info);
    }
    while (mp->m_size < size)
    {
        if (mp == curbuf->b_m_search)
        {
            if (mbp->mb_next)
                mbp = mbp->mb_next;
            else
                mbp = &curbuf->b_block_head;
            mp = curbuf->b_m_search = &(mbp->mb_info);
            if (mbp == curbuf->b_mb_current)
            {
                int n = (size_align > (2044 / 4)
                                                 ? size_align : 2044);
                mp = (minfo_T *)u_blockalloc((long_u)n);
                if (mp == ((void *)0))
                    return (((void *)0));
                mp->m_size = n;
                u_free_line((char_u *)mp + (sizeof(long_u)), 1);
                mp = curbuf->b_m_search;
                mbp = curbuf->b_mb_current;
            }
        }
        mprev = mp;
        if ((mp = mp->m_next) == ((void *)0))
            mp = &(mbp->mb_info);
    }
    if ((long)mp->m_size - size_align >= (long)(sizeof(minfo_T) + 1))
    {
        mp2 = (minfo_T *)((char_u *)mp + size_align);
        mp2->m_size = mp->m_size - size_align;
        mp2->m_next = mp->m_next;
        mprev->m_next = mp2;
        mp->m_size = size_align;
    }
    else
    {
        mprev->m_next = mp->m_next;
    }
    curbuf->b_m_search = mprev;
    curbuf->b_mb_current = mbp;
    mp = (minfo_T *)((char_u *)mp + (sizeof(long_u)));
    *(char_u *)mp = '\000';
    return ((char_u *)mp);
}
    static char_u * u_save_line(lnum)
    linenr_T lnum;
{
    char_u *src;
    char_u *dst;
    unsigned len;
    src = ml_get(lnum);
    len = (unsigned)strlen((char *)(src));
    if ((dst = u_alloc_line(len)) != ((void *)0))
        memmove((char *)(dst), (char *)(src), (size_t)(len + 1));
    return (dst);
}
    int bufIsChanged(buf)
    buf_T *buf;
{
    return
            !bt_dontwrite(buf) &&
            (buf->b_changed || file_ff_differs(buf));
}
    int curbufIsChanged()
{
    return
        !bt_dontwrite(curbuf) &&
        (curbuf->b_changed || file_ff_differs(curbuf));
}
