#!/bin/sh
#set -vx
TIMING_RESULT=results.txt
rm -f $TIMING_RESULT

timing() {
	job=$2
	make clean
	if test -f $TIMING_RESULT; then
	  echo "$1" $job >> $TIMING_RESULT
	else
	  echo "$1" $job > $TIMING_RESULT
	fi
	if [ "$job" != "" ]; then
		/usr/bin/time --format=%e -a -o $TIMING_RESULT make CC="$1" -j$job 
	else 
		/usr/bin/time --format=%e -a -o $TIMING_RESULT make CC="$1" 
	fi
}
timing /usr/bin/gcc
timing /usr/bin/gcc
timing /usr/bin/gcc 5
timing /usr/bin/gcc 20
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/distcc/distcc /usr/bin/gcc"
timing "$HOME/software/bin/Linux/distcc/distcc /usr/bin/gcc"
timing "$HOME/software/bin/Linux/distcc/distcc /usr/bin/gcc" 5
timing "$HOME/software/bin/Linux/distcc/distcc /usr/bin/gcc" 20
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 5
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 20
make header -j20
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 5
timing "$HOME/software/bin/Linux/ccache/ccache /usr/bin/gcc" 20
timing $HOME/software/opt/intel_cc_80/bin/icc
timing $HOME/software/opt/intel_cc_80/bin/icc
timing $HOME/software/opt/intel_cc_80/bin/icc 5
timing $HOME/software/opt/intel_cc_80/bin/icc 20
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/distcc/distcc $HOME/software/opt/intel_cc_80/bin/icc"
timing "$HOME/software/bin/Linux/distcc/distcc $HOME/software/opt/intel_cc_80/bin/icc"
timing "$HOME/software/bin/Linux/distcc/distcc $HOME/software/opt/intel_cc_80/bin/icc" 5
timing "$HOME/software/bin/Linux/distcc/distcc $HOME/software/opt/intel_cc_80/bin/icc" 20
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc" 
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc" 
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc" 5
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc" 20
rm -f *.pchi
$HOME/software/bin/Linux/ccache/ccache -C
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc -pch" 
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc -pch" 
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc -pch" 5
timing "$HOME/software/bin/Linux/ccache/ccache $HOME/software/opt/intel_cc_80/bin/icc -pch" 20

